/**
 * Created by Administrator on 2016/11/28.
 */
"use strict";

var TdxUtils = {
  getQueryString: function (name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = decodeURI(window.location.search).substr(1).match(reg);
    if (r !== null) {

      return unescape(r[2]);
    }
    return null;
  },

  //是否大于等于0
  isYDDYZeroClr: function (e) {
    try {
      if (parseFloat(e) >= 0) {
        return "rgb(255,50,50)";
      }
      if (isNaN(parseFloat(e))) {
        return "gray";
      }
    }
    catch (err) {
      return "gray";
    }
    return "rgb(0,230,0)";
  },

  //xsws保留位数,cs被除数
  Format_Dec: function (sFloat, xsws, cs) {
    if (!cs) {
      cs = 1;
    }
    try {
      var f = (sFloat / cs).toFixed(xsws);
      if (isNaN(f)) {
        return "--";
      }
      return (sFloat / cs).toFixed(xsws);
    }
    catch (e) {
      return "--";
    }
  },

  //日期格式化
  Format_Date: function (val, datatype) {
    var ret = val;
    if (datatype === "D1") {
      ret = ret.substr(0, 4) + "-" + ret.substr(4, 2) + "-" + ret.substr(6, 2);
    }
    else if (datatype === "D2") {
      ret = ret.substr(0, 4) + "/" + ret.substr(4, 2) + "/" + ret.substr(6, 2);
    }
    else if (datatype === "D3") {
      ret = ret.substr(0, 4) + "年" + ret.substr(4, 2) + "月" + ret.substr(6, 2) + "日";
    }
    else if (datatype === "D4") {
      ret = ret.substr(2, 6);
    }
    else if (datatype === "D5") {
      ret = ret.substr(2, 2) + "-" + ret.substr(4, 2) + "-" + ret.substr(6, 2);
    }
    else if (datatype === "D6") {
      ret = ret.substr(2, 2) + "/" + ret.substr(4, 2) + "/" + ret.substr(6, 2);
    }
    else if (datatype === "D7") {
      ret = ret.substr(2, 2) + "年" + ret.substr(4, 2) + "月" + ret.substr(6, 2) + "日";
    }
    else if (datatype === "D8") {
      ret = ret.substr(4, 2) + ret.substr(6, 2);
    }
    else if (datatype === "D9") {
      ret = ret.substr(4, 2) + "-" + ret.substr(6, 2);
    }
    else if (datatype === "D10") {
      ret = ret.substr(4, 2) + "/" + ret.substr(6, 2);
    }
    else if (datatype === "D11") {
      ret = ret.substr(4, 2) + "月" + ret.substr(6, 2) + "日";
    }
    return ret;
  },

  //日期格式化
  Format_Time: function (val, datatype) {
    var ret = val;
    if (datatype === "T1") {
      ret = ret.substr(0, 2) + ":" + ret.substr(2, 2) + ":" + ret.substr(4, 2);
    }
    else if (datatype === "T2") {
      ret = ret.substr(0, 4);
    }
    else if (datatype === "T3") {
      ret = ret.substr(0, 2) + ":" + ret.substr(2, 2);
    }
    return ret;
  },

  //一直预期评级
  getYZYQ_pj: function (e) {
    var fval = 0.00;
    try {
      fval = parseFloat(e);
      fval.toFixed(2);
    }
    catch (err) {
      fval = 0.00;
    }
    if (fval < 1) {
      return ["未知(0.00)", "rgb(153,153,153)"];
    }
    else if (1 <= fval && fval < 1.6) {
      return ["卖出(" + TdxUtils.Format_Dec(fval, 2) + ")", "rgb(0,230,0)"];
    }
    else if (1.6 <= fval && fval < 2.6) {
      return ["减持(" + TdxUtils.Format_Dec(fval, 2) + ")", "rgb(0,230,0)"];
    }
    else if (2.6 <= fval && fval < 3.6) {
      return ["中性(" + TdxUtils.Format_Dec(fval, 2) + ")", "rgb(153,153,153)"];
    }
    else if (3.6 <= fval && fval < 4.6) {
      return ["增持(" + TdxUtils.Format_Dec(fval, 2) + ")", "rgb(255,50,50)"];
    }
    else if (4.6 <= fval) {
      return ["买入(" + TdxUtils.Format_Dec(fval, 2) + ")", "rgb(255,50,50)"];
    }
    else {
      return ["未知(0.00)", "rgb(153,153,153)"];
    }
  },

  SpanZDFClrBegin: function (val) {
    var ret = "<span class=";
    if (parseFloat(val) > 0){
      ret += "ClassUP";
    }
    else if (parseFloat(val) < 0) {
      ret += "ClassDOWN";
    }else{
      ret += "ClassZero";
    }
    ret += ">";
    return ret;
  },
  SpanZDFClrEnd: function () {
    return "</span>";
  },

  // 将字符串形式的日期转换成日期对象
// var strTime="2011-04-16"; //字符串日期格式
// var date= new Date(Date.parse(strTime.replace(/-/g,   "/"))); //转换成Data();
// var month=date.getMonth()+1; //获取当前月份


  DateAdd: function (interval, number, date) {
    /*
     *   功能:实现VBScript的DateAdd功能.
     *   参数:interval,字符串表达式，表示要添加的时间间隔.
     *   参数:number,数值表达式，表示要添加的时间间隔的个数.
     *   参数:date,时间对象.
     *   返回:新的时间对象.
     *   var   now   =   new   Date();
     *   var   newDate   =   DateAdd( "d ",5,now);
     *---------------   DateAdd(interval,number,date)   -----------------
     */
    switch (interval) {
      case "y":
        date.setFullYear(date.getFullYear() + number);
        break;
      case "q":
        date.setMonth(date.getMonth() + number * 3);
        break;
      case "w":
        date.setDate(date.getDate() + number * 7);
        break;
      case "d":
        date.setDate(date.getDate() + number);
        break;
      case "h":
        date.setHours(date.getHours() + number);
        break;
      case "m":
        date.setMinutes(date.getMinutes() + number);
        break;
      case "s":
        date.setSeconds(date.getSeconds() + number);
        break;
      default:
        date.setDate(date.getDate() + number);
    }

    return date;
  },
  getDate: function (s) {
    var  d = s;
    var  year = d.getFullYear();
    var  mon = d.getMonth() + 1;
    var  day = d.getDate();
    var  Date = "" + year + (mon < 10 ? ("0" +mon) : mon) + (day < 10 ? ("0" + day) : day);
    return Date;
  }
};

