//rem自适应
;(function(designWidth, maxWidth){
	var doc = document,
	win = window,
	docEl = doc.documentElement,
	remStyle = document.createElement("style"),
	tid;

	function refreshRem() {
		var width = docEl.getBoundingClientRect().width;
		maxWidth = maxWidth || 540;
		width>maxWidth && (width=maxWidth);
		var rem = width * 20 / designWidth;
		remStyle.innerHTML = 'html{font-size:' + rem + 'px;}';
	}

	if (docEl.firstElementChild) {
		docEl.firstElementChild.appendChild(remStyle);
	} else {
		var wrap = doc.createElement("div");
		wrap.appendChild(remStyle);
		doc.write(wrap.innerHTML);
		wrap = null;
	}
	//要等 wiewport 设置好后才能执行 refreshRem，不然 refreshRem 会执行2次；
	refreshRem();

	win.addEventListener("resize", function() {
		clearTimeout(tid); //防止执行两次
		tid = setTimeout(refreshRem, 300);
	}, false);

	win.addEventListener("pageshow", function(e) {
		if (e.persisted) { // 浏览器后退的时候重新计算
			clearTimeout(tid);
			tid = setTimeout(refreshRem, 300);
		}
	}, false);

	if (doc.readyState === "complete") {
		doc.body.style.fontSize = "16px";
	} else {
		doc.addEventListener("DOMContentLoaded", function(e) {
			doc.body.style.fontSize = "16px";
		}, false);
	}
})(375, 640);

var Sign_Flag = 0;
var User = {};
var Product = {};
var __global = [];
var MaxSignDays = 0;
var LatestSignDate = "";

var dateObj = (function(){
	var _date = new Date();
	return {
		getDate: function(){
			return _date;
		},
		setDate: function(date){
			_date = date;
		}
	};
})();

window.onload = onLoad;

function onLoad(){

	getL2Account(function(user) {
		User = user;
		//设置calendar div html
		renderHtml();
		//界面显示
		MyquerySignDate();
		//绑定事件
		bindEvent();

		$('#link').click(function(){
	 		$('#msg-bk').css('display', 'block');
	 	});

	 	$('#close').click(function(){
	 		$('#msg-bk').css('display', 'none');
	 	});

	});
};

function renderHtml(){
	var calendar = document.getElementById('calendar');
	var titleBox = document.createElement('div');
	var bodyBox = document.createElement('div');

	//设置title html
	titleBox.className = 'calendar-title-box';
	titleBox.innerHTML = "<img class='prev-month' id='prevMonth' src='images/prev.png'>" + 
	"<span class='calendar-title' id='calendarTitle'></span>" + 
	"<img id='nextMonth' class='next-month' src='images/next.png'>";

	calendar.appendChild(titleBox);

	//设置body 表格
	bodyBox.className = 'calendar-body-box';
	var _headHtml = "<tr class='week'>" + 
				"<th>日</th>" + 
				"<th>一</th>" +
				"<th>二</th>" +
				"<th>三</th>" +
				"<th>四</th>" +
				"<th>五</th>" +
				"<th>六</th>" +
			  "</tr>";
	var _bodyHtml = "";

	//一个月最多31天，最多六行
	for(var i=0; i<6; i++){
		_bodyHtml += "<tr>" + 
				"<td></td>" + 
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
				"<td></td>" +
			  "</tr>";
	}
	bodyBox.innerHTML = "<table id='calendarTable' class='calendar-table'>" + 
		_headHtml + _bodyHtml + 
		"</table>";

	calendar.appendChild(bodyBox);
}


function showCalendarData(){
	var _year = dateObj.getDate().getFullYear();
	var month = dateObj.getDate().getMonth() + 1;
	var _dateStr = getDateStr(dateObj.getDate()); //20170814

	//设置日历表头
	var calendarTitle = document.getElementById('calendarTitle');
	var titleStr = _dateStr.substr(0, 4) + "年" + _dateStr.substr(4, 2) + "月";
	calendarTitle.innerText = titleStr;

	//设置日历中日期数据
	var _table = document.getElementById('calendarTable');
	var _tds = _table.getElementsByTagName('td');
	//获取当月第一天: Tue Aug 01 2017 00:00:00 GMT+0800 (中国标准时间)
	var _firstDay = new Date(_year, month-1, 1);
	//_firstDay.getDay(); //获取星期几  2
	//getDate()  //获取当日   1
	for(var i = 0; i <_tds.length; i++){
		var _thisDay = new Date(_year, month-1, i+1-_firstDay.getDay()); 
		var _thisDayStr = getDateStr(_thisDay); //20170730
		_tds[i].innerHTML = "<div>" + _thisDay.getDate()+ "</div>"; //30

		_tds[i].setAttribute('data', _thisDayStr);

		if(_thisDayStr == getDateStr(new Date())){
			_tds[i].className = 'currentDay';
			_tds[i].id = 'currentDay';
		} else if(_thisDayStr.substr(0, 6) == getDateStr(_firstDay).substr(0, 6)){
			_tds[i].className = 'currentMonth';
		} else{
			_tds[i].className = 'otherMonth';
		}

		for(var j = 0, len = __global.length; j < len; j++){
			if(_thisDayStr == __global[j]){
				_tds[i].setAttribute('class', 'signStyle');
			}
		}
	}
}

function querySignStatus(){
	//显示领取状态
	if(Sign_Flag == 1 || Sign_Flag == 2){
		dispAwardStatus(Sign_Flag);
		//领取
		MyAwardClick(Sign_Flag);
	} else if(Sign_Flag == 0) {
		dispAwardStatus(Sign_Flag);
	}
	//显示签到状态
	if(LatestSignDate == getDateStr(new Date())){
		//已签到 XX 天
		dispSignStatus();
	} else{
		// 签到
		SignInClick();
	}		
}

function MyquerySignDate(){ //'u_no','signin_num','signin_first_date','get_flag'

	querySignDate(function(data){

		try {

			var result = FormatResult(data);
			if(result.ErrorCode != 0) {
				alert(result.ErrorInfo);
				return;
			}
			var num = result.Num;
			if(num == 0){
				return
			}
			var list = result.rows;
			var firstDays = list[0]["signin_first_date"];
			var signDays = list[0]["signin_num"];
			Sign_Flag = list[0]["get_flag"];
			
			firstDays = firstDays.split(",");
			signDays = signDays.split(",");
			
			//获取最新连续签到天数
			var len = signDays.length;
			MaxSignDays = Number(signDays[len-1]);

			var endDays = [];
			for(var i = 0, len = firstDays.length; i < len; i++){
				endDays.push(getEndDate(firstDays[i], signDays[i]-1));
			}

			for(var i = 0, len = endDays.length; i < len; i++){
				getAllSignDate(firstDays[i], endDays[i]);
			}
			//获取最新一天的签到日期
			LatestSignDate = endDays[endDays.length - 1];

			//查询签到状态以及是否领取(签到按钮部分)
			querySignStatus();
			//查询签到日期 再显示表格日期及签到日期(日历部分)
			showCalendarData();
		}
		catch(e) {
			alert(e);
		}
	})
	
}

function dispAwardStatus(flag){
	if(flag == 1){
		$('#signAward').attr('src', 'images/award_1.png');
	} else if(flag == 2){
		$('#signAward').attr('src', 'images/award_3.png');
	} else if(flag == 0){
		$('#signAward').attr('src', 'images/award_no.png');
	}
}

function MyAwardClick(flag){
	var FLAG = true;
	$('#signAward').unbind('click').bind('click', function(){
		if(FLAG) {
			FLAG = false;
			getMyAward(function(data){
				FLAG = true;
				var result = FormatResult(data);
				if(result.ErrorCode != 0) {
					alert(result.ErrorInfo);
					return;
				}
				if(flag == 1){
					alert("领取Level2月卡成功！");
				} else if(flag == 2){
					alert("领取Level2季卡成功！");
				}
				$('#signAward').unbind('click');
				MyquerySignDate();
			});
		}
		
	})
}

function dispSignStatus(){
	MaxSignDays = MaxSignDays > 9 ? ("" + MaxSignDays) : ("0" + MaxSignDays);
	$('#signImg').attr('src', 'images/sign2.png');
	var div = "<div class='signDays'>" + MaxSignDays + "</div>";
	$('.sign').append(div);
}

function SignInClick(){
	var SIGN = true;
	$('#signImg').unbind('click').bind('click', function(){
		if(SIGN){
			SIGN = false;
			signIn(function(data){
				SIGN = true;
				var result = FormatResult(data);
				if(result.ErrorCode != 0) {
					alert(result.ErrorInfo);
					return;
				}
				$('#signImg').unbind('click');
				MyquerySignDate();
		 		$('#currentDay').addClass("signStyle");
			})
		}
		
 	});
}

function getDate(datestr){
  var date = new Date(datestr.substr(0, 4), parseInt(datestr.substr(4, 2)) - 1, datestr.substr(6, 2));
  return date;
}

function getEndDate(dateTemp, days){
    var nDate = getDate(dateTemp);
    var millSeconds = Math.abs(nDate) + (days * 24 * 60 * 60 * 1000);
    var rDate = new Date(millSeconds);
    var year = rDate.getFullYear();
    var month = rDate.getMonth() + 1;
    var day = rDate.getDate();
    month = (month > 9) ? ("" + month) : ("0" + month);
	day = (day > 9 ) ? ("" + day) : ("0" + day);
    return year + month + day;
}

function getAllSignDate(start, end){
	var startTime = getDate(start);  
	var endTime = getDate(end);  
	while((endTime.getTime() - startTime.getTime()) >= 0){  
	  var year = startTime.getFullYear();  
	  var month = startTime.getMonth() + 1;
	  var day = startTime.getDate();
	  month = (month > 9) ? ("" + month) : ("0" + month);
	  day = (day > 9 ) ? ("" + day) : ("0" + day);
	  __global.push((year + month + day));
	  startTime.setDate(startTime.getDate() + 1); 
	}
}

//绑定上个月下个月事件
function bindEvent(){
	var prevMonth = document.getElementById('prevMonth');
	var nextMonth = document.getElementById('nextMonth');
	addEvent(prevMonth, 'click', toPrevMonth);
	addEvent(nextMonth, 'click', toNextMonth);
}

function addEvent(dom, eType, func){
	if(dom.addEventListener){ //DOM 2.0
		dom.addEventListener(eType, function(e){
			func(e);
		});
	} else if(dom.attachEvent){ //IE5+
		dom.attachEvent('on', eType, function(e){
			func(e);
		}); 
	} else{ //DOM0
		dom['on' + eType] = function(e){
			func(e);
		};
	}		
}

function toPrevMonth(){
	var date = dateObj.getDate();
	//将dateObj设置成上个月第一天
	dateObj.setDate(new Date(date.getFullYear(), date.getMonth()-1, 1)); 
	showCalendarData();
}

function toNextMonth(){
	var date = dateObj.getDate();
	//将dateObj设置成下个月第一天
	dateObj.setDate(new Date(date.getFullYear(), date.getMonth()+1, 1));  
	showCalendarData(); 
}

function getDateStr(date){
	var _year = date.getFullYear();
	var month = date.getMonth() + 1;
	var day = date.getDate();

	month = (month > 9) ? ("" + month) : ("0" + month);
	day = (day >9 ) ? ("" + day) : ("0" + day);
	return _year + month + day;
}

//获取签到日期
function querySignDate(callback){
	__fwCallTql.send('Level2:GetSignInInfo', [{}], callback);
}
//签到
function signIn(callback){
	__fwCallTql.send('Level2:SignInByPhone', [{}], callback);
}
//领取
function getMyAward(callback){
	__fwCallTql.send('Level2:GetActionProductBySignIn', [{}], callback);
}
