
!function(_g){
	var user = {};
	var product = {};

	//检测用户是否登录
	var checkLogin = function(callback) {

		__tdxGetPulTdxID(function(data) {
			if (typeof data === 'string') {
				data = JSON.parse(data);
			}
			var tdxid;
			if (data.length > 3) {
				var result = FormatResult(data);
				tdxid = result.rows[0]["TDXID"];
			}

			// 一户通登录
			if (!tdxid) {
				__tdxYhtLogin();
				return
			}
			callback(tdxid);
		});
	}

	//获取注册手机号
	var getUserTel = function(callback) {
		__tdxGetRegTel(function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				alert(result.ErrorInfo);
				return;
			}
			var tel = result.rows[0]["YHTTEL"];
			callback(tel);
		});
	}

	//获取一户通昵称信息
	var getNickName = function(tdxid, callback) {
		getZhMessage(tdxid, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				alert(result.ErrorInfo);
				return;
			}
			var nick = result.rows[0]["NICK"];
			callback(nick);
		});
	}

	//获取一户通绑定信息
	var getZhBindInfo = function(tdxid, callback) {
		getZhConnect(tdxid, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				alert(result.ErrorInfo);
				return;
			}
			var list = result.rows;
			var yhtBindInfo, uname;
			for (var i = 0, len = list.length; i < len; i++) {
				if (list[i]["ATYPE"] == '292') {
					yhtBindInfo = list[i];
					uname = list[i]["AID"];
				}
			}
			callback(yhtBindInfo, uname);
		});
	}

	//注册level2账号
	var regL2Account = function(tel, nick, callback) {
		regAndBind(tel, nick, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				alert(result.ErrorInfo);
				return;
			}
			var uname = result.rows[0]["u_no"];
			callback(uname);
		});
	}

	//获取当前产品id
	var getCurProductId = function(callback) {
		queryProductID(function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				alert(result.ErrorInfo);
				return;
			}
			var pid = result.rows[0]["product_id"];
			if(pid == '126'){
				alert(result.ErrorInfo);
				return
			} else{
				callback(pid);
			}
		});
	}

	//根据产品id获取产品信息
	var getProductInfo = function(pid, callback) {
		queryProductFront(pid, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0) {
				alert(result.ErrorInfo);
				return;
			}
			var pname = result.rows[0]["pname"];
			callback(pname);
		})
	}

	//根据产品信息生成订单号
	var getSubmitOrder = function(pid, uname, callback) {
		submitOrder(pid, uname, function(data){
			var result = FormatResult(data);
			if(result.ErrorCode != 0) {
				alert(result.ErrorInfo);
				return;
			}
			var cid = result.rows[0]["cid"];
			callback(cid);
		})
	}

	//提交订单
	var payOrder = function(cid, pname, callback) {
		payFreeOrder(cid, pname, function(data){
			var result = FormatResult(data);
			if(result.ErrorCode != 0) {
				alert(result.ErrorInfo);
				return;
			}
			var data = result.rows[0]["strResp"];
			callback(data);
		})
	}

	var getL2Account = function(callback) {
		checkLogin(function(tdxid){
			user.tdxid = tdxid;
			getUserTel(function(tel){
				user.tel = tel;
				getNickName(tdxid, function(nick){
					user.nick = nick;
					getZhBindInfo(tdxid, function(yhtInfo, L2Account){
					// user.yhtInfo = yhtInfo;
						user.L2Account = L2Account;
						if(!yhtInfo){
							regL2Account(tel, nick, function(L2Account){
								user.L2Account = L2Account;
								callback(user);
							});
						} else{
							callback(user);
						}
					});
				});
				
			});
		});
	}

	var getProductLimit = function(uname, callback) {
		getCurProductId(function(pid){
			product.pid = pid;
			getProductInfo(pid, function(pname){
				product.pname = pname;
				getSubmitOrder(pid, uname, function(cid){
					product.cid = cid;
					payOrder(cid, pname, function(data){
						product.data = data;
						callback(product);
					});
				});
			});
		});
	}

	_g["getL2Account"] = getL2Account;
	_g["getProductLimit"] = getProductLimit;

}(window);

function getZhMessage(tdxid, callback) {
	var data = {
		ATYPE: '999',
		AID: tdxid,
		tdxPageID: "_UrlEncode"
	}

	__fwCallTql.send('PUL.cget_zh_message', [data], callback);
}

function getZhConnect(tdxid, callback) {
	var data = {
		ATYPE: '999',
		AID: tdxid,
		tdxPageID: "_UrlEncode"
	}

	__fwCallTql.send('PUL.cget_zh_connect', [data], callback);
}

function regAndBind(tel, nick, callback) {
	var data = {
		in_atype: "292",
		in_u_no: "",
		in_u_name: nick,
		in_u_pwd: "888888",
		in_use_pul_pwd: "1",
		in_sid: "",
		in_u_property: "全价",
		in_u_type: "个人",
		in_u_product: "level2",
		in_u_infotype: "TDXAPP",
		in_u_address: "#CN#",
		in_u_linkman: tel,
		in_u_tel: tel,
		in_u_mobile: tel,
		in_u_email: ""
	}

	__fwCallTql.send('Level2:RegAndBind', [data], callback);
}

function queryProductID(callback) {
	__fwCallTql.send('Level2:QueryProductID', [{}], callback);
}

// Level2产品价格查询
function queryProductFront(pid, callback) {
	__fwCallTql.send('Level2:QueryProductFront', [{
		"in_pid": pid
	}], callback);
}

function submitOrder(pid, uname, callback) {
	var data = {
		pid: pid,
		in_uno: uname,
		pnum: "1"
	}

	__fwCallTql.send('Level2:SubmitOrder', [data], callback);
}

function payFreeOrder(order_id, pname, callback) {
	var data = {
		"urlParam": {
			"order_id": order_id,
			"channel": '',
			"tdxalipay": "aliapp",
			"app_id": '',
			"method": "alipay.trade.app.pay",
			"subject": pname,
			"product_code": "QUICK_MSECURITY_PAY"
		}
	}

	__fwCallTql.send('Level2:FreePayOrderByPhone', [data], callback);
}
