/**
 * 重写交易中的 alert 弹框
 */
function GlobalAlert(json) {

  if (typeof json == "string") {
    json = {
      content: json
    };
  }

  if (typeof TextZH == "function") {
    json["content"] = TextZH(json["content"]);
  }

  // 将提示中的换行替换成 <br>
  json["content"] = json["content"].replace(/\r\n/g, "<br>");
  json["content"] = json["content"].replace(/\n/g, "<br>");

  MsgBox(json, 0);
}

/**
 * 重写交易的 Confirm 弹框
 */
function GlobalConfirm(json) {

  if (typeof json == "string") {
    json = {
      content: json["content"]
    };
  }

  if (typeof TextZH == "function") {
    json["content"] = TextZH(json["content"]);
  }

  // 将提示中的换行替换成 <br>
  json["content"] = json["content"].replace(/\r\n/g, "<br>");
  json["content"] = json["content"].replace(/\n/g, "<br>");

  MsgBox(json, 1);
}

/**
 * 弹框逻辑实现函数
 * @param { Object } box 提示框内容对象，包括提示内容，确定、取消 callback
 * @param { Number } type 提示框类型 0 - alert, 1 - confirm
 *
 * @return 无返回值
 */
function MsgBox(box, type) {

  var id = "__msgbox";
  var btnStr;
  if (typeof box.buttons != "undefined")
  {
    if (type == 1) {
      btnStr = "\n      <button class=\"msgbox-btn msgbox-btn-ca\">" + box.buttons[0] +
          "</button>\n      <button class=\"msgbox-btn msgbox-btn-ok\">" + box.buttons[1] + "</button>\n    ";
    } else {
      btnStr = "\n      <button class=\"msgbox-btn msgbox-btn-ok\">" +  box.buttons[0] + "</button>\n    ";
    }
  }
  else
  {
    if (type == 1) {
      btnStr = "\n      <button class=\"msgbox-btn msgbox-btn-ca\">\u53D6\u6D88</button>\n      <button class=\"msgbox-btn msgbox-btn-ok\">\u786E\u5B9A</button>\n    ";
    } else {
      btnStr = "\n      <button class=\"msgbox-btn msgbox-btn-ok\">\u786E\u5B9A</button>\n    ";
    }

  }

  var boxStr = "\n    <div class=\"msgbox-wrapper\">\n      <div class=\"msgbox\">\n        ";
  if (typeof box.title != 'undefined')
    boxStr += "<div class=\"msgbox-head\">" + box.title + "</div>\n        ";

  boxStr += "<div class=\"msgbox-body\">" + box.content + "</div>\n        <div class=\"msgbox-foot\">" + btnStr + "</div>\n      </div>\n    </div>\n  ";

  var styleStr = "\n    <style>\n      " +
      ".msgbox-wrapper {\n        " +
      "position: fixed;\n        " +
      "top: 0;\n        " +
      "left: 0;\n        " +
      "width: 100%;\n        " +
      "height: 100%;\n        " +
      "display: flex;\n        " +
      "align-items: center;\n        " +
      "justify-content: center;\n        " +
      "display: -webkit-flex;\n        " +
      "-webkit-align-items: center;\n        " +
      "-webkit-justify-content: center;\n        " +
      "background: rgba(0, 0, 0, 0.6);\n        " +
      "filter:progid:DXImageTransform.Microsoft.gradient(startColorstr=#7f000000,endColorstr=#7f000000);\n        " +
      "z-index: 1000;\n      }\n      " +
      ".msgbox {\n        " +
      "background-color: #fff;\n        " +
      "border: 1px solid #ddd;\n        " +
      "border-radius: 5px;\n        " +
      "max-width: 600px;\n        " +
      "min-width: 200px;\n        " +
      "max-height: 600px;\n        " +
      "min-height: 180px;\n        " +
      "width: 80%;\n        " +
      "display: flex;\n        " +
      "flex-direction: column;\n        " +
      "display: -webkit-flex;\n        " +
      "-webkit-flex-direction: column;\n      }\n      " +
      ".msgbox-head {\n        " +
      "flex: 0 0 50px;\n        " +
      "-webkit-flex: 0 0 50px;\n        " +
      "line-height: 50px;\n        " +
      "font-size: 18px;\n        " +
      "font-weight: bold;\n        " +
      "padding-left: 10px;\n        " +
      "padding-right: 10px;\n        " +
      "text-align: center;\n        " +
      "border-bottom: 1px solid #ddd;\n         " +
      "margin:5px 40px 0 40px;\n        }\n      " +
      ".msgbox-body {\n        " +
      "flex: 1 1 auto;\n        " +
      "-webkit-flex: 1 1 auto;\n        " +
      "padding: 5px 15px;\n        " +
      "margin: 10px 0px 30px 0px;\n        " +
      "overflow: auto;\n        " +
      "display: flex;\n        " +
      "align-items: center;\n        " +
      "display: -webkit-flex;\n        " +
      "-webkit-align-items: start;\n        " +
      "font-size: 16px;\n        " +
      "color: #171717;\n        " +
      "text-align: start;\n    " +
      "-webkit-justify-content: start;\n        " +
      "justify-content: start; }\n      " +
      ".msgbox-foot {\n        " +
      "flex: 0 0 60px;\n        " +
      "-webkit-flex: 0 0 60px;\n        " +
      "padding: 10px;\n        " +
      "display: flex;\n        " +
      "align-items: center;\n        " +
      "justify-content: center;\n        " +
      "display: -webkit-flex;\n        " +
      "-webkit-align-items: center;\n        " +
      "-webkit-justify-content: center;\n      }\n      " +
      ".msgbox-btn {\n        " +
      "border: 0;\n        " +
      "border-radius: 4px;\n        " +
      "box-shadow: inset 0 1px 0 rgba(255,255,255,.15), 0 1px 1px rgba(0,0,0,.075);\n        " +
      "text-align: center;\n        " +
      "cursor: pointer;\n        " +
      "margin: 10px 10px 30px 10px;\n        " +
      "padding: 3px 5px;\n        " +
      "font-size: 15px;\n        " +
      "line-height: 30px;\n        " +
      "white-space: nowrap;\n        " +
      "width: 60%;\n      }\n      " +
      ".msgbox-btn-ok {\n        " +
      "background-color: #F03838;\n        " +
      "border: 1px solid #E13356;\n        " +
      "color: #fff;\n      }\n      " +
      ".msgbox-btn-ca {\n        " +
      "border: 1px solid #ddd;\n               " +
      "color: #333333;\n }\n    </style>\n  ";

  $("body").append("<div id=\"" + id + "\">" + styleStr + boxStr + "</div>");

  $("#" + id).fadeIn();

  // 绑定函数
  $("#" + id + " .msgbox-btn-ok").unbind("click").bind("click", function () {

    $("#" + id).fadeOut(400, function () {

      $("#" + id).remove();

      if (typeof box.ok == "function") {

        box.ok();
      }
    });
  });

  $("#" + id + " .msgbox-btn-ca").unbind("click").bind("click", function () {

    $("#" + id).fadeOut(400, function () {

      $("#" + id).remove();

      if (typeof box.cancel == "function") {
        box.cancel();
      }
    });
  });
}