function slider(elem) {
    var items = elem.children(),
        max = items.length - 1,
        animating = false,
        currentElem,
        nextElem,
        pos = 0;

    sync();

    return {
        next: function () {
            move(1);
        },
        prev: function () {
            move(-1);
        },
        itemsNum: items && items.length
    };

    function move(dir) {
        if (animating) {
            return;
        }
        if (dir > 0 && pos == max || dir < 0 && pos == 0) {
            if (dir > 0) {
                nextElem = elem.children('div').first().remove();
                nextElem.hide();
                elem.append(nextElem);
            } else {
                nextElem = elem.children('div').last().remove();
                nextElem.hide();
                elem.prepend(nextElem);
            }
            pos -= dir;
            sync();
        }
        animating = true;
        items = elem.children();
        currentElem = items[pos + dir];
        $(currentElem).fadeIn(1600, function () {
            pos += dir;
            animating = false;
        });
    }

    function sync() {
        items = elem.children();
        for (var i = 0; i < items.length; ++i) {
            items[i].style.display = i == pos ? 'block' : '';
        }
    }

}

(function ($){
    $.Slider = function (state)
    {

        var animating_time = 0.8;

        this.state = state;

        var SlideInter;

        var _this = this;


        this.setState = function(_obj)
        {
            for(var key in _obj)
            {
                _this.state[key] = _obj[key];
            }
            _this.render(_this.state.distance, _this.state.time);

        };

        this.onTouchStart = function (e) {

            // e.preventDefault();

            _this.setState({
                time: 0,
                startX: e.originalEvent.targetTouches[0].pageX
            });
        };

        this.onTouchMove = function (e) {
            e.preventDefault();
            if (_this.state.autoSlide) {
                _this.stopSlideFun();
            }

            var _curX = e.originalEvent.targetTouches[0].pageX;
            var _moveX = _curX - _this.state.startX;
            var _distance = -(_this.state.index * _this.state.baseWidth - _moveX);

            _this.setState({
                curX: _curX,
                moveX: _moveX,
                time: 0,
                distance: _distance
            });
        };

        this.onTouchEnd = function (e) {
            if (Math.abs(_this.state.moveX) <= _this.state.swiper) {
                _this.slideFun('', '.5');
            } else {
                if (_this.state.moveX > _this.state.swiper) {
                    _this.slideFun('prev', '.5');
                } else if (Math.abs(_this.state.moveX) > _this.state.swiper) {
                    _this.slideFun('next', '.5');
                }
            }

            _this.setState({
                moveX: 0
            });
        };
        this.slideOver = function (_index) {
            _this.scrollFun(_index, 0);
            _this.autoSlideFun();
            _this.setState({
                index: _index
            });
        };

        this.slideFun = function (go, time) {

            var _index = _this.state.index;
            if (typeof go === "number") {
                _index = go;
            } else if (go == "next") {
                _index++;
            } else if (go == "prev") {
                _index--;
            }

            // 是否循环滚动
            if (_this.state.continuous) {
                if (_index > _this.state.length) {
                    _this.scrollFun(_index, time);
                    //返回第一个
                    _index = 1;
                    setTimeout(function(){
                        _this.slideOver(_index);
                    }, animating_time * 1000);
                } else if (_index < 1) {
                    _this.scrollFun(_index, time);
                    //返回最后一个
                    _index = _this.state.length;
                    setTimeout(function(){
                        _this.slideOver(_index);
                    }, animating_time * 1000);
                } else {
                    _this.scrollFun(_index, time);
                    _this.setState({
                        index: _index
                    });
                }
            }
            else
            {
                if (_index >=  _this.state.length - _this.state.countPerPage ) {
//                                _index = 0;
                    _index = _this.state.length - _this.state.countPerPage;
                }
                else if (_index < 0) {
//                                _index = _this.state.length - 1;
                    _index = 0;
                }
                _this.scrollFun(_index, time);
                _this.setState({
                    index: _index
                });
            }
        }

        // setInterval 改成 setTimeout，transitionend 加上函数autoSlideFun，其实就实现了循环
        this.autoSlideFun = function () {
            if (_this.state.autoSlide) {
                _this.stopSlideFun();
                SlideInter = setTimeout(function () {
                    _this.slideFun('next', animating_time);
                    //
                    //todo test the switch function

                } ,_this.state.slideSpeed);
            }
        }

        this.scrollFun = function (index, time) {
            _this.setState({
                time: time,
                distance: -(index * _this.state.baseWidth)
            });
        };

        this.stopSlideFun = function () {
            clearInterval(SlideInter);
        }
    }
})(jQuery);
