function findTradingDayInCache(day) {
	var tradingDayCache = window.localStorage.getItem("tradingDayCache" + day);
	return (tradingDayCache != null) ? true : false;
}

function isTradingDayInCache(day) {
	var tradingDayCache = window.localStorage.getItem("tradingDayCache" + day);
	return (tradingDayCache == "true") ? true : false;
}

function cacheTradingDay(day, isTrading) {

	window.localStorage.removeItem("tradingDayCache" + day);
	window.localStorage.setItem("tradingDayCache" + day, isTrading ? "true": "false");
}

function getTodayDate(){
	var d = getBeijingDate();
	var curr_date = d.getDate();
	var curr_month = d.getMonth() + 1;
	var curr_year = d.getFullYear();
	String(curr_month).length < 2 ? (curr_month = "0" + curr_month): curr_month;
	String(curr_date).length < 2 ? (curr_date = "0" + curr_date): curr_date;
	var yyyyMMdd = curr_year + "" + curr_month +""+ curr_date;
	return yyyyMMdd;
}

function getServerDate(callback){
	/*__tsCallTql.send("MszqMobileStock.FundFunction",
		{"CONTROLLER":"fund","FUNCTION":"getSysDate","formatString":"yyyyMMdd"},
		function(data) {
			data= JSON.parse(data);

			if(data.ERR_NO == 0 && data.sys_date)
			{
				callback(data.sys_date);
			}else{
				callback(getTodayDate());
			}
		});*/
	callback(getTodayDate());
}

function getNowTime(){
	var date = getBeijingDate();
	var hour = date.getHours();
	var minute = date.getMinutes();
	hour = (hour > 9) ?  hour + "" : ("0" + hour);
	minute = (minute > 9) ? minute + "" : ("0" + minute);
	return hour + minute;
}


function getBeijingDate(){
	var d = new Date(); //创建一个Date对象 time时间 offset 时区  中国为  8
	var localTime = d.getTime();
	var localOffset = d.getTimezoneOffset() * 60000; //获得当地时间偏移的毫秒数
	var utc = localTime + localOffset; //utc即GMT时间
	var beijingTime = utc + (3600000 * 8);
	return new Date(beijingTime);
}


function getServerTime(callback){
	/*__tsCallTql.send("MszqMobileStock.FundFunction",
		{"CONTROLLER":"fund","FUNCTION":"getSysDate","formatString":"HHmm"},
		function(data) {
			data= JSON.parse(data);
			if (data.ERR_NO == 0 && data.sys_date)
			{
				callback(data.sys_date);
			}else{
				callback(getNowTime());
			}
		});*/
	callback(getNowTime());
}

function verifyTradingDay(day, callback) {

	if (findTradingDayInCache(day))
	{
		callback(isTradingDayInCache(day));
		return;
	}

    __fwCallTql.send("TdxJavaModule:MessageFunction",
		{url: "/calendar/transaction?date=" + day},
		function(data) {
			data= JSON.parse(data);
			if (!data.ERR_NO)
			{
				// GlobalAlert("系统重连中，请稍候");
				return;
			}
            if(data.ERR_NO == 200)
            {
                if(data.ERR_MSG == "true"){
                    cacheTradingDay(day, true);
                    callback(true);
                }else{
                    cacheTradingDay(day, false);
                    callback(false);
                }

            }else{
                //接口出错的时候不缓存结果，只callback
                //cacheTradingDay(day, false);
                callback(false);
            }
		});
}

function isTradingDay(day, callback) {

	if (typeof day == 'undefined' || day == '')
	{
		getServerDate(function (date) {
			verifyTradingDay(date, callback);
		});
		return;
	}

	verifyTradingDay(day, callback);
}

// callback(0)       非交易时间
// callback(1)       交易时间
// startTime传值格式  0900
// endTime传值格式    1500

var syncTime = 0;
// 系统时间--当前时间
function isTradingTimeNow(startTime, stopTime, callback) {

	var date = getBeijingDate();
	if (date.getTime() - syncTime < 1000)
		return;
	syncTime = date.getTime();
	isTradingDay('', function (isTradingDay) {

		if (!isTradingDay)
		{
			callback(0);
			return;
		}

		getServerTime(function (now) {

			if (now >= startTime && now < stopTime)
			{
				callback(1);
			}
			else
			{
				callback(0);
			}
		})
	});
}

// 北京时间--当前时间
function isTradingTime(startTime, stopTime, callback) {
	var date = getBeijingDate();
	if (date.getTime() - syncTime < 1000)
		return;
	syncTime = date.getTime();

	isTradingDay(getTodayDate(), function (isTradingDay) {
		if (!isTradingDay) {
			callback(3);
			return;
		}
		startTime = Number(startTime);
		stopTime = Number(stopTime);
        var now = Number(getNowTime());
		if (now>= startTime && now < stopTime) {
			callback(0);
		}
		else if(now < startTime){
			callback(1);
		}else if(now > stopTime){
			callback(2);
		}
	});
}
