/*
 * 固定参数
 */
var ReqPack = [{}];
/*
 * 判断是否为 IOS 系统
 * true 是IOS  false 非ios
 */
var Check_IOS = function() {
	var xt_type = typeof(navigator.platform) == "undefined" ? "" : navigator.platform.toLowerCase();

	if (xt_type == "ipod" || xt_type == "iphone" || xt_type == "ipad" || xt_type == "iphone simulator" || xt_type == "ipad simulator") {
		return "IOS";
	}
	return "Andorid";
};

/*
 var userAgent = navigator.userAgent.toLowerCase();

 browser = {
 version: (userAgent.match(/.+(?:rv|it|ra|ie)[\/: ]([\d.]+)/) || [0, '0'])[1],
 safari: /webkit/.test(userAgent),
 opera: /opera/.test(userAgent),
 msie: /msie/.test(userAgent) && !/opera/.test(userAgent),
 mozilla: /mozilla/.test(userAgent) && !/(compatible|webkit)/.test(userAgent)
 }
 */

/*
 * IOS函数桥接
 */
var IOS_Bridge = {

	callbacksCount: 1,
	callbacks: {},

	resultForCallback: function resultForCallback(callbackId, resultArray) {
		try {
			var callback = IOS_Bridge.callbacks[callbackId];
			if (!callback) {
				return;
			}
			callback.apply(null, resultArray);
		} catch (e) {
			alert(e);
		}
	},

	/*
	 * functionName: 调用函数名称
	 * args:json 格式参数
	 * callback 回调函数，可有可无
	 */
	call: function call(functionName, args, funcID, frameID, callback) {

		var hasCallback = callback && typeof callback == "function";
		var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;

		if (hasCallback) {
			IOS_Bridge.callbacks[callbackId] = callback;
		}
		var iframe = document.createElement("IFRAME");
		iframe.setAttribute("src", "js-frame:" + functionName + ";;" + callbackId + ";;" + frameID + ";;" + funcID + ";;" + args + ";;" + callback);
		//encodeURIComponent(JSON.stringify(args)));
		document.documentElement.appendChild(iframe);
		iframe.parentNode.removeChild(iframe);
		iframe = null;
	},

	TdxCallTQL: function TdxCallTQL(tdxFuncName, tdxFuncParam, tdxCallBack, tdxPageID) {

		var hasCallback = tdxCallBack && typeof tdxCallBack == "function";
		var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;

		if (hasCallback) {
			IOS_Bridge.callbacks[callbackId] = tdxCallBack;
		}
		var iframe = document.createElement("IFRAME");
		//iframe.setAttribute("src", "tdx-frame:" + functionName + ";;" + frameID + ";;" + funcID + ";;" + args+";;"+callback);
		iframe.setAttribute("src", "tdx-frame:CallTQL;;" + tdxPageID + ";;" + tdxFuncName + ";;" + tdxFuncParam + ";;" + tdxCallBack);
		//encodeURIComponent(JSON.stringify(args)));
		document.documentElement.appendChild(iframe);
		iframe.parentNode.removeChild(iframe);
		iframe = null;
	},

	TdxWebCall: function TdxWebCall(tdxFuncName, tdxFuncParam, tdxCallBack, tdxPageID) {

		var hasCallback = tdxCallBack && typeof tdxCallBack == "function";
		var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;

		if (hasCallback) {
			IOS_Bridge.callbacks[callbackId] = tdxCallBack;
		}
		var iframe = document.createElement("IFRAME");
		//iframe.setAttribute("src", "tdx-frame:" + functionName + ";;" + frameID + ";;" + funcID + ";;" + args+";;"+callback);
		iframe.setAttribute("src", "tdx-frame:WebCall;;" + tdxPageID + ";;" + tdxFuncName + ";;" + tdxFuncParam + ";;" + tdxCallBack);
		//encodeURIComponent(JSON.stringify(args)));
		document.documentElement.appendChild(iframe);
		iframe.parentNode.removeChild(iframe);
		iframe = null;
	}
};



/*
 * 返回当前时间赋值F_RUNTIME
 */
function getRuntime() {
	var date = new Date();
	var now = "";
	now = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	return now;
}


/*
 * 获取 function 名称
 * 不处理 var xx = function(){}; 此种方式
 */
function Fun_Name(funname) {
	var tmp = funname.toString();
	var re = /function\s*(\w*)/i;
	var matches = re.exec(tmp);
	//alert("name:" +matches[1]);
	return matches[1];
}


/*
 * 移动平台调用
 * callback_name： 回调函数名
 * funid： 功能号
 * _parm： 请求参数对象 设置好的IXContent对象
 * _url： web端调用ajax 请求地址 （可送''）
 * _webtype：web端调用ajax 请求类型 web用属必送字段 post/get
 * _webdatatype：web端调用ajax 数据传输类型 web用属必送字段 text/json/....  如果是ix 字符串，则数据传输为text
 * SPEC： ix_js ToRequest 请求设置（可送''）
 * STRUCT： ix_js ToRequest 请求设置（可送''）
 * _mob_system： 移动平台送 系统标示 （非移动平台送''）
 * _mob_formid： 移动平台用框架ID （非移动平台送''）
 * _mob_taget： Android 平台用，如交易送'JY','TP'
 * _mob_ard_funcname：Android 平台用，后台功能模块名称 如'FuncID:'
 */
function Win_CallTQL(callback_name, funid, _parm, _url, _webtype, _webdatatype, SPEC, STRUCT, _mob_system, _mob_formid, _mob_taget, _mob_ard_funcname) {
	if (_mob_system == "IOS") {
		IOS_Bridge.call("Get_Ret", _parm.Value(), funid, _mob_formid, callback_name);
	} else {
		//如 FuncID:114
		var ardfun = _mob_ard_funcname + ':' + funid;
		window.tdx_java.Android_SendData(_mob_formid, ardfun, _mob_taget, _parm.Length(), _parm.Value(), callback_name);
	}
}



/*
 * 交易应答
 * formid：框架ID
 * funcid：功能号ID
 * flagtype：0：成功 ，1：失败
 * _data：返回的json 数据
 * callbackname : 回调函数
 */
function Get_Ret(formid, funcid, flagtype, _data, callbackname) {
	window.frames["Main_Frame"].Cmd_cbk(formid, funcid, flagtype, _data, callbackname);
}

function Cmd_cbk(formid, funcid, flagtype, _data, callbackname) {
	callbackname(formid, funcid, flagtype, _data);
}


/*
 * 页面跳转
 */
function Ref_url(_url) {
	location.href = _url;
}


/*
 * 定义 IXContent
 */
var IXContent = function() {
	this.ret = "";
	this.retcnt = [];
	this.retlength = 0;
}

IXContent.prototype = {
	Set: function(k, v) {
		if ($.trim(k) == "") {
			alert("当前键对获取为NULL，不予录入，请输入键值对");
			return;
		} else {

			if (typeof(v) == 'string') {
				this.retcnt.push("\"" + k + "\":" + "\"" + v + "\"");
			} else if (typeof(v) == 'number') {
				this.retcnt.push("\"" + k + "\":" + v);
			} else {
				var _cnts = [];
				$.each(v, function(n, m) {
					if (typeof(m) == 'string') {
						_cnts.push("\"" + k + "\":" + "\"" + v + "\"");
					} else {
						_cnts.push("\"" + k + "\":" + v);
					}
				});
				this.retcnt.push("\"" + k + "\":{" + this.retcnt.join(',') + "}");
			}
			this.retlength++;
		}
	},

	Length: function() {
		return this.retlength;
	},

	Value: function() {
		return "[{" + this.retcnt.join(',') + "}]";
		// this.ret = "{" + this.retcnt.join(',') + "}";
		// return $.parseJSON(this.ret);
	}
}



function stringToBytes(str) {
	var ch, st, re = [];
	for (var i = 0; i < str.length; i++) {
		ch = str.charCodeAt(i);
		st = [];
		do {
			st.push(ch & 0xFF);
			ch = ch >> 8;
		} while (ch);
		re = re.concat(st.reverse());
	}
	return re;
}

var request = {
	QueryString: function(val) {
		var url = window.location.search;
		var re = new RegExp("" + val + "=([^&?]*)", "ig");
		return ((url.match(re)) ? (url.match(re)[0].substr(val.length + 1)) : null);
	}
}

/*
 * 获取url信息
 */
function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if (r != null) {

		return unescape(r[2]);
	}
	return null;
}

/*
 * 返回币种信息
 */
function Return_BZ(rid) {

	var bz = "";

	switch (rid) {
		case "0":
			bz = "人民币";
			break;

		case "1":
			bz = "美元";
			break;

		case "2":
			bz = "港币";
			break;
	}

	return bz;
}

/*
 * 是否显示输入密码框
 */
function Show_mcdd(sid) {

	var _sid = sid.split('-');

	switch (_sid[3]) {
		case "0":
			//都不显示
			$("#yh_div").css({
				"display": "none"
			});
			$("#zj_div").css({
				"display": "none"
			});
			break;

		case "1":
			//银行密码
			$("#yh_div").css({
				"display": ""
			});
			$("#zj_div").css({
				"display": "none"
			});
			break;

		case "2":
			//资金密码
			$("#yh_div").css({
				"display": "none"
			});
			$("#zj_div").css({
				"display": ""
			});
			break;

		default:
			//都显示
			$("#yh_div").css({
				"display": ""
			});
			$("#zj_div").css({
				"display": ""
			});
			break;
	}
}

/*
 * 解析提交的应答
 */
function Return_Reply(_json) {
	var _ret = "";

	for (var i = 2; i < _json.length; i++) {
		$.each(_json[0], function(n, m) {

			if (m == "0") {
				if (_json[i][n] != "") {
					_ret += _json[1][n] + ":" + _json[i][n];
				}
			}
		});
	}

	return _ret;
}

/*
 * 获取股东名称
 */
function Return_Gdmc(gdid) {
	var GDMC = "";

	switch (gdid) {
		case "0":
			GDMC = "深A";
			break;

		case "1":
			GDMC = "沪A";
			break;

		case "2":
			GDMC = "深B";
			break;

		case "3":
			GDMC = "沪B";
			break;

		case "12":
			GDMC = "三板A";
			break;

		case "13":
			GDMC = "三板B";
			break;
	}
	return GDMC;

}

/*
 * 自定义样式
 */
function setStyle(_style) {
	var css = document.createElement('style');
	css.setAttribute('type', 'text/css');
	// var cssText = 'label{color:Red;font-size:;} input[type="button"]{font-size:;}';
	var cssText = _style;
	if (css.styleSheet) { // IE
		css.styleSheet.cssText = cssText;
	} else {
		css.appendChild(document.createTextNode(cssText));
	}
	document.getElementsByTagName("head")[0].appendChild(css);
}

/*
 * 设置主题
 */
function setTheme(_theme) {

	if (_theme.length > 0) {

		var themeHref = "../css/" + _theme + ".css";
		$("#csslink").attr("href", themeHref);
	}
}



/*********** 框架层数据获取 *****************/


var _fm_system = '';

function BaseInfo() {
	_fm_system = Check_IOS();
	//获取
	var ix = new IXContent();
	ix.Set("zjxx", 'loc');
	Win_CallTQL('Global_Variables', 'uinfo', ix, '', '', '', '', '', _fm_system, '0', 'JY', 'FuncID');

}

/*
 * 独立缓存获取
 */
function Global_Variables(_formid, funcid, flagtype, _json) {
	localStorage.clear();
	var _temp = $.parseJSON(_json);
	localStorage.setItem("wtfs", $.trim(_temp['wtfs']));
	localStorage.setItem("gddm", $.trim(_temp['gddm']));
	localStorage.setItem("khh", $.trim(_temp['khh']));
	localStorage.setItem("zjzh", $.trim(_temp['zjzh']));
	localStorage.setItem("mob_system", _fm_system);

	StartFun();

}


/*
*设置DPI
*/
(function(){
	var Paltform;
	try{
		Paltform=Check_IOS();
	}
		catch(e){
	}
	if (Paltform=='Andorid'){
		try{
			var _text=window.tdxJy_java.Andorid_Dpi();
			$("#devicepdi").attr("content", "width=device-width, height=device-height, initial-scale=1.0, maximum-scale=1.0, target-densitydpi="+_text);
		}
		catch(e){}
	}

	//tdx_zy添加
	SetTelephone();
})();


function SetTelephone(){
	var ms=document.getElementsByTagName('meta');
	var p=ms[ms.length-1].parentNode;

	for(var i=0;i<ms.length;i++){
      if(ms[i].getAttribute('name')=='format-detection'){
      	ms[i].setAttribute('content',"telephone=no");
      	return;
      }
    }

	var meta =document.createElement('meta');
	meta.content = 'telephone=no';
	meta.name = 'format-detection';
	p.appendChild(meta);
}