/*
作者: tdx_zy
说明: 依赖raphael.js自绘
用法: 必须注册才可用
*/

var tdxPaperDraw={
//注册入ToRaphael中；画布对象可以直接调用
RegisterToRaphael : function (Paper){
	Paper.__proto__.tdxSector=tdxPaperDraw.Sector;
	Paper.__proto__.tdxPie=tdxPaperDraw.Pie;
	Paper.__proto__.tdxRing=tdxPaperDraw.Ring;
	Paper.__proto__.tdxLabel=tdxPaperDraw.Label;
	Paper.__proto__.tdxDayFund=tdxPaperDraw.DayFund;
	Paper.__proto__.tdxDayFundTDX=tdxPaperDraw.DayFundTDX;
},

/*
标准的元素
扇形(顺时针方向;角度-360;)
params:圆心X，圆心Y，半径R，扇形角度Angle，离X轴角度Angle，截取的半径cutR(不能大于半径)
注意:圆形不要这个
*/
Sector : function (centerPx,centerPy,R,Angle,AngleToX,cutR){
	if(this instanceof Raphael){
		tdxPaperDraw.Sector.Paper=this; //Sector.Paper中转用，不能用在画图
	}
	if(!(this instanceof tdxPaperDraw.Sector)){
		return new tdxPaperDraw.Sector(centerPx,centerPy,R,Angle,AngleToX,cutR);
	}
	if(tdxPaperDraw.Sector.Paper){
		this.Paper=tdxPaperDraw.Sector.Paper; //this.Paper是该画布
	}
	if(arguments.length<5){
		this.centerPx=0;
		this.centerPy=0;
		this.R=0;
		this.Angle=0;
		this.AngleToX=0;
		this.cutR=0;
		this.AngleCenter=0; //扇形中线与X轴方向的角度
	}
	else{
		this.centerPx= centerPx;
		this.centerPy= centerPy;
		this.R= R;
		this.Angle= ((Angle%360)/180)*Math.PI;
		this.AngleToX= ((AngleToX%360)/180)*Math.PI; 
		this.cutR=0;
		if(!!cutR && TdxUtils.isNumber(cutR)){
			this.cutR=cutR;
		}
		if(this.cutR>=this.R){
			this.cutR=0;
		}
		this.AngleCenter=this.AngleToX+this.Angle/2;
	}

	if(this.Paper && this.R>0 && Math.abs(this.Angle)>0){
		var benginP={
			x: this.centerPx+Math.cos(this.AngleToX)*this.R,
			y: this.centerPy+Math.sin(this.AngleToX)*this.R
		};
		var endP={
			x: this.centerPx+Math.cos(this.Angle+this.AngleToX)*this.R,
			y: this.centerPy+Math.sin(this.Angle+this.AngleToX)*this.R
		};

		var benginP_cutR={
			x: this.centerPx+Math.cos(this.AngleToX)*this.cutR,
			y: this.centerPy+Math.sin(this.AngleToX)*this.cutR
		};
		var endP_cutR={
			x: this.centerPx+Math.cos(this.Angle+this.AngleToX)*this.cutR,
			y: this.centerPy+Math.sin(this.Angle+this.AngleToX)*this.cutR
		};
	
		var bigarg='1';
		if ((Math.abs(this.Angle))<Math.PI){
			bigarg='0';
		}
		var ssz='1';
		if (this.Angle<0){
			ssz='0';
		}
		var PathLine=''
		if(this.cutR===0){
			PathLine='M'+this.centerPx+','+this.centerPy+' ';
			PathLine+='L'+benginP.x+','+benginP.y+' ';
			PathLine+='A'+this.R+','+this.R+',0,'+bigarg+','+ssz+','+endP.x+','+endP.y+' ';
			PathLine+='Z'+this.centerPx+','+this.centerPy;
		}
		else{

			PathLine='M'+benginP_cutR.x+','+benginP_cutR.y+' ';
			PathLine+='L'+benginP.x+','+benginP.y+' ';
			PathLine+='A'+this.R+','+this.R+',0,'+bigarg+','+ssz+','+endP.x+','+endP.y+' ';
			PathLine+='L'+endP_cutR.x+','+endP_cutR.y+' ';
			if(ssz=='1'){ssz='0'}
			else{ssz='1'}
			PathLine+='A'+this.cutR+','+this.cutR+',0,'+bigarg+','+ssz+','+benginP_cutR.x+','+benginP_cutR.y+' ';
		}
		
		var pathobj=this.Paper.path(PathLine);
		TdxUtils.merge(this,pathobj); //使this能调用原始方法
	}
},

/*
非标准的元素
饼图(顺时针方向;角度-360;)
params:圆心X，圆心Y，半径R，截取的半径cutR(不能大于半径)
*/
Pie : function (centerPx,centerPy,R,cutR,OffCenter){
	if(this instanceof Raphael){
		tdxPaperDraw.Pie.Paper=this;
	}
	if(!(this instanceof tdxPaperDraw.Pie)){
		return new tdxPaperDraw.Pie(centerPx,centerPy,R,cutR,OffCenter);
	}
	if(tdxPaperDraw.Pie.Paper){
		this.Paper=tdxPaperDraw.Pie.Paper; //this.Paper是该画布
	}
	this.centerPx=0;
	this.centerPy=0;
	this.R=0;
	this.cutR=0;
	this.OffCenter=0; //离心px
	if(arguments.length===5){
		this.centerPx=centerPx;
		this.centerPy=centerPy;
		this.R=R;
		this.cutR=cutR;
		this.OffCenter=OffCenter;
	}
	if(this.R<this.cutR){this.cutR=0;}
	if(this.Paper && this.R>0 && this.R>this.cutR){
		this.SectorSet=this.Paper.set();
	}

	/*
	data: [{},{}]
	总和比例不能超过100% 比例值:0-100
	*/
	this.setPieData=function(data){
		if(this.Paper){
			this.SectorSet.remove();
			var AngleToX=0;
			for(var i=0;i<data.length;i++){
				var val=data[i].val;
				if(val>100 || val<=0){continue;}
				var lable=data[i].lable;
				var color=data[i].color;
				var Sector=this.Paper.tdxSector(this.centerPx,this.centerPy,this.R,val/100*360,AngleToX,this.cutR);
				AngleToX+=val/100*360;
				//离心平移
				if(this.OffCenter>0){
					var Tx=Math.cos(Sector.AngleCenter)*this.OffCenter;
					var Ty=Math.sin(Sector.AngleCenter)*this.OffCenter;
					Sector.transform('t'+Tx+','+Ty);
				}
				//属性
				Sector.attr({
					'fill' : color,
					'stroke-width':0,
				});
				//毛边
				//Sector.glow({});


				this.SectorSet.push(Sector);
			}
		}
	};
},

/*
非标准的元素
环形图(顺时针方向;角度-360;)
params:圆心X，圆心Y，半径R，截取的半径cutR(不能大于半径)，截取像素cutPX
*/
Ring : function (centerPx,centerPy,R,cutR,cutPX){
	if(this instanceof Raphael){
		tdxPaperDraw.Ring.Paper=this;
	}
	if(!(this instanceof tdxPaperDraw.Ring)){
		return new tdxPaperDraw.Ring(centerPx,centerPy,R,cutR,cutPX);
	}
	if(tdxPaperDraw.Ring.Paper){
		this.Paper=tdxPaperDraw.Ring.Paper;
	}
	this.Label=this.Paper.tdxLabel(); //标签
	this.PathSet=this.Paper.set();
	this.centerPx=0;
	this.centerPy=0;
	this.R=0;
	this.cutR=0;
	this.cutPX=1; //px
	if(arguments.length===5){
		this.centerPx=centerPx;
		this.centerPy=centerPy;
		this.R=R;
		this.cutR=cutR;
		this.cutPX=cutPX/2;
	}
	if(this.R<this.cutR && this.cutR<=0){this.cutR=this.R/2;}
	if(this.cutPX<=0){this.cutPX=1;}
	/*
	data: [{},{}]
	总和比例不能超过100% 比例值:0-100
	*/
	this.setRingData=function(data){
		function A(R){
			var x=Math.sqrt(R*R-this.cutPX*this.cutPX);

			return Raphael.angle(0,0,-x,-this.cutPX)/360*2*Math.PI;
		};
		function P(angle,R){
			var D={
				x: this.centerPx+Math.cos(angle)*R,
				y: this.centerPy+Math.sin(angle)*R
			};

			return D;
		};
		var angle1=A.call(this,this.cutR);
		var angle2=A.call(this,this.R);
		if(this.PathSet){this.PathSet.remove();}

		var LabelList=[];
		if(this.Paper){
			var AngleToX=0;
			for(var i=0;i<data.length;i++){
				var val=data[i].val;
				if(val>100 || val<=0){continue;}
				var lable=data[i].lable;
				var color=data[i].color;
				var angle=val/100*2*Math.PI+AngleToX;
				var centangle=val/100*2*Math.PI/2+AngleToX; //中线
				
				var cetP={
					x : this.centerPx+Math.cos(centangle)*(this.R+10),
					y : this.centerPy+Math.sin(centangle)*(this.R+10),
				}
				if(centangle>=0 && centangle<Math.PI/4){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'left',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
				}
				else if(centangle>=Math.PI/4 && centangle<Math.PI/2){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'top',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
				}
				else if(centangle>=Math.PI/2 && centangle<Math.PI*3/4){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'top',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
				}
				else if(centangle>=Math.PI*3/4 && centangle<Math.PI){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'right',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
				}
				else if(centangle>=Math.PI && centangle<Math.PI*5/4){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'right',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
				}
				else if(centangle>=Math.PI*5/4 && centangle<Math.PI*3/2){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'bottom',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
				}
				else if(centangle>=Math.PI*3/2 && centangle<Math.PI*7/4){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'bottom',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
				}
				else if(centangle>=Math.PI*7/4 && centangle<Math.PI*2){
					LabelList.push({x:cetP.x,y:cetP.y,pos:'left',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
				}

				//内弧线点
				var p1=P.call(this,AngleToX+angle1,this.cutR);
				var p2=P.call(this,angle-angle1,this.cutR);
				
				//外弧线点
				var p3=P.call(this,AngleToX+angle2,this.R);
				var p4=P.call(this,angle-angle2,this.R);
				var bigarg='1';
				if(val<=51.5){
					bigarg='0';
				}

				var PathLine='M'+p1.x+','+p1.y+' ';
				PathLine+='L'+p3.x+','+p3.y+' ';
				PathLine+='A'+this.R+','+this.R+',0,'+bigarg+',1,'+p4.x+','+p4.y+' ';
				PathLine+='L'+p2.x+','+p2.y+' ';
				PathLine+='A'+this.cutR+','+this.cutR+',0,'+bigarg+',0,'+p1.x+','+p1.y+' ';
				var pathobj=this.Paper.path(PathLine);
				//毛边
				/*this.PathSet.push(pathobj.glow({
					width:1,
					fill:true,
					opacity:0.85,
					color:color,
				}));*/
				//属性
				pathobj.attr({
					'fill' : color,
					'stroke-width':0,
					'stroke':color,
				});
				this.PathSet.push(pathobj);
				AngleToX+=val/100*2*Math.PI;
			}
		
			this.Label.setLabelData(LabelList);

		}
	};
},


/*
非标准的元素
Lable图(顺时针方向;角度-360;)
params:位置X，位置Y，箭头Pos=['left','top','right','bottom']
*/
Label : function(){
	if(this instanceof Raphael){
		tdxPaperDraw.Label.Paper=this;
	}
	if(!(this instanceof tdxPaperDraw.Label)){
		return new tdxPaperDraw.Label();
	}
	if(tdxPaperDraw.Label.Paper){
		this.Paper=tdxPaperDraw.Label.Paper;
	}
	this.PathSet=this.Paper.set();

	this.Draw=function(Px,Py,Pos,W,H,Angle1,Angle2,AngleH,LabelClr,LabelTextClr,LabelText){
		if(!LabelTextClr){LabelTextClr='#000000'}
		if (Pos=='top'){
			var p1={
				x : Px-AngleH/Math.tan(Angle1),
				y : Py+AngleH
			};
			var p2={
				x1 : p1.x+W/2,
				y1 : p1.y,
				x2 : p1.x+W/2,
				y2 : p1.y+H,
				x3 : p1.x-W/2,
				y3 : p1.y+H,
				x4 : p1.x-W/2,
				y4 : p1.y,
			};
			var p3={
				x : Px-AngleH/Math.tan(Angle2),
				y : Py+AngleH
			};
			var centP={
				x : (p2.x1-p2.x4)/2+p2.x4,
				y : (p2.y2-p2.y1)/2+p2.y1,
			};

			var PathLine='M'+Px+','+Py+' ';
			PathLine+='L'+p1.x+','+p1.y+' ';
			PathLine+='L'+p2.x1+','+p2.y1+' ';
			PathLine+='L'+p2.x2+','+p2.y2+' ';
			PathLine+='L'+p2.x3+','+p2.y3+' ';
			PathLine+='L'+p2.x4+','+p2.y4+' ';
			PathLine+='L'+p3.x+','+p3.y+' ';
			PathLine+='Z'+Px+','+Py;
			var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
			this.PathSet.push(pathobj);
			this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
		}
		else if(Pos=='left'){
			var p1={
				x : Px+AngleH,
				y : Py+AngleH/Math.tan(Angle1),
			};
			var p2={
				x1 : p1.x,
				y1 : p1.y-H/2,
				x2 : p1.x+W,
				y2 : p1.y-H/2,
				x3 : p1.x+W,
				y3 : p1.y+H/2,
				x4 : p1.x,
				y4 : p1.y+H/2,
			};
			var p3={
				x : Px+AngleH,
				y : Py+AngleH/Math.tan(Angle2),
			};
			var centP={
				x : (p2.x2-p2.x1)/2+p2.x1,
				y : (p2.y3-p2.y2)/2+p2.y2,
			};

			var PathLine='M'+Px+','+Py+' ';
			PathLine+='L'+p1.x+','+p1.y+' ';
			PathLine+='L'+p2.x1+','+p2.y1+' ';
			PathLine+='L'+p2.x2+','+p2.y2+' ';
			PathLine+='L'+p2.x3+','+p2.y3+' ';
			PathLine+='L'+p2.x4+','+p2.y4+' ';
			PathLine+='L'+p3.x+','+p3.y+' ';
			PathLine+='Z'+Px+','+Py;
			var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
			this.PathSet.push(pathobj);
			this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
		}
		else if(Pos=='right'){
			var p1={
				x : Px-AngleH,
				y : Py+AngleH/Math.tan(Angle1),
			};
			var p2={
				x1 : p1.x,
				y1 : p1.y-H/2,
				x2 : p1.x-W,
				y2 : p1.y-H/2,
				x3 : p1.x-W,
				y3 : p1.y+H/2,
				x4 : p1.x,
				y4 : p1.y+H/2,
			};
			var p3={
				x : Px-AngleH,
				y : Py+AngleH/Math.tan(Angle2),
			};
			var centP={
				x : (p2.x2-p2.x1)/2+p2.x1,
				y : (p2.y2-p2.y3)/2+p2.y3,
			};
			var PathLine='M'+Px+','+Py+' ';
			PathLine+='L'+p1.x+','+p1.y+' ';
			PathLine+='L'+p2.x1+','+p2.y1+' ';
			PathLine+='L'+p2.x2+','+p2.y2+' ';
			PathLine+='L'+p2.x3+','+p2.y3+' ';
			PathLine+='L'+p2.x4+','+p2.y4+' ';
			PathLine+='L'+p3.x+','+p3.y+' ';
			PathLine+='Z'+Px+','+Py;
			var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
			this.PathSet.push(pathobj);
			this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
		}
		else if (Pos=='bottom'){
			var p1={
				x : Px-AngleH/Math.tan(Angle1),
				y : Py-AngleH
			};
			var p2={
				x1 : p1.x+W/2,
				y1 : p1.y,
				x2 : p1.x+W/2,
				y2 : p1.y-H,
				x3 : p1.x-W/2,
				y3 : p1.y-H,
				x4 : p1.x-W/2,
				y4 : p1.y,
			};
			var p3={
				x : Px-AngleH/Math.tan(Angle2),
				y : Py-AngleH
			};
			var centP={
				x : (p2.x3-p2.x2)/2+p2.x2,
				y : (p2.y2-p2.y1)/2+p2.y1,
			};
			var PathLine='M'+Px+','+Py+' ';
			PathLine+='L'+p1.x+','+p1.y+' ';
			PathLine+='L'+p2.x1+','+p2.y1+' ';
			PathLine+='L'+p2.x2+','+p2.y2+' ';
			PathLine+='L'+p2.x3+','+p2.y3+' ';
			PathLine+='L'+p2.x4+','+p2.y4+' ';
			PathLine+='L'+p3.x+','+p3.y+' ';
			PathLine+='Z'+Px+','+Py;
			var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
			this.PathSet.push(pathobj);
			this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
		}
	};
	
	/*
	data: [{},{}]
	*/
	this.setLabelData=function(data){
		var Px=0;
		var Py=0;
		var Pos='left';
		if(this.PathSet){this.PathSet.remove();}
		for(var i=0;i<data.length;i++){
			var W=50; //宽
			var H=26; //高
			var Angle1=2*Math.PI*(60)/360;
			var Angle2=2*Math.PI*(45)/360;
			var AngleH=12;
			var LabelText='';
			var LabelClr='#000000';
			var LabelTextClr='#000000';
			Px=data[i].x;
			Py=data[i].y;
			Pos=data[i].pos;
			if(data[i].hasOwnProperty('w')){W=data[i].w;}
			if(data[i].hasOwnProperty('h')){H=data[i].h;}
			if(data[i].hasOwnProperty('angle1')){Angle1=2*Math.PI*(data[i].angle1)/360;}
			if(data[i].hasOwnProperty('angle2')){Angle2=2*Math.PI*(data[i].angle2)/360;}
			if(data[i].hasOwnProperty('angleH')){AngleH=data[i].angleH;}
			if(data[i].hasOwnProperty('labeltext')){LabelText=data[i].labeltext;}
			if(data[i].hasOwnProperty('labelclr')){LabelClr=data[i].labelclr;}
			if(data[i].hasOwnProperty('labeltextclr')){LabelTextClr=data[i].labeltextclr;}
			this.Draw(Px,Py,Pos,W,H,Angle1,Angle2,AngleH,LabelClr,LabelTextClr,LabelText);
		}
	};
},

/*
非标准的元素
DayFund:资金图
params:centerPx,centerPy,标题,单位
*/
DayFund : function(centerPx,centerPy,title,unit){
	if(this instanceof Raphael){
		tdxPaperDraw.DayFund.Paper=this;
	}
	if(!(this instanceof tdxPaperDraw.DayFund)){
		return new tdxPaperDraw.DayFund(centerPx,centerPy,title,unit);
	}
	if(tdxPaperDraw.DayFund.Paper){
		this.Paper=tdxPaperDraw.DayFund.Paper;
	}
	this.PathSet=this.Paper.set();
	this.x=centerPx;
	this.y=centerPy;
	this.title=title;
	this.unit=unit;
	this.BarW=40;
	this.BarH=25;
	this.BarDis=20;

	this.CenterTitle={
		x : this.x,
		y : this.y-this.BarH-20
	};

	this.CenterBar={
		x : this.x,
		y : this.y
	};

	/*
	data: [[],[]]
	日期，数据
	*/
	this.setDayFundData=function(data){
		if(this.PathSet){this.PathSet.remove();}
		if(data && data.length==2){
			var Left=0;
			var Count=Math.min(data[0].length,data[1].length);
			if(!!Count){
				var WBar=Count*this.BarW+Count*this.BarDis;
				Left=Math.max(0,this.x-WBar/2);
				
				//Title
				this.PathSet.push(this.Paper.text(Left+WBar/2, this.CenterTitle.y, this.title).attr({
					'fill':g_TDX_Font_2,
					'font-size':14,
					'font-weight':'bold',
				})); 
				//中线
				this.PathSet.push( this.Paper.rect(Left, this.CenterBar.y, WBar, 2).attr({
					'fill':'#c2c2c2',
					'stroke-width':0
				}));
				//bar
				var Labs=data[1].map(function(elm){return Math.abs(elm)});
				var ValMax=Math.max.apply(Math, Labs);
				var ValMin=Math.min.apply(Math, Labs);
				var valtopx=0.00;
				var valBegin=ValMin;
				if(ValMax===ValMin){valtopx=this.BarH/ValMax;}
				else{
					valtopx=this.BarH/(ValMax-ValMin);
				}

				Left+=this.BarDis/2;
				
				for(var i=0;i<Count;i++){
					var px=valtopx*(Math.abs(data[1][i])-valBegin);
					if(px===0){px=2;}
					if(data[1][i]<0){
						var pathobj=this.Paper.rect(Left, this.CenterBar.y+2, this.BarW, px).attr({
							'fill':g_TDX_Font_4,
							'stroke':g_TDX_Font_4,
							'stroke-width':0
						});
						this.PathSet.push(pathobj);
						//毛边
						pathobj.glow({
							width:2,
							fill:false,
							opacity:0.3,
							color:g_TDX_Font_4,
						});
						this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y-10, data[1][i]).attr({
							'fill':g_TDX_Font_4
						})); 
					}
					else{
						var pathobj=this.Paper.rect(Left, this.CenterBar.y-px, this.BarW, px).attr({
							'fill':g_TDX_Font_3,
							'stroke':g_TDX_Font_3,
							'stroke-width':0
						});
						this.PathSet.push(pathobj);
						//毛边
						pathobj.glow({
							width:2,
							fill:false,
							opacity:0.3,
							color:g_TDX_Font_3,
						});
						this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+10, data[1][i]).attr({
							'fill':g_TDX_Font_3
						})); 
					}
					this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+this.BarH+15, data[0][i]).attr({
						'fill':'#c2c2c2',
						'font-size':14
					})); 
					Left+=this.BarDis+this.BarW;
				}

				//资金流入 资金流出
				Left=Math.max(0,this.x-WBar/2)+this.BarDis/2;
				Top=this.CenterBar.y+this.BarH+45;
				this.PathSet.push(this.Paper.circle(Left, Top, 3).attr({
					'fill':g_TDX_Font_3,
					'stroke-width':0
				}));
				Left+=10;
				this.PathSet.push(this.Paper.text(Left, Top, '资金流入').attr({
					'fill':'#c2c2c2',
					'font-size':14,
					'font-weight':'bold',
					'text-anchor':'start'
				}));
				Left+=75;
				this.PathSet.push(this.Paper.circle(Left, Top, 3).attr({
					'fill':g_TDX_Font_4,
					'stroke-width':0
				}));
				Left+=10;
				this.PathSet.push(this.Paper.text(Left, Top, '资金流出').attr({
					'fill':'#c2c2c2',
					'font-size':14,
					'font-weight':'bold',
					'text-anchor':'start'
				}));

				Left+=85;
				this.PathSet.push(this.Paper.text(Left, Top, this.unit).attr({
					'fill':'#c2c2c2',
					'font-size':14,
					'font-weight':'bold',
					'text-anchor':'start'
				}));

			}
		}
	}
},

/*
非标准的元素
DayFundTDX:TDX资金图
params:centerPx,centerPy,标题,单位
*/
DayFundTDX : function(centerPx,centerPy,title,unit){
	if(this instanceof Raphael){
		tdxPaperDraw.DayFundTDX.Paper=this;
	}
	if(!(this instanceof tdxPaperDraw.DayFundTDX)){
		return new tdxPaperDraw.DayFundTDX(centerPx,centerPy,title,unit);
	}
	if(tdxPaperDraw.DayFundTDX.Paper){
		this.Paper=tdxPaperDraw.DayFundTDX.Paper;
	}
	this.PathSet=this.Paper.set();
	this.x=centerPx;
	this.y=centerPy;
	this.title=title;
	this.unit=unit;
	this.BarW=50;
	this.BarH=25;
	this.BarDis=20;

	this.BarH0=25;
	this.CenterBar={
		x : this.x,
		y : this.y
	};
	this.CenterBar0={
		x : this.x,
		y : this.y-this.BarH-this.BarH0/2-20
	};
	this.CenterTitle={
		x : this.x,
		y : this.CenterBar0.y-this.BarH0/2-40
	};
	
	/*
	data: [[],[]]
	数据，数据
	*/
	this.setDayFundDataTDX=function(data){
		if(this.PathSet){this.PathSet.remove();}
		if(data && data.length==3){
			var Left=0;
			var Count=data[1].length;
			if(!!Count){
				var WBar=Count*this.BarW+Count*this.BarDis;
				Left=Math.max(0,this.x-WBar/2);
				
				//Title
				this.PathSet.push(this.Paper.text(Left+WBar/2, this.CenterTitle.y, this.title).attr({
					'fill':g_TDX_Font_2,
					'font-size':14,
					'font-weight':'bold',
				})); 
				//bar0
				if(data[0].length===2){
					WBar=200;
					Left=Math.max(0,this.x-WBar/2)
					var CZ=data[0][0]-data[0][1];
					CZ=CZ.toFixed(1);
					var CZclr=g_ZJLX_CLR_4;
					if(CZ<0){
						CZclr=g_ZJLX_CLR_1;
					}

					var zbRed=0.5;
					var zbGreed=0.5;
					if(data[0][0]+data[0][1]!=0){
						zbRed=data[0][0]/(data[0][0]+data[0][1]);
						zbGreed=data[0][1]/(data[0][0]+data[0][1]);
					}
					var TextRed='买('+(zbRed*100).toFixed(0)+'%)\n'+data[0][0];
					var TextGreen='卖('+(100-(zbRed*100).toFixed(0))+'%)\n'+data[0][1];
					var LenRed=zbRed*WBar;
					var LenGreen=zbGreed*WBar;
					var pathobjRed=this.Paper.rect(Left, this.CenterBar0.y-this.BarH0/2, LenRed, this.BarH0).attr({
						'fill':g_ZJLX_CLR_4,
						'stroke':'none',
						'stroke-width':0
					});
					//毛边
					/*this.PathSet.push(pathobjRed.glow({
						width:2,
						fill:false,
						opacity:0.3,
						color:g_ZJLX_CLR_4,
					}));*/
					this.PathSet.push(pathobjRed);
					
					var pathobjGreen=this.Paper.rect(Left+LenRed, this.CenterBar0.y-this.BarH0/2, LenGreen, this.BarH0).attr({
						'fill':g_ZJLX_CLR_1,
						'stroke':'none',
						'stroke-width':0
					});
					//毛边
					/*this.PathSet.push(pathobjGreen.glow({
						width:2,
						fill:false,
						opacity:0.3,
						color:g_ZJLX_CLR_1,
					}));*/
					this.PathSet.push(pathobjGreen);

					this.PathSet.push( this.Paper.rect(this.CenterBar0.x-1, this.CenterBar0.y-this.BarH0/2, 2, this.BarH0).attr({
						'fill':g_TDX_Line_1,
						'stroke-width':0,
						'stroke':'none',
					}));

					this.PathSet.push(this.Paper.text(this.CenterBar0.x, this.CenterBar0.y-this.BarH0/2-15, CZ).attr({
						'fill':CZclr,
						'font-size':12,
					})); 


					this.PathSet.push(this.Paper.text(Left-2, this.CenterBar0.y, TextRed).attr({
						'fill':g_ZJLX_CLR_4,
						'font-size':12,
						'text-anchor': 'end',
					})); 

					this.PathSet.push(this.Paper.text(Left+WBar+2, this.CenterBar0.y, TextGreen).attr({
						'fill':g_ZJLX_CLR_1,
						'font-size':12,
						'text-anchor': 'start',
					})); 
				}
				
				WBar=Count*this.BarW+Count*this.BarDis;
				Left=Math.max(0,this.x-WBar/2);
				//中线
				this.PathSet.push( this.Paper.rect(Left, this.CenterBar.y, WBar, 2).attr({
					'fill':g_TDX_Line_1,
					'stroke-width':0,
					'stroke':'none',
				}));
				//bar
				var Labs=data[1].map(function(elm){return Math.abs(elm)});
				var ValMax=Math.max.apply(Math, Labs);
				var ValMin=Math.min.apply(Math, Labs);
				var valtopx=0.00;
				var valBegin=ValMin;
				if(ValMax===ValMin){valtopx=this.BarH/ValMax;}
				else{
					valtopx=this.BarH/(ValMax-ValMin);
				}
				Left+=this.BarDis/2;
				for(var i=0;i<Count;i++){
					var px=valtopx*(Math.abs(data[1][i])-valBegin);
					if(px===0){px=1;}
					if(!px){px=1;}
					if(data[1][i]<0){
						var pathobj=this.Paper.rect(Left, this.CenterBar.y+2, this.BarW, px).attr({
							'fill':g_ZJLX_CLR_1,
							'stroke':g_ZJLX_CLR_1,
							'stroke-width':0
						});
						this.PathSet.push(pathobj);
						//毛边
						/*this.PathSet.push(pathobj.glow({
							width:2,
							fill:false,
							opacity:0.3,
							color:g_ZJLX_CLR_1,
						}));*/
						this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y-10, data[1][i]).attr({
							'fill':g_ZJLX_CLR_1
						})); 
					}
					else{
						var pathobj=this.Paper.rect(Left, this.CenterBar.y-px, this.BarW, px).attr({
							'fill':g_ZJLX_CLR_4,
							'stroke':g_ZJLX_CLR_4,
							'stroke-width':0
						});
						this.PathSet.push(pathobj);
						//毛边
						/*this.PathSet.push(pathobj.glow({
							width:2,
							fill:false,
							opacity:0.3,
							color:g_ZJLX_CLR_4,
						}));*/
						this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+10, data[1][i]).attr({
							'fill':g_ZJLX_CLR_4
						})); 
					}

					this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+this.BarH+15, data[2][i]).attr({
						'fill':g_TDX_Font_2,
						'font-size':12
					})); 
					Left+=this.BarDis+this.BarW;
				}

			}
		}
	}
},

}; //tdxPaperDraw
