//交易发送协议(信用-资金股份)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //股份数据查询
            funcid = "1114";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 1: //资产负债数据查询
            funcid = "104";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            ix.Set("F130", "0");    //买卖标志
            ix.Set("F132", "0");
            break;
        case 2: //返回买入所需字段名(证券代码)
            return ["F140"];
        case 3: //返回卖出所需字段名(证券代码)
            return ["F140"];
        case 4: //返回资金数据展示所需字段名(参考市值、总资产、盈亏、币种、可用资金、冻结资金、在途资金)
            return ["F205", "F310", "F204", "F132", "F301", "F161", "F280"];
        case 5: //返回现金还款所需字段名(证券代码、证券名称)
            return ["F140", "F141"];
        case 6: //返回卖劵还券所需字段名(证券代码、证券名称)
            return ["F140", "F141"];
        case 7: //返回现券还券所需字段名(证券代码、证券名称)
            return ["F140", "F141"];
        default:
            break;
    }
    return [funcid, ix];
}

var drykRmb = 0;
var drykMy = 0;
var drykGb = 0;

SetDataField = function(jsonData, flag) {

    var startTime = '0900';
    var endTime = '1800';
    if(flag == "cc") {
        isTradingTime( startTime, endTime, function(sflag){
            // sflag:
            // 0. 交易日的交易时间 startTime~endTime； 正常显示
            // 1. 交易日 0点~startTime； 显示0
            // 2. 交易日 endTime~24点； 显示‘--’
            // 3. 非交易日；  显示0
            switch (sflag){
                case 0:
                    // 在这里计算持仓的盈亏，缓存下来
                    jsonData.slice(2).map(function(row) {

                        if(row.F132 == 0) {
                            drykRmb += parseFloat(row.F5643);
                        }
                        else if(row.F132 == 1) {
                            drykMy += parseFloat(row.F5643);
                        }
                        else if(row.F132 == 2) {
                            drykGb += parseFloat(row.F5643);
                        }
                        if(!isNaN(row.F5949)){
                            row.F5949 = Number(row.F5949).toFixed(2) + '%';
                        }
                    });
                    break;
                case 2:
                    jsonData.slice(2).map(function(row){
                        row.F5643 = '--';
                        row.F5949 = '--';
                        drykRmb = '--';
                        drykMy = '--';
                        drykGb = '--';
                    });
                    break;
                default:
                    jsonData.slice(2).map(function(row){
                        row.F5643 = '0.00';
                        row.F5949 = '0.00%';
                        drykRmb = 0;
                        drykMy = 0;
                        drykGb = 0;
                    });
            }
            return jsonData;
        });
    }
    else if(flag == "zj") {
        jsonData.slice(2).map(function(row, index) {
            if(row.F132 == 0) {
                jsonData[index + 2]["F5643"] = !isNaN(drykRmb)? drykRmb.toFixed(2):drykRmb;
            }
            else if(row.F132 == 1) {
                jsonData[index + 2]["F5643"] = !isNaN(drykMy)? drykMy.toFixed(2):drykMy;
            }
            if(row.F132 == 2) {
                jsonData[index + 2]["F5643"] = !isNaN(drykGb)? drykGb.toFixed(2):drykGb;
            }
        });
    }

    return jsonData;
}