﻿//交易发送协议(港股通公司行为申报)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、业务类型字段、业务类型内容、申报类型字段、申报类型内容)
            return ["F123", gddm_arr, "ywlx", GetYWLXFieldWord(), "sblx", GetSBLXFieldWord()];
        case 1: //配套查询
            funcid = "1458";    //功能号
            ix.Set("F125", zhlb_url);   //账号类别
            ix.Set("F123", _uinfo["gdzh"]["zhlb-" + zhlb_url]); //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //沪港通信息查询
            funcid = "1452";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1217", "1");   //备注
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 4: //返回证券信息展示所需字段名(证券名称)
            return ["F141"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            break;
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、业务类型、申报类型、行为代码、委托编号、申报数量)
            return ["F125", "F123", "F140", "F141", "ywlx", "sblx", "xwdm", "wtbh", "sbsl"];
        case 9: //表单提交
            funcid = "1450"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "1");    //操作标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F1227", json["F1227"]); //参数
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    //申报类型初始化响应
    RespondSBLX($("#sblx")[0]);

    //树显示
    var skin = mob_form["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["cells"] = [
        "",
        {
            "cccx": [
                { "text": ["持仓查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "gsxwdrwt": [
                { "text": ["公司行为委托查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
//            "gsxwlswt": [
//                { "text": ["公司行为历史委托"] },
//                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
//            ],
            "qyxx": [
                { "text": ["权益登记信息"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ]
        },
        ""
    ];
    mob_tree["fun"] = "RespondGotoPage";
    CreateMobTree("tree", mob_tree);
}

//页面跳转
RespondGotoPage = function (dom) {
    var field = "F140,F125";
    var value = GetMobFormDes("sblx");
    var type = GetSBLXFieldWord(value);
    switch (type) {
        case "HCD":
            //公司行为代码、委托编号、申报数量
            field += ",xwdm/F5875,wtbh/F169/F146/F377,sbsl/F193";
            break;
        case "HCX":
            //公司行为代码
            field += ",xwdm/F5875";
            break;
        case "HSB":
        default:
            //公司行为代码、申报数量
            field += ",xwdm/F5875,sbsl/F193";
            break;
    }
    var id = dom.id;
    switch (id) {
        case "cccx": //持仓查询
            LocationHref("works/ggt/ggtcccx.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "持仓查询");
            break;
        case "gsxwdrwt": //公司行为当日委托
            LocationHref("works/ggt/ggtgsxwdrwt.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "公司行为当日委托");
            break;
        case "gsxwlswt": //公司行为历史委托
            LocationHref("works/ggt/ggtgsxwlswt.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "公司行为历史委托");
            break;
        case "qyxx": //权益登记信息
            LocationHref("works/ggt/ggtqyxx.html?html=" + mob_filename + "&gobackfield=" + field + "&zhlb=" + zhlb_url, "权益信息");
            break;
        default:
            break;
    }
}

//获取业务类型
GetYWLXFieldWord = function (str) {
    var json = {
        "H63": "公司收购申报业务",
        "H64": "公开招股申报业务",
        "H65": "供股行权申报业务",
        "H66": "红利现金选择权申报业务"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//获取申报类型
GetSBLXFieldWord = function (str) {
    var json = {
        "HSB": "申报",
        "HCD": "撤销",
        "HCX": "查询"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//申报类型切换响应
RespondSBLX = function (dom) {
    try {
        var id = dom.id;
        var value = GetMobFormDes(id);
        var type = GetSBLXFieldWord(value);
        switch (type) {
            case "HSB":
                SetMobFormDes("wtbh", "");
                $("#wtbh").parent().parent().parent().parent().hide();
                $("#sbsl").parent().parent().parent().parent().show();
                break;
            case "HCD":
                $("#wtbh").parent().parent().parent().parent().show();
                $("#sbsl").parent().parent().parent().parent().show();
                break;
            case "HCX":
                SetMobFormDes("wtbh", "");
                $("#wtbh").parent().parent().parent().parent().hide();
                SetMobFormDes("sbsl", "");
                $("#sbsl").parent().parent().parent().parent().hide();
                break;
            default:
                break;
        }
    }
    catch (err) {
    }
}

//行情数据设置
SetQuoteField = function (jsonData) {
    try {
        var field = [
            "F125"  //账号类别
        ]

        //数据字段设置逻辑
        var result = [];
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            json[field[0]] = "";
            result.push(json);
        }
        return result;
    }
    catch (err) {
    }
    return jsonData;
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    var field = [["ywlx", "sblx", "xwdm", "sbsl"], "F234", "F1227"];    //[[业务类型,申报类型,行为代码,申报数量],类型,参数]
    var ywlx = GetYWLXFieldWord(json[field[0][0]]);
    var sblx = GetSBLXFieldWord(json[field[0][1]]);
    switch (sblx) {
        case "HSB":
            json[field[1]] = "0";
            break;
        case "HCD":
            json[field[1]] = "1";
            break;
        case "HCX":
            json[field[1]] = "2";
            break;
        default:
            break;
    }
    var value = "REPORT," + json[GetSendData(2)[0]] + ",";
    for (var i = 0; i < field[0].length; i++) {
        var n = field[0][i];
        var m = json[n];
        if (typeof (m) != "string") {
            m = "";
        }
        if (i == 0) {
            value += ywlx;
        }
        else if (i == 1) {
            if (sblx == "HCD") {
                value += "HSB";
            }
            else if (typeof (sblx) == "string" && sblx != "") {
                value += sblx;
            }
            else {
                value += "HSB";
            }
        }
        else if (i == 3) {
            if (sblx == "HCD") {
                value += "-" + m;
            }
            else {
                value += m;
            }
        }
        else {
            value += m;
        }
        value += ',';
    }
    json[field[2]] = value;
    return json;
}

//页面激活
tdxActivity = function () {
    try {
        ProcessRowGoback(function (json) {
            var setzhlb = json["F125"];
            var setgddm = GetZhlbGddm(setzhlb);
            if (typeof (setgddm) == "string" && setgddm != "") {
                $("#F123").html(setgddm);
            }
            QueryStock(json);
        });
    }
    catch (err) {
    }
}