﻿//交易发送协议(港股通零股卖出)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、申报类型字段、申报类型内容)
            return ["F123", gddm_arr, "F166", GetTDX_FLAG_WTLB_WP("0")];
        case 1: //配套查询
            funcid = "1458";    //功能号
            ix.Set("F125", zhlb_url);   //账号类别
            ix.Set("F123", _uinfo["gdzh"]["zhlb-" + zhlb_url]); //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //沪港通信息查询
            funcid = "1452";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "1");   //操作标志
            ix.Set("F130", "1");   //买卖标志
            ix.Set("F1217", "13456");   //备注
            ix.Set("F234", "1");   //类型
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F166", GetTDX_FLAG_WTLB_WP(GetMobFormDes("F166"))); //委托方式
            break;
        case 4: //返回证券信息展示所需字段名(证券名称、最小交易股数、可卖数量、当前汇率)
            return ["F141", "F187", "F201", "F278"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6: //计算可买(卖)数
            break;
        case 7: //返回可买(卖)数展示所需字段名(可用股份、买一价、当前价、昨收价、委托价格)
            return ["F201", [["F910", "F949", "F946"], "F145"]];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托价格、委托数量)
            return ["F125", "F123", "F140", "F141", "F145", "F144"];
        case 9: //表单提交
            funcid = "1450"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "1");    //操作标志
            ix.Set("F130", "1");    //买卖标志
            ix.Set("F234", "1");   //类型
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F145", json["F145"]);   //委托价格
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F166", GetTDX_FLAG_WTLB_WP(GetMobFormDes("F166"))); //委托方式
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    var skin = mob_form["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["cells"] = [
        "",
        {
            "cccx": [
                { "text": ["持仓查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "wtcx": [
                { "text": ["委托查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "cjcx": [
                { "text": ["成交查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ]
        },
        ""
    ];
    mob_tree["fun"] = "RespondGotoPage";
    CreateMobTree("tree", mob_tree);
}

//页面跳转
RespondGotoPage = function (dom) {
    var field = "F140,F125";
    var id = dom.id;
    switch (id) {
        case "cccx": //持仓查询
            LocationHref("works/ggt/ggtcccx.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "持仓查询");
            break;
        case "wtcx": //委托查询
            LocationHref("works/ggt/ggtdrwt.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "当日委托");
            break;
        case "cjcx": //成交查询
            LocationHref("works/ggt/ggtdrcj.html?gobackfield=" + field + "&zhlb=" + zhlb_url, "当日成交");
            break;
        default:
            break;
    }
}

//获取申报类型
GetTDX_FLAG_WTLB_WP = function (str) {
    var json = {
        "0": "限价盘",
        "1": "竞价盘",
        "2": "竞价限价盘",
        "3": "增强限价盘",
        "4": "特别限价盘",
        "5": "市价盘",
        "6": "超级增强限价盘",
        "7": "超级特别限价盘",
        "8": "(?)限价盘"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//行情数据设置
SetQuoteField = function (jsonData) {
    try {
        var field = [
            "F125"  //账号类别
        ]
        
        //数据字段设置逻辑
        var result = [];
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            json[field[0]] = "";
            result.push(json);
        }
        return result;
    }
    catch (err) {
    }
    return jsonData;
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        var field = ["F145", "F1227"];  //委托价格、参数
        var value = [GetMobFormDes(field[0]), zqxxCache[2][field[1]]];

        //价差显示逻辑
        var dist = [];
        var sep = ["@", ","];   //分隔符
        var parts = value[1].split(sep[0]);
        for (var i = 0; i < parts.length; i++) {
            var range = parts[i].split(sep[1]);
            if (typeof (range) == "object" && range.length > 2) {
                var min = Number(range[0]);
                var max = Number(range[1]);
                var val = Number(range[2]);
                if (!isNaN(min) && !isNaN(max) && !isNaN(val)) {
                    dist.push([min, max, val]);
                }
            }
        }
        var num = Number(value[0]);
        if (!isNaN(num)) {
            for (var i = 0; i < dist.length; i++) {
                if (i == 0 && num <= dist[i][0]) {
                    SetMobFormDes(field[1], dist[i][2]);
                    return;
                }
                else if (i == dist.length - 1 && num > dist[i][1]) {
                    SetMobFormDes(field[1], dist[i][2]);
                    return;
                }
                else if (num > dist[i][0] && num <= dist[i][1]) {
                    SetMobFormDes(field[1], dist[i][2]);
                    return;
                }
            }
        }
        SetMobFormDes(field[1], dist[0][2]);
    }
    catch (err) {
        SetMobFormDes(field[1], "");
    }
}

//页面激活
tdxActivity = function () {
    try {
        ProcessRowGoback(function (json) {
            var setzhlb = json["F125"];
            var setgddm = GetZhlbGddm(setzhlb);
            if (typeof (setgddm) == "string" && setgddm != "") {
                $("#F123").html(setgddm);
            }
            QueryStock(json);
        });
    }
    catch (err) {
    }
}