﻿//交易发送协议(股票质押回购补充质押)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容)
            return ["F123", json["gddm"]];
        case 1: //配套查询
            funcid = "1804";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3:
            break;
        case 4: //返回证券信息展示或查询所需字段名(证券名称、合约编号)
            return ["F141", "F759"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            return [];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、补充质押证券代码、补充质押证券名称、委托金额、委托数量、合约编号)
            return ["F125", "F123", "F140_BCZY", "F141_BCZY", "F148", "F144", "F759"];
        case 9: //表单提交
            funcid = "1800";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F115", "2");    //合作回购状态
            ix.Set("F140", json["F140_BCZY"]);  //证券代码
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F1227", json["F759"]);  //参数
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        //显示提示
        ShowCombineString();

        //扩展查询
        if (typeof (Controller) != "object") {
            ReadJavaScript("../../trade/Controller/Controller.js", function () {
                QueryGPZYHG();
            });
        }
        else {
            QueryGPZYHG();
        }
    }
    catch (err) {
    }
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        CheckGPZYHG();
    }
    catch (err) {
    }
}

/***********************************************************************************************************************/
//显示提示
ShowCombineString = function () {
    ReadFileString("mob_form_" + mob_filename + "_tip.json", function (str) {
        try {
            eval("var json = " + str.slice(str.indexOf("{"), str.lastIndexOf("}") + 1));
            var tip = GetCombineString(json);
            SetMobFormDes("tip", tip);
        }
        catch (err) {
        }
    });
}

//获取组合字符串
GetCombineString = function (json) {
    try {
        var result = '';
        for (var n in json) {
            var m = json[n];
            switch (n) {
                case "text":
                    result += m;
                    break;
                case "link":
                    result += '<span style="color:' + mob_form["color"]["R"] + ';text-decoration:underline;"';
                    if (typeof (m["src"]) == "object") {
                        result += ' onclick="LocationHref(\'' + m["src"]["href"] + '\',\'' + m["src"]["title"] + '\');"';
                    }
                    result += '>';
                    result += m["txt"];
                    result += '</span>';
                    break;
                default:
                    break;
            }
        }
        return result;
    }
    catch (err) {
    }
    return "";
}

/***********************************************************************************************************************/
//查询股票质押回购
QueryGPZYHG = function () {
    Controller.send = function (n, json) {
        var funcid = "";
        var ix = new IXContent();
        switch (n) {
            case 0: //股票质押回购权益查询
                funcid = "1806";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F1207", "P");   //起始序号
                break;
            case 1: //股票质押回购业务操作信息查询
                funcid = "1826";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F1177", "1");   //合约类型
                ix.Set("F1207", "P");   //操作标志
                break;
            case 2: //查询客户身份信息
                funcid = "1130";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F113", "0");    //操作标志
                break;
            case 3: //查询补充质押股票行情
                funcid = "102"; //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F140", json["F140"]);   //证券代码
                break;
            default:
                break;
        }
        return [funcid, ix];
    };
    Controller.call([0, 1, 2], function (n, jsonData) {
        switch (n) {
            case 0:
                if (typeof (jsonData) == "object" && jsonData.length > 2) {
                    var newData = [];
                    for (var i = 0; i < jsonData.length; i++) {
                        var json = {};
                        for (var N in jsonData[i]) {
                            var M = jsonData[i][N];
                            json[N + "_BCZY"] = M;
                        }
                        newData.push(json);
                    }
                    Controller.cache["data" + n] = newData;
                }
                break;
            default:
                break;
        }
    });
}

//检查股票质押回购
CheckGPZYHG = function () {
    var field = ["F140", "F140_BCZY"];
    var value = [];
    for (var i = 0; i < field.length; i++) {
        var val = GetMobFormDes(field[i]);
        if (typeof (val) == "string" && val != "") {
            value.push(val);
        }
        else {
            return;
        }
    }
    if (value[1] != value[0]) {
        Controller.set("F140", value[1]);
        Controller.call([3], function (N, jsonData) {
            try {
                if (jsonData[2]["F125"] != hqcxCache[2]["F125"]) {
                    alert(GetMobTextZH("补充质押证券需与原协议质押证券同市场"));
                    var json = Controller.cache["data0"][0];
                    for (var n in json) {
                        var m = json[n];
                        SetMobFormDes(n, "");
                    }
                }
            }
            catch (err) {
            }
        });
    }
}

/***********************************************************************************************************************/
//表单提交发送
SetBDTJFSFormSubmit = function (callback) {
    ReadFileString("bqxy.txt", function (str) {
        try {
            if (typeof (str) == "string" && str != "") {
                str = GetStringXY(str);
                SetAgreeBookShow([
                    {
                        "param": [
                            {},
                            {},
                            { "txt": str }
                        ],
                        "way": "txt"
                    }
                ], {
                    "button": ["确定", "取消"],
                    "fun": function () {
                        callback();
                    }
                });
            }
            else {
                throw "default";
            }
        }
        catch (err) {
            callback();
        }
    });
}

//协议内容
GetStringXY = function (str) {
    var result = str;
    try {
        var obj = {
            "khxm": "",
            "khh": "",
            "sfzh": "",
            "zqzh": "",
            "zqmc": "",
            "zqdm": "",
            "bczyje": "",
            "zysl": "",
            "xybh": "",
            "csrq": "",
            "ghjyr": "",
            "bdmc": "",
            "bddm": "",
            "zqsl": "",
            "csje": "",
            "ghje": "",
            "rzll": "",
            "ts": ""
        };
        var param0 = Controller.cache["data2"][2];
        try { obj["khxm"] = param0["F122"]; } catch (er) { };
        try { obj["khh"] = _uinfo["khh"] } catch (er) { };
        try { obj["sfzh"] = param0["F454"]; } catch (er) { };
        try { obj["zqzh"] = GetMobFormDes("F123"); } catch (er) { };
        var param1 = GetTradeData();
        try { obj["zqmc"] = param1["F141_BCZY"]; } catch (er) { };
        try { obj["zqdm"] = param1["F140_BCZY"]; } catch (er) { };
        try { obj["bczyje"] = param1["F148"]; } catch (er) { };
        try { obj["zysl"] = param1["F144"]; } catch (er) { };
        var param2 = GetStockData("F759", GetMobFormDes("F759"));
        try { obj["xybh"] = param2["F759"] } catch (er) { };
        try { obj["csrq"] = param2["F150"] } catch (er) { };
        try { obj["ghjyr"] = param2["F5607"] } catch (er) { };
        try { obj["bdmc"] = param2["F141"] } catch (er) { };
        try { obj["bddm"] = param2["F140"] } catch (er) { };
        try { obj["zqsl"] = param2["F152"] } catch (er) { };
        try { obj["csje"] = param2["F154"] } catch (er) { };
        try { obj["ghje"] = param2["F5773"] } catch (er) { };
        try { obj["rzll"] = MathRound(parseFloat(param2["F5545"]), 2); } catch (er) { };
        try { obj["ts"] = param2["F5775"]; } catch (er) { };
        for (var n in obj) {
            var m = obj[n];
            result = result.replace(n, m);
        }
        result = result.replace(/\s/g, "\r\n");
    }
    catch (err) {
    }
    return result;
}

/***********************************************************************************************************************/
//显示补充质押证券
ShowBCZYZQ = function (n) {
    try {
        var json = Controller.cache["data0"][n];
        for (var n in json) {
            var m = json[n];
            SetMobFormDes(n, m);
        }
        CheckGPZYHG();
        RespondBCZYJE();
    }
    catch (err) {
    }
}

/***********************************************************************************************************************/
//补充质押证券响应
ResopndBCZYZQ = function (dom) {
    try {
        var field = ["F140_BCZY", "F141_BCZY"]; //证券代码、证券名称
        var options = SiftFieldsData(Controller.cache["data0"], field);
        ShowMobOptions(dom, options, "ShowBCZYZQ");
    }
    catch (err) {
    }
}

//补充质押金额
RespondBCZYJE = function (dom) {
    try {
        var field = ["F140_BCZY", "F203_BCZY", "F5733_BCZY", "F148", "F144"]; //补充质押证券代码、补充质押最新价、补充质押折算率、委托金额、委托数量
        var bczyzqdm = GetMobFormDes(field[0])
        var json = GetMatch(Controller.cache["data0"], field[0], bczyzqdm);
        var bczyzxj = json[field[1]];
        var bczyzsl = json[field[2]];
        var wtje = GetMobFormDes(field[3]);
        var wtsl = parseInt(Number(wtje) / Number(bczyzxj) / Number(bczyzsl)) + 1;
        if (Number(wtje) == 0 || isNaN(wtsl)) {
            SetMobFormDes(field[4], "");
        }
        else {
            SetMobFormDes(field[4], wtsl.toString());
        }
    }
    catch (err) {
    }
}