﻿//交易发送协议(股票质押回购初始交易)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容)
            return ["F123", json["gddm"]];
        case 1: //配套查询
            funcid = "1806";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3:
            break;
        case 4: //返回证券信息展示或查询所需字段名(证券名称、可融资金额)
            return ["F141", "F5780"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            return [];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托金额)
            return ["F125", "F123", "F140", "F141", "F148"];
        case 9: //表单提交
            funcid = "1800";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F115", "1");    //合作回购状态
            ix.Set("F391", json["F391"]);   //产品代码
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F148", json["F148"]);   //委托金额
            ix.Set("F142", json["F142"]);   //委托日期
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        //显示提示
        ShowCombineString();

        //扩展查询
        if (typeof (Controller) != "object") {
            ReadJavaScript("../../trade/Controller/Controller.js", function () {
                QueryGPZYHG();
            });
        }
        else {
            QueryGPZYHG();
        }
    }
    catch (err) {
    }
}

/***********************************************************************************************************************/
//显示提示
ShowCombineString = function () {
    ReadFileString("mob_form_" + mob_filename + "_tip.json", function (str) {
        try {
            eval("var json = " + str.slice(str.indexOf("{"), str.lastIndexOf("}") + 1));
            var tip = GetCombineString(json);
            SetMobFormDes("tip", tip);
        }
        catch (err) {
        }
    });
}

//获取组合字符串
GetCombineString = function (json) {
    try {
        var result = '';
        for (var n in json) {
            var m = json[n];
            switch (n) {
                case "text":
                    result += m;
                    break;
                case "link":
                    result += '<span style="color:' + mob_form["color"]["R"] + ';text-decoration:underline;"';
                    if (typeof (m["src"]) == "object") {
                        result += ' onclick="LocationHref(\'' + m["src"]["href"] + '\',\'' + m["src"]["title"] + '\');"';
                    }
                    result += '>';
                    result += m["txt"];
                    result += '</span>';
                    break;
                default:
                    break;
            }
        }
        return result;
    }
    catch (err) {
    }
    return "";
}

/***********************************************************************************************************************/
//查询股票质押回购
QueryGPZYHG = function () {
    Controller.send = function (n, json) {
        var funcid = "";
        var ix = new IXContent();
        switch (n) {
            case 0: //股票质押回购期限利率查询
                funcid = "1808";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F1207", "P");   //操作标志
                break;
            case 1: //股票质押回购业务操作信息查询
                funcid = "1826";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F1177", "1");   //合约类型
                ix.Set("F1207", "P");   //操作标志
                break;
            case 2: //查询客户身份信息
                funcid = "1130";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F113", "0");    //操作标志
                break;
            case 3: //查询额度
                funcid = "170"; //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F113", "18");   //操作标志
                ix.Set("F114", "0");    //操作状态
                break;
            case 4: //调整额度
                funcid = "170"; //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F113", "18");   //操作标志
                ix.Set("F114", "1");    //操作状态
                break;
            default:
                break;
        }
        return [funcid, ix];
    };
    Controller.call([0, 1, 2], function (n, jsonData) {
        switch (n) {
            case 0:
                var field = ["F392"]; //产品名称
                var value = [];
                for (var i = 0; i < field.length; i++) {
                    var array = [];
                    for (var j = 2; j < jsonData.length; j++) {
                        array.push(jsonData[j][field[i]]);
                    }
                    value.push(array);
                }
                SetMobFormDes(field[0], value[0]);
                RespondCPDM($("#" + field[0])[0]);
                break;
            case 2:
                QueryED();
                break;
            default:
                break;
        }
    });
}

/***********************************************************************************************************************/
//查询额度
QueryED = function () {
    Controller.call([3], function (n, jsonData) {
        var field = ["F149"]; //返回信息
        var value = [];
        for (var i = 0; i < field.length; i++) {
            var array = [];
            for (var j = 2; j < jsonData.length; j++) {
                array.push(jsonData[j][field[i]]);
            }
            value.push(array);
        }
        var STRING = value[0][0];
        var ARRAY = STRING.split(",");
        var SXED = ARRAY[0];
        var YYED = ARRAY[1];
        SetMobFormDes("SXED", SXED);
        SetMobFormDes("YYED", YYED);
    });
}

//调整额度
ChangeED = function () {
    Controller.call([4], function (n, jsonData) {
        if (typeof (jsonData) == "object") {
            if (jsonData.length > 2) {
                alert(GetMobTextZH(jsonData[2]["F149"]));
                QueryED();
            }
            else if (typeof (jsonData[0]) == "string" && jsonData[0] != "") {
                alert(GetMobTextZH(jsonData[0]));
            }
        }
    });
}

/***********************************************************************************************************************/
//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        var id = "F392"; //产品名称
        var des = GetMobFormDes(id);
        var list = GetMatch(Controller.cache["data0"], id, des);
        json["F391"] = list["F391"];
        json["F144"] = parseInt(Number(json["F148"]) / Number(array[0]["F203"]) / Number(array[0]["F5733"])) + 1;
        json["F142"] = GetMobFormDes("GHRQ").replace(/-/g, "");
    }
    catch (err) {
    }
    return json;
}

/***********************************************************************************************************************/
//表单提交发送
SetBDTJFSFormSubmit = function (callback) {
    ReadFileString("csxy.txt", function (str) {
        try {
            if (typeof (str) == "string" && str != "") {
                str = GetStringXY(str);
                SetAgreeBookShow([
                    {
                        "param": [
                            {},
                            {},
                            { "txt": str }
                        ],
                        "way": "txt"
                    }
                ], {
                    "button": ["确定", "取消"],
                    "fun": function () {
                        callback();
                    }
                });
            }
            else {
                throw "default";
            }
        }
        catch (err) {
            callback();
        }
    });
}

//协议内容
GetStringXY = function (str) {
    var result = str;
    try {
        var obj = {
            "khxm": "",
            "khh": "",
            "sfzh": "",
            "zqzh": "",
            "zqmc": "",
            "zqdm": "",
            "csjyje": "",
            "zqsl": "",
            "rzll": "",
            "ts": "",
            "csjyr": "",
            "ghjyr": "",
            "ghje": ""
        };
        var param0 = Controller.cache["data2"][2];
        try { obj["khxm"] = param0["F122"]; } catch (er) { };
        try { obj["khh"] = _uinfo["khh"] } catch (er) { };
        try { obj["sfzh"] = param0["F454"]; } catch (er) { };
        try { obj["zqzh"] = GetMobFormDes("F123"); } catch (er) { };
        var param1 = GetTradeData();
        try { obj["zqmc"] = param1["F141"]; } catch (er) { };
        try { obj["zqdm"] = param1["F140"]; } catch (er) { };
        try { obj["csjyje"] = param1["F148"]; } catch (er) { };
        try { obj["zqsl"] = param1["F144"]; } catch (er) { };
        var param2 = GetMatch(Controller.cache["data0"], "F392", GetMobFormDes("F392"));
        try { obj["rzll"] = param2["F5712"]; } catch (er) { };
        try { obj["ts"] = param2["F5775"]; } catch (er) { };
        try { obj["csjyr"] = GetMobFormDes("CSRQ"); } catch (er) { };
        try { obj["ghjyr"] = GetMobFormDes("GHRQ"); } catch (er) { };
        try {
            var csjyje = Number(obj["csjyje"]);
            var rzll = Number(obj["rzll"]);
            var ts = Number(obj["ts"]);
            var lx = csjyje * rzll * ts / 365 / 100;
            var ghje = MathRound(csjyje + lx, 2);
            obj["ghje"] = ghje;
        }
        catch (er) {
        };
        for (var n in obj) {
            var m = obj[n];
            result = result.replace(n, m);
        }
        result = result.replace(/\s/g, "\r\n");
    }
    catch (err) {
    }
    return result;
}

/***********************************************************************************************************************/
//产品代码响应
RespondCPDM = function (dom) {
    try {
        var id = dom.id;
        var des = GetMobFormDes(id);
        var jsonData = Controller.cache["data0"];
        var json = GetMatch(jsonData, id, des);
        for (var n in json) {
            var m = json[n];
            if (n != id) {
                SetMobFormDes(n, m);
            }
        }
        var dayNum = Number(json["F5775"]);
        if (!isNaN(dayNum)) {
            var CSRQ = GetMobFormDes("CSRQ");
            var startTime = new Date(Date.parse(CSRQ.replace(/-/g, "/"))).getTime();
            var endTime = startTime + dayNum * 1000 * 60 * 60 * 24;
            var endDate = new Date();
            endDate.setTime(endTime);
            var GHRQ = GetDateByFormat(endDate);
            SetMobFormDes("GHRQ", GHRQ);
        }
    }
    catch (err) {
    }
}