﻿//交易发送协议(股票质押回购延期购回)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容)
            return ["F123", json["gddm"]];
        case 1: //配套查询
            funcid = "1804";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3:
            break;
        case 4: //返回证券信息展示或查询所需字段名(证券名称、合约编号)
            return ["F141", "F759"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            return [];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、合约编号)
            return ["F125", "F123", "F140", "F141", "F759"];
        case 9: //表单提交
            funcid = "1800";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F115", "6");    //合作回购状态
            ix.Set("F391", json["F391"]);   //产品代码
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F1227", json["F759"]);  //参数
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        //显示提示
        ShowCombineString();

        //扩展查询
        if (typeof (Controller) != "object") {
            ReadJavaScript("../../trade/Controller/Controller.js", function () {
                QueryGPZYHG();
            });
        }
        else {
            QueryGPZYHG();
        }
    }
    catch (err) {
    }
}

/***********************************************************************************************************************/
//显示提示
ShowCombineString = function () {
    ReadFileString("mob_form_" + mob_filename + "_tip.json", function (str) {
        try {
            eval("var json = " + str.slice(str.indexOf("{"), str.lastIndexOf("}") + 1));
            var tip = GetCombineString(json);
            SetMobFormDes("tip", tip);
        }
        catch (err) {
        }
    });
}

//获取组合字符串
GetCombineString = function (json) {
    try {
        var result = '';
        for (var n in json) {
            var m = json[n];
            switch (n) {
                case "text":
                    result += m;
                    break;
                case "link":
                    result += '<span style="color:' + mob_form["color"]["R"] + ';text-decoration:underline;"';
                    if (typeof (m["src"]) == "object") {
                        result += ' onclick="LocationHref(\'' + m["src"]["href"] + '\',\'' + m["src"]["title"] + '\');"';
                    }
                    result += '>';
                    result += m["txt"];
                    result += '</span>';
                    break;
                default:
                    break;
            }
        }
        return result;
    }
    catch (err) {
    }
    return "";
}

/***********************************************************************************************************************/
//查询股票质押回购
QueryGPZYHG = function () {
    Controller.send = function (n, json) {
        var funcid = "";
        var ix = new IXContent();
        switch (n) {
            case 0: //股票质押回购期限利率查询
                funcid = "1808";    //功能号
                ix.Set("F110", json["wtfs"]);   //委托方式
                ix.Set("F1207", "P");   //操作标志
                break;
            default:
                break;
        }
        return [funcid, ix];
    }
    Controller.call([0], function (n, jsonData) {
        switch (n) {
            case 0:
                var field = ["F5775"]; //交易天数
                var value = [];
                for (var i = 0; i < field.length; i++) {
                    var array = [];
                    for (var j = 2; j < jsonData.length; j++) {
                        array.push(jsonData[j][field[i]]);
                    }
                    value.push(array);
                }
                SetMobFormDes(field[0], value[0]);
                RespondHYQX();
                break;
            default:
                break;
        }
    });
}

/***********************************************************************************************************************/
//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        var field = ["F5775", "F391"]; //交易天数、产品代码
        var value = [];
        value.push(GetMobFormDes(field[0]));
        value.push(GetMatch(Controller.cache["data0"], field[0], value[0], field[1]));
        json[field[1]] = value[1];
    }
    catch (err) {
    }
    return json;
}

/***********************************************************************************************************************/
//表单提交发送
SetBDTJFSFormSubmit = function (callback) {
    try {
        var field = ["F5775", "F759"]; //交易天数、合约编号
        var yqqx = Number(GetMobFormDes(field[0]));
        var hybh = GetMobFormDes(field[1]);
        var cpqx = Number(GetStockData(field[1], hybh, field[0]));
        if (!isNaN(yqqx) && yqqx != 0 && !isNaN(cpqx) && cpqx != 0 && yqqx <= cpqx) {
            alert(GetMobTextZH("您选择的延期期限必须大于产品期限，否则不可延期。"));
        }
        else {
            throw "default";
        }
    }
    catch (err) {
        callback();
    }
}

/***********************************************************************************************************************/
//合约期限响应
RespondHYQX = function (dom) {
    try {
        var field = ["F5775", "F5712"]; //交易天数、利率
        var value = [];
        value.push(GetMobFormDes(field[0]));
        value.push(GetMatch(Controller.cache["data0"], field[0], value[0], field[1]));
        SetMobFormDes(field[1], value[1]);
    }
    catch (err) {
    }
}