﻿//交易发送协议(基金定投)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(基金定投周期ID、基金定投周期内容、扣款日星期ID、扣款日星期内容、期满条件ID、期满条件内容、申请日期ID、申请日期内容、起始日期ID、起始日期内容)
            return ["cycle", [json["cycle"][0], json["cycle"][3]], "weeks", json["weeks"], "kinds", json["kinds"], "appDate", endDate, "startDate", endDate];
        case 1: //开放式基金帐号查询
            funcid = "2126"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //开放式基金定期定额申购品种查询
            funcid = "2134";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 3: //返回开放式基金信息查询所需字段名(基金代码)
            return ["F402"];
        case 4: //开放式基金信息查询
            funcid = "2110";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F402", json["F402"]);   //基金代码
            break;
        case 5: //返回开放式基金信息展示所需字段名(基金名称、基金净值、个人最低投资、收费方式)
            return ["F403", "F406", "F481", "F429"];
        case 6: //返回表单提交所需字段名(基金公司代码、基金账户、基金代码、基金名称、交易金额、每月扣款日、收费方式、类型、参数、模式)
            return ["F426", "F417", "F402", "F403", "F405", "F449", "F429", "F234", "F1227", "F1228"];
        case 7: //表单提交(风险标志)
            funcid = "2130"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F126", json["startDate"]);  //开始日期
            ix.Set("F449", json["F449"]);   //每月扣款日
            ix.Set("F127", json["endDate"]);    //终止日期
            ix.Set("F113", "0");    //操作标志
            ix.Set("F429", json["F429"]);   //收费方式
            ix.Set("F234", json["F234"]);   //类型
            ix.Set("F1227", json["F1227"]); //参数
            ix.Set("F1228", json["F1228"]); //模式
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 8: //返回表单提交风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 9: //表单提交
            funcid = "2130"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F126", json["startDate"]);  //开始日期
            ix.Set("F449", json["F449"]);   //每月扣款日
            ix.Set("F127", json["endDate"]);    //终止日期
            ix.Set("F113", "0");    //操作标志
            ix.Set("F429", json["F429"]);   //收费方式
            ix.Set("F234", json["F234"]);   //类型
            ix.Set("F1227", json["F1227"]); //参数
            ix.Set("F1228", json["F1228"]); //模式
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}