﻿//交易发送协议(OTC确认买入)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(基金代码字段、产品代码内容)
            return ["F402", GetTDX_ID_CPDM()];
        case 1: //帐号查询
            funcid = "2636"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "-1");   //操作标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //配套查询
            funcid = "2604"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "1");    //交易标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 3: //返回信息查询所需字段名(基金代码、产品代码、产品名称)
            return ["F402", "F391", "F392"];
        case 4: //信息查询
            json["F426"] = GetFundData("F391", json["F402"], "F393");   //产品公司代码
            json["F145"] = GetMobFormDes("F145");   //委托价格
            funcid = "2602";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "12");    //交易标志
            ix.Set("F145", json["F145"]);   //委托价格
            if (typeof (json["F145"]) == "string" && json["F145"] != "") {
                
            }
            else {
                funcid = "";
            }
            break;
        case 5: //返回信息展示所需字段名(基金名称、可用资金、最大可买)
            return ["F403", "F301", "F211"];
        case 6: //返回表单提交所需字段名(基金公司代码、基金账户、基金代码、基金名称、委托数量、委托价格、约定序号)
            return ["F426", "F417", "F402", "F403", "F144", "F145", "F241"];
        case 7: //表单提交
            funcid = "2600"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "12");    //交易标志
            ix.Set("F144", json["F144"]);   //委托价格
            ix.Set("F145", json["F145"]);   //委托数量
            ix.Set("F241", json["F241"]);   //约定序号
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    var skin = mob_form["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["cells"] = [
        "",
        {
            "otczhhq": [
                { "text": ["OTC行情查询"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ]
        },
        ""
    ];
    mob_tree["fun"] = "RespondGotoPage";
    CreateMobTree("tree", mob_tree);

    //表单信息查询
    RespondCPDM();

    //交易提示
    try {
        if ($("#tip").length == 0) {
            var HTML = '';
            HTML += '<div id="tip" style="';
            HTML += 'font-size:' + mob_form["font"][0] + ';';
            HTML += 'font-weight:' + mob_form["font"][1] + ';';
            HTML += 'color:' + mob_form["color"]["T"];
            HTML += '">';
            HTML += '<table cellspacing="0" cellpadding="0" border="0" style="margin:0px auto;">';
            HTML += '<tr><td>';
            HTML += '对意向委托的确认约定号区间';
            HTML += '</td></tr>';
            HTML += '<tr><td>';
            HTML += '2000001～3000000';
            HTML += '</td></tr>';
            HTML += '<tr><td style="padding:10px 0px 0px 0px;">';
            HTML += '</td></tr>';
            HTML += '<tr><td>';
            HTML += '对定价委托的确认约定号区间';
            HTML += '</td></tr>';
            HTML += '<tr><td>';
            HTML += '3000001～4000000';
            HTML += '</td></tr>';
            HTML += '</table>';
            HTML += '</div>';
            $("#table").after(HTML);
        }
    }
    catch (err) {
    }
}

//页面跳转
RespondGotoPage = function (dom) {
    var id = dom.id;
    switch (id) {
        case "otczhhq": //OTC行情查询
            var field = ["F402", "F400"]; //基金代码、交易标志
            var value = [GetMobFormDes(field[0]), "12"];
            LocationHref("works/otc/otczhhq.html" + "?" + field[0] + "=" + value[0] + "&" + field[1] + "=" + value[1], "OTC行情查询");
            break;
        default:
            break;
    }
}

//获取产品代码
GetTDX_ID_CPDM = function () {
    var result = [];
    try {
        var field = "F391"; //产品代码
        for (var i = 2; i < fundData.length; i++) {
            var value = fundData[i][field];
            if (typeof (value) == "string" && value != "") {
                result.push(value);
            }
        }
    }
    catch (err) {
    }
    return result;
}

//产品代码响应
RespondCPDM = function () {
    try {
        var field = "F402"; //基金代码
        RespondCx($("#" + field)[0]);
    }
    catch (err) {
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        //发送数据添加
        var field = ["F417"]; //基金账户
        json[field[0] + "_" + 0] = "OTC账户";
    }
    catch (err) {
    }
    return json;
}