﻿//交易发送协议(OTC申购)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容
            return [];
        case 1: //帐号查询
            funcid = "2636"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "-1");   //操作标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //配套查询
            funcid = "2604"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F400", "1");    //交易标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 3: //返回信息查询所需字段名(基金代码、产品代码、产品名称)
            return ["F402", "F391", "F392"];
        case 4: //信息查询
            json["F426"] = GetFundData("F391", json["F402"], "F393");   //产品公司代码
            funcid = "2602";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "1");    //交易标志
            break;
        case 5: //返回信息展示所需字段名(基金名称、基金净值、可用资金)
            return ["F403", "F406", "F301"];
        case 6: //返回表单提交所需字段名(基金公司代码、基金账户、基金代码、基金名称、交易金额)
            return ["F426", "F417", "F402", "F403", "F405"];
        case 7: //表单提交(风险标志)
            funcid = "2600"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "1");    //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 8: //返回表单提交风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 9: //表单提交
            funcid = "2600"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "1");    //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        //扩展查询
        if (typeof (Controller) != "object") {
            ReadJavaScript("../../trade/Controller/Controller.js", function () {
                Controller.send = function (n, json) {
                    var funcid = "";
                    var ix = new IXContent();
                    switch (n) {
                        case 0: //OTC电子合同查询
                            funcid = "2610";    //功能号
                            ix.Set("F110", json["wtfs"]);   //委托方式
                            ix.Set("F1207", "P");   //起始序号
                            break;
                        case 1: //OTC电子签名约定书查询
                            funcid = "2602";    //功能号
                            ix.Set("F125", ""); //账号类别
                            ix.Set("F123", ""); //股东代码
                            ix.Set("F110", json["wtfs"]);   //委托方式
                            ix.Set("F1217", "DZQMYDS"); //备注
                            break;
                        default:
                            break;
                    }
                    return [funcid, ix];
                }
                Controller.call([0, 1], function (n) {
                    if (n == 1) {
                        var parmStr = window.location.search.substr(1);
                        var json = ParseParmStr(parmStr);
                        if (typeof (json["otcdm"]) == "string") {
                            var field = GetSendData(3);
                            json[field[0]] = json["otcdm"];
                            SetMobFormDes(field[0], json[field[0]]);
                            QueryStock(json);
                        }
                    }
                });
            });
        }
    }
    catch (err) {
    }
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        var field = ["F426", "F402", "F1223"]; //基金公司代码、基金代码、检查风险标志
        var dzhtf = ["F391", "F395", "F147"]; //产品名称、产品状态、状态说明
        if (typeof (zqxxCache) == "object" && zqxxCache.length > 2) {
            var skin = mob_form["skin"];
            if (typeof (skin) == "string") {
                mob_tree = window[skin + "_mob_tree"];
            }
            mob_tree["cells"] = [
                "",
                {
                    "otckh": [
                        { "text": ["OTC账户"], "width": "70px" },
                        { "text": ["", "", ["12px", "bold"]] },
                        { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
                    ],
                    "otcdzhtqs": [
                        { "text": ["电子合同"], "width": "70px" },
                        { "text": ["", "", ["12px", "bold"]] },
                        { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
                    ],
                    "otcdzqmyds": [
                        { "text": ["电子签名"], "width": "70px" },
                        { "text": ["", "", ["12px", "bold"]] },
                        { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
                    ]
                },
                ""
            ];
            for (var i = 0; i < field.length; i++) {
                var n = field[i];
                var m = zqxxCache[2][field[i]];
                switch (i) {
                    case 0: //OTC开户判断流程
                        var accountJson = GetAccount(n, m);
                        if (typeof (accountJson) == "object" && accountJson[n] == m) {
                            mob_tree["cells"][1]["otckh"][1]["text"][0] = "已开户";
                            mob_tree["cells"][1]["otckh"][1]["text"][2][2] = "R";
                        }
                        else {
                            mob_tree["cells"][1]["otckh"][1]["text"][0] = "未开户";
                            mob_tree["cells"][1]["otckh"][1]["text"][2][2] = "G";
                        }
                        break;
                    case 1: //电子合同判断流程
                        var na = dzhtf[0];
                        var ma = m;
                        var dzhtJson = GetMatch(Controller.cache["data0"], na, ma);
                        if (typeof (dzhtJson) == "object" && dzhtJson[na] == ma) {
                            var nb = dzhtf[1];
                            var mb = dzhtJson[nb];
                            switch (mb) {
                                case "0": //未签署
                                    mob_tree["cells"][1]["otcdzhtqs"][1]["text"][2][2] = "G";
                                    break;
                                case "1": //已签署
                                    mob_tree["cells"][1]["otcdzhtqs"][1]["text"][2][2] = "R";
                                    break;
                                default:
                                    break;
                            }
                            var nc = dzhtf[2];
                            var mc = dzhtJson[nc];
                            mob_tree["cells"][1]["otcdzhtqs"][1]["text"][0] = mc;
                        }
                        break;
                    case 2: //电子签名约定书判断流程
                        var dzqmJson = Controller.cache["data1"][2];
                        if (typeof (dzqmJson) == "object") {
                            var nd = n;
                            var md = dzqmJson[nd];
                            switch (md) {
                                case "0": //未开通
                                    mob_tree["cells"][1]["otcdzqmyds"][1]["text"][0] = "未开通";
                                    mob_tree["cells"][1]["otcdzqmyds"][1]["text"][2][2] = "G";
                                    break;
                                case "1": //已开通
                                    mob_tree["cells"][1]["otcdzqmyds"][1]["text"][0] = "已开通";
                                    mob_tree["cells"][1]["otcdzqmyds"][1]["text"][2][2] = "R";
                                    break;
                                default:
                                    break;
                            }
                        }
                        break;
                    default:
                        break;
                }
            }
            mob_tree["fun"] = "RespondGotoPage";
            CreateMobTree("tree", mob_tree);
        }
        else {
            $("#tree").html("");
        }
    }
    catch (err) {
    }
}

//页面跳转
RespondGotoPage = function (dom) {
    var id = dom.id;
    switch (id) {
        case "otckh": //OTC开户
            LocationHref("works/otc/otckh.html", "OTC开户");
            break;
        case "otcdzhtqs": //电子合同
            LocationHref("works/otc/otcdzhtqs.html", "OTC电子合同签署");
            break;
        case "otcdzqmyds": //OTC电子签名约定书
            LocationHref("works/otc/otcdzqmyds.html", "OTC电子签名约定书");
            break;
        default:
            break;
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        //发送数据添加
        var field = ["F417"]; //基金账户
        json[field[0] + "_" + 0] = "OTC账户";
    }
    catch (err) {
    }
    return json;
}