﻿//交易发送协议(OTC预约申购)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容
            return [];
        case 1: //帐号查询
            funcid = "2636"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "-1");   //操作标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //配套查询
            funcid = "2628"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "19");   //操作标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 3: //返回信息查询所需字段名(基金代码、产品代码、产品名称)
            return ["F402", "F391", "F392"];
        case 4: //信息查询
            funcid = "2602";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "19");   //交易标志
            break;
        case 5: //返回信息展示所需字段名(基金名称、基金净值、可用资金)
            return ["F403", "F406", "F301"];
        case 6: //返回表单提交所需字段名(基金公司代码、基金账户、基金代码、基金名称、交易金额、发生日期)
            return ["F426", "F417", "F402", "F403", "F405", "F409"];
        case 7: //表单提交(风险标志)
            funcid = "2600"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "19");   //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F409", json["F409"]);   //发生日期
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 8: //返回表单提交风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 9: //表单提交
            funcid = "2600"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "19");   //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F409", json["F409"]);   //发生日期
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        //发送数据添加
        var field = ["F417", "F409"]; //基金账户、发生日期
        for (var i = 0; i < field.length; i++) {
            switch (i) {
                case 0: //基金账户
                    json[field[i] + "_" + 0] = "OTC账户";
                    break;
                case 1: //发生日期
                    var value = json[field[i]];
                    if (typeof (value) == "string") {
                        json[field[i]] = value.replace(/-/g, "");
                    }
                    break;
                default:
                    break;
            }
        }
    }
    catch (err) {
    }
    return json;
}