﻿//交易发送协议(协议签署)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //查询协议
            funcid = "140"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "7");    //操作标志
            break;
        case 1: //客户操作确认(开通权限)
            funcid = "170"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "7");    //操作标志
            ix.Set("F736", json["F149_0"]); //信息类型
            break;
        case 2: //客户操作确认(取消权限)
            funcid = "170"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "8");    //操作标志
            ix.Set("F736", json["F149_0"]); //信息类型
            break;
        case 3: //风险揭示书类型标志
            return ["F149_0"];
        case 4: //风险揭示书内容字段
            return ["F251_2"];
        case 5: //开通状态标志字段(检查风险标志)
            return ["F1223"];
        case 6: //业务名称
            return ["F149_1"];
        default:
            break;
    }
    return [funcid, ix];
}

//股东代码设置
SetGddmField = function (n, json) {
    switch (n) {
        case 0:
            return [json["gddm"]];
        default:
            break;
    }
    return [];
}

//数据字段设置
SetDataField = function (jsonData) {
    try {
        var field = [
            "F1223",    //检查风险标志
            "F149", //返回信息
            "F251"  //提示信息
        ];

        //数据字段设置逻辑
        var result = [];
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            for (var n in json) {
                var m = json[n];
                switch (n) {
                    case field[0]:  //开通状态
                        switch (m) {
                            case "0":
                                json[n + "_" + 0] = "未开通";
                                break;
                            case "1":
                                json[n + "_" + 0] = "已开通";
                                break;
                            default:
                                json[n + "_" + 0] = "";
                                break;
                        }
                        break;
                    case field[1]:  //业务名称
                        var sep = ",";  //分隔符
                        var arr = m.split(sep);
                        for (var j = 0; j < arr.length; j++) {
                            var value = arr[j];
                            json[n + "_" + j] = value;
                        }
                        break;
                    case field[2]:  //风险揭示书
                        var sep = m.slice(0, 1);    //分隔符
                        var arr = m.split(sep);
                        for (var j = 0; j < arr.length; j++) {
                            var value = arr[j];
                            if (value.indexOf("\\r\\n") != -1) {
                                value = value.replace(/\\r\\n/g, "\r\n");
                            }
                            json[n + "_" + j] = value;
                        }
                        break;
                    default:
                        break;
                }
            }
            result.push(json);
        }
        return result;
    }
    catch (err) {
    }
    return jsonData;
}

//列表按钮内容设置
SetListButtonDes = function (n) {
    switch (n) {
        case 0: //返回开通状态字段(检查风险标志)
            return "F1223";
        case 1: //按钮文本
            return { "0": "开通权限", "1": "取消权限" };
        default:
            break;
    }
}

//网页参数设置
SetWebUrlParms = function (src, parm) {
    try {
        switch (parm) {
            case "white":   //白背景
                var href = src + "?white";
                return href;
            default:    //黑背景
                var href = src + "?black";
                return href;
        }
    }
    catch (err) {
    }
    return src;
}

//开放试函数点击阅读
RespondReadButton = function (n) {
    var field = "F1223";    //检查风险标志
    var json = dataCache["data"][n];
    var value = json[field];
    switch (value) {
        case "0":   //未开通
            RespondYd(n);
            break;
        case "1":   //已开通
            alert(GetMobTextZH("已完成开通"));
            break;
        default:
            RespondYd(n);
            break;
    }
}