﻿//交易发送协议(上海债券报价回购)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容)
            return ["F123", json["gddm"]];
        case 1: //合作回购产品代码查询
            funcid = "2008";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(产品代码)
            return ["F391"];
        case 3: //合作回购产品信息查询
            funcid = "2010";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F391", json["F391"]);   //产品代码
            break;
        case 4: //返回证券信息展示所需字段名(产品名称、合约期限、合约利率、提前终止利率、个人最低认购金额、交易单位、可用资金)
            return ["F392", "F1195", "F1184", "F1198", "F419", "F133", "F301"];
        case 5:
            break;
        case 6:
            break;
        case 7:
            break;
        case 8: //返回表单提交所需字段名(账号类别、股东代码、产品代码、产品名称、委托数量、终止日期)
            return ["F125", "F123", "F391", "F392", "F144", "F127"];
        case 9: //表单提交
            funcid = "2002";    //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F115", "0");    //合作回购状态
            ix.Set("F391", json["F391"]);   //产品代码
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F127", json["F127"].replace(/-/g, "")); //终止日期
            ix.Set("F665", json["F665"]);   //自动委托标记
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    var field = ["setDate", "F127"];    //展期、终止日期
    SetMobFormDes(field[0], GetZQSZFieldWord());
    $("#" + field[0]).parent().parent().parent().parent().hide();
    $("#" + field[1]).parent().parent().parent().parent().hide();
}

//扩展区域字段
GetKZQYFieldWord = function (jsonData) {
    try {
        var field = ["F665", "setDate", "F127"];    //自动委托标记、展期、终止日期
        var value = jsonData[2][field[0]];
        switch (value) {
            case "0":
                $("#" + field[1]).parent().parent().parent().parent().hide();
                $("#" + field[2]).parent().parent().parent().parent().hide();
                break;
            case "1":
                $("#" + field[1]).parent().parent().parent().parent().show();
                $("#" + field[2]).parent().parent().parent().parent().show();
                $("#" + field[1]).html(GetZQSZFieldWord("1"));
                SelectZQSZQH($("#" + field[1])[0]);
                break;
            default:
                break;
        }

        var set = ["F144", "F419"]; //委托金额、最小买入金额
        SetMobFormDes(set[0], jsonData[2][set[1]]);
    }
    catch (err) {
    }
    return jsonData;
}

//展期设置响应
SelectZQSZQH = function (dom) {
    var field = ["F127"];   //终止日期
    var value = GetMobFormDesByDom(dom);
    var type = GetZQSZFieldWord(value);
    switch (type) {
        case "0":
            $("#" + field[0]).parent().parent().parent().parent().hide();
            SetMobFormDes(field[0], "");
            break;
        case "1":
            $("#" + field[0]).parent().parent().parent().parent().show();
            var date = new Date();
            var day = date.getDay();
            if (day > 0 && day < 5) {
                SetMobFormDes(field[0], GetNowDate(1));
            }
            else {
                SetMobFormDes(field[0], GetNowWeekDay(1, 1));
            }
            break;
        default:
            break;
    }
}

//展期设置翻译
GetZQSZFieldWord = function (str) {
    var json = {
        "0": "不设置终止日期",
        "1": "设置终止日期"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    var field = ["F125", "F123", "F127", "F665"];   //账号类别、股东代码、终止日期、自动委托标记
    json[field[0]] = array[0][field[0]];
    json[field[1]] = GetGddmCode(GetZhlbGddm(array[0][field[0]]));
    if (typeof (json[field[2]]) == "string" && json[field[2]] != "") {
        json[field[3]] = "1";
    }
    else {
        json[field[3]] = "0";
    }
    return json;
}