﻿//交易发送协议(卖出)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、申报类型字段、申报类型内容)
            return ["F123", json["gddm"], "F166", GetTDX_ID_WTFS()];
        case 1: //配套查询
            funcid = "1114";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //证券信息查询
            break;
        case 4: //返回证券信息展示所需字段名(证券名称、可卖数量)
            return ["F141", "F201"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6: //计算可买(卖)数
            break;
        case 7: //返回可买(卖)数展示所需字段名(可用股份、买一价、当前价、昨收价、委托价格)
            return ["F201", [["F910", "F949", "F946"], "F145"]];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托价格、委托数量)
            return ["F125", "F123", "F140", "F141", "F145", "F144"];
        case 9: //表单提交
            json["F166"] = GetTDX_ID_WTFS(GetMobFormDes("F166"));
            if (json["F166"] == "0") {
                json["F130"] = "1";
            }
            else {
                json["F130"] = "68";
                json["F145"] = "1";
            }
            funcid = "202"; //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F130", json["F130"]);   //买卖标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F145", json["F145"]);   //委托价格
            ix.Set("F133", "0");    //交易单位
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F166", json["F166"]);   //委托方式
            break;
        default:
            break;
    }
    return [funcid, ix];
}

/***********************************************************************************************************************/
//获取报价方式
GetTDX_ID_WTFS = function (str) {
    var json = {
        "0": "限价委托",
        "1": "对手方最优价格",
        "2": "本方最优价格",
        "3": "即时成交剩余撤销",
        "4": "最优五档即时成交剩余撤销",
        "5": "全额成交或撤销",
        "6": "最优五档即时成交剩余转限价"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

/***********************************************************************************************************************/
//表单初始化
SetBDCSHLoadForm = function () {
    try {
        RespondBjfs();
    }
    catch (err) {
    }
};

/***********************************************************************************************************************/
//报价方式响应
RespondBjfs = function () {
    var field = ["F166", "F145", "SJWT"];
    try {
        var value = [];
        for (var i = 0; i < field.length; i++) {
            value.push(GetMobFormDes(field[i]));
        }
        var bjfs = GetTDX_ID_WTFS(value[0]);
        if (bjfs != "0") {
            $("#" + field[1]).parent().hide();
            $("#" + field[2]).parent().show();
            $("#" + field[2]).parent().css("padding-left", "5px");
            return;
        }
    }
    catch (err) {
    }
    $("#" + field[1]).parent().show();
    $("#" + field[2]).parent().hide();
}