﻿//交易发送协议(网络投票)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //投票信息查询
            funcid = "326"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1050", json["F1050"]); //大会编码
            break;
        case 1: //返回投票方案查询所需字段名(证券代码)
            return ["F140"];
        case 2: //投票方案查询
            funcid = "324"; //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F1050", json["F1050"]); //大会编码
            break;
        case 3: //返回投票结果提交所需字段名(投票结果、股东代码、账号类别)
            return ["F335", "F123", "F125"];
        case 4: //投票结果提交
            funcid = "328"; //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F334", json["F334"]);   //投票代码
            ix.Set("F331", json["F1052"]);  //方案代码
            ix.Set("F335", json["F335"]);   //投票结果
            ix.Set("F1217", "SHWLTP");  //备注
            ix.Set("F1050", json["F1050"]); //大会编码
            ix.Set("F234", "1");    //类型
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//投票数据字段设置
SetDataField = function (jsonData) {
    try {
        var field = [
            "F1054",    //累积应选
            "F1056",    //议案类型
            "F1053",    //议案标题
            "F1052" //议案编号
        ];

        //数据字段设置逻辑
        var result = [];
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            result.push(json);

            //数据更改逻辑
            var value = [];
            for (var j = 0; j < field.length; j++) {
                value.push(json[field[j]]);
            }
            switch (value[1]) {
                case "P":   //非累积议案
                    result[i][field[0]] = "0";
                    break;
                case "L":   //累积议案
                    var reg = /^\+?[1-9][0-9]*$/;
                    if (reg.test(Number(value[3]))) {
                        result[i][field[2]] = json[field[2]] + "（" + "当选人数：" + json[field[0]] + "）";
                    }
                    else {
                        result[i][field[0]] = "0";
                    }
                    break;
                default:
                    break;
            }
        }
        return result;
    }
    catch (err) {
    }
    return jsonData;
}