﻿/***********************************************************************************************************************/
//功能脚本(新股申购首页)
Controller.send = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //资金数据查询
            funcid = "104"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F132", "0");    //币种
            break;
        case 1: //市值额度查询
            funcid = "1340";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        default:
            break;
    }
    return [funcid, ix];
}

/***********************************************************************************************************************/
//三方配色方案设置
GetColorConfig = function (key) {
    var skin = $("body").attr("skin");
    switch (skin) {
        case "white": //白色皮肤方案
            switch (key) {
                case "page-background": //页面背景
                    return "rgb(238,242,246)";
                case "area-background": //区域背景
                    return "rgb(46,107,177)";
                case "area-border-color": //区域边界
                    return "rgb(230,233,242)";
                case "area-normal-color": //区域一般字体
                    return "rgb(255,255,255)";
                case "area-light-color": //区域淡化字体
                    return "rgb(168,204,245)";
                case "normal-font-color": //正常字体
                    return "rgb(100,100,100)";
                case "light-font-color": //淡化字体
                    return "rgb(150,150,150)";
                default:
                    return "";
            }
            break;
        default: //默认皮肤方案
            switch (key) {
                case "page-background": //页面背景
                    return "rgb(16,20,25)";
                case "area-background": //区域背景
                    return "rgb(29,34,40)";
                case "area-border-color": //区域边界
                    return "rgb(6,8,11)";
                case "area-normal-color": //区域一般字体
                    return "rgb(255,255,255)";
                case "area-light-color": //区域淡化字体
                    return "rgb(119,122,126)";
                case "normal-font-color": //正常字体
                    return "rgb(255,255,255)";
                case "light-font-color": //淡化字体
                    return "rgb(119,122,126)";
                default:
                    return "";
            }
            break;
    }
}

//初始化数据
GetInitData = function (listData) {
    var jsonData = listData["data"];
    if (typeof (jsonData) != "object" || jsonData.length <= 2) {
        var seats = listData["seats"];
        if (typeof (seats) == "object" && typeof (seats["cells"]) == "object") {
            var cells = seats["cells"];
            if (typeof (cells) == "object") {
                var newjsonData = [{}, {}];
                if (typeof (jsonData) == "object" && typeof (jsonData[0]) == "string") {
                    newjsonData[0]["error"] = jsonData[0];
                }
                for (var j = 0; j < cells.length; j++) {
                    if (typeof (cells[j]) == "object") {
                        newjsonData.push({});
                    }
                }
                for (var j = 0; j < cells.length; j++) {
                    if (typeof (cells[j]) == "object") {
                        for (var k = 0; k < cells[j].length; k++) {
                            if (typeof (cells[j][k]) == "object") {
                                for (var n in cells[j][k]) {
                                    newjsonData[j + 2][n] = "--";
                                }
                            }
                        }
                    }
                }
                return newjsonData;
            }
        }
        else {
            var cells = listData["cells"];
            if (typeof (cells) == "object") {
                var newjsonData = [{}, {}, {}];
                if (typeof (jsonData) == "object" && typeof (jsonData[0]) == "string") {
                    newjsonData[0]["error"] = jsonData[0];
                }
                for (var j = 0; j < cells.length; j++) {
                    if (typeof (cells[j]) == "object") {
                        for (var n in cells[j]) {
                            newjsonData[2][n] = "--";
                        }
                    }
                }
                return newjsonData;
            }
        }
    }
}

//重构申购额度数据
ParseDataSGED = function (jsonData) {
    try {
        var newjsonData = [{}, {}, {}];
        for (var i = 2; i < jsonData.length; i++) {
            var zhlb = jsonData[i]["F125"];
            for (var n in jsonData[i]) {
                for (var j = 0; j < 2; j++) {
                    if (typeof (jsonData[j][n]) == "string") {
                        newjsonData[j][n + zhlb] = jsonData[j][n];
                    }
                }
                newjsonData[2][n + zhlb] = jsonData[i][n];
            }
        }
        return newjsonData;
    }
    catch (err) {
    }
    return jsonData;
}

/***********************************************************************************************************************/
//加载顶部区域
LoadTopArea = function () {
    var div = $("body").children("div");
    var winWidth = $(window).width();
    var rightWidth = Math.round(winWidth * 1 / 2);
    $(div[0]).css("right", rightWidth + "px");
    $(div[1]).css("width", rightWidth + "px");
    var divHeight = $(div[0]).height();
    var HTML = '';
    HTML += '<div style="';
    HTML += 'top:0px;';
    HTML += 'left:0px;';
    HTML += 'right:0px;';
    HTML += 'height:' + divHeight + 'px;';
    HTML += 'position:absolute;';
    HTML += 'overflow:hidden;';
    HTML += 'background-image:url(../../trade/images/top.png);';
    HTML += 'background-size:100% ' + divHeight + 'px;';
    HTML += 'background-position:center;';
    HTML += 'background-repeat:no-repeat;';
    HTML += '">';
    $(div[0]).before(HTML);
}

/***********************************************************************************************************************/
//页面元件加载
LoadPageData = function () {
    LoadTopArea();
    mob_list["background"]["B"] = "transparent";
    mob_list["border-color"] = "transparent";
    mob_list["color"]["T"] = GetColorConfig("area-light-color");
    mob_list["color"]["L"] = GetColorConfig("area-normal-color");
    mob_list["color"]["Z"][2] = mob_list["color"]["L"];
    mob_list["color"]["O"][2] = mob_list["color"]["L"];
    var skin = mob_list["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["background"]["P"] = GetColorConfig("page-background");
    mob_tree["border-color"] = GetColorConfig("area-border-color");
    mob_tree["color"]["P"] = GetColorConfig("light-font-color");
    mob_tree["color"]["H"] = GetColorConfig("normal-font-color");
    mob_tree["color"]["T"] = GetColorConfig("normal-font-color");
    $("body").css("background-color", GetColorConfig("page-background"));
    ReadJsShow("mob_list_" + mob_filename + "_kyzj.js", function (listData) {
        listData["data"] = GetInitData(listData);
        window["dataCache_kyzj"] = listData;
        ReadJsShow("mob_list_" + mob_filename + "_sged.js", function (listData) {
            listData["data"] = GetInitData(listData);
            window["dataCache_sged"] = listData;
            ReadJsShow("mob_tree_" + mob_filename + ".js", function (treeData) {
                window["dataCache_tree"] = treeData;
                window["dataCache_kyzj"] = CreateMobList("kyzj", window["dataCache_kyzj"]);
                window["dataCache_sged"] = CreateMobList("sged", window["dataCache_sged"]);
                window["dataCache_tree"] = CreateMobTree("tree", window["dataCache_tree"]);
                QueryPageData();
            }, mob_tree);
        });
    });
}

//页面数据查询
QueryPageData = function () {
    Controller.call([0, 1], function (n, jsonData) {
        if (typeof (jsonData) == "object" && jsonData.length > 2) {
            switch (n) {
                case 0:
                    window["dataCache_kyzj"]["data"] = jsonData;
                    window["dataCache_kyzj"] = CreateMobList("kyzj", window["dataCache_kyzj"]);
                    break;
                case 1:
                    window["dataCache_sged"]["data"] = ParseDataSGED(jsonData);
                    window["dataCache_sged"] = CreateMobList("sged", window["dataCache_sged"]);
                    break;
                default:
                    break;
            }
        }
        if (n == 1) {
            CallAppFunc({ "Target": 0 }, "WebCall:tdxXgslReq", function (ref) {
                var obj;
                try {
                    obj = JSON.parse(ref);
                }
                catch (err) {
                    obj = ref;
                }
                $("#SGSL").html(obj["SGSL"]);
            });
        }
    });
}

/***********************************************************************************************************************/
LoadPageData();