﻿//交易发送协议(信用投票)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、表决意见ID、表决意见内容、存在关系ID、存在关系内容)
            return ["F123", json["gddm"], "bjyj", GetTDX_ID_BJYJ(), "czgx", GetTDX_ID_CZGX()];
        case 1:
            break;
        case 2: //证券代码
            return ["F140"];
        case 3: //投票信息查询
            var pars = ParseParmStr(window.location.search.slice(1));
            funcid = "326"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F334", json["F140"]);   //投票代码
            ix.Set("F331", pars["F331"]);   //方案代码
            ix.Set("F1050", pars["F1050"]); //大会编码
            break;
        case 4: //返回投票信息展示所需字段名(投票代码、方案代码、类型)
            return ["F334", "F331", "F234"];
        case 5:
            break;
        case 6:
            break;
        case 7:
            break;
        case 8: //返回表单提交所需字段名(账号类别、股东代码、投票代码、方案代码)
            return ["F125", "F123", "F334", "F331"];
        case 9: //表单提交
            var pars = ParseParmStr(window.location.search.slice(1));
            funcid = "328"; //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F334", json["F334"]);   //投票代码
            ix.Set("F331", json["F331"]);   //方案代码
            ix.Set("F335", json["tpjg"]);   //投票结果
            ix.Set("F1227", json["czgx"]);  //参数
            ix.Set("F333", json["falx"]);   //方案类型
            ix.Set("F1050", pars["F1050"]); //大会编码
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//获取表决意见
GetTDX_ID_BJYJ = function (str) {
    var json = {
        "1": "同意",
        "2": "反对",
        "3": "弃权"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//获取存在关系
GetTDX_ID_CZGX = function (str) {
    var json = {
        "0": "存在关系",
        "2": "不存在关系"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//获取议案类型
GetTDX_ID_LX = function (str) {
    var json = {
        "0": "表决制",
        "1": "累积投票制"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//数据字段翻译
GetZQXXFieldWord = function (n) {
    switch (n) {
        case 0: //返回议案类型字段(类型)
            return "F234";
        case 1: //议案类型内容
            return { "0": GetTDX_ID_LX("0"), "1": GetTDX_ID_LX("1") };
        default:
            break;
    }
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        var id = ["bjyj", "tpps"];
        for (var i = 0; i < id.length; i++) {
            $("#" + id[i]).parent().parent().parent().parent().hide();
        }
    }
    catch (err) {
    }
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        var id = ["bjyj", "tpps"];
        switch (zqxxCache[2]["F234"]) {
            case "0":   //表决制
                $("#" + id[0]).parent().parent().parent().parent().show();
                $("#" + id[1]).parent().parent().parent().parent().hide();
                break;
            case "1":   //累积投票制
                $("#" + id[0]).parent().parent().parent().parent().hide();
                $("#" + id[1]).parent().parent().parent().parent().show();
                break;
            default:
                break;
        }
        $("#F123").html(GetZhlbGddm(zqxxCache[2]["F125"]));
    }
    catch (err) {
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    var id = ["bjyj", "tpps", "tpjg", "falx", "czgx"];
    switch (array[1]["F234"]) {
        case "0":   //表决制
            json[id[2]] = GetTDX_ID_BJYJ(GetMobFormDes(id[0]));
            json[id[3]] = "1";
            break;
        case "1":   //累积投票制
            json[id[2]] = GetMobFormDes(id[1]);
            json[id[3]] = "0";
            break;
        default:
            break;
    }
    json[id[4]] = GetTDX_ID_CZGX(GetMobFormDes(id[4]));
    return json;
}