﻿//交易发送协议(约定回购初始交易)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、资金用途字段、资金用途内容)
            return ["F123", json["gddm"], "F1217", GetTDX_ID_SDK_ZJYT()];
        case 1: //配套查询
            funcid = "2070";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //证券信息查询
            json["F144"] = GetMobFormDes("F144");   //证券数量
            json["F148"] = GetMobFormDes("F148");   //委托金额
            json["CSRQ"] = GetMobFormDes("CSRQ").replace(/-/g, ""); //初始日期
            json["GHRQ"] = GetMobFormDes("GHRQ").replace(/-/g, ""); //购回日期
            funcid = "2098";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "0");    //操作标志
            if (typeof (json["F140"]) == "string" && json["F140"] != "") {
                ix.Set("F140", json["F140"]);   //证券代码
            }
            else {
                funcid = "";
            }
            if (typeof (json["F144"]) == "string" && json["F144"] != "") {
                ix.Set("F144", json["F144"]);   //委托数量
            }
            else {
                funcid = "";
            }
            ix.Set("F148", json["F148"]);   //委托金额
            ix.Set("F142", json["CSRQ"]);   //委托日期
            ix.Set("F1199", json["GHRQ"]);  //到期日
            break;
        case 4: //返回证券信息展示或查询所需字段名(证券名称、成交金额)
            return ["F141", "F154"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            return [];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托数量、委托金额、初始日期、购回日期、备注)
            return ["F125", "F123", "F140", "F141", "F144", "F148", "CSRQ", "GHRQ", "F1217"];
        case 9: //表单提交
            funcid = "2098";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "1");   //操作标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F148", json["F148"]);   //委托金额
            ix.Set("F142", json["CSRQ"].replace(/-/g, "")); //初始日期
            ix.Set("F1199", json["GHRQ"].replace(/-/g, ""));    //购回日期
            ix.Set("F1217", json["F1217"]); //备注
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    var skin = mob_form["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["cells"] = [
        "",
        {
            "bdzq": [
                { "text": ["标的证券"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "cccx": [
                { "text": ["股票持仓"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "cplv": [
                { "text": ["产品利率"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "sxed": [
                { "text": ["授信额度"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ]
        },
        ""
    ];
    mob_tree["fun"] = "RespondGotoPage";
    CreateMobTree("tree", mob_tree);

    //交易提示
    try {
        if ($("#tip").length == 0) {
            var HTML = '';
            HTML += '<div id="tip" style="';
            HTML += 'font-size:' + mob_form["font"][0] + ';';
            HTML += 'font-weight:' + mob_form["font"][1] + ';';
            HTML += 'color:' + mob_form["color"]["T"];
            HTML += '">';
            HTML += '</div>';
            $("#table").after(HTML);
        }
        ReadFileString("mob_form_" + mob_filename + "_tip.txt", function (str) {
            if (typeof (str) == "string") {
                $("#tip").html(str);
            }
        });
    }
    catch (err) {
    }
}

//页面跳转
RespondGotoPage = function (dom) {
    var id = dom.id;
    switch (id) {
        case "bdzq": //标的证券
            LocationHref("works/ydhg/ydhgbdzq.html", "约定回购标的证券查询");
            break;
        case "cccx": //股票持仓
            LocationHref("works/ydhg/ydhgcccx.html", "约定回购持仓查询");
            break;
        case "cplv": //产品利率
            LocationHref("works/ydhg/ydhgcplv.html", "约定回购产品利率查询");
            break;
        case "sxed": //授信额度
            LocationHref("works/ydhg/ydhgsxed.html", "约定回购授信额度查询");
            break;
        default:
            break;
    }
}

//获取资金用途
GetTDX_ID_SDK_ZJYT = function (str) {
    var json = {
        "1": "1.补充流动资金",
        "2": "2.投资",
        "3": "3.突发事件应急",
        "4": "4.日常生活需要",
        "5": "5.其他"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//扩展区域字段
GetKZQYFieldWord = function (jsonData) {
    try {
        var field = ["F142", "GHRQ", "CSRQ", "GHQX"]; //委托日期、购回日期、初始日期、购回期限
        var WTRQ = jsonData[2][field[0]];
        if (typeof (WTRQ) == "string" && WTRQ != "") {
            var GHRQ = FormatDate(WTRQ);
            SetMobFormDes(field[1], GHRQ);
        }
    }
    catch (err) {
    }
    return jsonData;
}

//约定回购信息查询响应
RespondYDHGXXCX = function () {
    var field = GetSendData(2);
    var dom = document.getElementById(field[0]);
    RespondCx(dom);
}

//计算购回期限
RespondJSGHQX = function () {
    var field = ["GHRQ", "CSRQ", "GHQX"]; //购回日期、初始日期、购回期限
    var GHRQ = GetMobFormDes(field[0]);
    var CSRQ = GetMobFormDes(field[1]);
    var startTime = new Date(Date.parse(CSRQ.replace(/-/g, "/"))).getTime();
    var endTime = new Date(Date.parse(GHRQ.replace(/-/g, "/"))).getTime();
    var GHQX = (endTime - startTime) / (1000 * 60 * 60 * 24);
    SetMobFormDes(field[2], GHQX);
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        RespondJSGHQX();
    }
    catch (err) {
    }
}

//同意委托提交响应
RespondTjByAgree = function (dom) {
    try {
        var field = ["TYSB"]; //同意申报交易委托
        var value = [];
        for (var i = 0; i < field.length; i++) {
            value.push(GetMobFormDes(field[0]));
        }
        for (var i = 0; i < field.length; i++) {
            switch (i) {
                case 0: //同意申报交易委托
                    if (value[0][0]) {
                        RespondTj(dom); //提交响应
                    }
                    else {
                        alert(GetMobTextZH("请勾选“" + value[0][1] + "”后再委托！"));
                    }
                    break;
                default:
                    break;
            }
        }
    }
    catch (err) {
        alert("同意委托提交失败，配置有误\r\n" + err);
    }
}