﻿//交易发送协议(约定回购履约保障交易)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、初始成交编号字段、初始成交编号内容)
            return ["F123", json["gddm"], "F5601", GetTDX_ID_CSCJBH()];
        case 1: //配套查询
            funcid = "2072";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //证券信息查询
            json["zhlb"] = hqcxCache[2]["F125"];
            json["F5601"] = GetMobFormDes("F5601");
            json["F1227"] = GetStockData("F5601", json["F5601"], "F1227");    //参数
            json["F144"] = GetMobFormDes("F144");   //证券数量
            json["F148"] = GetMobFormDes("F148");   //委托金额
            json["CSRQ"] = GetMobFormDes("CSRQ").replace(/-/g, ""); //初始日期
            json["GHRQ"] = GetMobFormDes("GHRQ").replace(/-/g, ""); //购回日期
            funcid = "2098";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "2");    //操作标志
            ix.Set("F1227", json["F1227"]); //参数
            if (typeof (json["F140"]) == "string" && json["F140"] != "") {
                ix.Set("F140", json["F140"]);   //证券代码
            }
            else {
                funcid = "";
            }
            if (typeof (json["F144"]) == "string" && json["F144"] != "") {
                ix.Set("F144", json["F144"]);   //委托数量
            }
            else {
                funcid = "";
            }
            ix.Set("F148", json["F148"]);   //委托金额
            ix.Set("F142", json["CSRQ"]);   //委托日期
            ix.Set("F146", json["F5601"]);  //委托编号
            ix.Set("F1199", json["GHRQ"]);  //到期日
            break;
        case 4: //返回证券信息展示或查询所需字段名(证券名称、委托金额、成交金额、保证金比例)
            return ["F141", "F148", "F154", "F546"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6:
            break;
        case 7:
            return [];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托数量、委托金额、初始日期、委托编号、购回日期)
            return ["F125", "F123", "F140", "F141", "F144", "F148", "CSRQ", "F5601", "GHRQ"];
        case 9: //表单提交
            funcid = "2098";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "3");   //操作标志
            ix.Set("F1227", json["F1227"]); //参数
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F148", json["F148"]);   //委托金额
            ix.Set("F142", json["CSRQ"].replace(/-/g, "")); //初始日期
            ix.Set("F146", json["F5601"]);  //委托编号
            ix.Set("F1199", json["GHRQ"].replace(/-/g, ""));    //购回日期
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    var skin = mob_form["skin"];
    if (typeof (skin) == "string") {
        mob_tree = window[skin + "_mob_tree"];
    }
    mob_tree["cells"] = [
        "",
        {
            "wghhy": [
                { "text": ["未购回合约"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "cccx": [
                { "text": ["股票持仓"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "cplv": [
                { "text": ["产品利率"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ],
            "sxed": [
                { "text": ["授信额度"] },
                { "icon": ["../../trade/images/right.png", "", ["7px", "13px"]] }
            ]
        },
        ""
    ];
    mob_tree["fun"] = "RespondGotoPage";
    CreateMobTree("tree", mob_tree);

    //表单信息展示
    var field = "F5601"; //初始成交编号
    RespondCSCJBH($("#" + field)[0]);
}

//页面跳转
RespondGotoPage = function (dom) {
    var id = dom.id;
    switch (id) {
        case "wghhy": //未购回合约
            LocationHref("works/ydhg/ydhgwghhy.html", "约定回购未购回合约查询");
            break;
        case "cccx": //股票持仓
            LocationHref("works/ydhg/ydhgcccx.html", "约定回购持仓查询");
            break;
        case "cplv": //产品利率
            LocationHref("works/ydhg/ydhgcplv.html", "约定回购产品利率查询");
            break;
        case "sxed": //授信额度
            LocationHref("works/ydhg/ydhgsxed.html", "约定回购授信额度查询");
            break;
        default:
            break;
    }
}

//获取初始成交编号
GetTDX_ID_CSCJBH = function () {
    var result = [];
    try {
        var field = "F5601"; //初始成交编号
        for (var i = 2; i < stockData.length; i++) {
            var value = stockData[i][field];
            if (typeof (value) == "string" && value != "") {
                result.push(value);
            }
        }
    }
    catch (err) {
    }
    return result;
}

//初始成交编号响应
RespondCSCJBH = function (dom) {
    try {
        var field = ["F5605"]; //购回交易日
        var fieldx = ["GHRQ"]; //购回日期
        for (var i = 0; i < field.length; i++) {
            var n0 = dom.id;
            var m0 = GetMobFormDes(n0);
            var n1 = field[i];
            var m1 = GetStockData(n0, m0, n1);
            if (typeof (m1) == "string" && m1 != "") {
                if (i == 0) {
                    var nx = fieldx[i];
                    var mx = FormatDate(m1);
                    SetMobFormDes(nx, mx);
                }
                else {
                    SetMobFormDes(n1, m1);
                }
            }
        }
    }
    catch (err) {
    }
}

//扩展区域字段
GetKZQYFieldWord = function (jsonData) {
    try {
        var field = ["F142", "GHRQ", "CSRQ", "GHQX"]; //委托日期、购回日期、初始日期、购回期限
        var WTRQ = jsonData[2][field[0]];
        if (typeof (WTRQ) == "string" && WTRQ != "") {
            var GHRQ = FormatDate(WTRQ);
            SetMobFormDes(field[1], GHRQ);
        }
    }
    catch (err) {
    }
    return jsonData;
}

//约定回购信息查询响应
RespondYDHGXXCX = function () {
    var field = GetSendData(2);
    var dom = document.getElementById(field[0]);
    RespondCx(dom);
}

//计算购回期限
RespondJSGHQX = function () {
    var field = ["GHRQ", "CSRQ", "GHQX"]; //购回日期、初始日期、购回期限
    var GHRQ = GetMobFormDes(field[0]);
    var CSRQ = GetMobFormDes(field[1]);
    var startTime = new Date(Date.parse(CSRQ.replace(/-/g, "/"))).getTime();
    var endTime = new Date(Date.parse(GHRQ.replace(/-/g, "/"))).getTime();
    var GHQX = (endTime - startTime) / (1000 * 60 * 60 * 24);
    SetMobFormDes(field[2], GHQX);
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        RespondJSGHQX();
    }
    catch (err) {
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    var field = ["F5601", "F1227", "F125"]; //初始成交编号、参数、账号类别
    json[field[1]] = GetStockData(field[0], json[field[0]], field[1]);
    json[field[2]] = hqcxCache[2][field[2]];
    json["zhlb"] = json[field[2]];
    return json;
}