﻿//交易发送协议(银行理财电子合同签署列表)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //电子合同列表查询
            funcid = "160";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "3");    //操作标志
            ix.Set("F397", "3");    //产品标志
            ix.Set("F1207", "P");   //起始序号
            break;
        case 1: //电子合同信息查询
            funcid = "162";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F391"]);   //证券代码
            ix.Set("F397", "3");    //产品标志
            break;
        case 2: //电子合同信息展示所需字段名(URL、提示信息1、URL2)
            return ["F1249", "F251", "F1256"];
        case 3: //客户信息查询
            funcid = "2118";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "0");    //操作标志
            break;
        case 4: //客户信息展示所需字段名(客户名称、性别、证件类别、证件号码、用户联系方式、邮政编码、用户EMAIL、用户通讯地址)
            return [["F122", "F952", "F452", "F454", "F128", "F953", "F129", "F950"]];
        case 5: //阅读内容排序
            return [3, 0, 1, 2];
        case 6: //阅读内容类型
            return ["json", "web", "web", "web"];
        case 7: //签署协议提交(风险标志)
            funcid = "156"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "0");    //操作标志
            ix.Set("F140", json["F391"]);   //证券代码
            ix.Set("F1227", json["F1227"]); //参数
            ix.Set("F397", "3");    //产品标志
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 8: //返回风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 9: //签署协议提交
            funcid = "156"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "0");    //操作标志
            ix.Set("F140", json["F391"]);   //证券代码
            ix.Set("F1227", json["F1227"]); //参数
            ix.Set("F397", "3");    //产品标志
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//数据字段设置
SetDataField = function (jsonData) {
    try {
        var field = [
            "F147", //状态说明
            "F395"  //产品状态
        ];

        //数据字段设置逻辑
        var result = [];
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            for (var n in json) {
                var m = json[n];
                switch (n) {
                    case field[0]:  //状态说明
                        switch (m) {
                            case "未签约":
                                json[n + "_" + 0] = "0";
                                break;
                            default:
                                json[n + "_" + 0] = "1";
                                break;
                        }
                        break;
                    default:
                        break;
                }
            }

            //筛选逻辑
            var value = [];
            for (var j = 0; j < field.length; j++) {
                value.push(json[field[j]]);
            }
            switch (value[1]) {
                case "0":
                    result.push(json);
                    break;
                default:
                    break;
            }
        }
        return result;
    }
    catch (err) {
    }
    return jsonData;
}

//合同内容字段
GetHTNRFieldWord = function (array) {
    var result = [];
    try {
        var heads = ["客户姓名", "性别", "证件类型", "证件号码", "联系电话", "邮政编码", "电子邮件", "联系地址"];
        for (var i = 0; i < array.length; i++) {
            var temp = array[i];
            if (i == 0) {
                var num = 0;
                for (var n in temp[0]) {
                    //数据描述重写
                    temp[1][n] = heads[num];
                    num += 1;

                    //数据内容翻译
                    var m = temp[2][n];
                    switch (n) {
                        case "F952": //性别
                            temp[2][n] = GetCustData(3, m);
                            break;
                        case "F452": //证件类别
                            temp[2][n] = GetCustData(1, m);
                            break;
                        default:
                            break;
                    }
                }
            }
            result.push(temp);
        }
    }
    catch (err) {
        result = array;
    }
    return result;
}

//获取自定义数据集
GetCustData = function (type, str) {
    var json;
    switch (type) {
        case 0: //开户标志
            json = {
                "0": "首次开设基金账号",
                "1": "使用已有基金账号"
            };
            break;
        case 1: //证件类型
            json = {
                "0": "身份证",
                "1": "护照",
                "2": "营业执照",
                "3": "军官证"
            };
            break;
        case 2: //账单方式
            json = {
                "1": "不寄送",
                "2": "按月寄送",
                "3": "按季寄送",
                "4": "半年寄送",
                "5": "一年寄送"
            };
            break;
        case 3: //性别
            json = {
                "0": "男",
                "1": "女"
            };
            break;
        case 4: //职业
            json = {
                "1": "工程师",
                "2": "公务员",
                "3": "学生",
                "4": "待业",
                "5": "其他"
            };
            break;
        case 5: //教育程度
            json = {
                "1": "研究生",
                "2": "本科",
                "3": "专科",
                "4": "高中",
                "5": "初中",
                "6": "小学",
                "7": "其他"
            };
            break;
        default:
            json = {};
            break;
    }
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}