﻿//交易发送协议(银行理财开户)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(开户标志内容、证件类型内容、账单方式内容、性别内容、职业内容、教育程度内容)
            return [json["khbz"], json["zjlx"], json["zdfs"], json["xb"], json["zy"], json["jycd"]];
        case 1: //基金公司查询
            funcid = "2124";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            ix.Set("F397", "3");    //产品标志
            break;
        case 2: //返回基金公司展示所需字段名(基金公司代码、基金公司名称)
            return ["F426", "F401"];
        case 3: //开放式基金资金帐户开户查询
            funcid = "2118";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F113", "0");    //操作标志
            ix.Set("F397", "3");    //产品标志
            break;
        case 4: //返回开放式基金资金帐户开户展示所需字段名(基金账户、客户名称、用户通讯地址、用户联系方式、用户EMAIL、证件号码、移动电话、住宅电话、单位电话、传真、年收入、邮政编码)
            return ["F417", "F122", "F950", "F128", "F129", "F454", "F455", "F456", "F463", "F457", "F459", "F953"];
        case 5: //返回表单多选下拉框展示所需字段名(开户类别、证件类别、对账单标志、性别、职业、教育程度)
            return ["F450", "F452", "F467", "F952", "F465", "F458"];
        case 6: //表单提交
            funcid = "2118";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F113", "1");    //操作标志
            ix.Set("F122", json["F122"]);   //客户名称
            ix.Set("F950", json["F950"]);   //用户通讯地址
            ix.Set("F128", json["F128"]);   //用户联系方式
            ix.Set("F129", json["F129"]);   //用户EMAIL
            ix.Set("F450", json["F450"]);   //开户类别
            ix.Set("F454", json["F454"]);   //证件号码
            ix.Set("F455", json["F455"]);   //移动电话
            ix.Set("F456", json["F456"]);   //住宅电话
            ix.Set("F463", json["F463"]);   //单位电话
            ix.Set("F457", json["F457"]);   //传真
            ix.Set("F458", json["F458"]);   //教育程度
            ix.Set("F459", json["F459"]);   //年收入
            ix.Set("F465", json["F465"]);   //职业
            ix.Set("F467", json["F467"]);   //对账单标志
            ix.Set("F952", json["F952"]);   //性别
            ix.Set("F953", json["F953"]);   //邮政编码
            ix.Set("F452", json["F452"]);   //证件类别
            ix.Set("F466", json["F466"]);   //分红标志
            ix.Set("F464", json["F122"]);   //姓名
            ix.Set("F397", "3");    //产品标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//证件类别字典
GetTDX_ID_ZJLB = function (str) {
    var json = {
        "0": "身份证",
        "1": "护照",
        "2": "军官证",
        "4": "回乡证",
        "5": "户口本",
        "6": "外国护照",
        "7": "技术监督局代码",
        "8": "营业执照",
        "9": "行政机关",
        "10": "社会团体",
        "11": "军队",
        "12": "武警",
        "13": "下属机构",
        "14": "基金会",
        "99": "其他"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//获取分红标志
GetTDX_ID_FHBZ = function (str) {
    var json = {
        "1": "红利转投",
        "2": "现金分红"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        var field = "F466"; //分红标志
        var value = GetTDX_ID_FHBZ();
        SetMobFormDes(field, value);
    }
    catch (err) {
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        var field = "F466"; //分红标志
        var value = GetMobFormDes(field);
        json[field] = GetTDX_ID_FHBZ(value);
    }
    catch (err) {
    }
    return json;
}