﻿//交易发送协议(银行理财认购)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容
            return [];
        case 1: //帐号查询
            funcid = "2262"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //配套查询
            funcid = "2256"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            ix.Set("F113", "0");    //操作标志
            break;
        case 3: //返回信息查询所需字段名(基金代码、银行产品代码、银行产品名称)
            return ["F402", "F1136", "F1137"];
        case 4: //信息查询
            json["F426"] = GetFundData("F1136", json["F402"], "F393");  //产品公司代码
            funcid = "2110";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "0");    //交易标志
            ix.Set("F397", "3");    //产品标志
            break;
        case 5: //返回信息展示所需字段名(基金名称、基金净值、可用资金)
            return ["F403", "F406", "F301"];
        case 6: //返回表单提交所需字段名(基金公司代码、基金账户、基金代码、基金名称、交易金额)
            return ["F426", "F417", "F402", "F403", "F405"];
        case 7: //表单提交(风险标志)
            funcid = "2100"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "0");    //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F397", "3");    //产品标志
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 8: //返回表单提交风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 9: //表单提交
            funcid = "2100"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F426", json["F426"]);   //基金公司代码
            ix.Set("F417", json["F417"]);   //基金账户
            ix.Set("F402", json["F402"]);   //基金代码
            ix.Set("F400", "0");    //交易标志
            ix.Set("F405", json["F405"]);   //交易金额
            ix.Set("F397", "3");    //产品标志
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//表单初始化
SetBDCSHLoadForm = function () {
    try {
        var field = ["F425"]; //基金状态
        var result = [];
        var jsonData = fundData;
        result.push(jsonData[0]);
        result.push(jsonData[1]);
        for (var i = 2; i < jsonData.length; i++) {
            var json = jsonData[i];
            for (var n in json) {
                var m = json[n];
                switch (n) {
                    case field[0]:  //基金状态
                        switch (m) {
                            case "2": //认购期
                                result.push(json);
                                break;
                            default:
                                break;
                        }
                        break;
                    default:
                        break;
                }
            }
        }
        fundData = result;
    }
    catch (err) {
    }
}

//表单已查询
SetBDYCXLoadForm = function () {
    try {
        //表单信息显示
        var field = ["F402", "F1136"];  //产品代码输入框ID、银行产品代码字段
        var value = GetMobFormDes(field[0]);
        var json = GetFundData(field[1], value);
        var formData = dataCache;
        for (var n in json) {
            var m = json[n];
            if (typeof (m) == "string" && m != "") {
                formData["data"][2][n] = m;
            }
        }
        dataCache = CreateMobTable("table", formData);
    }
    catch (err) {
    }

    try {
        //资金余额查询
        if (typeof (Controller) != "object") {
            ReadJavaScript("../../trade/Controller/Controller.js", function () {
                SetZJYEForForm();
            });
        }
        else {
            SetZJYEForForm();
        }
    }
    catch (err) {
    }
}

//资金余额查询
SetZJYEForForm = function () {
    try {
        Controller.send = function (n, json) {
            var funcid = "";
            var ix = new IXContent();
            switch (n) {
                case 0: //资金余额
                    funcid = "104"; //功能号
                    ix.Set("F110", json["wtfs"]);   //委托方式
                    ix.Set("F132", "-1");   //币种
                    ix.Set("F113", "-1");   //操作标志
                    break;
                default:
                    break;
            }
            return [funcid, ix];
        }
        Controller.call([0], function (n, jsonData) {
            try {
                var field = "F301"; //可用资金
                var value = jsonData[2][field];
                SetMobFormDes(field, value);
            }
            catch (er) {
            }
        });
    }
    catch (err) {
    }
}

//表单提交字段
GetBDTJFieldWord = function (json, array) {
    try {
        //发送数据添加
        var field = ["F426", "F417", "F393", "F417", "F1137"]; //基金公司代码、基金账户、产品公司代码、理财账户、银行产品名称
        var value = [json[field[0]], "", json[field[0]], "", ""];
        value[3] = GetAccount(field[2], value[2], field[3]);
        value[1] = value[3];
        for (var i = 0; i < field.length; i++) {
            if (typeof (value[i]) == "string" && value[i] != "") {
                json[field[i]] = value[i];
            }
        }
        json[field[3] + "_" + 0] = "产品账号";
        json[field[1] + "_" + 0] = json[field[3] + "_" + 0];
        json[field[4] + "_" + 0] = "产品名称";
    }
    catch (err) {
    }
    return json;
}