﻿//交易发送协议(债券业务融资回购)
GetSendData = function (n, json) {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
        case 0: //返回表单多选下拉框所需内容(股东代码字段、股东代码内容、报价方式字段、报价方式内容)
            return ["F123", json["gddm"], "F166", GetTDX_FLAG_WTLB("0")];
        case 1: //配套查询
            funcid = "1240";    //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F1207", "P");   //起始序号
            break;
        case 2: //返回证券信息查询所需字段名(证券代码)
            return ["F140"];
        case 3: //证券信息查询
            funcid = "1124";    //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F130", "0");   //买卖标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F1223", "1");   //检查风险标志
            ix.Set("F166", GetTDX_FLAG_WTLB(GetMobFormDes("F166")));    //委托方式
            break;
        case 4: //返回证券信息展示所需字段名(证券名称、可用资金)
            return ["F141", "F301"];
        case 5: //行情查询
            funcid = "102"; //功能号
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            break;
        case 6: //计算可买(卖)数
            funcid = "110"; //功能号
            ix.Set("F125", json["zhlb"]);   //账号类别
            ix.Set("F123", json["gddm"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F130", "19");   //买卖标志
            ix.Set("F949", json["F145"]);   //当前价
            ix.Set("F301", json["F301"]);   //可用资金
            ix.Set("F166", GetTDX_FLAG_WTLB(GetMobFormDes("F166")));    //委托方式
            ix.Set("F514", "0");    //投保标志
            ix.Set("F113", "0");    //操作标志
            break;
        case 7: //返回可买(卖)数展示所需字段名(可用股份、卖一价、当前价、昨收价、委托价格)
            return ["F201", [["F930", "F949", "F946"], "F145"]];
        case 8: //返回表单提交所需字段名(账号类别、股东代码、证券代码、证券名称、委托价格、委托数量)
            return ["F125", "F123", "F140", "F141", "F145", "F144"];
        case 9: //表单提交(风险标志)
            funcid = "202";    //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F130", "0");    //买卖标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F145", json["F145"]);   //委托价格
            ix.Set("F133", "2");    //交易单位
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F166", GetTDX_FLAG_WTLB(GetMobFormDes("F166")));    //委托方式
            ix.Set("F1223", "1");   //检查风险标志
            break;
        case 10: //返回表单提交风险提示所需字段名(检查风险标志、返回信息、提示信息1、提示信息2)
            return ["F1223", "F149", "F251", "F252"];
        case 11: //表单提交
            funcid = "202";    //功能号
            ix.Set("F125", json["F125"]);   //账号类别
            ix.Set("F123", json["F123"]);   //股东代码
            ix.Set("F110", json["wtfs"]);   //委托方式
            ix.Set("F130", "0");    //买卖标志
            ix.Set("F140", json["F140"]);   //证券代码
            ix.Set("F145", json["F145"]);   //委托价格
            ix.Set("F133", "2");    //交易单位
            ix.Set("F144", json["F144"]);   //委托数量
            ix.Set("F166", GetTDX_FLAG_WTLB(GetMobFormDes("F166")));    //委托方式
            ix.Set("F1223", "0");   //检查风险标志
            break;
        default:
            break;
    }
    return [funcid, ix];
}

//获取报价方式
GetTDX_FLAG_WTLB = function (str) {
    var json = {
        "0": "限价委托",
        "1": "对方最优",
        "2": "本方最优",
        "3": "即成剩撤",
        "4": "五档剩撤",
        "5": "全额委托",
        "6": "五档剩转"
    };
    if (typeof (DataZH) == "function") {
        json = DataZH(json);
    }
    var array = [];
    for (var n in json) {
        var m = json[n];
        if (str == undefined) {
            array.push(m);
        }
        else {
            if (str == n) {
                return m;
            }
            if (str == m) {
                return n;
            }
        }
    }

    if (array.length > 0) {
        return array;
    }
    else {
        return "";
    }
}