﻿//交易发送协议(新股申购)
GetSendData = function (n, json) {
  var funcid = "";
  var ix = new IXContent();
  switch (n) {
    case 0: //查询IPO列表
      funcid = "1156";    //功能号
      ix.Set("F110", json["wtfs"]);   //委托方式
      ix.Set("F126", json["endDate"]);    //开始日期
      ix.Set("F127", json["endDate"]);    //终止日期
      ix.Set("F1207", "P");   //起始序号
      break;
    case 1: //资金数据查询
      funcid = "104"; //功能号
      ix.Set("F110", json["wtfs"]);   //委托方式
      ix.Set("F132", "0");    //币种
      break;
    case 2: //返回资金数据显示所需字段名(可用资金)
      return ["F301"];
    case 3: //返回金额数据计算所需字段名(委托价格)
      return ["F145"];
    case 4:
      break;
    case 5: //返回表单提交所需字段名(账号类别、股东代码、委托数量)
      return ["F125", "F123", "F144"];
    case 6: //表单提交
      funcid = "202"; //功能号
      ix.Set("F125", json["F125"]);   //账号类别
      ix.Set("F123", json["F123"]);   //股东代码
      ix.Set("F110", json["wtfs"]);   //委托方式
      ix.Set("F130", "0");    //买卖标志
      ix.Set("F140", json["F140"]);   //证券代码
      ix.Set("F145", json["F145"]);   //委托价格
      ix.Set("F144", json["F144"]);   //委托数量
      ix.Set("F166", "0");    //委托方式
      break;
    default:
      break;
  }
  return [funcid, ix];
}

//新增数据查询流程
GetSendData_Extend = function (n, json, array) {
  if (typeof (array) != "object") {
    var funcid = "";
    var ix = new IXContent();
    switch (n) {
      case 0: //查询市值额度
        funcid = "1340";    //功能号
        ix.Set("F110", json["wtfs"]);   //委托方式
        ix.Set("F1207", "P");   //起始序号
        break;
      default:
        break;
    }
    return [funcid, ix];
  }
  else {
    try {
      var field = [
        "F10017",    //新股申购额度
        "F125"  //账号类别
      ];

      //数据字段添加逻辑
      var jsonData = array[0];
      var listData = array[1];
      var result = [];
      for (var i = 0; i < jsonData.length; i++) {
        var json = jsonData[i];
        if (i < 2) {
          var list = listData[i];
          json[field[0]] = list[field[0]];
        }
        else {
          json[field[0]] = "0";
          for (var j = 2; j < listData.length; j++) {
            var list = listData[j];
            var Sc0 = GetJYSCJC(json[field[1]]);
            var Sc1 = GetJYSCJC(list[field[1]]);
            if (typeof (Sc0) == "string" && typeof (Sc1) == "string" && Sc0 == Sc1) {
              json[field[0]] = list[field[0]];
              break;
            }
          }
        }
        result.push(json);
      }
      return result;
    }
    catch (err) {
      return jsonData;
    }
  }
}

//获取交易市场简称
GetJYSCJC = function (zhlb) {
  try {
    switch (zhlb.toString()) {
      case "0":   //深证A股
      case "2":   //深证B股
        return "Ss";
      case "1":   //上证A股
      case "3":   //上证B股
        return "Hs";
      default:
        break;
    }
  }
  catch (err) {
  }
}

//数据字段修正
CorrDataField = function (jsonData) {
  try {
    var field = [
      "F962", //最低数量
      "F125"  //账号类别
    ];

    //数据字段修正逻辑
    var result = [];
    result.push(jsonData[0]);
    result.push(jsonData[1]);
    for (var i = 2; i < jsonData.length; i++) {
      var json = jsonData[i];
      var value = [json[field[0]], json[field[1]]];
      switch (value[1].toString()) {
        case "0":   //深证A股
        case "2":   //深证B股
          value[0] = Math.max(Number(value[0]), 500).toString();
          break;
        case "1":   //上证A股
        case "3":   //上证B股
          value[0] = Math.max(Number(value[0]), 1000).toString();
          break;
        default:
          break;
      }
      json[field[0]] = value[0];
      result.push(json);
    }
    return result;
  }
  catch (err) {
  }


  return jsonData;
}

//数据字段添加
AddDataField = function (jsonData) {

  try {
    var field = [
      "sgsl", //新增字段名(申购数量)
      "F10017",    //新股申购额度
      "F961"  //最高数量
    ];


    //数据字段添加逻辑
    var result = [];
    result.push(jsonData[0]);
    result.push(jsonData[1]);
    for (var i = 2; i < jsonData.length; i++) {
      var json = jsonData[i];
      var value = ["", json[field[1]], json[field[2]]];
      value[0] = Math.min(Number(value[1]), Number(value[2]));
      if (!isNaN(value[0])) {
          json[field[0]] = value[0].toString();
      }
      result.push(json);
    }
    if (jsonData.length <= 2) {

      result=['<br/><br/>今日没有可以申购的新股'];
    }
    return result;
  }
  catch (err) {
  }
  if (jsonData.length <= 2) {

    jsonData = ['<br/><br/>今日没有可以申购的新股']
  }
  return jsonData;
}

//数据字段复制
GetCopyField = function (n) {
  switch (n) {
    case 0: //返回全选后需要复制内容的字段
      return "sgsl";
    case 1: //返回需要填写复制内容的元件id
      return "fill";
    default:
      break;
  }
}