/*数据配置对象
strtext: 	['','','','']
jsnfile: 	jsn数据文件 "jsnfile":"list/yzyq01.jsn"
childjsnfile: 子jsn文件夹 "childjsnfile":"yzyq/"
template: 	[1,4]模板
sorttype:   倒序升序
sortcol:    排序列
hashqreq: 	是否请求行情文件数据 false|true
childcfg: 	关联子配置文件
gotof5: 	跳转行情 false|true (点击整块区域跳转)
titlelist:  显示标题列表 [{"name":"行业分类", "align":"center", "width":"25%"} ...]
titlefixed: 列表模板的表头是否固定 false|true

datacol:////数据列表字段
colname: 	；列名称
datatype:	S	字符串
			F	浮点数
			I	整数
			D0	日期20150101
			D1	日期2015-01-01
			D2	日期2015/01/01
			D3	日期2015年01月01日
			D4	日期150101
			D5	日期15-01-01
			D6	日期15/01/01
			D7	日期15年01月01日
			D8	日期0101
			D9	日期01-01
			D10	日期01/01
			D11	日期01月01日
			T0	时间093000
			T1	时间09:30:00
			T2	时间0930
			T3	时间09:30
decimal:	小数位数[0,4]
bcs:		被除数100 10000等
dw:			单位 元 万 亿 %等
pre: 		文本之前 比如 10.00  pre:"(" = (10.00
isstockcode:	该jsn数据列是否是股票代码(计算行情有用) false true
isbigtext:	是否是大文本false true
iszdf:		是否是涨跌幅false true (dataclrtype会用到1-依赖涨幅)
ischildjsn: 是否是关联子jsn数据列 false true
jsncolindex:	对应的jsn文件数据列索引号[0,n](-1或不配置此字段表示不存在)必须存在
exdata:		扩展数据类型(-1或不配置此字段表示不用计算)
		0	成分股串
		1	成分股均涨幅
		2	成分股加权涨幅
		3	龙头股
		4	龙头股涨幅
		5	龙头股现价
		6	上涨比例,
		7	成分股数
		11	hq-市场代码,
		12	hq-代码,
		13	hq-简称,
		14	hq-现价,
		15	hq-昨收,
		16	hq-流通股本(.2万),
		17	hq-成交量,
		18	hq-涨幅
calc: 	计算公式 //(function(){ return val; })(); 可以使用的对象:RowL[i]  HQ[0-7]  CFGL[0-7] Str[0-N] g_DataHQ[RowL[3]][3]
shownameindex:	显示colname对应网页模板的位置[0,n](-1或不配置此字段表示不显示)
showdataindex:	显示数据对应网页模板的位置[0,n](-1或不配置此字段表示不显示)
namealign:	colname显示对齐方式[left,center,rigth]
dataalign:	数据显示对齐方式[left,center,rigth]
dataclrtype:	数据颜色处理类型[0-数据本身正负,1-依赖涨幅]
gotof5: 	跳转行情 false|true (点击显示该字段区域跳转)
*/

function DataCfg(cfgfile){
	if(!(this instanceof DataCfg)){
		return new DataCfg(cfgfile);
	}
	this.selfcfg = cfgfile;

	this.strtext = [];
	this.jsnfile = "";
	this.childjsnfile = "";
	this.template = -1;
	this.sorttype = 0;
	this.sortcol = -1;
	this.hashqreq = false;
	this.gotof5 = false;
	this.titlelist = [];
	this.titlefixed = false;
	this.childcfg = "";

	this.datacol = [];

	this.isreqCfg = false;
	this.CfgFinishNotify = null;
}

DataCfg.prototype.ReqCfg = function(FinishNotify){
	if( this.isreqCfg ) {
		FinishNotify(this);
		return;
	}
	this.CfgFinishNotify = FinishNotify;
	g_ReqFile(this.selfcfg, "0", "_CallBackDataCfg", _CallBackDataCfg);
}

function _CallBackDataCfg(filename,id,type,data){
	if( g_DataCfg[filename] ){
		g_DataCfg[filename].CallBackCfg(data);
	}else{
		alert("_CallBackDataCfg Err");
	}
}

DataCfg.prototype.CallBackCfg = function(data){
	var callback = this.CfgFinishNotify;
	var obj = {};
	if( data.length == 0 ){
		if( callback )
			callback(this);
		return;
	}
	try{
		obj=JSON.parse(data);
	}
	catch(err){
		obj={};
		if( callback )
			callback(this);
		alert("cfg err");
		return;
	}
	this.strtext = obj["strtext"];
	this.isreqCfg  = true;
	this.jsnfile = obj["jsnfile"];
	if(TdxUtils.hasOwnProperty(obj, "childjsnfile")){
		this.childjsnfile = obj["childjsnfile"];
	}
	this.template = obj["template"];
	this.sorttype = obj["sorttype"];
	this.sortcol = obj["sortcol"];
	this.hashqreq = obj["hashqreq"];
	this.childcfg = obj["childcfg"];
	this.gotof5 = !!obj["gotof5"];
	this.titlelist = obj["titlelist"];
	this.titlefixed = !!obj["titlefixed"];
	this.datacol = obj["datacol"];
	if( callback )
		callback(this);
}
//分析配置文件数据列
DataCfg.prototype.AnalyDataCol = function(){
	var CFGColPos = -1; //指定成分股jsn数据列(计算成分股)
	var StockCodeColPos = -1; //指定股票代码jsn数据列(计算行情)
	var BigTextColPos = -1; //指定大文本jsn数据列(另种方式展示)
	var ZDFColPos = -1; //指定涨跌幅数据列(数据颜色)
	var ChildJsnPos = -1; //指定子jsn数据列(关联子数据)
	var ShowColPosObj={}; //"pos0":["showtext",{属性}]
	var GoTof5PosList=[]; //[1,2,3] 点击可跳转F5的数据显示位置
	for(var i=0; i<this.datacol.length; i++){
		var obj = this.datacol[i];
		if(TdxUtils.hasOwnProperty(obj, "jsncolindex") && TdxUtils.hasOwnProperty(obj, "exdata")){
			if(obj["jsncolindex"] >=0 && obj["exdata"] ==0 ){
				CFGColPos = obj["jsncolindex"];
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "jsncolindex") && TdxUtils.hasOwnProperty(obj, "isstockcode")){
			if(obj["jsncolindex"] >=0 && obj["isstockcode"] == true){
				StockCodeColPos = obj["jsncolindex"];
			}else if( obj["showdataindex"] >=0 && obj["isstockcode"] == true ){
				StockCodeColPos = obj["showdataindex"];
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "jsncolindex") && TdxUtils.hasOwnProperty(obj, "isbigtext")){
			if(obj["jsncolindex"] >=0 && obj["isbigtext"] == true){
				BigTextColPos = obj["jsncolindex"];
			}
			else if( obj["showdataindex"] >=0 && obj["isbigtext"] == true ){
				BigTextColPos = obj["showdataindex"];
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "jsncolindex") && TdxUtils.hasOwnProperty(obj, "iszdf")){
			if(obj["jsncolindex"] >=0 && obj["iszdf"] == true){
				ZDFColPos = obj["jsncolindex"];
			}
			else if( obj["showdataindex"] >=0 && obj["iszdf"] == true ){
				ZDFColPos = obj["showdataindex"];
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "jsncolindex") && TdxUtils.hasOwnProperty(obj, "ischildjsn")){
			if(obj["jsncolindex"] >=0 && obj["ischildjsn"] == true){
				ChildJsnPos = obj["jsncolindex"];
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "shownameindex")){
			var pos =  obj["shownameindex"];
			if( pos >=0){
				ShowColPosObj["pos"+pos] = [obj["colname"], obj];//"pos0":["colname",{属性}]
			}
		}
		if(TdxUtils.hasOwnProperty(obj, "showdataindex")){
			var pos =  obj["showdataindex"];
			if( pos >=0 ){
				GoTof5PosList.push[pos];
				if( TdxUtils.isNumber(obj["jsncolindex"]) && obj["jsncolindex"] == -1){
					if( TdxUtils.hasOwnProperty(obj, "exdata") )
						ShowColPosObj["pos"+pos] = [obj["exdata"], obj];//"pos0":[展示计算列,{属性}] 
					else if( TdxUtils.hasOwnProperty(obj, "calc") ){
						ShowColPosObj["pos"+pos] = [-2, obj];//-2则需要计算
					}
				}
				else
					ShowColPosObj["pos"+pos] = [-1, obj];//-1则展示jsn数据列
			}
		}
	}
	var ret = {};
	ret.CFGColPos = CFGColPos;
	ret.StockCodeColPos = StockCodeColPos;
	ret.BigTextColPos = BigTextColPos;
	ret.ZDFColPos = ZDFColPos;
	ret.ChildJsnPos = ChildJsnPos;
	ret.ShowColPosObj = ShowColPosObj;
	ret.GoTof5PosList = GoTof5PosList;
	return ret;
}

//成分股数据计算
DataCfg.prototype.CalcCFG = function(stockL){
	var Ret = [];
	var exdata0 = ""; //成分股串
	var exdata1 = 0.00; //成分股均涨幅
	var exdata2 = 0.00; //成分股加权涨幅
	var exdata3 = "--"; //龙头股
	var exdata4 = 0.00; //龙头股涨幅
	var exdata5 = 0.00; //龙头股现价
	var exdata6 = 0.00; //上涨比例
	var exdata7 = 0; //成分股数
	var validCnt = 0; //剔除了停板成分股数
	var allszNow = 0.00 //现总流通市值
	var allszClose = 0.00 //昨收总流通市值

	for(var i=0; i<stockL.length; i++ ){
		var sc = stockL[i].substr(0,1);
		var code = stockL[i].substr(2,6);
		var HQ = g_DataHQ[code];
		if(TdxUtils.isArray(HQ) == false) continue;
		exdata7++;
		if(parseFloat(HQ[3]) <= 0.01) continue;
		validCnt++;
		allszNow += parseFloat(HQ[3]) * parseFloat(HQ[5]);
		allszClose += parseFloat(HQ[4]) * parseFloat(HQ[5]);
		var zdf = 0.0;
		if( parseFloat(HQ[4]) >0 )
			zdf = (parseFloat(HQ[3])-parseFloat(HQ[4])) / parseFloat(HQ[4]) *100;
		if( exdata7 == 1 ){
			exdata3 = HQ[2];
			exdata4 = zdf;
			exdata5 = HQ[3];
		}else if( zdf > exdata4 ){
			exdata3 = HQ[2];
			exdata4 = zdf;
			exdata5 = HQ[3];
		}
		if( zdf > 0 )
			exdata6++;
		exdata1 += zdf;
		if( exdata0.length >0 )
			exdata0 += ",";
		exdata0 += code;
	}
	if( exdata7 >0 ){
		exdata1 = exdata1 / exdata7;
		exdata6 = exdata6 / exdata7 * 100;
	}
	if( allszClose > 0 )
		exdata2 = (allszNow - allszClose ) / allszClose * 100;
	Ret = [exdata0,exdata1,exdata2,exdata3,exdata4,exdata5,exdata6,exdata7];
	return Ret;
}
//text转换
DataCfg.prototype.TextConvert = function(val, attrobj){
	var ret = val;
	if(TdxUtils.hasOwnProperty(attrobj, "datatype")){
		var datatype = attrobj["datatype"];
		if( datatype == 'F' || datatype == 'I' ){
			var decimal = 0;
			var bcs = 1;
			if(TdxUtils.hasOwnProperty(attrobj, "decimal"))
				decimal = parseInt(attrobj["decimal"]);
			if(TdxUtils.hasOwnProperty(attrobj, "bcs"))
				bcs = parseInt(attrobj["bcs"]);
			ret = TdxUtils.Format_Dec(val, decimal, bcs);
		}else if( datatype == 'D1' ){
			ret = ret.substr(0,4) + "-" + ret.substr(4,2) + "-" + ret.substr(6,2);
		}
		else if( datatype == 'D2' ){
			ret = ret.substr(0,4) + "/" + ret.substr(4,2) + "/" + ret.substr(6,2);
		}
		else if( datatype == 'D3' ){
			ret = ret.substr(0,4) + "年" + ret.substr(4,2) + "月" + ret.substr(6,2)+"日";
		}
		else if( datatype == 'D4' ){
			ret = ret.substr(2,6);
		}
		else if( datatype == 'D5' ){
			ret = ret.substr(2,2) + "-" + ret.substr(4,2) + "-" + ret.substr(6,2);
		}
		else if( datatype == 'D6' ){
			ret = ret.substr(2,2) + "/" + ret.substr(4,2) + "/" + ret.substr(6,2);
		}
		else if( datatype == 'D7' ){
			ret = ret.substr(2,2) + "年" + ret.substr(4,2) + "月" + ret.substr(6,2)+"日";
		}
		else if( datatype == 'D8' ){
			ret = ret.substr(4,2) + ret.substr(6,2);
		}
		else if( datatype == 'D9' ){
			ret = ret.substr(4,2) + "-" + ret.substr(6,2);
		}
		else if( datatype == 'D10' ){
			ret = ret.substr(4,2) + "/" + ret.substr(6,2);
		}
		else if( datatype == 'D11' ){
			ret = ret.substr(4,2) + "月" + ret.substr(6,2)+"日";
		}
		else if( datatype == 'T1' ){
			ret = ret.substr(0,2) + ":" + ret.substr(2,2) + ":" + ret.substr(4,2);
		}
		else if( datatype == 'T2' ){
			ret = ret.substr(0,4) 
		}
		else if( datatype == 'T3' ){
			ret = ret.substr(0,2) + ":" + ret.substr(2,2);
		}
	}
	if(TdxUtils.hasOwnProperty(attrobj, "pre"))
		ret = attrobj["pre"] + ret;
	if(TdxUtils.hasOwnProperty(attrobj, "dw"))
		ret += attrobj["dw"];
	return ret;
}
//文本分析 return [text, align, clrclass, retgotof5]
DataCfg.prototype.TextAnaly = function(sPos, AnalyRes, RowL){
	var rettext = "--";
	var retalign = "center";
	var retclrclass = "";
	var retgotof5 = false;
	if( AnalyRes.ShowColPosObj[sPos] ){
		var datatext = AnalyRes.ShowColPosObj[sPos][0];
		var dataattr = AnalyRes.ShowColPosObj[sPos][1];
		//gotof5
		if(TdxUtils.hasOwnProperty(dataattr, "gotof5")){
			if( dataattr["gotof5"] ){
				retgotof5 = true;
				retclrclass += "gotof5 ";
			}
		}
		//text
		if( datatext == -1 ){//显示jsn数据列中数据
			var datacol = dataattr["jsncolindex"];
			rettext = this.TextConvert(RowL[datacol], dataattr);
			if( TdxUtils.hasOwnProperty(dataattr, "dataalign") ){
				retalign = dataattr["dataalign"];
			}
		}
		else if( datatext == -2 ){ //calc计算
			var strjs = dataattr["calc"];
			var HQ = [];
			var CFGL = [];
			var Str = this.strtext;
			//var Format_Dec = TdxUtils.Format_Dec;
			//var Format_Date = TdxUtils.Format_Date;
			//var Format_Time = TdxUtils.Format_Time;
			if( AnalyRes.StockCodeColPos >=0 ){
				var stockcode = RowL[AnalyRes.StockCodeColPos];
				HQ = g_DataHQ[stockcode];
			}
			if( AnalyRes.CFGColPos >=0 ){
				var stocks = RowL[AnalyRes.CFGColPos];
				var stockL = stocks.split(",");
				CFGL = this.CalcCFG(stockL);
			}
			try{//(function(){ return val; })(); RowL[i] HQ[11-18] CFGL[0-7] Str[0-N]
				rettext = this.TextConvert(eval(strjs), dataattr); 
			}catch(err){
				rettext="--";
			}
			if( TdxUtils.hasOwnProperty(dataattr, "dataalign") ){
				retalign = dataattr["dataalign"];
			}
		}
		else if( TdxUtils.isString(datatext) ){ //显示cfn数据colname
			rettext = datatext;
			if( TdxUtils.hasOwnProperty(dataattr, "namealign") ){
				retalign = dataattr["namealign"];
			}
		}
		else{ //显示计算exdata
			var exdata = datatext;
			if( exdata >= 11 && exdata <= 20 && AnalyRes.StockCodeColPos >=0 ){ //显示个股行情数据
				var stockcode = RowL[AnalyRes.StockCodeColPos];
				var HQ = g_DataHQ[stockcode];
				if( TdxUtils.isArray(HQ) )
					rettext = this.TextConvert(HQ[exdata - 11], dataattr);
			}else if( exdata >= 0 && exdata <= 10 && AnalyRes.CFGColPos >=0 ){
				var stocks = RowL[AnalyRes.CFGColPos];
				var stockL = stocks.split(",");
				var CFGL = this.CalcCFG(stockL);
				rettext = this.TextConvert(CFGL[exdata], dataattr);
			}
			else
				rettext = "--";
			if( TdxUtils.hasOwnProperty(dataattr, "dataalign") ){
				retalign = dataattr["dataalign"];
			}
		}
		//clrclass
		if(TdxUtils.hasOwnProperty(dataattr, "dataclrtype")){
			var srctext = rettext;
			if( TdxUtils.hasOwnProperty(dataattr, "pre") ){
				var prestrlen = dataattr["pre"].length;
				srctext = srctext.substr(prestrlen);
			}
			var clr = parseInt(dataattr["dataclrtype"]);
			if( clr == 0 ) { //数据本身正负
				var val = parseFloat(srctext);
				if( parseFloat(val) > 0)
					retclrclass += "ClassUP";
				else if( parseFloat(val) < 0)
					retclrclass += "ClassDOWN";
				else 
					retclrclass += "ClassZero";
			}else if( clr == 1 && AnalyRes.ZDFColPos >=0 ){ //依赖涨幅
				var zdfpos = "pos"+AnalyRes.ZDFColPos;
				var val = parseFloat(srctext);
				if( zdfpos != sPos ){
					var ll = this.TextAnaly(zdfpos, AnalyRes, RowL);
					val = parseFloat(ll[0]);
				}
				if( parseFloat(val) > 0)
					retclrclass += "ClassUP";
				else if( parseFloat(val) < 0)
					retclrclass += "ClassDOWN";
				else 
					retclrclass += "ClassZero";
			}
		}
	}
	if(rettext.length == 0 ) {
		if( this.template == 7 && sPos == 'pos1' ) rettext = '';
		else rettext = '--';
	}
	return [rettext,retalign,retclrclass,retgotof5];
}

//渲染
DataCfg.prototype.Render = function(DataJsn){
	//排序
	if( this.sortcol >= 0 ){
		var AnalyRes = this.AnalyDataCol();
		for(var i=0; i<DataJsn.DataList.length; i++){
			var RowL = DataJsn.DataList[i];
			var textLL = this.TextAnaly("pos"+this.sortcol, AnalyRes, RowL);//1-数据位
			DataJsn.DataList[i].push(textLL[0]);
		}
		if( this.sorttype == 1 ){
			DataJsn.DataList.sort(function(a,b){
				return parseFloat(a[a.length-1]) < parseFloat(b[b.length-1]) ? 1 : -1;
        	});
		}else{
			DataJsn.DataList.sort(function(a,b){
				return parseFloat(a[a.length-1]) > parseFloat(b[b.length-1]) ? 1 : -1;
        	});
		}
	}
	
	if( this.template == 1 ){
		this.Rendertemplate1(DataJsn);
	}
	else if( this.template == 2 ){
		this.Rendertemplate2(DataJsn);
	}
	else if( this.template == 3 ){
		this.Rendertemplate3(DataJsn);
	}
	else if( this.template == 4 ){
		this.Rendertemplate4(DataJsn);
	}
	else if( this.template == 5 ){
		this.Rendertemplate5(DataJsn);
	}
	else if( this.template == 6 ){
		this.Rendertemplate6(DataJsn);
	}
	else if( this.template == 7 ){
		this.Rendertemplate7(DataJsn);
	}

	$('.gotof5').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate1 = function(DataJsn){
	/************************
	总共10个数据位
	<div class="Item_One" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Warp">
			<div id="DivLeft">
				<div>1</div>
				<div>2</div>
			</div>
			<div id="DivRight">
				<div>3<span>4</span></div>
				<div>5<span>6</span></div>
				<div>7<span>8</span><span>9</span><span>10</span></div>
			</div>
		</div>
		<div class='Childs' style='display:none'>...</div>
	</div>
	*************************/
	var HQ;
	var DataPosCnt = 10; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateOne = "<div class='Item_One' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateOne += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateOne += "setcode='" + HQ[0] + "' ";
				TemplateOne += "stockcode='" + HQ[1] + "' ";
				TemplateOne += "stockname='" + HQ[2] + "' ";
			}
			TemplateOne += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "' ";
			if(g_Version == 2)
				TemplateOne += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "' ";
		}
		if( this.childcfg && this.childcfg.length > 0 ){
			TemplateOne += "childcfgfile='" + this.childcfg + "' ";
		}
		TemplateOne += ">";

		var textLL = [];
		TemplateOne += "<div class='Item_Warp'><div id='DivLeft'><div class='";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</div><div class='";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</div></div><div id='DivRight'><div class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos5", AnalyRes, RowL);//5-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos6", AnalyRes, RowL);//6-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos7", AnalyRes, RowL);//7-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos8", AnalyRes, RowL);//8-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos9", AnalyRes, RowL);//9-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];
		TemplateOne += "</span></div></div></div><div class='Childs' style='display:none'></div></div>";

		$('#Wrap_Content').append(TemplateOne);
	}
	if( this.childcfg && this.childcfg.length > 0 )//优先响应子数据
		$('#Wrap_Content>.Item_One>.Item_Warp').TapEvent(TemplateOneItemClick);
	else if( this.gotof5 )
		$('#Wrap_Content>.Item_One>.Item_Warp').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate2 = function(DataJsn){
	/************************
	总共7个数据位
	<div class="Item_Two" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Warp">
			<div id="DivLeft">
				<div>1</div>
				<div>2</div>
				<div>3</div>
			</div>
			<div id="DivRight">
				<div>4<span>5</span><span>6</span></div>
				<div>7</div>
			</div>
		</div>
		<div class='Childs' style='display:none'>...</div>
	</div>
	*************************/
	var HQ;
	var DataPosCnt = 7; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateTwo = "<div class='Item_Two' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateTwo += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateTwo += "setcode='" + HQ[0] + "' ";
				TemplateTwo += "stockcode='" + HQ[1] + "' ";
				TemplateTwo += "stockname='" + HQ[2] + "' ";
			}
			TemplateTwo += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateTwo += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateTwo += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateTwo += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		if( this.childcfg && this.childcfg.length > 0 ){
			TemplateTwo += "childcfgfile='" + this.childcfg + "'";
		}
		TemplateTwo += ">";

		var textLL = [];
		TemplateTwo += "<div class='Item_Warp'><div id='DivLeft'><div class='";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div><div class='";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div><div class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div></div><div id='DivRight'><div class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "<span class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</span><span class='";
		textLL = this.TextAnaly("pos5", AnalyRes, RowL);//5-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</span></div><div class='";
		textLL = this.TextAnaly("pos6", AnalyRes, RowL);//6-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div></div></div><div class='Childs' style='display:none'></div></div>";
		$('#Wrap_Content').append(TemplateTwo);
	}
	if( this.childcfg && this.childcfg.length > 0 )
		$('#Wrap_Content>.Item_Two>.Item_Warp').TapEvent(TemplateTwoItemClick);
	else if( this.gotof5 )
		$('#Wrap_Content>.Item_Two>.Item_Warp').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate3 = function(DataJsn){
	/************************
	总共5个数据位
	<div class="Item_Three [Item_Second]" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Cor" style="width:25%">
			<div class="one">1</div>
			<div class="two">2</div>
		</div>
		<div class="Item_Cor" style="width:25%">
			<div>3</div>
		</div>
		<div class="Item_Cor" style="width:25%">
			<div>4</div>
		</div>
		<div class="Item_Cor" style="width:25%">
			<div>5</div>
		</div>
	</div>
	*************************/
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = this.titlelist.length + 1; //每行数据位置不确定 
	var AnalyRes = this.AnalyDataCol();

	var widthL = [];
	for(var i=0; i<this.titlelist.length; i++){
		var width = this.titlelist[i]["width"];
		if( TdxUtils.isString(width) == false ) width = "25%";
		widthL.push(width);
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateThree = "<div class='Item_Three' ";
		if(i%2)
			var TemplateThree = "<div class='Item_Three Item_Second' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateThree += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateThree += "setcode='" + HQ[0] + "' ";
				TemplateThree += "stockcode='" + HQ[1] + "' ";
				TemplateThree += "stockname='" + HQ[2] + "' ";
			}
			TemplateThree += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateThree += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateThree += ">";

		var textLL = [];
		TemplateThree += "<div class='Item_Cor' style='width:";
		TemplateThree += widthL[0] + ";";
		TemplateThree += "'><div class='one ";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div><div class='two ";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		var posindex = 2;
		for(var j=1; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			TemplateThree += "</div></div><div class='Item_Cor' style='width:";
			TemplateThree += widthL[j] + ";";
			TemplateThree += "'><div class='";
			textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateThree += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateThree += "setcode='" + HQ[0] + "' ";
				TemplateThree += "stockcode='" + HQ[1] + "' ";
				TemplateThree += "stockname='" + HQ[2] + "' ";
			}
			TemplateThree += " style='text-align:";
			TemplateThree += textLL[1];
			TemplateThree += ";'>";
			TemplateThree += textLL[0];
		}

		TemplateThree += "</div></div></div>";
		$('#Wrap_Content').append(TemplateThree);
	}
	if( this.gotof5 )
		$('#Wrap_Content>.Item_Three').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate4 = function(DataJsn){
	/************************
	总共2*N个数据位,N列数
	<div class="Item_Four [Item_Second]" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Cor" style="width:X">
			<div class="first">1</div>
			<div class="second">2</div>
		</div>
		<div class="Item_Cor" style="width:X">
			<div class="first">1</div>
			<div class="second">2</div>
		</div>
		.
		.
		.
	</div>
	*************************/
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = 2 * this.titlelist.length; //每行数据位置不确定 单一定是2的倍数
	var AnalyRes = this.AnalyDataCol();
	var widthL = [];
	for(var i=0; i<this.titlelist.length; i++){
		var width = this.titlelist[i]["width"];
		if( TdxUtils.isString(width) == false ) width = "80px";
		widthL.push(width);
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		if(i%2)
			var TemplateFour = "<div class='Item_Four Item_Second' ";
		else
			var TemplateFour = "<div class='Item_Four' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateFour += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateFour += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateFour += ">";

		var posindex = 0;
		for(var j=0; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			var textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='Item_Cor' style='width:";
			TemplateFour += widthL[j] + ";'>";

			TemplateFour += "<div class='first ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0];
			TemplateFour += "</div>";

			strpos = "pos"+posindex;
			posindex++;
			textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='second ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0];
			TemplateFour += "</div>";

			TemplateFour += "</div>";
			
		}
		TemplateFour += "</div>";
		$('#Wrap_Content').append(TemplateFour);
	}
	if( this.gotof5 )
		$('#Wrap_Content>.Item_Four').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate5 = function(DataJsn){
	/************************
	总共N个数据位,N列数
	<div class="Item_Five [Item_Second]" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Cor" style="width:X%">1</div>
		<div class="Item_Cor" style="width:X%">2</div>
		.
		.
		.
	</div>
	*************************/
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = this.titlelist.length; //每行数据位置不确定 
	var AnalyRes = this.AnalyDataCol();
	var widthL = [];
	for(var i=0; i<this.titlelist.length; i++){
		var width = this.titlelist[i]["width"];
		if( TdxUtils.isString(width) == false ) width = "80px";
		widthL.push(width);
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		if(i%2)
			var TemplateFour = "<div class='Item_Five Item_Second' ";
		else
			var TemplateFour = "<div class='Item_Five' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateFour += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateFour += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateFour += ">";

		var posindex = 0;
		for(var j=0; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			var textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='Item_Cor ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='width:";
			TemplateFour += widthL[j] + ";text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0]?textLL[0]:'--';
			TemplateFour += "</div>";
		}
		TemplateFour += "</div>";
		$('#Wrap_Content').append(TemplateFour);
	}
	if( this.gotof5 )
		$('#Wrap_Content>.Item_Five').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate6 = function(DataJsn){
	/************************
	总共10个数据位
	<div class="Item_Six" cfgcode="" setcode="" stockcode="" stockname="" stockcodepos="" childjsnfile="" childcfgfile="">
		<div class="Item_Warp">
			<div><span>1</span><span>2</span><span>3</span></div>
			<div>4<span>5</span><span>6</span></div>
			<div>7<span>8</span><span>9</span><span>10</span></div>
		</div>
		<div class='Childs' style='display:none'>...</div>
	</div>
	*************************/
	var HQ;
	var DataPosCnt = 10; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateOne = "<div class='Item_Six' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateOne += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateOne += "setcode='" + HQ[0] + "' ";
				TemplateOne += "stockcode='" + HQ[1] + "' ";
				TemplateOne += "stockname='" + HQ[2] + "' ";
			}
			TemplateOne += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateOne += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		if( this.childcfg && this.childcfg.length > 0 ){
			TemplateOne += "childcfgfile='" + this.childcfg + "'";
		}
		TemplateOne += ">";

		var textLL = [];
		TemplateOne += "<div class='Item_Warp'><div><span class='";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span><span class='";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span><span class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos5", AnalyRes, RowL);//5-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos6", AnalyRes, RowL);//6-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos7", AnalyRes, RowL);//7-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos8", AnalyRes, RowL);//8-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos9", AnalyRes, RowL);//9-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div></div><div class='Childs' style='display:none'></div></div>";

		$('#Wrap_Content').append(TemplateOne);
	}
	if( this.childcfg && this.childcfg.length > 0 )
		$('#Wrap_Content>.Item_Six>.Item_Warp').TapEvent(TemplateSixItemClick);
	else if( this.gotof5 )
		$('#Wrap_Content>.Item_Six>.Item_Warp').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate7 = function(DataJsn){
	/************************
	总共N+1个数据位,N列数据
	列宽用屏幕的百分比
	<div class="Wrap_VScroll">
		<div class="FixedLeft">
			<div id="Wrap_Content_Title">
				<div style="text-align:center"><span>Title</span></div>
			</div>
			<div class="Item_Seven">
				<div class="Item_Cor">
					<div class="one">1</div>
					<div class="two">2</div>
				</div>
			</div>
		</div>
		<div class="FixedRight">
			<div class="Wrap_HScroll">
				<div id="Wrap_Content_Title">
					<div style="text-align:center"><span>22</span></div>
					<div style="text-align:center"><span>33</span></div>
					<div style="text-align:center"><span>44</span></div>
				</div>
				<div class="Item_Seven">
					<div class="Item_Cor">
						<div>3</div>
					</div>
					<div class="Item_Cor">
						<div>4</div>
					</div>
					<div class="Item_Cor">
						<div>5</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	*************************/
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = this.titlelist.length + 1; //每行数据位置不确定 
	var AnalyRes = this.AnalyDataCol();

	var nwidth = parseInt($('#Wrap_Content .Wrap_VScroll .FixedLeft').width());
	var allwidth = nwidth / parseInt(this.titlelist[0]["width"]) * 100;
	var widthL = [0];
	var rightallwidth = 0;
	for(var i=1; i<this.titlelist.length; i++){
		var width = parseInt(this.titlelist[i]["width"]);
		if( width == 0 ) width = 20;//20%
		rightallwidth += allwidth * width / 100;
		widthL.push(allwidth * width / 100 + 'px');
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateThree = "<div class='Item_Seven' ";
		if(0==i)
			TemplateThree = "<div class='Item_Seven Item_First_Fixed' ";
		if(i%2)
			TemplateThree = "<div class='Item_Seven Item_Second' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateThree += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateThree += "setcode='" + HQ[0] + "' ";
				TemplateThree += "stockcode='" + HQ[1] + "' ";
				TemplateThree += "stockname='" + HQ[2] + "' ";
			}
			TemplateThree += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateThree += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateThree += ">";

		//pos1文本为空，则单行显示
		var textLLpos2 = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		var classone = 'one';
		var classtwo = 'two'
		if(textLLpos2[0].length == 0){
			classone = '';
			classtwo = '';
		}

		var textLL = [];
		var TemplateLeft = "<div class='Item_Cor'><div class='" + classone + " ";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateLeft += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateLeft += "setcode='" + HQ[0] + "' ";
			TemplateLeft += "stockcode='" + HQ[1] + "' ";
			TemplateLeft += "stockname='" + HQ[2] + "' ";
		}
		TemplateLeft += " style='text-align:";
		TemplateLeft += textLL[1];
		TemplateLeft += ";'>";
		TemplateLeft += textLL[0];

		TemplateLeft += "</div><div class='" + classtwo + " ";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateLeft += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateLeft += "setcode='" + HQ[0] + "' ";
			TemplateLeft += "stockcode='" + HQ[1] + "' ";
			TemplateLeft += "stockname='" + HQ[2] + "' ";
		}
		TemplateLeft += " style='text-align:";
		TemplateLeft += textLL[1];
		TemplateLeft += ";'>";
		TemplateLeft += textLL[0];

		TemplateLeft += "</div></div></div>";
		$('#Wrap_Content .FixedLeft').append(TemplateThree + TemplateLeft);

		var posindex = 2;
		TemplateRigth = '';
		for(var j=1; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			TemplateRigth += "<div class='Item_Cor' style='width:";
			TemplateRigth += widthL[j] + ";";
			TemplateRigth += "'><div class='";
			textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateRigth += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateRigth += "setcode='" + HQ[0] + "' ";
				TemplateRigth += "stockcode='" + HQ[1] + "' ";
				TemplateRigth += "stockname='" + HQ[2] + "' ";
			}
			TemplateRigth += " style='text-align:";
			TemplateRigth += textLL[1];
			TemplateRigth += ";'>";
			TemplateRigth += textLL[0];
			TemplateRigth += "</div></div>";
		}
		TemplateRigth += "</div>";
		$('#Wrap_Content .FixedRight .Wrap_HScroll').append(TemplateThree + TemplateRigth);
	}
	if( this.gotof5 )
		$('#Wrap_Content>.Item_Seven').TapEvent(GotoStock);

	//竖向滚动 固定表头
	$('#Wrap_Content .Wrap_VScroll #Wrap_Content_Title').css('position', 'absolute');
	$('#Wrap_Content .Wrap_VScroll .Wrap_HScroll #Wrap_Content_Title').css('width', rightallwidth+'px');
	$('#Wrap_Content .Item_First_Fixed').css('padding', '31px 0px 0px 0px');
	//$(".Wrap_VScroll #Wrap_Content_Title").scrollFixed({fixed:'top',scroll:$('#Wrap_Content')});
	
	var timer;
	var bStrat = true;
	$('#Wrap_Content').scroll(function(){
		if(bStrat){
			bStrat = false;
			$(".Wrap_VScroll #Wrap_Content_Title").css('top', '-32px');
		}
		if(timer){
            clearTimeout(timer);
        }
        timer = setTimeout( function(){
        	bStrat = true;
        	//endscroll
            timer = null;
            $(".Wrap_VScroll #Wrap_Content_Title").css('top', $("#Wrap_Content").scrollTop()+'px');
        }, 200);
	})
	
}

DataCfg.prototype.RenderChild = function(DataJsn){
	//排序
	if( this.sortcol >= 0 ){
		var AnalyRes = this.AnalyDataCol();
		for(var i=0; i<DataJsn.DataList.length; i++){
			var RowL = DataJsn.DataList[i];
			var textLL = this.TextAnaly("pos"+this.sortcol, AnalyRes, RowL);//1-数据位
			DataJsn.DataList[i].push(textLL[0]);
		}
		if( this.sorttype == 1 ){
			DataJsn.DataList.sort(function(a,b){
				return parseFloat(a[a.length-1]) < parseFloat(b[b.length-1]) ? 1 : -1;
        	});
		}else{
			DataJsn.DataList.sort(function(a,b){
				return parseFloat(a[a.length-1]) > parseFloat(b[b.length-1]) ? 1 : -1;
        	});
		}
	}

	if( this.template == 1 ){
		this.Rendertemplate1Child(DataJsn);
	}
	else if( this.template == 2 ){
		this.Rendertemplate2Child(DataJsn);
	}
	else if( this.template == 3 ){
		this.Rendertemplate3Child(DataJsn);
	}
	else if( this.template == 4 ){
		this.Rendertemplate4Child(DataJsn);
	}
	else if( this.template == 5 ){
		this.Rendertemplate5Child(DataJsn);
	}
	else if( this.template == 7 ){
		this.Rendertemplate7Child(DataJsn);
	}
	$('.gotof5').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate1Child = function(DataJsn){
	var HQ;
	var DataPosCnt = 10; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateOne = "<div class='Item_One' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateOne += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateOne += "setcode='" + HQ[0] + "' ";
				TemplateOne += "stockcode='" + HQ[1] + "' ";
				TemplateOne += "stockname='" + HQ[2] + "' ";
			}
			TemplateOne += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateOne += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateOne += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		if( this.childcfg && this.childcfg.length > 0 ){
			TemplateOne += "childcfgfile='" + this.childcfg + "'";
		}
		TemplateOne += ">";

		var textLL = [];
		TemplateOne += "<div class='Item_Warp'><div id='DivLeft'><div class='";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</div><div class='";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</div></div><div id='DivRight'><div class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos5", AnalyRes, RowL);//5-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span></div><div class='";
		textLL = this.TextAnaly("pos6", AnalyRes, RowL);//6-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "<span class='";
		textLL = this.TextAnaly("pos7", AnalyRes, RowL);//7-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos8", AnalyRes, RowL);//8-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];

		TemplateOne += "</span>    <span class='";
		textLL = this.TextAnaly("pos9", AnalyRes, RowL);//9-数据位
		TemplateOne += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateOne += "setcode='" + HQ[0] + "' ";
			TemplateOne += "stockcode='" + HQ[1] + "' ";
			TemplateOne += "stockname='" + HQ[2] + "' ";
		}
		TemplateOne += ">";
		TemplateOne += textLL[0];
		TemplateOne += "</span></div></div></div><div class='Childs' style='display:none'></div></div>";

		g_CurChildObj.append(TemplateOne);
	}
	if( this.gotof5 )
		$('.Childs>.Item_One>.Item_Warp').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate2Child = function(DataJsn){
	var HQ;
	var DataPosCnt = 7; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateTwo = "<div class='Item_Two' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateTwo += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateTwo += "setcode='" + HQ[0] + "' ";
				TemplateTwo += "stockcode='" + HQ[1] + "' ";
				TemplateTwo += "stockname='" + HQ[2] + "' ";
			}
			TemplateTwo += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateTwo += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateTwo += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateTwo += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateTwo += ">";

		var textLL = [];
		TemplateTwo += "<div class='Item_Warp'><div id='DivLeft'><div class='";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div><div class='";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div><div class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div></div><div id='DivRight'><div class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "<span class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</span><span class='";
		textLL = this.TextAnaly("pos5", AnalyRes, RowL);//5-数据位
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</span></div><div class='";
		textLL = this.TextAnaly("pos6", AnalyRes, RowL);//6-数据位
		textLL[0]=textLL[0].replace(/\r\n/g,"<BR>")  
        textLL[0]=textLL[0].replace(/\n/g,"<BR>"); 
		TemplateTwo += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateTwo += "setcode='" + HQ[0] + "' ";
			TemplateTwo += "stockcode='" + HQ[1] + "' ";
			TemplateTwo += "stockname='" + HQ[2] + "' ";
		}
		TemplateTwo += ">";
		TemplateTwo += textLL[0];

		TemplateTwo += "</div></div></div><div class='Childs' style='display:none'></div></div>";
		g_CurChildObj.append(TemplateTwo);
	}
	if( this.gotof5 )
		$('.Childs>.Item_Two>.Item_Warp').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate3Child = function(DataJsn){
	var HQ;
	var DataPosCnt = 5; //每行数据位置
	var AnalyRes = this.AnalyDataCol();
	var width0 = "25%";
	var width1 = "25%";
	var width2 = "25%";
	var width3 = "25%";
	if( this.titlelist.length == 4){
		width0 = this.titlelist[0]["width"];
		if( TdxUtils.isString(width0) == false ) width0 = "25%";
		width1 = this.titlelist[1]["width"];
		if( TdxUtils.isString(width1) == false ) width1 = "25%";
		width2 = this.titlelist[2]["width"];
		if( TdxUtils.isString(width2) == false ) width2 = "25%";
		width3 = this.titlelist[3]["width"];
		if( TdxUtils.isString(width3) == false ) width3 = "25%";
	}
	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateThree = "<div class='Item_Three' ";
		if(i%2)
			var TemplateThree = "<div class='Item_Three Item_Second' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateThree += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateThree += "setcode='" + HQ[0] + "' ";
				TemplateThree += "stockcode='" + HQ[1] + "' ";
				TemplateThree += "stockname='" + HQ[2] + "' ";
			}
			TemplateThree += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateThree += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateThree += ">";

		var textLL = [];
		TemplateThree += "<div class='Item_Cor' style='width:";
		TemplateThree += width0 + ";";
		TemplateThree += "'><div class='one ";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div><div class='two ";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div></div><div class='Item_Cor' style='width:";
		TemplateThree += width1 + ";";
		TemplateThree += "'><div class='";
		textLL = this.TextAnaly("pos2", AnalyRes, RowL);//2-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div></div><div class='Item_Cor' style='width:";
		TemplateThree += width2 + ";";
		TemplateThree += "'><div class='";
		textLL = this.TextAnaly("pos3", AnalyRes, RowL);//3-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div></div><div class='Item_Cor' style='width:";
		TemplateThree += width3 + ";";
		TemplateThree += "'><div class='";
		textLL = this.TextAnaly("pos4", AnalyRes, RowL);//4-数据位
		TemplateThree += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateThree += "setcode='" + HQ[0] + "' ";
			TemplateThree += "stockcode='" + HQ[1] + "' ";
			TemplateThree += "stockname='" + HQ[2] + "' ";
		}
		TemplateThree += " style='text-align:";
		TemplateThree += textLL[1];
		TemplateThree += ";'>";
		TemplateThree += textLL[0];

		TemplateThree += "</div></div></div>";
		g_CurChildObj.append(TemplateThree);
	}
	if( this.gotof5 )
		$('.Childs>.Item_Three').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate4Child = function(DataJsn){
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = 2 * this.titlelist.length; //每行数据位置不确定 单一定是2的倍数
	var AnalyRes = this.AnalyDataCol();
	var widthL = [];
	for(var i=0; i<this.titlelist.length; i++){
		var width = this.titlelist[i]["width"];
		if( TdxUtils.isString(width) == false ) width = "80px";
		widthL.push(width);
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		if(i%2)
			var TemplateFour = "<div class='Item_Four Item_Second' ";
		else
			var TemplateFour = "<div class='Item_Four' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateFour += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateFour += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateFour += ">";

		var posindex = 0;
		for(var j=0; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			var textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='Item_Cor' style='width:";
			TemplateFour += widthL[j] + ";'>";

			TemplateFour += "<div class='first ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0];
			TemplateFour += "</div>";

			strpos = "pos"+posindex;
			posindex++;
			textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='second ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0];
			TemplateFour += "</div>";

			TemplateFour += "</div>";
			
		}
		TemplateFour += "</div>";
		g_CurChildObj.append(TemplateFour);
	}
	if( this.gotof5 )
		$('.Childs>.Item_Four').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate5Child = function(DataJsn){
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = this.titlelist.length; //每行数据位置不确定 
	var AnalyRes = this.AnalyDataCol();
	var widthL = [];
	for(var i=0; i<this.titlelist.length; i++){
		var width = this.titlelist[i]["width"];
		if( TdxUtils.isString(width) == false ) width = "80px";
		widthL.push(width);
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		if(i%2)
			var TemplateFour = "<div class='Item_Five Item_Second' ";
		else
			var TemplateFour = "<div class='Item_Five' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateFour += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateFour += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateFour += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateFour += ">";

		var posindex = 0;
		for(var j=0; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			var textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateFour += "<div class='Item_Cor ";
			TemplateFour += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateFour += "setcode='" + HQ[0] + "' ";
				TemplateFour += "stockcode='" + HQ[1] + "' ";
				TemplateFour += "stockname='" + HQ[2] + "' ";
			}
			TemplateFour += " style='width:";
			TemplateFour += widthL[j] + ";text-align:";
			TemplateFour += textLL[1];
			TemplateFour += ";'>";
			TemplateFour += textLL[0];
			TemplateFour += "</div>";
		}
		TemplateFour += "</div>";
		g_CurChildObj.append(TemplateFour);
	}
	if( this.gotof5 )
		$('.Childs>.Item_Five').TapEvent(GotoStock);
}

DataCfg.prototype.Rendertemplate7Child = function(DataJsn){
	/************************
	总共N+1个数据位,N列数据
	列宽用屏幕的百分比
	<div class="Wrap_VScroll">
		<div class="FixedLeft">
			<div id="Wrap_Content_Title">
				<div style="text-align:center"><span>Title</span></div>
			</div>
			<div class="Item_Seven">
				<div class="Item_Cor">
					<div class="one">1</div>
					<div class="two">2</div>
				</div>
			</div>
		</div>
		<div class="FixedRight">
			<div class="Wrap_HScroll">
				<div id="Wrap_Content_Title">
					<div style="text-align:center"><span>22</span></div>
					<div style="text-align:center"><span>33</span></div>
					<div style="text-align:center"><span>44</span></div>
				</div>
				<div class="Item_Seven">
					<div class="Item_Cor">
						<div>3</div>
					</div>
					<div class="Item_Cor">
						<div>4</div>
					</div>
					<div class="Item_Cor">
						<div>5</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	*************************/
	var HQ;
	if( this.titlelist.length ==0 ) return;
	var DataPosCnt = this.titlelist.length + 1; //每行数据位置不确定 
	var AnalyRes = this.AnalyDataCol();

	var nwidth = parseInt($('#Wrap_Content .Wrap_VScroll .FixedLeft').width());
	var allwidth = nwidth / parseInt(this.titlelist[0]["width"]) * 100;
	var widthL = [0];
	var rightallwidth = 0;
	for(var i=1; i<this.titlelist.length; i++){
		var width = parseInt(this.titlelist[i]["width"]);
		if( width == 0 ) width = 20;//20%
		rightallwidth += allwidth * width / 100;
		widthL.push(allwidth * width / 100 + 'px');
	}

	for(var i=0; i<DataJsn.DataList.length; i++){
		var RowL = DataJsn.DataList[i];
		var sc_ = '';
		if(DataJsn.sc_childjsonfile >= 0){
			sc_ = RowL[DataJsn.sc_childjsonfile];
		}
		var TemplateThree = "<div class='Item_Seven' ";
		if(0==i)
			TemplateThree = "<div class='Item_Seven Item_First_Fixed' ";
		if(i%2)
			TemplateThree = "<div class='Item_Seven Item_Second' ";
		if(AnalyRes.CFGColPos >=0 && TdxUtils.isString(RowL[AnalyRes.CFGColPos]) ){ //成分股
			TemplateThree += "cfgcode='" + RowL[AnalyRes.CFGColPos] + "' ";
		}
		if(AnalyRes.StockCodeColPos >=0 && TdxUtils.isString(RowL[AnalyRes.StockCodeColPos]) ){ //股票代码
			var stockcode = RowL[AnalyRes.StockCodeColPos];
			HQ = g_DataHQ[stockcode];
			if( this.gotof5 && TdxUtils.isArray(HQ) ){
				TemplateThree += "setcode='" + HQ[0] + "' ";
				TemplateThree += "stockcode='" + HQ[1] + "' ";
				TemplateThree += "stockname='" + HQ[2] + "' ";
			}
			TemplateThree += "stockcodepos='" + RowL[AnalyRes.StockCodeColPos] + "' ";
		}
		if(AnalyRes.ChildJsnPos >=0 && TdxUtils.isString(RowL[AnalyRes.ChildJsnPos]) ){ //子jsn文件
			//TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
			if(g_Version == 2)
				TemplateThree += "childjsnfile='" + this.childjsnfile +sc_+ RowL[AnalyRes.ChildJsnPos] + ".jsn' ";
			else
				TemplateThree += "childjsnfile='" + RowL[AnalyRes.ChildJsnPos] + "'";
		}
		TemplateThree += ">";

		var textLL = [];
		var TemplateLeft = "<div class='Item_Cor'><div class='one ";
		textLL = this.TextAnaly("pos0", AnalyRes, RowL);//0-数据位
		TemplateLeft += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateLeft += "setcode='" + HQ[0] + "' ";
			TemplateLeft += "stockcode='" + HQ[1] + "' ";
			TemplateLeft += "stockname='" + HQ[2] + "' ";
		}
		TemplateLeft += " style='text-align:";
		TemplateLeft += textLL[1];
		TemplateLeft += ";'>";
		TemplateLeft += textLL[0];

		TemplateLeft += "</div><div class='two ";
		textLL = this.TextAnaly("pos1", AnalyRes, RowL);//1-数据位
		TemplateLeft += textLL[2] + "' ";
		if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
			TemplateLeft += "setcode='" + HQ[0] + "' ";
			TemplateLeft += "stockcode='" + HQ[1] + "' ";
			TemplateLeft += "stockname='" + HQ[2] + "' ";
		}
		TemplateLeft += " style='text-align:";
		TemplateLeft += textLL[1];
		TemplateLeft += ";'>";
		TemplateLeft += textLL[0];

		TemplateLeft += "</div></div></div>";
		$('#Wrap_Content .FixedLeft').append(TemplateThree + TemplateLeft);

		var posindex = 2;
		TemplateRigth = '';
		for(var j=1; j<this.titlelist.length; j++){
			var strpos = "pos"+posindex;
			posindex++;
			TemplateRigth += "<div class='Item_Cor' style='width:";
			TemplateRigth += widthL[j] + ";";
			TemplateRigth += "'><div class='";
			textLL = this.TextAnaly(strpos, AnalyRes, RowL);//数据位
			TemplateRigth += textLL[2] + "' ";
			if( textLL[3] && TdxUtils.isArray(HQ) ){ //gotof5=true && HQ存在
				TemplateRigth += "setcode='" + HQ[0] + "' ";
				TemplateRigth += "stockcode='" + HQ[1] + "' ";
				TemplateRigth += "stockname='" + HQ[2] + "' ";
			}
			TemplateRigth += " style='text-align:";
			TemplateRigth += textLL[1];
			TemplateRigth += ";'>";
			TemplateRigth += textLL[0];
			TemplateRigth += "</div></div>";
		}
		TemplateRigth += "</div>";
		$('#Wrap_Content .FixedRight .Wrap_HScroll').append(TemplateThree + TemplateRigth);
	}
	if( this.gotof5 )
		$('.Childs>.Item_Seven').TapEvent(GotoStock);
}