define(["jquery", "selfcnt", "common"], function(require, exports, module) {
    var common = require("common")
    var selfcnt = require("selfcnt")
    var locationparm = common.locationparm;
    var globVal = {
        "arrId":["hyfxhygk","hyfxcwzk","hyfxscbx","hyfxgsgm","hyfxgzsp"],
        "TqlName":"phf10_f10_hyfx",
        "tot":0,
        "gljyrec":{}
    }

    reqhyfx()
    function  reqhyfx() {

        common.loading(true,100)
        $.each(globVal.arrId,function(i,stype){
            if($("#"+stype).length==0){
                $('<div id="'+stype+'"></div>').appendTo("#content")
            }
            selfcnt.send(globVal.TqlName, [stype,locationparm["code"]], function(data){
                common.loading(false)
                data = selfcnt.seftFmtResult(data)
                if(data.ErrorCode == 0){
                    var nlen = data.tables.length;
                    var stype =data.tables[nlen-1].rows[0]["stype"]
                    if(stype=="hyfxhygk"){
                        sethyfx(stype,data.tables[0].rows)
                    }else {
                        var rows = [],rows2 = data.tables[nlen-2].rows,nlen2 = data.tables[nlen-2].rows.length;
                        var mapField = {"hyfxcwzk":["T011","T012","T013","T014","T015"],
                            "hyfxscbx":["T021","T022","T023","T024","T025"],
                            "hyfxgsgm":["T009","T008","T007","T006","T010"],
                            "hyfxgzsp":["T017","T018","T016","T019","T020"]}
                        for(var i = 0;i<nlen-2;i++){
                            if(data.tables[i].rows.length) {
                                if (nlen2) {
                                    data.tables[i].rows[0]["hypj"] = rows2[0][mapField[stype][i]||""]
                                }
                                rows.push(data.tables[i].rows[0])
                            }
                        }
                        sethyfx(stype,rows)
                    }
                }else {
                    globVal.tot+=1;
                    if(globVal.tot==5){
                        common.setTsInfo(true,"content")
                    }
                }
            })
        })
    }
    function sethyfx(stype,data) {
        if((stype=="hyfxhygk"&&data.length&&common.etyStr(data[0]["hyname"])=="--")||data.length==0){
            globVal.tot+=1;
            if(globVal.tot==5){
                common.setTsInfo(true,"content")
            }
            return
        }
        if(stype=="hyfxhygk"){
            common.createHm([
                {"opts": [{}, {"text": "行业概况"}], "config": {"flagwidth": "1"}, "type": "1"},
                {
                    "tbody": [
                        [{"width": "100", "name": "行业名称"}, { "width": "100%", "field": "hyname"}],
                        [{"width": "100", "name": "公司家数"}, { "width": "100%", "field": "cnt"}],
                        [{"width": "100", "name": "截止日期"}, {"width": "100%", "field": "jzrq","fmtFn":common.formatDate}]
                    ], "type": "2", "rows": data
                }
            ], {"parentId": stype})
        }else{
            var head = [
                {"class":"txtleft","width":"120","name":"指标"},
                {"class":"txtright","width":"50%","name":"指标数值"},
                {"class":"txtright","width":"50%","name":"行业平均"},
                {"class":"txtright","width":"60","name":"排名"}
            ],stext ="",tbody = [{"class":"txtleft","width":"120","field":"name"},
                {"class":"txtright","width":"50%","field":"cw", "fmtFn": common.fmtB},
                {"class":"txtright","width":"50%","field":"hypj","fmtFn": common.fmtB},
                {"class":"txtright","width":"60","field":"pm", "fmtFn": common.fmtIt}]
            if(stype=="hyfxcwzk"){
                stext = "财务状况排名"
                tbody[1]["fmtFn"]=f
                tbody[2]["fmtFn"]=f
                function f(v,row) {
                    if(row["name"]=="每股收益" || row["name"]=="每股净资产")
                        return common.fmtTwo(v)
                    else
                        return common.fmtB(v)
                }
            }else if(stype=="hyfxscbx"){
                stext="市场表现排名"
            }else if(stype=="hyfxgsgm"){
                stext="公司规模排名"
                tbody[1]["fmtFn"]=common.fmtBig
                tbody[2]["fmtFn"]=common.fmtBig
                function e(v) {
                    var f = parseFloat(v)
                    if (isNaN(f) || f == 0)
                        return "--"
                    return (f / 100000000).toFixed(2) + "亿"
                }
            }else if(stype=="hyfxgzsp"){
                stext="估值水平排名"
                tbody[1]["fmtFn"]=common.fmtTwo
                tbody[2]["fmtFn"]=common.fmtTwo
            }
            common.createHm([
                {"opts":[{},{"text":stext}],"config":{"flagwidth":"1"},"type":"1"},
                {"header":head,"tbody":tbody,"type":"3","rows":data}
            ],{"parentId":stype})
        }
        common.getcontainheight()
    }
   

})
