define(['jquery', 'selfcnt', 'common', '../js/phf10_jk_common.js'], function(
  require,
  exports,
  module
) {
  var common = require('common');
  var selfcnt = require('selfcnt');
  var jk_common = require('../js/phf10_jk_common.js');
  var locationparm = common.locationparm;

  common.scrollSet();
  var globVal = {
    arrId: ['gdqkkggx', 'gdqkgdrs', 'gdqkjgcg', 'gdqkltgd', 'gdqksdgd'],
    TqlName: 'phf10_jk_gdqk',
    tot: 0
  };

  reqgdqk();
  function reqgdqk() {
    common.loading(true, 100);
    $.each(globVal.arrId, function(i, stype) {
      if ($('#' + stype).length == 0) {
        $('<div id="' + stype + '"></div>').appendTo('#content');
      }
      selfcnt.send(globVal.TqlName, [stype, locationparm['code']], function(
        data
      ) {
        common.loading(false);
        data = selfcnt.seftFmtResult(data);
        if (data.ErrorCode == 0 && data.tables.length > 1) {
          var nlen = data.tables.length;
          var stype = data.tables[nlen - 1].rows[0]['stype'];
          if (stype == 'gdqkgdrs') {
            var jkd = jk_common.transbgq(data, [
              { name: '股东人数/户', field: 'T003', fmtFn: common.fmtBig },
              { name: '变动户数/户', field: 'T012', fmtFn: common.fmtBig },
              {
                name: '较上期变化%',
                field: 'T005',
                fmtFn: function(v) {
                  var cls = '';
                  v = common.fmtFlt(v);
                  if (v > 0) cls = 'hprice';
                  else if (v < 0) cls = 'lprice';
                  return (
                    '<div class="' + cls + '">' + common.fmtTwo(v) + '</div>'
                  );
                }
              },
              { name: '人均流通股/股', field: 'T004', fmtFn: common.fmtBig },
              {
                name: '较上期变化%',
                field: 'T006',
                fmtFn: function(v) {
                  var cls = '';
                  v = common.fmtFlt(v);
                  if (v > 0) cls = 'hprice';
                  else if (v < 0) cls = 'lprice';
                  return (
                    '<div class="' + cls + '">' + common.fmtTwo(v) + '</div>'
                  );
                }
              },
              { name: '股价/元', field: 'T007' }
            ]);
            setgdqk(stype, jkd);
          } else if (stype == 'gdqkjgcg') {
            var jkd = jk_common.transbgq(data, [
              { name: '机构数', field: 'T003' },
              { name: '持股数', field: 'T005', fmtFn: common.fmtBig },
              {
                name: '持股比例',
                field: 'T008',
                fmtFn: function(v) {
                  return common.fmtTwo(v) + '%';
                }
              },
              {
                name: '持股变化量',
                field: 'T006',
                fmtFn: function(v) {
                  var cls = '';
                  v = common.fmtFlt(v);
                  if (v > 0) cls = 'hprice';
                  else if (v < 0) cls = 'lprice';
                  return (
                    '<div class="' + cls + '">' + common.fmtBig(v) + '</div>'
                  );
                }
              },
              {
                name: '持股变化比例',
                field: 'T010',
                fmtFn: function(v) {
                  var cls = '';
                  v = common.fmtFlt(v);
                  if (v > 0) cls = 'hprice';
                  else if (v < 0) cls = 'lprice';
                  return (
                    '<div class="' + cls + '">' + common.fmtTwo(v) + '%</div>'
                  );
                }
              }
            ]);
            setgdqk(stype, jkd);
          } else {
            setgdqk(stype, data.tables[0].rows);
          }
        } else {
          globVal.tot += 1;
          if (globVal.tot == 5) {
            common.setTsInfo(true, 'content');
          }
        }
      });
    });
  }
  function setgdqk(stype, data) {
    if (
      ((stype == 'gdqkgdrs' || stype == 'gdqkjgcg') &&
        data['data'].length == 0) ||
      data.length == 0
    ) {
      globVal.tot += 1;
      if (globVal.tot == 5) {
        common.setTsInfo(true, 'content');
      }
      return;
    }
    if (stype == 'gdqkkggx') {
      common.createHm(
        [
          {
            opts: [{}, { text: '控股关系' }],
            config: { flagwidth: '1' },
            type: '1'
          },
          {
            tbody: [
              [
                { width: '90', name: '截止日期' },
                { width: '100%', field: 'T001' }
              ],
              [
                { width: '90', name: '控股股东' },
                {
                  width: '100%',
                  field: 'kggd',
                  fmtFn: function(v, row) {
                    if (v == '无') return '--';
                    if (common.fmtTwo(row['T004']) == '--')
                      return common.etyStr(v);
                    return (
                      common.etyStr(v) + '(' + common.fmtTwo(row['T004']) + '%)'
                    );
                  }
                }
              ],
              [
                { width: '90', name: '实控人' },
                {
                  width: '100%',
                  field: 'sjkzr',
                  fmtFn: function(v, row) {
                    if (v == '无') return '--';
                    if (common.fmtTwo(row['T006']) == '--')
                      return common.etyStr(v);
                    return (
                      common.etyStr(v) + '(' + common.fmtTwo(row['T006']) + '%)'
                    );
                  }
                }
              ],
              [
                { width: '90', name: '关系说明' },
                {
                  width: '100%',
                  field: 'T009',
                  fmtFn: function(v) {
                    if (common.etyStr(v) == '--') return '--';
                    else {
                      return common.etyStr(v.replace(/；/g, '；<br/><br/>'));
                    }
                  }
                }
              ]
            ],
            type: '2',
            rows: data
          }
        ],
        { parentId: stype }
      );
    } else if (stype == 'gdqkgdrs' || stype == 'gdqkjgcg') {
      var head = data['head'];
      var headcol = head.length;
      var bfb = parseFloat(100) / headcol;

      var arrhead = [],
        arrBody = [],
        tot = 0;
      $.each(head, function(i, name) {
        if (i < 3) {
          if (i == headcol - 1) {
            //arrhead.push({"class":"txtright","width":"34%","name":name})
            //arrBody.push({"class":"txtright","width":"34%","field":"T00"+(i+2)})
            arrhead.push({
              class: 'txtright',
              width: 100 - tot + '%',
              name: name
            });
            arrBody.push({
              class: 'txtright',
              width: 100 - tot + '%',
              field: 'T00' + (i + 2)
            });
          } else {
            //arrhead.push({"class":"txtright","width":"33%","name":name})
            //arrBody.push({"class":"txtright","width":"33%","field":"T00"+(i+2)})
            arrhead.push({ class: 'txtright', width: bfb + '%', name: name });
            arrBody.push({
              class: 'txtright',
              width: bfb + '%',
              field: 'T00' + (i + 2)
            });
          }
          tot += bfb;
        }
      });
      arrhead.unshift({ class: 'txtleft', width: '95', name: '截止日期' });
      arrBody.unshift({ class: 'txtleft txtfix', width: 95, field: 'T001' });

      var sn = stype == 'gdqkjgcg' ? '机构持股' : '股东人数';

      var height = stype == 'gdqkjgcg' ? 180 : 210;

      //console.log(arrhead)
      //console.log(arrBody)
      var leftdata = [],
        rightdata = [];
      $.each(data['data'], function(i, d) {
        var od = {};

        $.each(d, function(k, v) {
          if (k == 'T001') leftdata.push({ T001: v });
          else od[k] = v;
        });
        rightdata.push(od);
      });

      var lefthtml = common
        .createHm(
          [
            {
              header: [arrhead[0]],
              tbody: [arrBody[0]],
              type: '3',
              rows: leftdata
            }
          ],
          {}
        )
        .join('');
      var righthtml = common
        .createHm(
          [
            {
              header: arrhead.slice(1),
              tbody: arrBody.slice(1),
              type: '3',
              rows: rightdata
            }
          ],
          {}
        )
        .join('');

      var html = common
        .createHm(
          [{ opts: [{}, { text: sn }], config: { flagwidth: '1' }, type: '1' }],
          {}
        )
        .join('');
      var stx = '';
      if (stype == 'gdqkjgcg') {
        stx =
          '<table  class="webtable" style="width: 100%;table-layout: fixed;border-collapse: collapse;"> <tbody> <tr><td class="txtfix" style="padding:0px;font-size:12px">备注：此数据为已经发布报告的基金持股和公司十大流通股东汇总而成，可能因为基金投资组合或公司定期报告未披露完毕，导致汇总数据不够完整，仅供参考</td></tr></tbody></table>';
      }
      $('#' + stype).append(
        html +
          stx +
          '<table style="width: 100%;table-layout: fixed;border-collapse: collapse;"> <tbody> <tr>' +
          '<td   style="width: 100px;" width="120" valign="top">' +
          lefthtml +
          '</td><td width="100%" valign="top">' +
          '<div  style="-webkit-overflow-scrolling: touch;width: 100%;height: ' +
          height +
          'px;">' +
          righthtml +
          '</div></td>' +
          '<td class="tiparrow" shref="' +
          stype +
          '" width="20">&nbsp;</td>'
      );
      /*html+'<table style="width: 100%;table-layout: fixed;border-collapse: collapse;"> <tbody> <tr>'+
                '<td   style="width: 100px;" width="120" valign="top">'+lefthtml+'</td>'+
                '<td width="100%" valign="top"><div id="wrapper'+stype+'" style="position: relative;z-index: 1;height: 160px;width: 100%;overflow: hidden;height: '+height+'px;"><div style="position: absolute;z-index: 1;">'+righthtml+'</div></td>')*/
      if (stype == 'gdqkjgcg') {
        $(
          $('#' + stype)
            .children('.nav')
            .get(0)
        ).after();
      }
      $('#content .tiparrow').click(function() {
        var href = $(this).attr('shref');
        if (href && href.length && href == stype) {
          var sparam = 'code=' + common.locationparm['code'];
          var name = '股东人数';
          if (href == 'gdqkjgcg') name = '机构持股';

          selfcnt.goDetail(
            'phf10_jk_gdqkmx.html?code=' +
              common.locationparm['code'] +
              '&' +
              'stype=' +
              href,
            { OpenName: name + '详情' || '' }
          );
        }
      });

      //
      /* common.createHm([
                {"opts":[{},{"text":sn}],"config":{"flagwidth":"1"},"type":"1"},
                {"header":arrhead,"tbody":arrBody,"type":"3","rows":data["data"]||[]}],{"parentId": stype})*/
    } else if (stype == 'gdqksdgd' || stype == 'gdqkltgd') {
      var sname = '十大流通股东';
      if (stype == 'gdqksdgd') sname = '十大股东';
      common.createHm(
        [
          {
            opts: [{}, { text: sname }, { text: data[0]['T002'] || '' }],
            config: {
              flagwidth: '2',
              selcls: '1',
              arrCls: ['nim', 'navtitle', 'navtime']
            },
            type: '1'
          },
          {
            header: [
              { class: 'txtleft', width: '100%', name: '股东名称' },
              { class: 'txtright', width: '85', name: '持股数' },
              { class: 'txtright', width: '55', name: '占比' },
              { class: 'txtright', width: '85', name: '增减' }
            ],
            tbody: [
              { class: 'txtleft', width: '100%', field: 'T003' },
              {
                class: 'txtright',
                width: '85',
                field: 'T006',
                fmtFn: common.fmtBig
              },
              {
                class: 'txtright',
                width: '55',
                field: 'T007',
                fmtFn: common.fmtB
              },
              {
                type: 'zdf',
                class: 'txtright',
                width: '85',
                field: 'T008',
                fmtFn: function(v) {
                  var cls = '';
                  var v1 = common.fmtFlt(v);
                  if (v == '新进') {
                    cls = 'hprice';
                  } else {
                    if (v1 > 0) cls = 'hprice';
                    else if (v1 < 0) cls = 'lprice';
                  }
                  if (v1 == 0) {
                    return (
                      '<div class="' + cls + '">' + common.etyStr(v) + '</div>'
                    );
                  } else {
                    return (
                      '<div class="' + cls + '">' + common.fmtBig(v) + '</div>'
                    );
                  }
                }
              }
            ],
            type: '3',
            rows: data
          }
        ],
        { parentId: stype }
      );
    }
    common.getcontainheight();
  }
});
