define(['jquery', 'selfcnt', 'common'], function(require, exports, module) {
  var common = require('common');
  var selfcnt = require('selfcnt');
  var locationparm = common.locationparm;
  var globVal = {
    TqlName: 'phf10_jk_gsjj',
    gglbrec: {}
  };
  reqgsjj();

  function reqgsjj() {
    common.loading(true, 100);
    selfcnt.send(globVal.TqlName, [locationparm['code']], function(data) {
      common.loading(false);
      data = selfcnt.seftFmtResult(data);
      if (data.ErrorCode == 0 && data.tables.length > 1) {
        var hidenoData = true;
        if (data.tables[0].rows.length) {
          hidenoData = false;
          var rows = data.tables[0].rows;
          var tb = [
            [
              {
                width: '80',
                name: '公司名称'
              },
              {
                colspan: '3',
                width: '100%',
                field: 'T003'
              }
            ],
            [
              {
                width: '80',
                name: '曾用名'
              },
              {
                colspan: '3',
                width: '100%',
                field: 'T005'
              }
            ],
            [
              {
                width: '80',
                name: '所属行业'
              },
              {
                width: '40%',
                field: 'T039'
              },
              {
                width: '70',
                name: '上市日期'
              },
              {
                width: '60%',
                field: 'T031',
                class: 'txtright'
              }
            ],
            [
              {
                width: '80',
                name: '发行价'
              },
              {
                width: '40%',
                field: 'T042',
                fmtFn: function(v) {
                  return common.fmtTwo(v) + '元';
                }
              },
              {
                width: '70',
                name: '发行数量'
              },
              {
                width: '60%',
                field: 'T044',
                fmtFn: function(v) {
                  return common.fmtBigT(v) + '股';
                },
                class: 'txtright'
              }
            ],
            [
              {
                width: '80',
                name: '联系电话'
              },
              {
                colspan: '3',
                width: '100%',
                field: 'T015'
              }
            ],
            [
              {
                width: '80',
                name: '办公地址'
              },
              {
                colspan: '3',
                width: '100%',
                field: 'T012'
              }
            ],
            [
              {
                width: '80',
                name: '主营业务'
              },
              {
                colspan: '3',
                width: '100%',
                field: 'T017'
              }
            ]
          ];
          if (rows[0]['kcbflag'] == '1') {
            tb.splice(4, 0, [
              {
                width: '80',
                name: '投票权'
              },
              {
                width: '40%',
                field: 'tpq'
              },
              {
                width: '70',
                name: '上市标准'
              },
              {
                width: '60%',
                field: 'ssbz',
                class: 'txtright'
              }
            ]);
            tb.splice(
              5,
              0,

              [
                {
                  width: '80',
                  name: '盈利状态'
                },
                {
                  width: '40%',
                  field: 'ylzt'
                },
                {
                  width: '70',
                  name: '扩位简称'
                },
                {
                  width: '60%',
                  field: 'kcbjc',
                  class: 'txtright'
                }
              ]
            );
          }
          common.createHm(
            [
              {
                opts: [
                  {},
                  {
                    text: '公司概况'
                  }
                ],
                config: {
                  flagwidth: '1'
                },
                type: '1'
              },
              {
                tbody: tb,
                type: '2',
                rows: data.tables[0].rows
              }
            ],
            {
              parentId: 'content'
            }
          );
        }
        $(
          $('#content')
            .children('.multable')
            .get(0)
        )
          .children('tbody')
          .prepend(
            '<tr>' +
              '<td style="padding:0px;line-height:0px" width="80"></td>' +
              '<td style="padding:0px;line-height:0px" width="40%"></td>' +
              '<td style="padding:0px;line-height:0px" width="70"></td>' +
              '<td style="padding:0px;line-height:0px" width="60%"></td></tr>'
          );
        var zxtsData = transzxts(data);
        if (zxtsData.length) {
          hidenoData = false;
          common.createHm(
            [
              {
                opts: [
                  {},
                  {
                    text: '最新提示'
                  },
                  {
                    text: zxtsData[0]['T002'] || ''
                  }
                ],
                config: {
                  flagwidth: '2',
                  selcls: '1',
                  arrCls: ['nim', 'navtitle', 'navtime']
                },
                type: '1'
              },
              {
                tbody: [
                  [
                    {
                      width: '80',
                      name: '每股收益'
                    },
                    {
                      width: '54%',
                      field: 'T056',
                      class: 'txtright padright',
                      fmtFn: common.fmtY
                    },
                    {
                      width: '110',
                      name: '净资产收益率-摊薄',
                      class: 'txtleft padleft'
                    },
                    {
                      width: '46%',
                      field: 'T064',
                      class: 'txtright',
                      fmtFn: common.fmtB
                    }
                  ],
                  [
                    {
                      width: '80',
                      name: '每股净资产'
                    },
                    {
                      width: '54%',
                      field: 'T059',
                      fmtFn: common.fmtY,
                      class: 'txtright padright'
                    },
                    {
                      width: '110',
                      name: '每股经营现金流',
                      class: 'txtleft padleft'
                    },
                    {
                      width: '46%',
                      field: 'T062',
                      fmtFn: common.fmtY,
                      class: 'txtright'
                    }
                  ],
                  [
                    {
                      width: '80',
                      name: '每股公积金'
                    },
                    {
                      width: '54%',
                      field: 'T061',
                      fmtFn: common.fmtY,
                      class: 'txtright padright'
                    },
                    {
                      width: '110',
                      name: '每股未分配利润',
                      class: 'txtleft padleft'
                    },
                    {
                      width: '46%',
                      field: 'T060',
                      class: 'txtright',
                      fmtFn: common.fmtY
                    }
                  ],
                  [
                    {
                      width: '80',
                      name: '利润总额'
                    },
                    {
                      width: '54%',
                      field: 'T016',
                      fmtFn: common.fmtBig,
                      class: 'txtright padright'
                    },
                    {
                      width: '110',
                      name: '归属母公司净利',
                      class: 'txtleft padleft'
                    },
                    {
                      width: '46%',
                      field: 'T019',
                      class: 'txtright',
                      fmtFn: common.fmtBig,
                      class: 'txtright'
                    }
                  ],
                  [
                    {
                      width: '80',
                      name: '营业收入'
                    },
                    {
                      width: '54%',
                      field: 'T003',
                      class: 'txtright padright',
                      fmtFn: common.fmtBig
                    },
                    {
                      width: '110',
                      name: '流通A股',
                      class: 'txtleft padleft'
                    },
                    {
                      width: '46%',
                      field: 'bt006',
                      fmtFn: common.fmtBigT,
                      class: 'txtright'
                    }
                  ],
                  [
                    {
                      width: '80',
                      name: '总股本'
                    },
                    {
                      width: '54%',
                      field: 'bt003',
                      fmtFn: common.fmtBigT,
                      class: 'txtright padright'
                    },
                    {
                      width: '110',
                      name: '&nbsp'
                    },
                    {
                      width: '46%',
                      name: '&nbsp'
                    }
                  ]
                ],
                type: '2',
                rows: zxtsData
              }
            ],
            {
              parentId: 'content'
            }
          );
        }
        if (data.tables[4].rows.length) {
          hidenoData = false;
          setgglb(data.tables[4].rows);
        }
        if (hidenoData) {
          common.setTsInfo(true, 'content');
        }
      } else {
        common.setTsInfo(true, 'content');
      }
    });
  }

  function transzxts(data) {
    var rowd = data.tables[1].rows[0] || {};
    if (data.tables[2].rows.length) {
      var row2 = data.tables[2].rows[0];
      var row3 = data.tables[3].rows[0];
      if (row3 && row3['T002'] && row3['T002'] > row2['T004']) {
        rowd = {
          T002: row3['T002'],
          T056: rowd['T125'],
          T059: rowd['T123'],
          T062:
            common.fmtFlt(rowd['T022']) /
            (common.fmtFlt(data.tables[3].rows[0]['T005']) * 10000),
          T060: rowd['T129'],
          T061: rowd['T127'],
          bt006: row3['T033'],
          bt003: row3['T005']
        };
      } else {
        rowd = {
          T002: row2['T004'],
          T056: row2['T016'],
          T059: rowd['T036'],
          T064: row2['T024'],
          T062: row2['T034'],
          T019: row2['T008']
        };
        if (row3) {
          rowd['bt006'] = row3['T033'];
          rowd['bt003'] = row3['T005'];
        }
      }
    } else {
      if (data.tables[3].rows.length) {
        if (data.tables[3].rows[0]['T002'] > rowd['T002']) {
          rowd = {
            T002: data.tables[3].rows[0]['T002'],
            T056: rowd['T125'],
            T059: rowd['T123'],
            T062:
              common.fmtFlt(rowd['T022']) /
              (common.fmtFlt(data.tables[3].rows[0]['T005']) * 10000),
            T060: rowd['T129'],
            T061: rowd['T127'],
            bt006: data.tables[3].rows[0]['T033'],
            bt003: data.tables[3].rows[0]['T005']
          };
        } else {
          rowd['bt006'] = data.tables[3].rows[0]['T033'];
          rowd['bt003'] = data.tables[3].rows[0]['T005'];
        }
      }
    }
    if ($.isEmptyObject(rowd)) {
      return [];
    } else {
      return [rowd];
    }
  }

  function setgglb(tem) {
    var arrNavHm = [];
    var arrBody = [
      {
        class: 'txtleft',
        width: '80',
        field: 'T002',
        class: 'txtlink'
      },
      {
        class: 'txtleft',
        width: '100%',
        field: 'sT004'
      },
      {
        class: 'txtright',
        width: '85',
        field: 'T012',
        fmtFn: function(v) {
          return common.fmtTwo(common.fmtFlt(v) / 10000);
        }
      },
      {
        class: 'txtright',
        width: '85',
        field: 'T010',
        fmtFn: common.fmtTwo
      }
    ];
    arrNavHm.push(
      common.contentNav(
        [
          {},
          {
            text: '高管列表'
          }
        ],
        {
          flagwidth: '1'
        }
      )
    );
    arrNavHm.push(common.getSpe());
    arrNavHm.push(
      '<table class="webtable" id="gglb" style="width: 100%;table-layout: fixed;">'
    );
    arrNavHm.push(
      common.getHeadHtml([
        {
          class: 'txtleft',
          width: '80',
          name: '高管姓名'
        },
        {
          class: 'txtleft',
          width: '100%',
          name: '公司职务'
        },
        {
          class: 'txtright',
          width: '85',
          name: '持股数/万'
        },
        {
          class: 'txtright',
          width: '85',
          name: '薪酬/万元'
        }
      ])
    );
    var arrRows = [],
      mapM = {};
    $.each(tem, function(i, row) {
      if (mapM[row['T002']]) {
        mapM[row['T002']] += ',' + row['T004'];
      } else {
        arrRows.push(row);
        mapM[row['T002']] = row['T004'];
      }
    });
    var arrTr = [];
    $.each(arrRows, function(k, row) {
      row['sT004'] = mapM[row['T002']];
      arrTr.push(
        common
          .getTr(row, arrBody)
          .replace('<tr>', '<tr attrid="' + row['rec_id'] + '">')
      );
      arrTr.push(
        '<tr style="display:none" id="' +
          row['rec_id'] +
          '"><td colspan="4"></td></tr>'
      );
    });
    arrNavHm.push('<tbody>');
    arrNavHm.push(arrTr.join(''));
    arrNavHm.push(common.getSpe());
    arrNavHm.push('</tbody></table>');
    $(arrNavHm.join('')).appendTo($('#content'));
    common.getcontainheight();
    if ($('#gglb').length) {
      $('#gglb tbody tr').click(function(event) {
        var attrid = $(this).attr('attrid');
        if (!attrid) return;

        var priid = $('#gglb tbody').attr('attrid');
        if (priid) {
          if (attrid == priid) {
            if ($('#' + attrid).attr('sflsg') == 'open') {
              $('#' + attrid).attr('sflsg', 'close');
              $('#' + attrid).css('display', 'none');
            } else {
              $('#' + attrid).attr('sflsg', 'open');
              $('#' + attrid).css('display', '');
            }
          } else {
            $('#' + priid).attr('sflsg', 'close');
            $('#' + priid).css('display', 'none');
            $('#' + attrid).attr('sflsg', 'open');
            $('#' + attrid).css('display', '');
          }
        } else {
          $('#' + attrid).attr('sflsg', 'open');
          $('#' + attrid).css('display', '');
        }
        // if (!attrid || attrid == "null" || attrid == 'undefined') {
        //     $($("#" + attrid + ' td')[0]).text("暂无个人简介")
        //     return
        // }
        $('#gglb tbody').attr('attrid', attrid);
        if (globVal.gglbrec[attrid]) {
          $($('#' + attrid + ' td')[0]).text(
            common.etyStr(globVal.gglbrec[attrid])
          );
          common.getcontainheight();
        } else {
          selfcnt.send('phf10_id_text', ['gsjjgglb', attrid], function(data) {
            data = selfcnt.seftFmtResult(data);
            if (data.ErrorCode == 0) {
              if (data.tables[0].rows.length) {
                var row = data.tables[0].rows[0];
                globVal.gglbrec[row['rec_id']] = row['T013'];
                $($('#' + row['rec_id'] + ' td')[0]).text(
                  common.etyStr(row['T013'])
                );
              } else {
                $($('#' + attrid + ' td')[0]).text('暂无个人简介');
              }
              common.getcontainheight();
            }
          });
        }
      });
    }
  }
});
