define(["jquery", "selfcnt", "common"], function (require, exports, module) {
    var common = require("common")
    var selfcnt = require("selfcnt")
    var locationparm = common.locationparm;
    reqrzrq()

    function reqrzrq() {
        common.loading(true, 100)
        selfcnt.send("phf10_zj_rzrq", [locationparm["code"]], function (data) {
            common.loading(false)
            data = selfcnt.seftFmtResult(data)
            if (data.ErrorCode == 0) {
                var rows = [],
                    nlen = data.tables[0].rows.length;
                if (nlen == 0) {

                    common.setTsInfo(true, "content")
                    return
                }
                var closePrice = 0
                var trows = data.tables[0].rows
                if (data.tables[1].rows.length) {
                    closePrice = data.tables[1].rows[0]["ClosePrice"]
                }

                for (var k = nlen - 1; k > -1; k--) {
                    if (common.fmtFlt(trows[k]["ClosePrice"]) == 0) {
                        if (k == nlen - 1) {
                            trows[k]["ClosePrice"] = closePrice
                        } else {
                            trows[k]["ClosePrice"] = common.fmtFlt(trows[k + 1]["ClosePrice"])
                        }
                    }
                }
                $.each(data.tables[0].rows, function (i, row) {
                    if (i != nlen - 1) {
                        row["ye"] = (common.fmtFlt(row["T003"]) + common.fmtFlt(row["T006"]) * common.fmtFlt(row["ClosePrice"])) / 10000
                        row["jmr"] = common.fmtFlt(row["T003"]) - common.fmtFlt(trows[i + 1]["T003"])
                        rows.push(row)
                    }
                })
                setrzrq(rows)
            } else {

                common.setTsInfo(true, "content")
            }
        })
    }

    function setrzrq(data) {
        common.createHm([{
            "opts": [{}, {
                "text": "融资融券余额曲线"
            }],
            "config": {
                "flagwidth": "1"
            },
            "type": "1"
        }, ], {
            "parentId": "navbox"
        })
        require.async(["highchart", "chartcolor"], function () {
            var chartcolor = require("chartcolor")
            var dch = {
                "cate": [],
                "yxas": []
            }
            $.each(data, function (i, trow) {
                dch["cate"].push(common.formatDate(trow["T001"]))
                dch["yxas"].push(common.fmtFlt(trow["ye"]))
            })
            var odChar = $.extend(true, {}, chartcolor[common.bgcolor] || {}, common.defaultChart, {
                chart: {
                    marginBottom: 20,
                    type: 'spline',
                },
                "legend": {
                    enabled: false
                },
                yAxis: {
                    labels: {
                        "format": "{value}亿"
                    }
                },
                xAxis: {
                    categories: dch["cate"]
                },
                series: [{
                    type: 'spline',
                    "name": "两融余额(亿)",
                    data: dch["yxas"]
                }],
            })
            $("#chartbox").highcharts(odChar)
            common.getcontainheight()
        })
        common.createHm([{
                "opts": [{}, {
                    "text": "详细数据"
                }],
                "config": {
                    "flagwidth": "1"
                },
                "type": "1"
            },
            {
                "header": [{
                        "class": "txtleft",
                        "width": "90",
                        "name": "交易日期"
                    },
                    {
                        "class": "txtright",
                        "width": "50%",
                        "name": "融资买入"
                    },
                    {
                        "class": "txtright",
                        "width": "50%",
                        "name": "融资净买入"
                    },
                    {
                        "class": "txtright",
                        "width": "80",
                        "name": "两融余额"
                    }
                ],
                "tbody": [{
                        "class": "txtleft",
                        "width": "90",
                        "field": "T001",
                        "fmtFn": common.formatDate
                    },
                    {
                        "class": "txtright",
                        "width": "50%",
                        "field": "T004",
                        "fmtFn": common.fmtBigT
                    },
                    {
                        "class": "txtright",
                        "width": "50%",
                        "field": "jmr",
                        "fmtFn": common.fmtBigT
                    },
                    {
                        "class": "txtright",
                        "width": "80",
                        "field": "ye",
                        "fmtFn": function (v) {
                            var f = parseFloat(v)
                            if (isNaN(f) || f == 0)
                                return "--"
                            if (Math.abs(f) < 10000) {
                                return f.toFixed(2) + "亿"
                            } else {
                                return (f / 10000).toFixed(2) + "万亿"
                            }
                        }
                    }
                ],
                "type": "3",
                "rows": data
            }
        ], {
            "parentId": "tablebox"
        })
        common.getcontainheight()
    }
})