define(["jquery", "selfcnt", "common"], function(require, exports, module) {
    var common = require("common")
    var colorStyle = {
        white:{
            lprice:"#1cb52e",
            hprice:"#ff4800",
            deephprice:"#fa0000",
            deeplprice:"#5dc829",
            innercicle:"#528ED7",
            outercicle:"#2863AB",
            textcolor:"#f0f0f0",
            titlecolor:"#8A8D8A"
        },
        black:{
            lprice:"#52b521",
            hprice:"#bf351f",
            deephprice:"#bc1818",
            deeplprice:"#0f931f",
            innercicle:"#101419",
            outercicle:"#2f353e",
            textcolor:"#f0f0f0",
            titlecolor:"#8A8D8A"
        }

    }
    colorSty = colorStyle[common.bgcolor] || colorStyle["white"]
    common.setTsInfo(false)
    require.async(["../mylib/raphael.min.js"], function() {
        var svgWidth = common.fmtIt($('#Vsg').css('width'));
        var svg = Raphael('Vsg');
        tdxPaperDraw.RegisterToRaphael(svg);
        svgring = svg.tdxRing(svgWidth / 2, 120, 70, 50, 3);
        svgfund = svg.tdxDayFundTDX(svgWidth / 2, 120 + 260, '最近5日多空对比(万元)', '单位(万元)');
        //圆
        svg.circle(svgWidth / 2, 120, 47).attr({
            'fill': colorSty.innercicle,
            'stroke-width': 0,
            "stroke": "none",
        });
        svg.circle(svgWidth / 2, 120, 37).attr({
            'fill': colorSty.outercicle,
            'stroke-width': 0,
            "stroke": "none",
        });
        svg.text(svgWidth / 2, 120, '今日资金').attr({
            'fill': colorSty.textcolor,
            'font-size': 15,
            'font-weight': 'bold',
        });
        svgring.setRingData([{val: 100, lable: '--', color: colorSty.hprice}]);
        if (__tdxMobSystem=='Android'){
            var name = wrapFn(androidcall)
            window.tdx_java.Android_SendData(0,"","",0,"Stock_ZJLX",name);
        }
        else if(__tdxMobSystem=='IOS'){
            //IOS_Bridge.call(strCallWay, cparams, strFuncName, formid, 'getCallBack');
            IOS_Bridge.call(util.wrapFn(ioscall),"","Stock_ZJLX","1");
            //_IOSBridgeConnect.call()
        }
        function  androidcall(data) {
            callback(data)
        }
        function ioscall(id,name,type,data) {
            callback(data)
        }
        function callback(data) {

            // ['主力流入','主力流出','散户流入','散户流出']
            // ['买入','卖出','超大单净额','大单净额','中单净额','小单净额']
            //data = '[["2","1","1","3.14"],["10000","20000","12003","-40000","-101000","14500"]]';
            var arrData  = []
            
            try{arrData=eval(data);}
            catch(err){return;}

            var arrD1=arrData[0];
            var Sum=eval(arrD1.join('+'));
            var svgWidth=common.fmtIt($('#Vsg').css('width'));
            if(!!Sum && arrD1.length==4){
                svgring.setRingData([
                    {val:(arrD1[3]/Sum*100).toFixed(1),lable:'散户流出',color:colorSty.lprice},
                    {val:(arrD1[1]/Sum*100).toFixed(1),lable:'主力流出',color:colorSty.deeplprice},
                    {val:(arrD1[0]/Sum*100).toFixed(1),lable:'主力流入',color:colorSty.hprice},
                    {val:(arrD1[2]/Sum*100).toFixed(1),lable:'散户流入',color:colorSty.deephprice},]);
            }
            var arrD2=arrData[1];
            var L1=arrD2.slice(0,2).map(function(elm){return parseFloat((elm/10000).toFixed(1))});
            var L2=arrD2.slice(2).map(function(elm){return parseFloat((elm/10000).toFixed(1))});
            svgfund.setDayFundDataTDX([L1, L2, ['超大单净额','大单净额','中单净额','小单净额']]);
            common.getcontainheight()
        }
    })
    var IOS_Bridge = {
        callbacksCount: 1,
        callbacks: {},
        call: function call(functionName, args, funcID, frameID, callback) {

            var hasCallback = callback && typeof callback == "function";
            var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;

            if (hasCallback) {
                IOS_Bridge.callbacks[callbackId] = callback;
            }
            var iframe = document.createElement("IFRAME");
            iframe.setAttribute("src", "js-frame:" + functionName + ";;" + callbackId + ";;" + frameID + ";;" + funcID + ";;" + args + ";;" + callback);
            //encodeURIComponent(JSON.stringify(args)));
            document.documentElement.appendChild(iframe);
            iframe.parentNode.removeChild(iframe);
            iframe = null;
        }
    }

    function wrapFn(fn) {
        // 如果fn不是一个函数，则直接返回
        if (typeof fn !== 'function') {
            return fn;
        }
        // 生成一个全局唯一的随机名称，将函数绑定到根作用域下
        var globalName = 'globalzjlx$$' +
            util.getUID() +
            '$' + Math.random().toString(16).substr(3, 6);
        window[globalName] = function (PCData, spare1, spare2, stream) {

            fn.call(this,stream);
            delete window[globalName];
        };
        return globalName;
    };
    var tdxPaperDraw={
        RegisterToRaphael : function (Paper){
            Paper.__proto__.tdxRing=tdxPaperDraw.Ring;
            Paper.__proto__.tdxLabel=tdxPaperDraw.Label;
            Paper.__proto__.tdxDayFundTDX=tdxPaperDraw.DayFundTDX;
        },
        /*
         非标准的元素
         环形图(顺时针方向;角度-360;)
         params:圆心X，圆心Y，半径R，截取的半径cutR(不能大于半径)，截取像素cutPX
         */
        Ring : function (centerPx,centerPy,R,cutR,cutPX){
            if(this instanceof Raphael){
                tdxPaperDraw.Ring.Paper=this;
            }
            if(!(this instanceof tdxPaperDraw.Ring)){
                return new tdxPaperDraw.Ring(centerPx,centerPy,R,cutR,cutPX);
            }
            if(tdxPaperDraw.Ring.Paper){
                this.Paper=tdxPaperDraw.Ring.Paper;
            }
            this.Label=this.Paper.tdxLabel(); //标签
            this.PathSet=this.Paper.set();
            this.centerPx=0;
            this.centerPy=0;
            this.R=0;
            this.cutR=0;
            this.cutPX=1; //px
            if(arguments.length===5){
                this.centerPx=centerPx;
                this.centerPy=centerPy;
                this.R=R;
                this.cutR=cutR;
                this.cutPX=cutPX/2;
            }
            if(this.R<this.cutR && this.cutR<=0){this.cutR=this.R/2;}
            if(this.cutPX<=0){this.cutPX=1;}
            /*
             data: [{},{}]
             总和比例不能超过100% 比例值:0-100
             */
            this.setRingData=function(data){
                function A(R){
                    var x=Math.sqrt(R*R-this.cutPX*this.cutPX);

                    return Raphael.angle(0,0,-x,-this.cutPX)/360*2*Math.PI;
                };
                function P(angle,R){
                    var D={
                        x: this.centerPx+Math.cos(angle)*R,
                        y: this.centerPy+Math.sin(angle)*R
                    };

                    return D;
                };
                var angle1=A.call(this,this.cutR);
                var angle2=A.call(this,this.R);
                if(this.PathSet){this.PathSet.remove();}

                var LabelList=[];
                if(this.Paper){
                    var AngleToX=0;
                    for(var i=0;i<data.length;i++){
                        var val=data[i].val;
                        if(val>100 || val<=0){continue;}
                        var lable=data[i].lable;
                        var color=data[i].color;
                        var angle=val/100*2*Math.PI+AngleToX;
                        var centangle=val/100*2*Math.PI/2+AngleToX; //中线

                        var cetP={
                            x : this.centerPx+Math.cos(centangle)*(this.R+10),
                            y : this.centerPy+Math.sin(centangle)*(this.R+10),
                        }
                        if(centangle>=0 && centangle<Math.PI/4){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'left',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
                        }
                        else if(centangle>=Math.PI/4 && centangle<Math.PI/2){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'top',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
                        }
                        else if(centangle>=Math.PI/2 && centangle<Math.PI*3/4){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'top',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
                        }
                        else if(centangle>=Math.PI*3/4 && centangle<Math.PI){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'right',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
                        }
                        else if(centangle>=Math.PI && centangle<Math.PI*5/4){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'right',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
                        }
                        else if(centangle>=Math.PI*5/4 && centangle<Math.PI*3/2){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'bottom',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color});
                        }
                        else if(centangle>=Math.PI*3/2 && centangle<Math.PI*7/4){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'bottom',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
                        }
                        else if(centangle>=Math.PI*7/4 && centangle<Math.PI*2){
                            LabelList.push({x:cetP.x,y:cetP.y,pos:'left',labelclr:color,labeltext:lable+'\n'+val+'%',labeltextclr:color,angle1:150,angle2:135});
                        }

                        //内弧线点
                        var p1=P.call(this,AngleToX+angle1,this.cutR);
                        var p2=P.call(this,angle-angle1,this.cutR);

                        //外弧线点
                        var p3=P.call(this,AngleToX+angle2,this.R);
                        var p4=P.call(this,angle-angle2,this.R);
                        var bigarg='1';
                        if(val<=51.5){
                            bigarg='0';
                        }

                        var PathLine='M'+p1.x+','+p1.y+' ';
                        PathLine+='L'+p3.x+','+p3.y+' ';
                        PathLine+='A'+this.R+','+this.R+',0,'+bigarg+',1,'+p4.x+','+p4.y+' ';
                        PathLine+='L'+p2.x+','+p2.y+' ';
                        PathLine+='A'+this.cutR+','+this.cutR+',0,'+bigarg+',0,'+p1.x+','+p1.y+' ';
                        var pathobj=this.Paper.path(PathLine);
                        //毛边
                        /*this.PathSet.push(pathobj.glow({
                         width:1,
                         fill:true,
                         opacity:0.85,
                         color:color,
                         }));*/
                        //属性
                        pathobj.attr({
                            'fill' : color,
                            'stroke-width':0,
                            'stroke':color,
                        });
                        this.PathSet.push(pathobj);
                        AngleToX+=val/100*2*Math.PI;
                    }

                    this.Label.setLabelData(LabelList);

                }
            };
        },


        /*
         非标准的元素
         Lable图(顺时针方向;角度-360;)
         params:位置X，位置Y，箭头Pos=['left','top','right','bottom']
         */
        Label : function(){
            if(this instanceof Raphael){
                tdxPaperDraw.Label.Paper=this;
            }
            if(!(this instanceof tdxPaperDraw.Label)){
                return new tdxPaperDraw.Label();
            }
            if(tdxPaperDraw.Label.Paper){
                this.Paper=tdxPaperDraw.Label.Paper;
            }
            this.PathSet=this.Paper.set();

            this.Draw=function(Px,Py,Pos,W,H,Angle1,Angle2,AngleH,LabelClr,LabelTextClr,LabelText){
                if(!LabelTextClr){LabelTextClr='#000000'}
                if (Pos=='top'){
                    var p1={
                        x : Px-AngleH/Math.tan(Angle1),
                        y : Py+AngleH
                    };
                    var p2={
                        x1 : p1.x+W/2,
                        y1 : p1.y,
                        x2 : p1.x+W/2,
                        y2 : p1.y+H,
                        x3 : p1.x-W/2,
                        y3 : p1.y+H,
                        x4 : p1.x-W/2,
                        y4 : p1.y,
                    };
                    var p3={
                        x : Px-AngleH/Math.tan(Angle2),
                        y : Py+AngleH
                    };
                    var centP={
                        x : (p2.x1-p2.x4)/2+p2.x4,
                        y : (p2.y2-p2.y1)/2+p2.y1,
                    };

                    var PathLine='M'+Px+','+Py+' ';
                    PathLine+='L'+p1.x+','+p1.y+' ';
                    PathLine+='L'+p2.x1+','+p2.y1+' ';
                    PathLine+='L'+p2.x2+','+p2.y2+' ';
                    PathLine+='L'+p2.x3+','+p2.y3+' ';
                    PathLine+='L'+p2.x4+','+p2.y4+' ';
                    PathLine+='L'+p3.x+','+p3.y+' ';
                    PathLine+='Z'+Px+','+Py;
                    var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
                    this.PathSet.push(pathobj);
                    this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
                }
                else if(Pos=='left'){
                    var p1={
                        x : Px+AngleH,
                        y : Py+AngleH/Math.tan(Angle1),
                    };
                    var p2={
                        x1 : p1.x,
                        y1 : p1.y-H/2,
                        x2 : p1.x+W,
                        y2 : p1.y-H/2,
                        x3 : p1.x+W,
                        y3 : p1.y+H/2,
                        x4 : p1.x,
                        y4 : p1.y+H/2,
                    };
                    var p3={
                        x : Px+AngleH,
                        y : Py+AngleH/Math.tan(Angle2),
                    };
                    var centP={
                        x : (p2.x2-p2.x1)/2+p2.x1,
                        y : (p2.y3-p2.y2)/2+p2.y2,
                    };

                    var PathLine='M'+Px+','+Py+' ';
                    PathLine+='L'+p1.x+','+p1.y+' ';
                    PathLine+='L'+p2.x1+','+p2.y1+' ';
                    PathLine+='L'+p2.x2+','+p2.y2+' ';
                    PathLine+='L'+p2.x3+','+p2.y3+' ';
                    PathLine+='L'+p2.x4+','+p2.y4+' ';
                    PathLine+='L'+p3.x+','+p3.y+' ';
                    PathLine+='Z'+Px+','+Py;
                    var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
                    this.PathSet.push(pathobj);
                    this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
                }
                else if(Pos=='right'){
                    var p1={
                        x : Px-AngleH,
                        y : Py+AngleH/Math.tan(Angle1),
                    };
                    var p2={
                        x1 : p1.x,
                        y1 : p1.y-H/2,
                        x2 : p1.x-W,
                        y2 : p1.y-H/2,
                        x3 : p1.x-W,
                        y3 : p1.y+H/2,
                        x4 : p1.x,
                        y4 : p1.y+H/2,
                    };
                    var p3={
                        x : Px-AngleH,
                        y : Py+AngleH/Math.tan(Angle2),
                    };
                    var centP={
                        x : (p2.x2-p2.x1)/2+p2.x1,
                        y : (p2.y2-p2.y3)/2+p2.y3,
                    };
                    var PathLine='M'+Px+','+Py+' ';
                    PathLine+='L'+p1.x+','+p1.y+' ';
                    PathLine+='L'+p2.x1+','+p2.y1+' ';
                    PathLine+='L'+p2.x2+','+p2.y2+' ';
                    PathLine+='L'+p2.x3+','+p2.y3+' ';
                    PathLine+='L'+p2.x4+','+p2.y4+' ';
                    PathLine+='L'+p3.x+','+p3.y+' ';
                    PathLine+='Z'+Px+','+Py;
                    var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
                    this.PathSet.push(pathobj);
                    this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
                }
                else if (Pos=='bottom'){
                    var p1={
                        x : Px-AngleH/Math.tan(Angle1),
                        y : Py-AngleH
                    };
                    var p2={
                        x1 : p1.x+W/2,
                        y1 : p1.y,
                        x2 : p1.x+W/2,
                        y2 : p1.y-H,
                        x3 : p1.x-W/2,
                        y3 : p1.y-H,
                        x4 : p1.x-W/2,
                        y4 : p1.y,
                    };
                    var p3={
                        x : Px-AngleH/Math.tan(Angle2),
                        y : Py-AngleH
                    };
                    var centP={
                        x : (p2.x3-p2.x2)/2+p2.x2,
                        y : (p2.y2-p2.y1)/2+p2.y1,
                    };
                    var PathLine='M'+Px+','+Py+' ';
                    PathLine+='L'+p1.x+','+p1.y+' ';
                    PathLine+='L'+p2.x1+','+p2.y1+' ';
                    PathLine+='L'+p2.x2+','+p2.y2+' ';
                    PathLine+='L'+p2.x3+','+p2.y3+' ';
                    PathLine+='L'+p2.x4+','+p2.y4+' ';
                    PathLine+='L'+p3.x+','+p3.y+' ';
                    PathLine+='Z'+Px+','+Py;
                    var pathobj=this.Paper.path(PathLine).attr({'stroke-width':1,'stroke':LabelClr});
                    this.PathSet.push(pathobj);
                    this.PathSet.push(this.Paper.text(centP.x, centP.y, LabelText).attr({'fill':LabelTextClr}));
                }
            };

            /*
             data: [{},{}]
             */
            this.setLabelData=function(data){
                var Px=0;
                var Py=0;
                var Pos='left';
                if(this.PathSet){this.PathSet.remove();}
                for(var i=0;i<data.length;i++){
                    var W=50; //宽
                    var H=26; //高
                    var Angle1=2*Math.PI*(60)/360;
                    var Angle2=2*Math.PI*(45)/360;
                    var AngleH=12;
                    var LabelText='';
                    var LabelClr='#000000';
                    var LabelTextClr='#000000';
                    Px=data[i].x;
                    Py=data[i].y;
                    Pos=data[i].pos;
                    if(data[i].hasOwnProperty('w')){W=data[i].w;}
                    if(data[i].hasOwnProperty('h')){H=data[i].h;}
                    if(data[i].hasOwnProperty('angle1')){Angle1=2*Math.PI*(data[i].angle1)/360;}
                    if(data[i].hasOwnProperty('angle2')){Angle2=2*Math.PI*(data[i].angle2)/360;}
                    if(data[i].hasOwnProperty('angleH')){AngleH=data[i].angleH;}
                    if(data[i].hasOwnProperty('labeltext')){LabelText=data[i].labeltext;}
                    if(data[i].hasOwnProperty('labelclr')){LabelClr=data[i].labelclr;}
                    if(data[i].hasOwnProperty('labeltextclr')){LabelTextClr=data[i].labeltextclr;}
                    this.Draw(Px,Py,Pos,W,H,Angle1,Angle2,AngleH,LabelClr,LabelTextClr,LabelText);
                }
            };
        },
        DayFundTDX : function(centerPx,centerPy,title,unit){
            if(this instanceof Raphael){
                tdxPaperDraw.DayFundTDX.Paper=this;
            }
            if(!(this instanceof tdxPaperDraw.DayFundTDX)){
                return new tdxPaperDraw.DayFundTDX(centerPx,centerPy,title,unit);
            }
            if(tdxPaperDraw.DayFundTDX.Paper){
                this.Paper=tdxPaperDraw.DayFundTDX.Paper;
            }
            this.PathSet=this.Paper.set();
            this.x=centerPx;
            this.y=centerPy;
            this.title=title;
            this.unit=unit;
            this.BarW=50;
            this.BarH=25;
            this.BarDis=20;

            this.BarH0=25;
            this.CenterBar={
                x : this.x,
                y : this.y
            };
            this.CenterBar0={
                x : this.x,
                y : this.y-this.BarH-this.BarH0/2-20
            };
            this.CenterTitle={
                x : this.x,
                y : this.CenterBar0.y-this.BarH0/2-40
            };

            /*
             data: [[],[]]
             数据，数据
             */
            this.setDayFundDataTDX=function(data){
                if(this.PathSet){this.PathSet.remove();}
                if(data && data.length==3){
                    var Left=0;
                    var Count=data[1].length;
                    if(!!Count){
                        var WBar=Count*this.BarW+Count*this.BarDis;
                        Left=Math.max(0,this.x-WBar/2);

                        //Title
                        this.PathSet.push(this.Paper.text(Left+WBar/2, this.CenterTitle.y, this.title).attr({
                            'fill':"#8A8D8A",
                            'font-size':14,
                            'font-weight':'bold',
                        }));
                        //bar0
                        if(data[0].length===2){
                            WBar=200;
                            Left=Math.max(0,this.x-WBar/2)
                            var CZ=data[0][0]-data[0][1];
                            CZ=CZ.toFixed(1);
                            var CZclr=colorSty.deephprice;
                            if(CZ<0){
                                CZclr=colorSty.deeplprice;
                            }

                            var zbRed=0.5;
                            var zbGreed=0.5;
                            if(data[0][0]+data[0][1]!=0){
                                zbRed=data[0][0]/(data[0][0]+data[0][1]);
                                zbGreed=data[0][1]/(data[0][0]+data[0][1]);
                            }
                            var TextRed='买('+(zbRed*100).toFixed(0)+'%)\n'+data[0][0];
                            var TextGreen='卖('+(100-(zbRed*100).toFixed(0))+'%)\n'+data[0][1];
                            var LenRed=zbRed*WBar;
                            var LenGreen=zbGreed*WBar;
                            var pathobjRed=this.Paper.rect(Left, this.CenterBar0.y-this.BarH0/2, LenRed, this.BarH0).attr({
                                'fill':colorSty.deephprice,
                                'stroke':'none',
                                'stroke-width':0
                            });
                            //毛边
                            /*this.PathSet.push(pathobjRed.glow({
                             width:2,
                             fill:false,
                             opacity:0.3,
                             color:g_ZJLX_CLR_4,
                             }));*/
                            this.PathSet.push(pathobjRed);

                            var pathobjGreen=this.Paper.rect(Left+LenRed, this.CenterBar0.y-this.BarH0/2, LenGreen, this.BarH0).attr({
                                'fill':colorSty.deeplprice,
                                'stroke':'none',
                                'stroke-width':0
                            });
                            //毛边
                            /*this.PathSet.push(pathobjGreen.glow({
                             width:2,
                             fill:false,
                             opacity:0.3,
                             color:g_ZJLX_CLR_1,
                             }));*/
                            this.PathSet.push(pathobjGreen);

                            this.PathSet.push( this.Paper.rect(this.CenterBar0.x-1, this.CenterBar0.y-this.BarH0/2, 2, this.BarH0).attr({
                               /* 'fill':g_TDX_Line_1,*/
                                'stroke-width':0,
                                'stroke':'none',
                            }));

                            this.PathSet.push(this.Paper.text(this.CenterBar0.x, this.CenterBar0.y-this.BarH0/2-15, CZ).attr({
                                'fill':CZclr,
                                'font-size':12,
                            }));


                            this.PathSet.push(this.Paper.text(Left-2, this.CenterBar0.y, TextRed).attr({
                                'fill':colorSty.deephprice,
                                'font-size':12,
                                'text-anchor': 'end',
                            }));

                            this.PathSet.push(this.Paper.text(Left+WBar+2, this.CenterBar0.y, TextGreen).attr({
                                'fill':colorSty.deeplprice,
                                'font-size':12,
                                'text-anchor': 'start',
                            }));
                        }

                        WBar=Count*this.BarW+Count*this.BarDis;
                        Left=Math.max(0,this.x-WBar/2);
                        //中线
                        this.PathSet.push( this.Paper.rect(Left, this.CenterBar.y, WBar, 2).attr({
                           /* 'fill':g_TDX_Line_1,*/
                            'stroke-width':0,
                            'stroke':'none',
                        }));
                        //bar
                        var Labs=data[1].map(function(elm){return Math.abs(elm)});
                        var ValMax=Math.max.apply(Math, Labs);
                        var ValMin=Math.min.apply(Math, Labs);
                        var valtopx=0.00;
                        var valBegin=ValMin;
                        if(ValMax===ValMin){valtopx=this.BarH/ValMax;}
                        else{
                            valtopx=this.BarH/(ValMax-ValMin);
                        }
                        Left+=this.BarDis/2;
                        for(var i=0;i<Count;i++){
                            var px=valtopx*(Math.abs(data[1][i])-valBegin);
                            if(px===0){px=1;}
                            if(!px){px=1;}
                            if(data[1][i]<0){
                                var pathobj=this.Paper.rect(Left, this.CenterBar.y+2, this.BarW, px).attr({
                                    'fill':colorSty.deeplprice,
                                    'stroke':colorSty.deeplprice,
                                    'stroke-width':0
                                });
                                this.PathSet.push(pathobj);
                                //毛边
                                /*this.PathSet.push(pathobj.glow({
                                 width:2,
                                 fill:false,
                                 opacity:0.3,
                                 color:g_ZJLX_CLR_1,
                                 }));*/
                                this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y-10, data[1][i]).attr({
                                    'fill':colorSty.deeplprice
                                }));
                            }
                            else{
                                var pathobj=this.Paper.rect(Left, this.CenterBar.y-px, this.BarW, px).attr({
                                    'fill':colorSty.deephprice,
                                    'stroke':colorSty.deephprice,
                                    'stroke-width':0
                                });
                                this.PathSet.push(pathobj);
                                //毛边
                                /*this.PathSet.push(pathobj.glow({
                                 width:2,
                                 fill:false,
                                 opacity:0.3,
                                 color:g_ZJLX_CLR_4,
                                 }));*/
                                this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+10, data[1][i]).attr({
                                    'fill':colorSty.deephprice
                                }));
                            }

                            this.PathSet.push(this.Paper.text(Left+this.BarW/2, this.CenterBar.y+this.BarH+15, data[2][i]).attr({
                                'fill':colorSty.titlecolor,
                                'font-size':12
                            }));
                            Left+=this.BarDis+this.BarW;
                        }

                    }
                }
            }
        }
        
    }; //tdxPaperDraw



})





