define(["jquery","iscroll","selfcnt"],function(require, exports, module) {
    var localopts = ParseParmStr(location.search.slice(1))
    function ParseParmStr(parmStr) {
        var parms = new Object();
        strs = parmStr.split("&");
        for (var i = 0; i < strs.length; i++) {
            parms[strs[i].split("=")[0]] = strs[i].split("=")[1];
        }
        return parms;
    }
    function formatDate(d) {
        if (!d || d.length == 0)
            return "--"
        if (d.length != 8)
            return d
        return d.slice(0, 4) + "-" + d.slice(4, 6) + "-" + d.slice(6, 8);
    }
    function etyStr(s){
        if (!s || s.length == 0 || s == 'null')
            return "--";
        return s;
    }
    function gettr(row,abody) {
        var str = "<tr>"
        if (row["sc"])
            str = '<tr gp="'+row["code"]+";"+row["name"]+";"+row["sc"] + '">'
        $.each(abody, function(i, tr) {
            if (tr["type"] == "zdf") {
                var cls = ''
                if (fFlt(row[tr["field"]]) > 0)
                    cls = 'hprice'
                else if (fFlt(row[tr["field"]]) < 0) {
                    cls = 'lprice'
                }
                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + " " + cls + '">' + (tr["fmtFn"] || etyStr)(row[tr["field"]], row) + '</td>')
            } else {
                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + '">' + (tr["fmtFn"] || etyStr)(row[tr["field"]], row) + '</td>')
            }
        })
        str += "</tr>"
        return str;
    }
    function fFlt(v){
        var f = parseFloat(v)
        return !isNaN(f) ? f : 0
    }
    var defaultChart = {
        chart:{
            height:210,
            spacingBottom:36
        },
        title:{
            text: ''
        },
        legend:{
            borderWidth:0,
            align:"right",
            verticalAlign: 'bottom',
            y: 20,
            floating: true
        },
        credits:{
            enabled:false
        },
        tooltip:{
            shadow:false,
            shared: true,
            enabled:true,
            formatter: function () {
                var s = '<span style="font-size: 12px;">'+this.x+'</span><br/>'
                $.each(this.points, function () {
                  s += '<span style="color:'+this.series.color+'">'+this.series.name+':'+fFlt(this.y).toFixed(2)+'</span><br/>'
                });
                return s
            },
            style:{
                fontSize: "12px",
                padding: "8px"
            }
        },
       
        plotOptions:{
            series:{
                events:{
                    mouseOver:function(){
                        return true
                    }
                }
            },
            spline:{
                lineWidth:2,
                marker:{
                    enabled:false,
                    radius:2,
                },
                events:{
                    legendItemClick:function(){
                        return false
                    }
                }
            }
        },
        yAxis:{
            startOnTick:true,
            title:{
                text:"",
                style:{
                    fontWeight:"normal"
                }
            },
            lineWidth:1,
            gridLineDashStyle:"Solid"
        },
        xAxis:{
            reversed:true,
            showFirstLabel:true,
            showLastLabel:true,
            title:
            {
                "text":"",
                "enabled":true
            },
            labels: {
                formatter:function(){
                  if(this.isFirst || this.isLast) { 
                    if(this.isFirst)
                        this.axis.labelAlign="right";
                    else
                        this.axis.labelAlign="left";
                    return this.value;
                  }
                },
               staggerLines: 1
            },
            tickLength:0,
            tickmarkPlacement:'on'
        }

    }
    var txSel = function(opts){
        var txDefault = {
            binit:true,
            fnCall:'',
            "field":"rq"
        };
        this.opts = $.extend(true, {}, txDefault, opts);
        function controlshow(oUl) {
            var oInput = oUl.prev()
            if (oInput.hasClass("tag_select_open")) {
                oInput.removeClass("tag_select_open")
                oInput.addClass("tag_select_close")
                oUl.css("display", "none")
                oInput.css("border-bottom-width", "1px")
            } else {
                oInput.removeClass("tag_select_close")
                oInput.addClass("tag_select_open")
                oUl.css("display", "")
                oInput.css("border-bottom-width", "0px")
            }
        }

        this._init = function(){
            if(this.opts.rows.length == 0)
                return
            var strli = ''
            var filed = this.opts["field"]
            $.each(this.opts.rows,function(i,row){

                if(i == 0)
                    strli += '<li id="selected" class="open_selected" value="'+row[filed]+'" style="cursor: pointer;">'+formatDate(row[filed])+'</li>'
                else
                    strli += '<li class="open" value="'+row[filed]+'" style="cursor: pointer;">'+formatDate(row[filed])+'</li>'
            })

            var sel =  '<div class="select_box" id="select_box">'+
                            '<div style="cursor: pointer;" class="tag_select_open" id="select_info_box" attr="'+this.opts.rows[0][filed]+'">'+formatDate(this.opts.rows[0][filed])+
                                
                            '</div>'+
                            '<ul style="position: absolute; z-index: 999;" class="tag_options" id="options_box">'+strli+
                                
                            '</ul>'+
                        '</div>'
          
            $(sel).appendTo($("#selectbox"))
            this._event()
        }
        this._event = function(){
            var fnCall = this.opts.fnCall;
            var oUl = $("#options_box")
            var oInput = oUl.prev();
            oUl.children('li').bind("click", function() {
                if ($(this).hasClass('open_selected')) {
                    controlshow(oUl);
                    return;
                }
                oUl.children('.open_selected').removeClass('open_selected')
                $(this).addClass('open_selected')
                oInput.text($(this).text())
                controlshow(oUl);
                if (typeof fnCall === 'function')
                    fnCall.call(this, $(this).text(), $(this).attr("value"))
            })
            $("#select_info_box").bind("click",function(){
                controlshow(oUl)
            })
            if(this.opts.binit){
                var havcall = false
                controlshow(oUl);
                oUl.children('li').each(function(){
                     if ($(this).hasClass("open_selected") && !havcall){
                        havcall = true
                        if (typeof fnCall === 'function')
                            fnCall.call(this, $(this).text(), $(this).attr("value"))
                     }
                })
            }
            $(document).bind("click.select", function(e) {
                var osel = $(e.target).closest("div.select_box");

                if(osel.length == 0){
                    $("#select_info_box").removeClass("tag_select_open")
                    $("#select_info_box").addClass("tag_select_close") 
                    $("#options_box").css("display","none")
                    $("#select_info_box").css("border-bottom-width","1px")
                }
            });
        }
        this._init();
    }
    var txScroll = function(options, otheropts) {

    //otheropts  id:滚动条ID,upCall:上滑动回调,downCall:下滑动回调    
        var txDefault = {
            probeType: 2,
            HWCompositing:false,
            scrollbars: "custom",
            mouseWheel: true,
            fadeScrollbars: true,
            bounce: true,
            interactiveScrollbars: true,
            shrinkScrollbars: 'scale',
            click: true,
            keyBindings: true,
            momentum: true
        };
        var txScOpts = $.extend(true, {}, txDefault, options);
        this.opts = $.extend(true, {}, {
            loadingStep: -1,
            hasUp: false, //判断是否继续上拉数据
            hasDown: false,
            isUp:true,
            page: 1 //下滑页数
        }, otheropts);
        this.IScroll = new IScroll('#' + this.opts["id"], txScOpts);
        document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false)
    }
    txScroll.prototype = {
        _init: function() {
            var __this__ = this;
            this._initDown();
            this._initUp();
            this.IScroll.on('scroll', function() {
                if (__this__.opts.loadingStep == 0 && !__this__.pullDownEl.attr('class').match('flip|loading') &&
                    !__this__.pullUpEl.attr('class').match('flip|loading')) {
                    if (this.y > 15 && __this__.opts.hasDown) {
                        //下拉刷新效果  
                        __this__.pullDownEl.attr('class', __this__.pullUpEl['class'])
                        __this__.pullDownEl.show();
                        __this__.IScroll.refresh();
                        __this__.pullDownEl.addClass('flip');
                        __this__.pullDownL.html('下拉刷新');
                        __this__.opts.loadingStep = 1;
                    } else if (this.y < (this.maxScrollY - 10)) {
                        //上拉刷新效果 
                         __this__.IScroll.refresh();
                        
                        __this__.pullUpEl.attr('class', __this__.pullUpEl['class'])
                        __this__.pullUpEl.show();
                        __this__.pullUpEl.addClass('flip');

                        if (!__this__.opts.hasUp)
                            __this__.pullUpL.html('已无数据');
                        else
                            __this__.pullUpL.html('加载更多');
                        __this__.opts.loadingStep = 1;
                    }
                }
            });
            //滚动完毕 
            this.IScroll.on('scrollEnd', function() {

                if (__this__.opts.loadingStep == 1) {
                    if (__this__.pullUpEl.attr('class').match('flip|loading')) {
                        __this__.pullUpEl.removeClass('flip').addClass('loading');
                        __this__.pullUpL.html('正在加载中');

                        __this__.opts.loadingStep = 2;
                        if (!__this__.opts.hasUp) {
                            __this__.pullUpL.html('已无数据');
                            __this__.upAction();
                        } else {
                            __this__.pullUpL.html('正在加载中');

                            if (typeof __this__.opts.upCall === 'function')
                                __this__.opts.upCall.call(__this__, __this__.opts.page);
                        }
                    } else if (__this__.pullDownEl.attr('class').match('flip|loading')) {
                        __this__.pullDownEl.removeClass('flip').addClass('loading');
                        __this__.opts.loadingStep = 2;
                        if (typeof __this__.opts.downCall === 'function')
                            __this__.opts.downCall.call(__this__, 1);

                    }
                }
            });
        },
        _setInit: function(opts) {
            for (var key in opts) {
                this.opts[key] = opts[key];
            }
        },
        _initDown: function() {
            this.pullDownEl = $('#pullDown');
            this.pullDownL = this.pullDownEl.find('.pullDownLabel');
            this.pullDownEl['class'] = this.pullDownEl.attr('class');
            this.pullDownEl.attr('class', '').hide();
        },
        _initUp: function() {
            this.pullUpEl = $('#pullUp');
            this.pullUpL = this.pullUpEl.find('.pullUpLabel');
            this.pullUpEl['class'] = this.pullUpEl.attr('class');
            this.pullUpEl.attr('class', '').hide();
        },
        downAction: function() { //下拉事件  
            this.pullDownEl.removeClass('loading');
            this.pullDownEl['class'] = this.pullDownEl.attr('class');
            this.pullDownEl.attr('class', '').hide();
            this.IScroll.refresh();
            this.opts.loadingStep = 0;
        },
        upAction: function() {
            this.pullUpEl.removeClass('loading');
            this.pullUpEl['class'] = this.pullUpEl.attr('class');
            this.pullUpEl.attr('class', '').hide();
            this.IScroll.refresh();
            this.opts.loadingStep = 0;
        }
    }

    return {
        locationparm:localopts,
        bgcolor:localopts["color"] || 'white',
        getcls:function(){
            var selfcnt = require("selfcnt")
            if(selfcnt.islocalreq == 0 || selfcnt.islocalreq ==1){
                return "gpcls"
            }
            return "gpcls"
        },
        bindGp:function(fn){
            var selfcnt = require("selfcnt")
            if(selfcnt.islocalreq == 0 || selfcnt.islocalreq == 1){
                fn()
            }
        },
        etyStr:function(s) {
            if (!s || s.length == 0 || s == 'null')
                return "--";
            return s;
        },
        fmtIt:function(v) {
            v = parseInt(v)
            return !isNaN(v) ? v : 0
        },
        fmtFlt:fFlt,
        fmtTwo:function(v) {
            var f = parseFloat(v)
            if (isNaN(f) || f == 0)
                return "--"
            return f.toFixed(2)
        },
        queryZf:function(close, now) {
            close = fFlt(close)
            now = fFlt(now)
            if (now == 0 || close == 0)
                return "--"
            return ((now - close) / Math.abs(close) * 100).toFixed(2)
        },
        "formatDate":formatDate,

        getcur:function() {
            date = new Date();
            var month = date.getMonth() + 1;
            month = (month < 10) ? ('0' + month) : month;
            var day = date.getDate();
            if (day < 10) day = "0" + day;
            return date.getFullYear() + "" + month + "" + day
        },
        "defaultChart":defaultChart,
        "txScroll":txScroll,
        "txSel":txSel,
        getChartCfg:function(chartclr,defau,yAxis){
            var b = []
            if( $.isArray( yAxis) ){
                $.each(yAxis,function(i,x){
                    b.push( $.extend(true,{},chartclr["yAxis"]||{},defau["yAxis"]||{},x) )
                })
                return b
            }
            return yAxis
        },
        getTableHead:function(ahead, sid) {
            sid = sid || "header"
            var shead = '<table class="webtable" style="width: 100%;table-layout: fixed;"><thead><tr>'
            $.each(ahead, function(i, head) {
                shead += ('<th class="' + head["class"] + '" width="' + (head["width"] || 80) + '">' + head["name"] + '</th>')

            })
            shead += '</tr></thead></table></div>'
            $(shead).appendTo("#" + sid)
        },
        getTableBody:function(rows, abody) {
            var sbody = ''
            $.each(rows, function(i, row) {
                sbody += gettr(row,abody)
            })
            return sbody
        },
        setTsInfo:function(bs,sid){
            bs = !!bs;
            sid = sid || "bodybox"
            var oTip = $("#txtipinfo")
            if(oTip.length){
                if(bs){
                    oTip.css("display","block")
                }else {
                    oTip.css("display","none")
                }
            } else {
                if(bs){
                    if($("#"+sid).parent('table').length == 1)
                        $('<div id="txtipinfo" class="tipinfo" style="display:block">暂无数据!!!</div>').insertBefore($("#"+sid).parent('table'))
                    else
                        $('<div id="txtipinfo" class="tipinfo" style="display:block">暂无数据!!!</div>').appendTo($("#"+sid))
                }
            }

        }

        
        
    }
})