define(["jquery", "selfcnt", "common"], function(require, exports, module) {
 
    var common = require("common")
    var selfcnt = require("selfcnt")
    var baseField = [{ "class": "txtcenter", "width": 80, "name": "证券名称" }, { "class": "txtcenter", "width": 120, "name": "事件类型" },
        { "class": "txtleft", "width": "100%", "name": "事件内容" }
    ]
    var basetbody = [{
        "class": "txtcenter",
        "fmtFn": function(v, row) {
            return '<p style="line-height: 18px;text-align:center">' + row["name"] + '</p>' + '<p style="line-height: 18px;text-align:center">' + row["code"] + '</p>'
        },
        "field": "T001"
    }, { "class": "txtleft", "field": "T008" }, { "class": "txtleft", "field": "T006" }]
    var aInfo = [
        { "name": "首发新股", "sid": "2", "strconst": "sfxg", "head": [{ "class": "txtleft", "width": 120, "name": "事件主体" },
            { "class": "txtleft", "width": "100%", "name": "事件内容" }
        ], body: [{
            "class": "txtleft",
            "fmtFn": function(v, row) {
                return '<p style="line-height: 18px;text-align:left">' + row["name"] + '</p>' + '<p style="line-height: 18px;text-align:left">' + row["T008"] + '</p>'
            },
            "field": "T001"
        }, { "class": "txtleft", "field": "T006" }] },
        { "name": "增发配股", "sid": "3", "strconst": "zfpg", "head":  [{ "class": "txtleft", "width": 120, "name": "事件主体" },
            { "class": "txtleft", "width": "100%", "name": "事件内容" }
        ], body: [{
            "class": "txtleft",
            "fmtFn": function(v, row) {
                return '<p style="line-height: 18px;text-align:left">' + row["name"] + '</p>' + '<p style="line-height: 18px;text-align:left">' + row["T008"] + '</p>'
            },
            "field": "T001"
        }, { "class": "txtleft", "field": "T006" }] },
        {
            "name": "限售解禁",
            "sid": "9",
            "strconst": "xsjj",
            "head": [
                { "class": "txtcenter", "width": 80, "name": "证券名称" },
                { "class": "txtcenter", "width": 75, "name": "解禁(万股)" },
                { "class": "txtcenter", "width": 75, "name": "占流通(%)" },
                { "class": "txtleft", "width": "100%", "name": "事件内容" }
            ],
            "body": [{
                    "class": "txtcenter",
                    "field": "T002",
                    "fmtFn": function(v, row) {
                        return '<p style="line-height: 18px;text-align:center">' + row["name"] + '</p>' + '<p style="line-height: 18px;text-align:center">' + row["code"] + '</p>'
                    }
                },
                { "class": "txtcenter", "field": "T004", "fmtFn": common.fmtTwo },
                { "class": "txtcenter", "field": "jj", "fmtFn": common.fmtTwo },
                { "class": "txtleft", "field": "T006" }
            ]
        },
        { "name": "分红转增", "sid": "4", "strconst": "fgzz", "head": baseField, body: basetbody },
        { "name": "特别处理", "sid": "5", "strconst": "tbcl", "head": baseField, body: basetbody },
        {
            "name": "停牌复牌",
            "sid": "10",
            "strconst": "tpfp",
            "head": baseField,
            body: [{
                "class": "txtcenter",
                "fmtFn": function(v, row) {
                    return '<p style="line-height: 18px;text-align:center">' + row["name"] + '</p>' + '<p style="line-height: 18px;text-align:center">' + row["code"] + '</p>'
                },
                "field": "T001"
            }, { "class": "txtcenter", "field": "T006" }, { "class": "txtleft", "field": "T007" }]
        },


        { "name": "股东大会", "sid": "6", "strconst": "gddh", "head": baseField, body: basetbody }

    ]
    function checknull(v) {
        if (!v || v == "null")
            return -1
        return v
    }
    var scroll = new common.txScroll({}, { "id": "selcontent","isUp":false,"click":true});
    scroll._init()
    
    selfcnt.send("phsj_gsrl", ['90', '0', '0'], function(data) {
        data = selfcnt.seftFmtResult(data)
        if (data.ErrorCode == 0 && data.tables.length != 0) {
            var row = data.tables[0].rows[0]
            new common.txSel({
                "rows":[{"rq":row["y1"]},{"rq":row["y2"]},{"rq":row["y3"]},{"rq":row["y4"]},{"rq":row["y5"]}],
                "fnCall":function(txt,val){
                    query(txt)
                }
            })
        }
    },{"reqtype":"cwserv"})

    function query(dt) {
        selfcnt.send("phsj_gsrl", ['0', '0', dt], function(data) {
            common.setTsInfo(false)
            $("#bodybox").empty()
            data = data.replace(/\\/ig, "/");
            data = selfcnt.seftFmtResult(data)
            var aText = []
            if (data.ErrorCode == 0) {
                if (data.tables.length == 7 && parseInt(data.tables[6].rows[0]["itype"]) == 0) {
                    var cacdata = []
                    var keyid = { "2": { "val": [], "cnt": 0 }, "3": { "val": [], "cnt": 0 }, "4": { "val": [], "cnt": 0 }, "5": { "val": [], "cnt": 0 }, "6": { "val": [], "cnt": 0 } }
                    $.each(data.tables[0].rows, function(i, tle) {
                        keyid[tle["sid"]]["val"].push(tle)
                    })
                    $.each(["2", "3", "4", "5", "6"], function(i, num) {
                        keyid[num]["cnt"] = data.tables[1].rows[i]
                    })
                    $.each(["2", "3", "9", "4", "5", "10", "6"], function(i, num) {
                        if (num == "9") {
                            cacdata.push(data.tables[2])
                            cacdata.push(data.tables[3])
                        } else if (num == "10") {
                            cacdata.push(data.tables[4])
                            cacdata.push(data.tables[5])
                        } else {
                            cacdata.push({ "rows": keyid[num]["val"] })
                            cacdata.push({ "rows": [keyid[num]["cnt"]] })
                        }
                    })
                    cacdata.push(data.tables[6])

                    creTable(cacdata, aInfo)
                    scroll.upAction()
                    
           
                     common.bindGp(function(){
                        $("#bodybox .webtable tbody tr").bind('click',function(){
                            selfcnt.goMulGpDetail($("#bodybox .webtable tbody tr"),$(this))
                        }) 
                    })
                    $("#bodybox .nav2 .more").bind("click",function(){
                        
                        selfcnt.goDetail('gsrlmx.html?sid='+$(this).attr("sid")+"&endtime="+data.tables[6].rows[0]["stime"],{"OpenName":$(this).attr("value")})
                        
                    })
                    $("#bodybox .nav2 .navimage,#bodybox .nav2 .navtitle").bind("click", function() {
                        var txt = '';
                        var __this = this;
                        if($(this).hasClass('navimage')){
                            txt = $(this).parent().next().children().text();
                        }else{
                            txt = $(this).text()
                            __this = $(this).parent().prev().children()
                        }

                        $.each(aInfo, function(j, sinfo) {
                            if (txt == sinfo["name"]) {
                                if ($(__this).hasClass("navshow")) {
                                    $(__this).removeClass("navshow")
                                    $(__this).addClass("navhide")
                                    $("#" + sinfo["strconst"]).css("display", "none")
                                } else {
                                    $(__this).removeClass("navhide")
                                    $(__this).addClass("navshow")
                                    $("#" + sinfo["strconst"]).css("display", "")
                                }
                                scroll.upAction()
                            }
                        })
                    })
                }
            }
        })
    }

    function creTable(rows, tableparam) {
        var atb = []
        var tot = 0
        $.each(tableparam, function(i, param) {
            if (rows[2 * i].rows.length != 0) {

                if (rows[2 * i].rows.length < parseInt(rows[2 * i + 1].rows[0]["cnt"])) //数据没显示全
                    atb.push('<div class="nav2" strconst=' + param["strconst"] + ' ><table style="width: 100%;table-layout: fixed"><thead><tr><td width="26;"><div class="navimage navshow"></div></td><td width="100%"><div class="navtitle">' + param["name"] + '</div></td><td width=40><div class="more" value="' + param["name"] + '" sid=' + param["sid"] + '></div></td></tr></thead></table></div>')
                else
                    atb.push('<div class="nav2" sid=' + param["sid"] + ' strconst=' + param["strconst"] + ' ><table style="width: 100%;table-layout: fixed"><thead><tr><td width="26;"><div class="navimage navshow"></div></td><td width="100%"><div class="navtitle">' + param["name"] + '</div></td></tr></thead></table></div>')
                atb.push('<table class="webtable" id="' + param["strconst"] + '">')
                atb.push(gethead(param["head"], param["showhead"]))

                atb.push(getbody(rows[2 * i].rows, param["body"]))
                atb.push('</table>')
            } else {
                tot++;
            }
        })
        if(tot == 7){
            common.setTsInfo(true)
            scroll.upAction()
            return
        }
        $(atb.join("")).appendTo($("#bodybox"))
        
        
    }

    function gethead(ahead) {
        var shead = '<thead ><tr>'

        $.each(ahead, function(i, head) {
            shead += ('<th class="' + head["class"] + '" width="' + (head["width"] || 80) + '">' + head["name"] + '</th>')
        })
        shead += '</tr></thead>'

        return shead
    }

    function getbody(rows, atr) {
        var str = "<tbody>"

        str+=common.getTableBody(rows, atr)
        str += "</tbody>"

        return str
    }

    function gettr(row, atr) {
        var str = "<tr>"
        $.each(atr, function(i, tr) {
            str += ('<td valign="' + (tr["valign"] || "top") + '" class="' + tr["class"] + '">' + (tr["fmtFn"] || common.etyStr)(row[tr["field"]], row) + '</td>')
        })
        str += "</tr>"
        return str;
    }

})
