define(["jquery", "selfcnt", "common"], function(require, exports, module) {
    var common = require("common")

    var selfcnt = require("selfcnt")
    
    function fmtD(d){
        if(!d||d.length == 0)
            return "--"
        if(d.length != 6)
            return d
        return d.slice(0, 4)+"-"+d.slice(4, 6);
    }
    var splineclr = ["#4a91d6","#ebaa01","#e0481e","#4a91d6"]
    var aInfo = [{"name":"GDP","strconst":"GDP",
                  "head":[ {"width":90,"name":"季度"},{"width":"60%","name":"总值(亿元)"},
                           {"width":"40%","name":"增长率(%)"}],
                   body:[{"field":"T001"},{"field":"T002"},{"field":"T003"}]},
                 {"name":"CPI","strconst":"CPI",
                 "head":[{"width":80,"name":"统计月度"},{"width":"34%","name":"全国:当月"},
                         {"width":"33%","name":"城市:当月"},{"width":"33%","name":"农村:当月"}],
                   body:[{"field":"T001","fmtFn":fmtD},{"field":"T002"},{"field":"T005"},{"field":"T008"}]},
                 {"name":"PPI","strconst":"PPI",
                 "head":[{"width":80,"name":"统计月度"},{"width":"25%","name":"当月"},
                         {"width":"50%","name":"同比增长(%)"},{"width":"25%","name":"累计"}],
                         body:[{"field":"T001","fmtFn":fmtD},{"field":"T002"},{"field":"T003"},{"field":"T004"}]},
                 {"name":"PMI","strconst":"PMI",
                 "head":[{"width":90,"name":"统计月度"},{"width":"60%","name":"制造业"},
                         {"width":"40%","name":"非制造业"}],
                         body:[{"field":"T001","fmtFn":fmtD},{"field":"T002"},{"field":"T004"}]},
                 {"name":"CCI","strconst":"CCI",
                 "head":[{"width":80,"name":"统计月度"},{"width":"34%","name":"消费者信心指数"},
                         {"width":"33%","name":"消费者预期指数"},{"width":"33%","name":"消费者满意指数"}],
                         body:[{"field":"T001","fmtFn":fmtD},{"field":"T002"},{"field":"T003"},{"field":"T004"}]},
                {"name":"货币供应","strconst":"HBGY",
                 "head":[{"width":80,"name":"统计月度"},{"width":"34%","name":"M2(万亿)"},
                         {"width":"33%","name":"M1(万亿)"},{"width":"33%","name":"M0(万亿)"}],
                         body:[{"field":"T001","fmtFn":fmtD},{"field":"T002"},{"field":"T004"},{"field":"T006"}]}
            ]
    selfcnt.send("phsj_hgfx", [], function(data){
        data = selfcnt.seftFmtResult(data)
        if(data.ErrorCode == 0 && data.tables.length == 6){
            var chdata= [
                {"chart":"GDP","field":["T002","T003"],"cate":[],"series":[
                      {"name":'总值(亿元)',data:[]},
                      {yAxis:1,"name":'增长率(%)',data:[]}]},
                {"chart":"CPI","field":["T002","T005","T008"],"cate":[],"series":[
                      {"name":'全国',data:[]},
                      {"name":'城市',data:[]},
                      {"name":'农村',data:[]}]},
                {"chart":"PPI","field":["T002","T004"],"cate":[],"series":[
                      {"name":'当月',data:[]},
                      {"name":'累计',data:[]}]},
                {"chart":"PMI","field":["T002","T004"],"cate":[],"series":[
                      {"name":'制造业',data:[]},
                      {"name":'非制造业',data:[]}]},
                {"chart":"CCI","field":["T002","T003","T004"],"cate":[],"series":[
                      {"name":'信心指数',data:[]},
                      {"name":'预期指数',data:[]},
                      {"name":'满意指数',data:[]}]},
                {"chart":"HBGY","field":["T003","T005","T007"],"cate":[],"series":[
                      {"name":'M2同比(%)',data:[]},
                      {"name":'M1同比(%)',data:[]},
                      {"name":'M0同比(%)',data:[]}]}
            ]
            var tot = 0
            $.each( data.tables,function(i,tables){
                $.each(tables.rows,function(j,row){
                    $.each(chdata[i]["field"],function(k,fld){
                        chdata[i]["series"][k]["data"].push(common.fmtFlt(row[fld]))
                    })
                    if( i == 0)
                        chdata[i]["cate"].push(row["T001"])
                    else
                        chdata[i]["cate"].push(fmtD(row["T001"]))
                })
                if(tables.rows.length == 0)
                  tot++;
            })
            if(tot == 6){
              common.setTsInfo(true,"box")
              return
            }
            var aHtml = []
            $.each(aInfo,function(i,info){
                aHtml.push(creTable(data.tables[i].rows.slice(0,3),info))
            })
           
        		$(aHtml.join("")).appendTo($(".box"))
                $(".navimage,.navtitle").bind("click", function() {
                    var txt = '';
                    var __this = this;
                    if($(this).hasClass('navimage')){
                        txt = $(this).parent().next().children().text();
                    }else{
                        txt = $(this).text()
                        __this = $(this).parent().prev().children()
                    }
                    $.each(aInfo,function(j,sinfo){
                        if(txt == sinfo["name"]){
                            if($(__this).hasClass("navshow")){
                                $(__this).removeClass("navshow")
                                $(__this).addClass("navhide")
                                $("#"+sinfo["strconst"]).css("display","none")
                            } else {
                                $(__this).removeClass("navhide")
                                $(__this).addClass("navshow")
                                $("#"+sinfo["strconst"]).css("display","")
                            }
                        }
                    })
                })


            require.async(["highchart", "chartcolor"], function() {
                var chartcolor = require("chartcolor")
                $.each(chdata,function(i,vl){
                    if(vl["cate"].length != 0){
                      var yAs = {labels:{"format":"{value}"}}
                      if(vl["chart"] == "GDP")
                           yAs = common.getChartCfg(chartcolor[common.bgcolor],common.defaultChart,[{labels:{
                             "format":"{value}"}},{"opposite":true}])
                          var odChar = $.extend(true, {}, chartcolor[common.bgcolor] || {}, common.defaultChart, {
                          chart: {
                              type: 'spline',
                          },
                          yAxis:yAs,
                          xAxis: {
                              categories: vl["cate"]
                          },
                          series: vl["series"]
                      })
                 
                      $("#ch"+vl["chart"]).highcharts(odChar)
                    }
                   
                })
             })
        }    
	},{"reqtype":"cwserv"})
 
	function creTable(alhg,param){
        var atb = []
        if(alhg && alhg.length  != 0){
            atb.push('<div class="nav2" strconst='+param["strconst"]+
            		 ' ><table style="width: 100%;table-layout: fixed"><thead><tr><td width="26;">'+
            		 '<div class="navimage navshow"></div></td><td width="100%">'+
            		 '<div class="navtitle">'+param["name"]+'</div></td></tr></thead></table></div>')
            atb.push('<div id="'+param["strconst"]+'">')
            atb.push('<div id="ch'+param["strconst"]+'"></div>')
            atb.push('<table class="webtable">')

            atb.push(gethead(param["head"]))
            atb.push(getbody(alhg,param["body"],param["strconst"]))
            atb.push('</table>')
            atb.push("</div>")
        }
        return atb.join("")
  
    }
    function gethead(ahead){
        var shead='<thead ><tr>'
        $.each(ahead,function(i,head){
            shead += ( '<th class="'+(head["class"] || "txtcenter")+'" width="'+(head["width"]||80)+'">'+head["name"]+'</th>' )
        })
        shead += '</tr></thead>'
        
        return shead
    }
    function getbody(rows,atr,sid){
        var str = "<tbody>"
        $.each(rows,function(i,row){
            str += gettr(row,atr,sid)
        })
        str += "</tbody>"
       
        return str
    }
    function gettr(row,atr,sid){
        var str = "<tr>"
        $.each(atr,function(i,tr){
            if(sid == 'PPI'){
                if(common.fmtFlt(row[tr["field"]])> 0 && tr["field"]=="T003")
                    str += ('<td  class="hprice '+(tr["class"]|| "txtcenter")+'">'+common.fmtTwo(row[tr["field"]])+'</td>')
                else if (common.fmtFlt(row[tr["field"]]) < 0 && tr["field"]=="T003")
                    str += ('<td  class="lprice '+(tr["class"]|| "txtcenter")+'">'+common.fmtTwo(row[tr["field"]])+'</td>')
                else
                    str += ( '<td class="'+(tr["class"]|| "txtcenter")+'">'+(tr["fmtFn"]||common.etyStr)(row[tr["field"]],row)+'</td>')
            }
			else
            	str += ( '<td class="'+(tr["class"]|| "txtcenter")+'">'+(tr["fmtFn"]||common.etyStr)(row[tr["field"]],row)+'</td>')
        })
        str += "</tr>"
        return str;
    }

})
