define(["jquery", "selfcnt", "common"], function(require, exports, module) {
    var common = require("common")
    console.log(common)
    var selfcnt = require("selfcnt")
    selfcnt.send("phsj_sczj", ["0"], etf,{"reqtype":"cwserv"})
    selfcnt.send("phsj_sczj", ["1"], rzrq,{"reqtype":"cwserv"})
    selfcnt.send("phsj_sczj", ["2"], jyjs,{"reqtype":"cwserv"})

    function etf(data) {
        sczj(data, "tbetf", ["rq", "T004", "T007"], "ETF规模合计(亿)", [{ "width": "94", "name": "日期", "align": "left" }, { "width": "50%", "name": "ETF规模合计", "align": "right" }, { "width": "50%", "name": "ETF申赎净量", "align": "right" }])
    }

    function rzrq(data) {
        sczj(data, "tbrzrq", ["rq", "T003", "T006", "tol"], "融资融券差额(亿)", [{ "width": "85", "name": "日期", "align": "left" }, { "width": "34%", "name": "融资余额", "align": "right" }, { "width": "32%", "name": "融券余额", "align": "right" }, { "width": "34%", "name": "差值", "align": "right" }])
    }

    function jyjs(data) {
        sczj(data, "tbjyjs", ["rq", "T003", "T004", "T007"], "交易结算资金(亿)", [{ "width": "85", "name": "截止日期", "align": "left" }, { "width": "34%", "name": "期末余额", "align": "right" }, { "width": "32%", "name": "日均余额", "align": "right" }, { "width": "34%", "name": "银证转账变动净额", "align": "right" }])
    }

    function sczj(data, sid, field, sername, ahead) {
        data = selfcnt.seftFmtResult(data)
        if (data.ErrorCode == 0) {
            var atb = []
            if(data.tables[1].rows.length == 0){
                common.setTsInfo(true,"ch" + sid)
                return
            }
            atb.push(gethead(ahead))
            atb.push(getTbody(data.tables[1].rows, field))
            $("#" + sid).css("display", "")
            $(atb.join("")).appendTo($("#" + sid))
            require.async(["highchart", "chartcolor"], function() {
                var chartcolor = require("chartcolor")
               
                var dch = { "cate": [], "yxas": [] }
                $.each(data.tables[0].rows, function(i, trow) {
                    dch["cate"].push(common.formatDate(trow["rq"]))
                    dch["yxas"].push(common.fmtFlt(trow["cd"]))
                })
                var odChar = $.extend(true, {}, chartcolor[common.bgcolor] || {}, common.defaultChart, {
                    chart: {
                        type: 'spline',
                    },
                    yAxis: {

                        labels: {
                            "format": "{value}亿"

                        }

                    },
                    xAxis: {

                        categories: dch["cate"]
                    },
                    series: [{ type: 'spline', "name": sername, data: dch["yxas"] }],
                })
                $("#ch" + sid).highcharts(odChar)
            })
        }
    }

    function getTbody(rows, field) {
        var tb = ["<tbody>"]
        $.each(rows, function(i, row) {
            tb.push(getTr(row, field))
        })
        tb.push("</tbody>")
        return tb.join("")
    }

    function getTr(row, afield) {
        var tr = ["<tr>"]
        $.each(afield, function(i, fd) {
            if (fd == "rq")
                tr.push('<td valign="top" class="txtleft">' + row[fd] /*formatDate(row[fd])*/ + '</td>')
            else
                tr.push('<td valign="top" class="txtright">' + common.fmtTwo(row[fd]) + '</td>')
        })
        tr.push('</tr>')
        return tr.join("")
    }

    function gethead(ahead) {
        var ahd = ['<thead><tr>']
        $.each(ahead, function(i, hd) {
            ahd.push('<th width="' + hd["width"] + '" style="text-align:' + hd["align"] + '">' + hd["name"] + '</th>')
        })
        ahd.push('</tr></thead>')
        return ahd.join('')
    }
})
