define(["jquery", "selfcnt", "common"], function(require, exports, module) {
    var common = require("common")

    var selfcnt = require("selfcnt")
    selfcnt.send("phsj_xsjj", ["0"], etf,{})
    function etf(data) {
        sczj(data, "tbetf", ["rq", "T004", "T007"], "ETF规模合计(亿)", [{ "width": "94", "name": "日期", "align": "left" }, { "width": "50%", "name": "ETF规模合计", "align": "right" }, { "width": "50%", "name": "ETF申赎净量", "align": "right" }])
    }
    function sczj(data, sid, field, sername, ahead) {
        data = selfcnt.seftFmtResult(data)
        if (data.ErrorCode == 0) {
            var atb = []
            if(data.tables[0].rows.length == 0){
                common.setTsInfo(true,"ch" + sid)
                return
            }
            require.async(["highchart", "chartcolor"], function() {
                var chartcolor = require("chartcolor")
                var dch = { "cate": [], "yxas": [] }
                $.each(data.tables[0].rows, function(i, trow) {
                    dch["cate"].push(trow["rq"])
                    dch["yxas"].push({
                        "y": common.fmtFlt(trow["sz"]),
                        "dataLabels": {
                            enabled: i%2==0, verticalAlign: "top", formatter: function () {
                                return this.y + "亿"
                            }
                        }
                    })
                })
                var odChar = $.extend(true, {}, chartcolor[common.bgcolor] || {}, common.defaultChart, {
                    chart: {
                        type: 'line',
                    },
                    yAxis: {
                        labels: {
                            "format": "{value}亿"
                        }
                    },
                    xAxis: {

                        categories: dch["cate"],
                        labels: {
                            formatter:function(){

                                return this.value;
                            },
                            staggerLines: 1
                        },
                    },
                    series: [{ showInLegend:true,type: 'line', "name": sername,data: dch["yxas"] }],
                })

                $("#ch" + sid).highcharts(odChar)
            })
        }
    }

    function getTbody(rows, field) {
        var tb = ["<tbody>"]
        $.each(rows, function(i, row) {
            tb.push(getTr(row, field))
        })
        tb.push("</tbody>")
        return tb.join("")
    }

    function getTr(row, afield) {
        var tr = ["<tr>"]
        $.each(afield, function(i, fd) {
            if (fd == "rq")
                tr.push('<td valign="top" class="txtleft">' + row[fd] /*formatDate(row[fd])*/ + '</td>')
            else
                tr.push('<td valign="top" class="txtright">' + common.fmtTwo(row[fd]) + '</td>')
        })
        tr.push('</tr>')
        return tr.join("")
    }

    function gethead(ahead) {
        var ahd = ['<thead><tr>']
        $.each(ahead, function(i, hd) {
            ahd.push('<th width="' + hd["width"] + '" style="text-align:' + hd["align"] + '">' + hd["name"] + '</th>')
        })
        ahd.push('</tr></thead>')
        return ahd.join('')
    }
})
