﻿var _mob_system = CheckMobSys();
/***********************************************************************************************************************/
//检测手机系统
function CheckMobSys() {
  var platform = typeof (navigator.platform) == "undefined" ? "" : navigator.platform.toLowerCase();
  if (platform == "ipod" || platform == "iphone" || platform == "ipad" || platform == "iphone simulator" || platform == "ipad simulator") {
    return "IOS";
  }
  var userAgent = typeof (navigator.userAgent) == "undefined" ? "" : navigator.userAgent;
  if (userAgent.indexOf("Android") > -1) {
    return "Android";
  }
  return "Other";
}


/*
 * 返回URL的一个随机串
 */
function getRnd() {
  return parseInt(Math.random() * 10000) + "=" + parseInt(Math.random() * 10000);
}


/*
 * 获取 function 名称
 */
function Fun_Name(funname) {
  var tmp = funname.toString();
  var re = /function\s*(\w*)/i;
  var matches = re.exec(tmp);
  //alert("name:" +matches[1]);
  return matches[1];
}


var _callFuncDict = {}; // 回调函数字典
//交易应答
//formid：框架ID
//funcid：功能号ID
//flagtype：0：成功 ，1：失败
//_data：返回的json 数据
//callbackname : 回调函数 (tdxPageID,strFuncName,strErrNo,strResultCont)
//统一不同方式的回调函数
function getCallBack(formid, strFuncName, strErrNo, strResultCont) {

  if (strErrNo != 0) {
    strResultCont = JSON.stringify([[strErrNo, strResultCont, '', '', ''], [], []]);
    if (strErrNo == '-10000') {
      __tdxLoginBox();
      strResultCont = JSON.stringify([[0, strResultCont, 0, "", ''], [], []]);
    }
  }

  if (_callFuncDict.hasOwnProperty(formid)) {
    var callback = _callFuncDict[formid];
    _callFuncDict[formid] = undefined;
    delete _callFuncDict[formid];
    callback(strResultCont);
  }
}


/***********************************************************************************************************************/
//IOS函数桥接
var IOS_Bridge = {
  callbacksCount: 1,
  callbacks: {},
  resultForCallback: function resultForCallback(callbackId, resultArray) {
    try {
      var callback = IOS_Bridge.callbacks[callbackId];
      if (!callback) {
        return;
      }
      callback.apply(null, resultArray);
    } catch (e) {
      alert(e);
    }
  },

  //functionName: 调用函数名称
  //args:json 格式参数
  //callback 回调函数，可有可无
  //mob_funcname 类似PUL 或 CCS
  call: function call(strCallWay, args, strFuncName, frameID, callback) {
    var hasCallback = callback && typeof callback == "function";
    var callbackId = hasCallback ? IOS_Bridge.callbacksCount++ : 0;
    if (hasCallback) {
      IOS_Bridge.callbacks[callbackId] = callback;
    }
    var iframe = document.createElement("IFRAME");
    iframe.setAttribute("src", "tdx-frame:" + strCallWay + ";;" + frameID + ";;" + strFuncName + ";;" + args + ";;" + callback);

    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
  }
};


function sendRequest(strCallWay, strFuncName, strFuncData, objOptParam, funcCallBack) {

  var callback_name = Fun_Name(funcCallBack);
  var formid = getRnd() + '_$$$$$' + '_' + callback_name;
  _callFuncDict[formid] = funcCallBack;


  if (_mob_system == "IOS") {
    //var session = objOptParam.sessionType;
    //var sessionId = objOptParam.SessionID;
    var cparams = strFuncData;
    if (strCallWay === "CallTQL") {
      var tmp = {
        "SessionType": objOptParam.sessionType,
        "TQLParam": strFuncData
      };
      if (objOptParam.sessionType === 'JYSession') {
        tmp.SessionID = objOptParam.SessionID;
        tmp.JYParam = strFuncData;
      }
      cparams = JSON.stringify(tmp);
    } else {
      cparams = JSON.stringify(strFuncData);
    }
    IOS_Bridge.call(strCallWay, cparams, strFuncName, formid, 'getCallBack');

  }
  else {

    if (typeof strFuncData != 'string') {
      strFuncData = JSON.stringify(strFuncData);
    }
    console.log(strFuncName + " " + strFuncData);
    if (strCallWay === "CallTQL") {
      //var session = objOptParam;
      var temp = {
        "SendSession": objOptParam.sessionType,
        "TQLParam": strFuncData
      };
      if (objOptParam.sessionType === 'JYSession') {
        temp.SessionID = objOptParam.SessionID;
      }
      var SendSession = JSON.stringify(temp);
      window.tdx_java.TdxSendData(strFuncName, strFuncData, SendSession, 'getCallBack', formid);
    } else {
      window.tdx_java.TdxWebCall(strFuncName, strFuncData, 'getCallBack', formid);
    }

  }
}


//交易请求发送:
var JYCallTql = function () {
  this.SessionID = '';
  this.objOptParam = {'sessionType': 'JYSession', 'SessionID': this.SessionID || ""};
  this.callWay = 'CallTQL';

}

JYCallTql.prototype.send = function (entry, stream, callback) {

  sendRequest(this.callWay, entry, stream, this.objOptParam, callback)

}

//行情请求发送:
var HQCallTql = function () {
  this.objOptParam = {'sessionType': 'HQSession'};
  this.callWay = 'CallTQL';
}

HQCallTql.prototype.send = function (entry, stream, callback) {

  sendRequest(this.callWay, entry, stream, this.objOptParam, callback);

}


//服务FWSession请求发送:
var FWCallTql = function () {

  this.objOptParam = {'sessionType': 'FWSession', 'SessionID': this.SessionID || ""};
  this.callWay = 'CallTQL';
}

FWCallTql.prototype.send = function (entry, stream, callback) {

  sendRequest(this.callWay, entry, stream, this.objOptParam, callback)

}


//链接跳转调用/调用硬代码功能/枚举交易账号/唤起登陆界面:
var WEBCallTql = function () {
  this.callWay = 'WebCall';
  this.objOptParam = {'sessionType': '', 'SessionID': this.SessionID || ""};

}

WEBCallTql.prototype.send = function (entry, stream, callback) {

  sendRequest(this.callWay, entry, stream, this.objOptParam, callback)

}


// 唤起登录框
function __tdxLoginBox(param, callback) {
  callback = callback || param;
  var webCallTql = new WEBCallTql();
  var par = param;
  if (typeof param == 'function' || param == undefined) {
    par = {'HostType': '0'};
  }
  webCallTql.send('tdxLoginTrade', par, function (data) {
    callback(data);
  });
}

//获取账户列表
function __tdxgetAccList(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxEnumTradeAcc', {}, function (data) {
    callback(data);
  });
}

//触发返回按钮
function __returnToSuperior() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('ReturnToSuperior', {}, function (data) {
    //callback(data);
  });
}

// 判断是否普通账户登录
function __isLoginNormal(callback) {
  __tdxgetAccList(function(data) {
    try {
      var curUser;
      if(typeof data == "string") { // ios
        data = JSON.parse(data);
        curUser = data[0];
      } else { // android
        curUser = JSON.parse(data[0] || {});
      }
    } catch(e) {}

    // 未登录或者当前账号不是普通账号
    if(data.length == 0 || curUser["HostType"] != 0) {
      callback(0);
    } else {
      callback(1);
    }
  })
}

//定义 IXContent
var IXContent = function () {
  this.ret = "";
  this.retcnt = [];
  this.retlength = 0;
};
IXContent.prototype = {
  Set: function (k, v) {
    if ($.trim(k) == "") {
      alert("当前键对获取为NULL，不予录入，请输入键值对");
      return;
    }
    else {
      if (v == undefined) {
        v = "";
      }
      if (typeof (v) == 'string') {
        this.retcnt.push("{\"" + k + "\":" + "\"" + v + "\"}");
      }
      else if (typeof (v) == 'number') {
        this.retcnt.push("{\"" + k + "\":" + v + "}");
      }
      else {
        var _cnts = [];
        $.each(v, function (n, m) {
          if (typeof (m) == 'string') {
            _cnts.push("\"" + k + "\":" + "\"" + v + "\"");
          } else {
            _cnts.push("\"" + k + "\":" + v);
          }
        });
        this.retcnt.push("\"" + k + "\":{" + this.retcnt.join(',') + "}");
      }
      this.retlength++;
    }
  },

  Length: function () {
    return this.retlength;
  },

  Value: function () {
    return "[" + this.retcnt.join(',') + "]";
  }
};


var FormatResult = function (data) {

  try {

    data = data.replace(/\r\n/ig, "<br>");
    data = data.replace(/\s/g, "");
    data = JSON.parse(data);

    var rt = {};
    rt.ErrorCode = data[0][0];
    rt.ErrorInfo = data[0][1];
    rt.Num = data[0][2];
    rt.Cookies = data[0][3];
    rt.POS = data[0][4];

    if (rt.ErrorCode != 0) {
      return rt;
    }

    // 数据部分
    rt.rows = [];
    var dataLen = data.length;
    var fieldLen = data[1].length;
    for (var i = 3; i < dataLen; i++) {
      var row = {};
      for (var j = 0; j < fieldLen; j++) {
        row[data[1][j]] = data[i][j];
      }
      rt.rows.push(row);
    }

    return rt;

  } catch (e) {

    alert(e);
    return {};
  }
}

// 这里实例化请求对象
var __webCallTql = new WEBCallTql();
// var __jyCallTql = new JYCallTql();
// var __hqCallTql = new HQCallTql();
var __fwCallTql = new FWCallTql();

!function () {

  // 这里实现公共函数,都绑定到 tdx 下
  var TDX = function () {
  };

  TDX.prototype.getUrlParam = function (url) {

    var param = {};
    var index = url.indexOf("?");
    if (index == -1) {
      return param;
    }

    url = url.substr(index + 1);
    var queryArr = url.split("&");
    queryArr.forEach(function (p) {
      var a = p.split("=");
      param[a[0]] = a[1];
    })

    return param;
  }

  window["tdx"] = new TDX();

}()