define(["jquery", "selfcnt", "common"], function (require, exports, module) {
    var common = require("common")
    var selfcnt = require("selfcnt")
    selfcnt.send("phsj_xg_ggxgrl", [common.locationparm["stock"]], function (data) {
        data = selfcnt.seftFmtResult(data)
        if (data.ErrorCode == 0) {
            if (!data.tables || data.tables.length == 0 || data.tables[0].rows.length == 0) {
                $('<div class="tipinfo" style="display:block">暂无新股详情数据!!!</div>').appendTo($("#box"))
                return
            }
            setHtml(data.tables[0].rows[0],
                [
                    {
                        "name": "申购进程",
                        "tbodys": [
                            [["股票简称", "股票代码","上市板块"], [{"field": "T002"}, {"field": "T001"}, {"field": "T005"}]],
                            [["申购开始日", "申购截止日","结果公布日", "一手中签率"], [{"field": "T012"}, {"field": "T013"},{"field": "T017"},{"field": "T019",fmtFn:function(v){
                                return common.fmtTwo(v)+"%"
                            }}]],
                            [["上市日期", "过户处"], [{"field": "T016"}, {"field": "T009"}]]
                        ]
                    },
                    {
                        "name": "发行状况",
                        "tbodys": [
                            [["招股价", "上市价","买卖单位","入场费用"], [{"field": "T025",fmtFn:function(v,recond){
                                return common.fmtTwo(v)+"--"+common.fmtTwo(recond["T024"])+'<span class="xglab">港元</span>'
                            }}, {"field": "T014",fmtFn:fmtY},{"field": "T008",fmtFn:function(v){
                                return common.fmtIt(v)+'<span class="xglab">股</span>'
                            }},{"field": "T015",fmtFn:fmtY}]],
                            [["公开发行数量","配售股份数量", "发售股份总量","募集资金总额"], [{"field": "T022",fmtFn:fmtW}, {"field": "T023",fmtFn:fmtW}, {"field": "T021",fmtFn:fmtW}, {"field": "T014",fmtFn:function(v,recond){
                                return common.fmtTwo(common.fmtFlt(v)*common.fmtFlt(recond["T021"])/100000000)+'<span class="xglab">亿元(港币)</span>'
                            }}]],
                            [["保荐人", "经办人"], [{"field": "T027"}, {"field": "T028"}]]
                        ]
                    },
                    {
                        "name": "公司简介",
                        "tbodys": [
                            [["公司名称","所属行业","公司网站","公司总部","主营业务"], [{"field": "ComName"}, {"field": "Sector1"},{"field": "WebSite",fmtFn:function(v){
                                if (!v || v.length == 0 || v == 'null')
                                    return "--";
                                return '<a href="javascript:void(0)" class="xglink" >'+v+'</a>'
                            }},{"field": "HOffice"},{"field": "Activities"}]]

                        ]
                    }
                ]
            )
            $(".webtable tbody tr td .xglink").bind("click",function(e) {
                selfcnt.goHref({"url":$(this).text()})
            })
            function fmtW(v) {
                return common.fmtTwo(common.fmtFlt(v)/100000000)+'<span class="xglab">亿股</span>'
            }
            function fmtY(v) {
                return common.fmtTwo(v)+'<span class="xglab">港元</span>'
            }
        } else {
            $('<div class="tipinfo" style="display:block">暂无新股详情数据!!!</div>').appendTo($("#box"))
            return
        }
    })

    function setHtml(rowdata, tables) {
        var strHtml = ""
        $.each(tables, function (k, tbe) {
            strHtml += '<div class="nav2 xgnav"><table style="width: 100%;table-layout: fixed"><thead><tr><td width="6;">&nbsp;</td><td width="100%"><div class="navtitle">' + tbe.name + '</div></td></tr></thead></table></div>'
            strHtml += '<table class="webtable" style="width: 100%;table-layout: fixed;"><tbody>'
            $.each(tbe.tbodys, function (i, tdy) {
                strHtml += '<tr><td valign="top" width="120" class="xglab">'
                $.each(tdy[0], function (n, tds) {
                    strHtml += '<p style="line-height: 22px;text-align:left">' + tds + '</p>'
                })
                strHtml += '</td><td width="100%">'
                $.each(tdy[1], function (n, tds) {
                    strHtml += '<p style="line-height: 22px;text-align:left">' + (tds["fmtFn"] || common.etyStr)(rowdata[tds["field"]],rowdata) + '</p>'
                })
                strHtml += '</td></tr>'
            })
            strHtml += '</tbody></table>'
        })
        $(strHtml).appendTo($("#box"))
    }


})
