define(["jquery", "selfcnt", "common"], function (require, exports, module) {
    var common = require("common")
    var selfcnt = require("selfcnt")
    selfcnt.send("phsj_xg_hsxgrl", [common.locationparm["stock"]], function (data) {
        data = selfcnt.seftFmtResult(data)
        if (data.ErrorCode == 0) {
            if (!data.tables || data.tables.length == 0 || data.tables[0].rows.length == 0) {
                $('<div class="tipinfo" style="display:block">暂无新股详情数据!!!</div>').appendTo($("#box"))
                return
            }
            setHtml(data.tables[0].rows[0],
                [
                    {
                        "name": "申购进程",
                        "tbodys": [
                            [["股票简称", "股票代码"], [{"field": "T042"}, {"field": "T043"}]],
                            [["申购代码", "申购日期"], [{"field": "T040"}, {"field": "T035"}]],
                            [["中签号公布日", "中签率"], [{"field": "T109"}, {
                                "field": "T051", fmtFn: function (v) {
                                    return common.fmtTwo(v) + "%"
                                }
                            }]],
                            [["上市日期"], [{"field": "T008"}]]
                        ]
                    },
                    {
                        "name": "发行状况",
                        "tbodys": [
                            [["发行价格", "发行市盈率", "每股净资产"], [{
                                "field": "T010", fmtFn: function (v) {
                                    return common.fmtTwo(v) + '<span class="xglab">元</span>'
                                }
                            }, {"field": "T014", fmtFn: common.fmtTwo}, {
                                "field": "T015", fmtFn: function (v) {
                                    return common.fmtTwo(v) + '<span class="xglab">元</span>'
                                }
                            }]],
                            [["网上发行量","网申上限", "网申下限", "有效申购"], [{"field": "T045", fmtFn: fmtW},
                               
                                {
                                "field": "T044",
                                fmtFn: fmtW
                            }, {"field": "T091", fmtFn: fmtW}, {
                                "field": "T055", fmtFn: function (v) {
                                    return common.fmtTwo(common.fmtFlt(v) * 1000) + '<span class="xglab">万股</span>'
                                }
                            }]],
                            [["主承销商","发行总量", "募资总额"], [{"field": "zcxs"},{"field": "T003", fmtFn: fmtW}, {
                                "field": "T027", fmtFn: function (v) {
                                    return common.fmtTwo(v) + '<span class="xglab">万元</span>'
                                }
                            }]]
                        ]
                    },
                    {
                        "name": "公司简介",
                        "tbodys": [
                            [["公司名称", "所属地区", "所属行业", "公司网站", "主营业务"], [{"field": "T033"}, {"field": "cT040"}, {"field": "cT045"}, {
                                "field": "T012", fmtFn: function (v) {
                                    if (!v || v.length == 0 || v == 'null')
                                        return "--";
                                    return '<a href="javascript:void(0)" class="xglink" >' + v + '</a>'
                                }
                            }, {"field": "T016"}]]

                        ]
                    }
                ]
            )
            $(".webtable tbody tr td .xglink").bind("click", function (e) {
                selfcnt.goHref({"url": $(this).text()})
            })
            function fmtW(v) {
                return common.fmtTwo(v) + '<span class="xglab">万股</span>'
            }
        } else {
            $('<div class="tipinfo" style="display:block">暂无新股详情数据!!!</div>').appendTo($("#box"))
            return
        }
    })

    function setHtml(rowdata, tables) {
        var strHtml = ""
        $.each(tables, function (k, tbe) {
            strHtml += '<div class="nav2 xgnav"><table style="width: 100%;table-layout: fixed"><thead><tr><td width="6;">&nbsp;</td><td width="100%"><div class="navtitle">' + tbe.name + '</div></td></tr></thead></table></div>'
            strHtml += '<table class="webtable" style="width: 100%;table-layout: fixed;"><tbody>'
            $.each(tbe.tbodys, function (i, tdy) {
                strHtml+='<tr><td><table class="webtable" style="width: 100%;table-layout: fixed;"><tbody>'
                $.each(tdy[0], function (n, tds) {
                    strHtml+="<tr style='background-size: 100% 0px;'>"
                    strHtml+='<td style="padding: 0px 0px;line-height: 22px;text-align:left" valign="top" width="120" class="xglab">'+tds+'</td>'
                    strHtml+='<td style="padding: 0px 0px;line-height: 22px;text-align:left" valign="top" width="100%" class="xglab">'+ (tdy[1][n]["fmtFn"] || common.etyStr)(rowdata[tdy[1][n]["field"]])+'</td>'
                    strHtml+="</tr>"
                })

                /*$.each(tdy[1], function (n, tds) {
                    strHtml += '<p style="line-height: 22px;text-align:left">' + + '</p>'
                })*/
                /*strHtml += '<tr><td valign="top" width="120" class="xglab"><table class="webtable" style="width: 100%;table-layout: fixed;"><tbody>'
                $.each(tdy[0], function (n, tds) {
                    strHtml += '<p style="line-height: 22px;text-align:left">' + tds + '</p>'
                })
                strHtml += '</td><td width="100%">'
                $.each(tdy[1], function (n, tds) {
                    strHtml += '<p style="line-height: 22px;text-align:left">' + (tds["fmtFn"] || common.etyStr)(rowdata[tds["field"]]) + '</p>'
                })
                strHtml += '</tbody></table></td></tr>'*/
                strHtml+='</tbody></table></td></tr>'
            })
            strHtml += '</tbody></table>'
        })
        $(strHtml).appendTo($("#box"))
    }
})
