define(["jquery","iscroll","selfcnt"],function(require, exports, module) {
    var localopts = ParseParmStr(location.search.slice(1))
    localopts["gp"] = "000002"
    if(!localopts["code"])
        localopts["code"] = localopts["gp"]
    function ParseParmStr(parmStr) {
        var parms = new Object();
        strs = parmStr.split("&");
        for (var i = 0; i < strs.length; i++) {
            parms[strs[i].split("=")[0]] = strs[i].split("=")[1];
        }
        return parms;
    }
    function formatDate(d) {
        if (!d || d.length == 0)
            return "--"
        if (d.length != 8)
            return d
        return d.slice(0, 4) + "-" + d.slice(4, 6) + "-" + d.slice(6, 8);
    }
    function etyStr(s){
        if (!s || s.length == 0 || s == 'null')
            return "--";
        return s;
    }
    function iFlt(v){
        var f = parseInt(v)
        return !isNaN(f) ? f : 0;
    }
    function fFltT(v) {
        var f = parseFloat(v)
        if (isNaN(f) || f == 0)
            return "--"
        var sf = f.toFixed(2)
        if (sf == "0.00")
            return "--"
        return sf
    }
    function getSpe(cls) {
        return '<div class="' + (cls || "spe") + '"></div>'
    }
    function getHeadHtml(ahead) {
        var shead = '<thead><tr>'
        $.each(ahead, function (i, head) {
            shead += ('<th class="' + head["class"] + '" width="' + (head["width"] || 80) + '">' + head["name"] + '</th>')
        })
        shead += '</tr></thead>'
        return shead
    }
   function getTableBody(rows, abody) {
        var sbody = ''
        $.each(rows, function (i, row) {
            sbody += gettr(row, abody)
        })
        return sbody
    }
    function contentNav(arrOpts, config) {
        var arrHtml = [], arrWidth = [8, 75, "100%"], arrCls = ['nim', 'navtitle', 'navtitle'];
        config = config || {}
        if (config["flagwidth"] == "1")//2列
            arrWidth = [8, "100%"]
        else if (config["flagwidth"] == "2") //3列，最后一列固定固定
            arrWidth = [8, "100%", 75]
        else if (config["flagwidth"] == "3") //自定义宽度
            arrWidth = config["arrWidth"]
        if (config["selcls"] == "1")
            arrCls = config["arrCls"]
        arrHtml.push('<div class="nav">')
        arrHtml.push('<table style="width: 100%;table-layout: fixed"><thead><tr>')
        if (arrOpts.length != arrWidth.length) {
            return
        }
        $.each(arrOpts, function (i, opt) {
            var tc = ""
           
            if(arrCls[i]=="nim"){
                tc="nimtd"
            }
            arrHtml.push('<td class="'+tc+'" width="' + arrWidth[i] + '" ><div class="' + arrCls[i] + (opt["cls"] ? " " + opt["cls"] : "") + '">' + (opt["text"] || "&nbsp") + '</div></td>')
        })
        arrHtml.push('</tr></thead></table></div>')
        return arrHtml.join("")
    }
    function getmulcol(arrCol,row) {
       
        //[
        // [{"name":"字段名"},{"field":"字段值","colspan":"1"},{"name":"字段名"},{"field":"字段值","name":"字段名","colspan":"1"}],
        // [{"name":"字段名"},{"field":"字段值","colspan":"1"},{"name":"字段名"},{"field":"字段值","colspan":"1"}]
        // ]
        var arrStr = []
        $.each(arrCol,function (i,col) {
            arrStr.push("<tr>")
            $.each(col,function (j,colattr) {
                arrStr.push("<td ")
                arrStr.push('valign="'+(colattr["valign"] || "top")+'" ')
                arrStr.push('width="'+(colattr["width"] || "100%")+'" ')
                if(colattr["colspan"]){
                    arrStr.push('colspan='+colattr["colspan"]+" ")
                }
                var cls = ''
                if (colattr["type"] == "zdf") {
                    if (fFlt(row[colattr["field"]]) > 0)
                        cls = 'hprice'
                    else if (fFlt(row[colattr["field"]]) < 0) {
                        cls = 'lprice'
                    }
                }

                if(colattr["name"]){
                    arrStr.push('class="txtfix '+(colattr["class"] || "txtleft")+" "+cls+'" ')
                    arrStr.push('>'+colattr["name"]+'</td>')
                }else{
                    arrStr.push('class="'+(colattr["class"] || "txtleft")+" "+cls+'" ')
                    arrStr.push('>'+(colattr["fmtFn"] || etyStr)(row[colattr["field"]], row)+'</td>')
                }

            })
            arrStr.push("</tr>")
        })
        return arrStr.join("")
    }
    function gettr(row,abody) {
        var str = "<tr>"
        if (row["sc"])
            str = '<tr gp="'+row["code"]+";"+row["name"]+";"+row["sc"] + '">'
        $.each(abody, function(i, tr) {
            if (tr["type"] == "zdf") {
                var cls = ''
                if (fFlt(row[tr["field"]]) > 0)
                    cls = 'hprice'
                else if (fFlt(row[tr["field"]]) < 0) {
                    cls = 'lprice'
                }
                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + " " + cls + '">' + (tr["fmtFn"] || etyStr)(row[tr["field"]], row) + '</td>')
            } else {
                str += ('<td valign="' + (tr["valign"] || "top") + '" width="' + (tr["width"] || "100%") + '" class="' + tr["class"] + '">' + (tr["fmtFn"] || etyStr)(row[tr["field"]], row) + '</td>')
            }
        })
        str += "</tr>"
        return str;
    }
    function fFlt(v){
        var f = parseFloat(v)
        return !isNaN(f) ? f : 0
    }
    var defaultChart = {
        chart:{
            height:210,
            spacingBottom:36
        },
        title:{
            text: ''
        },
        legend:{
            borderWidth:0,
            align:"right",
            verticalAlign: 'bottom',
            y: 20,
            floating: true
        },
        credits:{
            enabled:false
        },
        tooltip:{
            shadow:false,
            shared: true,
            enabled:true,
            formatter: function () {
                var s = '<span style="font-size: 12px;">'+this.x+'</span><br/>'
                $.each(this.points, function () {
                  s += '<span style="color:'+this.series.color+'">'+this.series.name+':'+fFlt(this.y).toFixed(2)+'</span><br/>'
                });
                return s
            },
            style:{
                fontSize: "12px",
                padding: "8px"
            }
        },
       
        plotOptions:{
            series:{
                events:{
                    mouseOver:function(){
                        return true
                    }
                }
            },
            
            spline:{
                lineWidth:2,
                marker:{
                    enabled:false,
                    radius:2,
                },
                events:{
                    legendItemClick:function(){
                        return false
                    }
                }
            }
        },
        yAxis:{
            startOnTick:true,
            title:{
                text:"",
                style:{
                    fontWeight:"normal"
                }
            },
            lineWidth:1,
            gridLineDashStyle:"Solid"
        },
        xAxis:{
            reversed:true,
            showFirstLabel:true,
            showLastLabel:true,
            title:
            {
                "text":"",
                "enabled":true
            },
            labels: {
                formatter:function(){
                  if(this.isFirst || this.isLast) { 
                    if(this.isFirst)
                        this.axis.labelAlign="right";
                    else
                        this.axis.labelAlign="left";
                    return this.value;
                  }
                },
               staggerLines: 1
            },
            tickLength:0,
            tickmarkPlacement:'on'
        }

    }
    var txScroll = function(options, otheropts) {

        //otheropts  id:滚动条ID,upCall:上滑动回调,downCall:下滑动回调
        var txDefault = {
            probeType: 2,
            HWCompositing:false,
            scrollbars: "custom",
            mouseWheel: true,
            fadeScrollbars: true,
            bounce: true,
            interactiveScrollbars: true,
            shrinkScrollbars: 'scale',
            click: true,
            keyBindings: true,
            momentum: true
        };
        var txScOpts = $.extend(true, {}, txDefault, options);
        this.opts = $.extend(true, {}, {
            loadingStep: -1,
            hasUp: false, //判断是否继续上拉数据
            hasDown: false,
            isUp:true,
            page: 1 //下滑页数
        }, otheropts);
        this.IScroll = new IScroll('#' + this.opts["id"], txScOpts);
    }
    txScroll.prototype = {
        _init: function() {
            var __this__ = this;
            this._initDown();
            this._initUp();
            this.IScroll.on('scroll', function() {
                if (__this__.opts.loadingStep == 0 && !__this__.pullDownEl.attr('class').match('flip|loading') &&
                    !__this__.pullUpEl.attr('class').match('flip|loading')) {
                    if (this.y > 15 && __this__.opts.hasDown) {
                        //下拉刷新效果
                        __this__.pullDownEl.attr('class', __this__.pullUpEl['class'])
                        __this__.pullDownEl.show();
                        __this__.IScroll.refresh();
                        __this__.pullDownEl.addClass('flip');
                        __this__.pullDownL.html('下拉刷新');
                        __this__.opts.loadingStep = 1;
                    } else if (this.y < (this.maxScrollY - 10)) {
                        //上拉刷新效果
                        __this__.IScroll.refresh();

                        __this__.pullUpEl.attr('class', __this__.pullUpEl['class'])
                        __this__.pullUpEl.show();
                        __this__.pullUpEl.addClass('flip');

                        if (!__this__.opts.hasUp)
                            __this__.pullUpL.html('已无数据');
                        else
                            __this__.pullUpL.html('加载更多');
                        __this__.opts.loadingStep = 1;
                    }
                }
            });
            //滚动完毕
            this.IScroll.on('scrollEnd', function() {

                if (__this__.opts.loadingStep == 1) {
                    if (__this__.pullUpEl.attr('class').match('flip|loading')) {
                        __this__.pullUpEl.removeClass('flip').addClass('loading');
                        __this__.pullUpL.html('正在加载中');

                        __this__.opts.loadingStep = 2;
                        if (!__this__.opts.hasUp) {
                            __this__.pullUpL.html('已无数据');
                            __this__.upAction();
                        } else {
                            __this__.pullUpL.html('正在加载中');

                            if (typeof __this__.opts.upCall === 'function')
                                __this__.opts.upCall.call(__this__, __this__.opts.page);
                        }
                    } else if (__this__.pullDownEl.attr('class').match('flip|loading')) {
                        __this__.pullDownEl.removeClass('flip').addClass('loading');
                        __this__.opts.loadingStep = 2;
                        if (typeof __this__.opts.downCall === 'function')
                            __this__.opts.downCall.call(__this__, 1);

                    }
                }
            });
        },
        _setInit: function(opts) {
            for (var key in opts) {
                this.opts[key] = opts[key];
            }
        },
        _initDown: function() {
            this.pullDownEl = $('#pullDown');
            this.pullDownL = this.pullDownEl.find('.pullDownLabel');
            this.pullDownEl['class'] = this.pullDownEl.attr('class');
            this.pullDownEl.attr('class', '').hide();
        },
        _initUp: function() {
            this.pullUpEl = $('#pullUp');
            this.pullUpL = this.pullUpEl.find('.pullUpLabel');
            this.pullUpEl['class'] = this.pullUpEl.attr('class');
            this.pullUpEl.attr('class', '').hide();
        },
        downAction: function() { //下拉事件
            this.pullDownEl.removeClass('loading');
            this.pullDownEl['class'] = this.pullDownEl.attr('class');
            this.pullDownEl.attr('class', '').hide();
            this.IScroll.refresh();
            this.opts.loadingStep = 0;
        },
        upAction: function() {
            this.pullUpEl.removeClass('loading');
            this.pullUpEl['class'] = this.pullUpEl.attr('class');
            this.pullUpEl.attr('class', '').hide();
            this.IScroll.refresh();
            this.opts.loadingStep = 0;
        }
    }
    return {
        "txScroll":txScroll,
        locationparm: localopts,
        bgcolor: localopts["color"] || 'white',
        getcls: function () {
            var selfcnt = require("selfcnt")
            if (selfcnt.islocalreq == 0 || selfcnt.islocalreq == 1) {
                return "gpcls"
            }
            return "gpcls"
        },
        bindGp: function (fn) {
            var selfcnt = require("selfcnt")

            if (selfcnt.islocalreq == 0 || selfcnt.islocalreq == 1) {
                fn()
            }
        },
        etyStr: function (s) {
            if (!s || s.length == 0 || s == 'null')
                return "--";
            return s;
        },
        fmtIt: function (v) {
            v = parseInt(v)
            return !isNaN(v) ? v : 0
        },
        fmtZeroInt:function (v) {
            v = parseInt(v)
            var iv = !isNaN(v) ? v : 0
            if(iv==0)
                return "--"
            return iv;
        },
        getBfb: function (v1, v2) {
            v1 = fFlt(v1)
            v2 = fFlt(v2)
            if (v2 == 0)
                return "--"
            var v = 100 * v1 / v2
            if (v == 0)
                return "--"
            return v
        },
        fmtFlt: fFlt,
        fmtTwo: function (v) {
            return fFltT(v)
        },
        fmtB:function (v) {
            v = fFltT(v)
            if(v=="--")
                return "--"
            return fFltT(v)+"%"
        },
        fmtBigT:function (v) {
            var f = parseFloat(v)
            var e = '',sdw='';
            if (isNaN(f) || f == 0)
                return "--"
            if(Math.abs(f)<10000){
                e = f.toFixed(2)
                sdw = '万'
                return f.toFixed(2) + "万"
            }else if(Math.abs(f)<100000000){
                e =  (f / 10000).toFixed(2)
                sdw = "亿"
            }else{
                e =  (f / 100000000).toFixed(2)
                sdw = "万亿"
            }
            if(e=="0.00") return "--"
            return e+sdw
        },
        fmtBig:function (v) {
            var f = parseFloat(v)
            if (isNaN(f) || f == 0)
                return "--"
            if(Math.abs(f)<100000000){
                return (f / 10000).toFixed(2) + "万"
            }else if(Math.abs(f)<1000000000000){
                return  (f / 100000000).toFixed(2) + "亿"
            }else{
                return (f / 1000000000000).toFixed(2) + "万亿"
            }
        },

        fmtW: function (v) {
            var f = parseFloat(v)
            if (isNaN(f) || f == 0)
                return "--"
            return (f / 10000).toFixed(2) + "万"
        },
        fmtBill: function (v) {
            var f = parseFloat(v)
            if (isNaN(f) || f == 0)
                return "--"
            return (f / 100000000).toFixed(2) + "亿"
        },
        fmtY:function(v) {
            return fFltT(v)+"元"
        },
        queryZf: function (close, now) {
            close = fFlt(close)
            now = fFlt(now)
            if (now == 0 || close == 0)
                return "--"
            return ((now - close) / Math.abs(close) * 100).toFixed(2)
        },
        "formatDate": formatDate,

        getcur: function () {
            date = new Date();
            var month = date.getMonth() + 1;
            month = (month < 10) ? ('0' + month) : month;
            var day = date.getDate();
            if (day < 10) day = "0" + day;
            return date.getFullYear() + "" + month + "" + day
        },
        "defaultChart": defaultChart,

        getChartCfg: function (chartclr, defau, yAxis) {
            var b = []
            if ($.isArray(yAxis)) {
                $.each(yAxis, function (i, x) {
                    b.push($.extend(true, {}, chartclr["yAxis"] || {}, defau["yAxis"] || {}, x))
                })
                return b
            }
            return yAxis
        },
        getTableHead: function (ahead, sid) {
            sid = sid || "header"
            var shead = '<table class="webtable" style="width: 100%;table-layout: fixed;"><thead><tr>'
            $.each(ahead, function (i, head) {
                shead += ('<th class="' + head["class"] + '" width="' + (head["width"] || 80) + '">' + head["name"] + '</th>')

            })
            shead += '</tr></thead></table></div>'
            $(shead).appendTo("#" + sid)
        },
        getHeadHtml: getHeadHtml,
        getTableBody: getTableBody,
        getTr: function (row, abody) {
            return gettr(row, abody)
        },
        getMulCol: function (arrCol, row) {
            return getmulcol(arrCol, row)
        },

        setTsInfo: function (bs, sid) {
            bs = !!bs;
            sid = sid || "bodybox"
            var oTip = $("#txtipinfo")
            if (oTip.length) {
                if (bs) {
                    oTip.css("display", "block")
                } else {
                    oTip.css("display", "none")
                }
            } else {
                if (bs) {
                    $('<div id="txtipinfo" class="tipinfo" style="display:block">暂无数据!!!</div>').appendTo($("#" + sid))
                }
            }

        },

        loading: function (bs,top,sid) {
            bs = !!bs;
            sid = sid || "content"
            top = top||200
            var load = $("#loading")
            if (load.length) {
                if (bs) {
                    load.css("display", "block")
                } else {
                    load.css("display", "none")
                }
            } else {
                if (bs) {
                    $('<div id="loading" class="load" style="display:block;top:'+top+'px">&nbsp</div>').appendTo($("body"))
                }
            }

        },
        cacheNav: function (arrOpts, config) {
            /*[{"name":"名称","boxID":"容器id","callback":回调函数}]*/
            var divwidth = 5, num = arrOpts.length, arrHtml = [];
            var colwidth = num == 3 ? 33 : 100 / num;
            var mapBoxIdFn = {}, arrBoxHtml = [];
            arrHtml.push('<table class="navtable"  cellspacing="0" cellpadding="0"><tbody><tr>')
            var firstId = '', preText = ""
            for (var i in arrOpts) {
                var colw = (num == 3 && i == num - 1) ? 34 : colwidth;
                var cls = ''
                if (arrOpts[i]["name"] == config["active"]) {
                    firstId = arrOpts[i]["boxID"]
                    preText = arrOpts[i]["name"]
                    cls = 'active'
                }
                arrHtml.push('<td boxid="' + arrOpts[i]["boxID"] + '" width="' + colw + '%" class="even ' + cls + '">' + arrOpts[i]["name"] + '</td>')
                if (i != num - 1) {
                    arrHtml.push('<td width="' + divwidth + '">&nbsp</td>')
                }
                mapBoxIdFn[arrOpts[i]["boxID"]] = arrOpts[i]
                if(!config["nosetbox"])
                    arrBoxHtml.push("<div id='" + arrOpts[i]["boxID"] + "'></div>")
            }
            arrHtml.push('</tr></tbody></table>')
            $(arrHtml.join('')).appendTo($("#" + (config["parentId"] || "navrl")))
            $(arrBoxHtml.join('')).appendTo($("#" + (config["parentBoxId"] || "content")))
            var arrEnent = $("#" + (config["parentId"] || "navrl") + " .even");

            arrEnent.click(function () {
                var boxid = $(this).attr("boxid")
                if ($(this).text() == preText)
                    return
                preText = $(this).text()
                clickFn(boxid)
            })
            clickFn(firstId)
            function clickFn(boxid) {
                
                if (!boxid) return
                arrEnent.each(function () {

                    if ($(this).attr("boxid") == boxid) {
                        $(this).addClass("active")
                        $("#" + $(this).attr("boxid")).css("display", "")
                        if (typeof mapBoxIdFn[boxid]["callback"] === 'function') {
                            mapBoxIdFn[boxid]["callback"].call(this, $(this).attr("boxid"), $(this).text())
                        }
                    } else {
                        $(this).removeClass("active")
                        $("#" + $(this).attr("boxid")).css("display", "none")

                    }
                })
            }
        },
        cacheNavCall: function (curBoxId, arrCache, parentId) {
            var arrEnent = $("#" + (parentId || "navrl") + " .even");
            arrEnent.each(function () {
                var boxid = $(this).attr("boxid")
                if (boxid != curBoxId) {
                    for (var i in arrCache) {
                        if (typeof arrCache[i] === 'function') {
                            arrCache[i](boxid)
                        }
                    }
                }
            })
        },
        tbnav: function (arrOpts, config) {
            var selfcnt = require("selfcnt")
            /*[{"name":"龙虎榜","href":"phf10_zj_lhb"},
             {"name":"大宗交易","href":"phf10_zj_dzjy"}]*/
            var divwidth = 5, num = arrOpts.length, arrHtml = [];
            var colwidth = num == 3 ? 33 : 100 / num;
            arrHtml.push('<table class="navtable"  cellspacing="0" cellpadding="0"><tbody><tr>')
            for (var i in arrOpts) {
                var colw = (num == 3 && i == num - 1) ? 34 : colwidth;
                var cls = ''
                if (arrOpts[i]["name"] == config["active"]) {
                    cls = 'active'
                }
                arrHtml.push('<td thref="' + arrOpts[i]["href"] + '" width="' + colw + '%" class="even ' + cls + '">' + arrOpts[i]["name"] + '</td>')
                if (i != num - 1) {
                    arrHtml.push('<td width="' + divwidth + '">&nbsp</td>')
                }
            }

            arrHtml.push('</tr></tbody></table>')
            $(arrHtml.join('')).appendTo($("#" + (config["parentId"] || "navrl")))
            $("#" + (config["parentId"] || "navrl") + " .even").click(function () {
                var thref = $(this).attr("thref")
                if ($(this).text() == config["active"])
                    return


                if(thref.indexOf(".html")!=-1){
                    selfcnt.goDetail(thref + '&code=' + localopts["code"], {"OpenName": config["active"] || ""})
                }else{

                    selfcnt.goDetail(thref + '.html?code=' + localopts["code"], {"OpenName": config["active"] || ""})
                }

            })
        },
         scrollSet:function(){
            if (__tdxMobSystem == "IOS"){
                $("#content").css("-webkit-overflow-scrolling","auto");
                $("#content")[0].scrollTop = 0;
                $("#content").css("-webkit-overflow-scrolling","touch");
            }
            else {
                $("#content")[0].scrollTop = 0;
            }

        },
        getcontainheight:function() {
            if(__tdxMobSystem == "IOS"){
                setTimeout(function(){
                    var height = document.body.scrollHeight
                    if(height<200) height=200

                    __webCallTql.send("tdxSetWebviewSize", {"Height":height}, "");
                },0)


            }
        },
        contentNav: contentNav,
        getSpe: getSpe,
        createHm: function (arropts, config) {
            /*
             [
             {"opts":[],"config":{},"type":"1"}, //nav,
             {"tbody":[],"type":"2","rows":[]},//多列mulcol
             {"header":[],"tbody":[],"type":"3","rows":[]},

             ]
             * */
            var arrNavHm = []
            $.each(arropts, function (i, opt) {
                if (opt["type"]) {
                    if (opt["type"] == "1") {
                        arrNavHm.push(contentNav(opt["opts"] || [], opt["config"]))
                        arrNavHm.push(getSpe())
                    } else if (opt["type"] == "2") {
                        arrNavHm.push('<table class="webtable multable" style="width: 100%;table-layout: fixed;">')
                        arrNavHm.push(getmulcol(opt["tbody"], opt["rows"][0] || {}))
                        arrNavHm.push("</tbody></table>")
                        arrNavHm.push(getSpe("divspe"))
                    } else if (opt["type"] == "3") {
                        arrNavHm.push('<table class="webtable" style="width: 100%;table-layout: fixed;">')
                        if(opt["header"]&&opt["header"].length){
                            arrNavHm.push(getHeadHtml(opt["header"]))
                        }
                        if(opt["tbody"]&&opt["tbody"].length){
                            arrNavHm.push("<tbody>")
                            arrNavHm.push(getTableBody(opt["rows"], opt["tbody"]))
                            arrNavHm.push("</tbody></table>")
                            arrNavHm.push(getSpe("divspe"))
                        }
                    }
                }
            })
            if(config["parentId"]){
                $(arrNavHm.join("")).appendTo($("#"+config["parentId"]))
            }else{
                return arrNavHm
            }
        },
        headrq:function(v){
            var syear = v.substring(0,4)
            var smonday = v.substring(5)
            var strQ = ""
            if(smonday=="03-31"){
                strQ="Q1"
            }else if(smonday=="06-30"){
                strQ="Q2"
            }else if(smonday=="09-30"){
                strQ="Q3"
            }else if(smonday=="12-31"){
                strQ="Q4"
            }
            if(strQ.length){
                return syear+"-"+strQ
            }
            return strQ;
        }
    }
})