/**
 * Created by Administrator on 2017/6/23.
 */

var app = new Vue({
  data: function() {
    return {
      tdxID: '',
      alertList: [],
      noList: false,
      noAlertInfo: '暂无提醒信息',
      loading: false,
      keyMap: {
        'zqcode': '1001',
        'setcode': '1002',
        'zqname': '1011',
        'curprice': '999',
        'zdf': '888',
        'itemid': '1010',
        '1003': {
          name: '价格高于',
          keyV: '',
          unit: '元',
          color: 'textup',
          isOn: false
        },
        '1004': {
          name: '价格低于',
          keyV: '',
          unit: '元',
          color: 'textup',
          isOn: false
        },
        '1005': {
          name: '日涨幅超',
          keyV: '',
          unit: '%',
          color: 'textup',
          isOn: false
        },
        '1006': {
          name: '日跌幅超',
          keyV: '',
          unit: '%',
          color: 'textdown',
          isOn: false
        }
      },
      limitItems: ['1003', '1004', '1005', '1006'],
      noSet: {
        '1003': 0.00,
        '1004': 0.00,
        '1005': -1.00,
        '1006': -1.00
      }
    };
  },
  watch: {
    alertList: function(val, oldVal) {
      if (this.alertList.length === 0) {
        this.noList = true;
      }

    }
  },
  methods: {
    openGGHQ: function(index) {
      var _ = this;
      var stream = {
        OpenID: "HQGG",
        OpenParam: {
          "ZQCODE": _.alertList[index].zqcode,
          "ZQSETCODE": _.alertList[index].setcode,
          "ZQNAME": _.alertList[index].zqname
        }
      };
      __webCallTql.send('tdxOpenNativeModule', stream, function(data) {

      });
    },

    setTips: function(index, index1, this_value) {
      var _ = this;
      var kaip = _.alertList[index].closeprice || 0; //昨收
      var nowPrice = _.alertList[index].curprice || 0; //现价
      var rate_show = _.alertList[index].zdf || 0; //涨跌幅

      var input_price, input_rate;
      switch (index1) {
        case 0:
          input_price = parseFloat(this_value);
          input_rate = parseFloat(parseFloat((this_value - kaip) / kaip * 100).toFixed(2));
          if (input_price < Math.abs(nowPrice)) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '低于的当前价';
            _.alertList[index].limits[index1].isOver = true;
          } else if (input_price > 99999.99) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '价格过高';
            _.alertList[index].limits[index1].isOver = true;
          } else {
            if (kaip === 0) {
              _.alertList[index].limits[index1].isIns = false;
              _.alertList[index].limits[index1].insInfo = '';
            } else {
              _.alertList[index].limits[index1].isIns = true;
              _.alertList[index].limits[index1].isOver = false;
              _.alertList[index].limits[index1].insInfo = "当日涨幅" + input_rate + '%';
            }
          }
          break;
        case 1:
          input_price = parseFloat(this_value);
          input_rate = parseFloat(parseFloat((this_value - kaip) / kaip * 100).toFixed(2));
          if (input_price > Math.abs(nowPrice)) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '高于当前价';
            _.alertList[index].limits[index1].isOver = true;
          } else {
            if (kaip === 0) {
              _.alertList[index].limits[index1].isIns = false;
              _.alertList[index].limits[index1].insInfo = '';
            } else {
              _.alertList[index].limits[index1].isIns = true;
              _.alertList[index].limits[index1].isOver = false;
              _.alertList[index].limits[index1].insInfo = "当日跌幅" + input_rate + '%';
            }
          }
          break;
        case 2:
          input_price = ((parseFloat(this_value) / 100 + 1) * kaip).toFixed(2);
          input_rate = parseFloat(parseFloat(this_value).toFixed(2));
          if (input_rate < Math.abs(rate_show) && rate_show > 0) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '低于当前涨幅';
            _.alertList[index].limits[index1].isOver = true;
          } else if (input_rate > 44) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '涨幅过高';
            _.alertList[index].limits[index1].isOver = true;
          } else {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].isOver = false;
            _.alertList[index].limits[index1].insInfo = "股价" + input_price;
          }
          break;
        case 3:
          input_price = ((-parseFloat(this_value) / 100 + 1) * kaip).toFixed(2);
          input_rate = parseFloat(parseFloat(this_value).toFixed(2));

          if (input_rate < Math.abs(rate_show) && rate_show < 0) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '低于当前跌幅';
            _.alertList[index].limits[index1].isOver = true;
          } else if (input_rate > 44) {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].insInfo = '跌幅过低';
            _.alertList[index].limits[index1].isOver = true;
          } else {
            _.alertList[index].limits[index1].isIns = true;
            _.alertList[index].limits[index1].isOver = false;
            _.alertList[index].limits[index1].insInfo = "股价" + input_price;
          }
          break;

      }
    },

    updateMade: function(index, isEd) {
      var _ = this;
      if (isEd) {
        _.loading = true;
        var del = true;
        var par = [{}];
        var isover = false;
        _.limitItems.forEach(function(val, index1, arr) {
          var tm = _.alertList[index].limits[index1].keyV;

          par[0][val] = tm === '' ? String(_.noSet[val]) : tm;
          if (String(par[0][val]) != String(_.noSet[val])) {
            del = false;
          }
        });

        par[0]['1010'] = _.alertList[index].itemid;
        __fwCallTql.send('PDataSvc.5104', par, function(data) {
          _.loading = false;
          var res = FormatResult(data);
          if (res.ErrorCode == 0) {
            _.alertList[index].isEdit = false;
            if (del) {
              _.alertList.splice(index, 1);
            }
            setTimeout(function() {
              alert('修改提醒成功！');
            }, 100)

          }
        });
      }
    },
    deleteAlert: function(index) {
      var _ = this;
      var con = confirm('确定要删除该提醒？');
      if (con) {
        var par = [{}];
        par[0]['1010'] = _.alertList[index].itemid;
        __fwCallTql.send('PDataSvc.5106', par, function(data) {
          var res = FormatResult(data);
          if (res.ErrorCode == 0) {
            _.alertList.splice(index, 1);
            alert('删除成功！');
          }
        });
      }

    },
    changestate: function(param) {
      var itemindex = param;
      this.alertList[itemindex].open = !this.alertList[itemindex].open;
      if (this.alertList[itemindex].open) {
        this.alertList[itemindex].limits.forEach(function(item, index, array) {
          if (item.keyV === '') {
            item.isOn = true;
          }
        });
      } else {
        this.alertList[itemindex].limits.forEach(function(item, index, array) {
          if (item.keyV === '') {
            item.isOn = false;
          }
        });
      }
    },
    limitSwitch: function(e, e1) {
      var _ = this;
      _.alertList[e].isEdit = true;
      _.alertList[e].limits[e1].keyV = '';
      if (!_.alertList[e].open) {
        _.alertList[e].limits[e1].isOn = false;
      }
    },
    onBlur: function(e, e1, e3) {
      var _ = this;
      var val = e3.target.value;
      if (_.alertList[e].limits[e1].keyVold !== val) {
        _.alertList[e].isEdit = true;
      }
      if (_.alertList[e].limits[e1].isOver && val !== '') {
        _.alertList[e].limits[e1].keyV = _.alertList[e].limits[e1].keyVold;
      }
      _.alertList[e].limits[e1].isIns = false;
      _.alertList[e].limits[e1].isIns.insInfo = "";

    },
    KeyupEvent: function(e, e1, e3) {
      var _ = this;
      var val = e3.target.value;
      var reg = /^[0-9]\d*[.]?([0-9]{1,2})?$/;
      if (!reg.test(val)) {
        e3.target.value = '';
      }
      _.alertList[e].limits[e1].keyV = e3.target.value;
      if (e3.target.value != '') {
        _.setTips(e, e1, e3.target.value);
      }

      if (_.alertList[e].limits[e1].keyVold !== val) {
        _.alertList[e].isEdit = true;
      }

    },
    getMyAlerts: function() {
      var _ = this;
      __tdxGetPulTdxID(function(data) {
        var res = FormatResult(data);
        if (res.ErrorCode == 0 && res.Num > 0) {
          var tdxid = res.rows[0]['TDXID'];
          _.tdxID = tdxid;
          if (tdxid === '') {
            _.noList = true;
            _.noAlertInfo = '请登录一户通账户';
            return;
          }
        } else {
          _.noList = true;
          _.noAlertInfo = '请登录一户通账户';
          return;
        }


        __fwCallTql.send('PDataSvc.5102', [{
          '1000': tdxid
        }], function(data) {
          var res = FormatResult(data);
          if (res.ErrorCode !== 0) {
            _.noList = true;
            _.noAlertInfo = '错误：' + res.ErrorInfo;
            _.alertList = [];
            return;
          }
          _.noList = false;
          _.noAlertInfo = '';

          var listarr = res.rows;
          var tmpalerts = [];
          var Secu = [];
          listarr.forEach(function(item, index, arr) {
            var tobj = {};

            tobj.open = false;
            tobj.zqcode = item[_.keyMap.zqcode];
            tobj.zqname = item[_.keyMap.zqname];
            tobj.itemid = item[_.keyMap.itemid];
            tobj.setcode = item[_.keyMap.setcode];

            tobj.isEdit = false;
            tobj.curprice = '--';
            tobj.zdf = '--';
            tobj.openprice = 0;
            tobj.limits = [];



            var tms = '';
            _.limitItems.forEach(function(k, m, n) {
              var atm = {};
              $.extend(true, atm, _.keyMap[k]);
              atm.keyV = parseFloat(item[k]).toFixed(2) <= _.noSet[k] ? '' : item[k];
              if (atm.keyV != "") {
                tms = atm.keyV;
              }
              atm[k] = 'keyV';
              if (atm.keyV != '') {
                atm.isOn = true;
              }
              atm.keyVold = atm.keyV;
              atm.isIns = false;
              atm.insInfo = '';
              atm.isOver = false;
              if (tobj.setcode === '31' && atm.unit === '元') {
                atm.unit = '港元';
              } else if (tobj.setcode === '74' && atm.unit === '元') {
                atm.unit = '美元';
              }

              tobj.limits.push(atm);
            });
            if (tms === '') {
              var par = [{}];
              par[0]['1010'] = tobj.itemid;
              __fwCallTql.send('PDataSvc.5106', par, function(data) {
                var res = FormatResult(data);
                if (res.ErrorCode == 0) {}
              });
            } else {
              Secu.push({
                'Code': tobj.zqcode,
                'Setcode': tobj.setcode
              });
              tmpalerts.push(tobj);

            }

          });
          _.alertList = tmpalerts;

          Secu.forEach(function(val, index, arr) {
            var flg = 0;
            if (val.Setcode != '0' && val.Setcode != '1') {
              flg = 1;
            }
            var pr = {
              "WantCol": ["CLOSE", "NOW", "OPEN"],
              "Secu": [val],
              "ExHQFlag": flg
            };

            __hqCallTql.send('HQServ.CombHQ', pr, function(data) {
              var r = JSON.parse(data);
              var e = [0, '', r.SBTSize, '', 0];
              var h = r.ListHead;
              var b = r.List;
              b.push([]);
              b.push(h);
              b.push(e);
              var tarr = b.reverse();
              var re = FormatResult(tarr);
              var tarrr = re.rows;
              tarrr.forEach(function(item, inx, arr) {
                if (_.alertList[index].zqname === '') {
                  _.alertList[index].zqname = item.Name;
                }
                _.alertList[index].curprice = item.NOW;
                _.alertList[index].openprice = item.OPEN;
                _.alertList[index].closeprice = item.CLOSE
                _.alertList[index].zdf = ((parseFloat(item.NOW) - parseFloat(item.CLOSE)) * 100.0 / parseFloat(item.CLOSE)).toFixed(2);
              });
            });

          });
        });
      });
    }
  },
  mounted: function() {
    var _ = this;
    _.getMyAlerts();
    window.tdxRefresh = function() {
      _.getMyAlerts();
    };

  }

});

app.$mount('#app');