// var clientType = {
//   "34": "Mobile",
//   "35": "iPhone",
//   "36": "iPad",
//   "37": "Android",
//   "38": "AndroidPad",
//   "39": "iMac",
//   "40": "Windows"
// };
var transType = {
  "phone": "手机",
  "pad": "iPad",
  "mac": "iMac",
  "pc": "电脑"
};
var devInfoObj = {};
var selfPhone = "";
var timer = play = null;

window.onload = onLoad;

function onLoad() {
  __tdxGetTradeMarkInfo(function(data){
    var result = FormatResult(data);
    // alert(JSON.stringify(result))
    if(result.ErrorCode != 0) {
      dispErrHtml(result.ErrorInfo);
      return;
    }

    var selfDevInfo = result.rows[0]["RESULT"];
    var selfDevArr = selfDevInfo.split(";");
    selfDevArr = selfDevArr[7].split("_");
    selfPhone = selfDevArr[0] + "(" + selfDevArr[1] + ")";

    getDevInfo(function(user) {
      // alert(JSON.stringify(user))
      var aid = user["aid"];
      var tdxid = user["tdxid"];
      var ind = [];
      if(aid) {
        //查询用户设备信息
        queryMyDevInfo(aid, function(did, type, dev, ip, time){
          devInfoObj.did = did;
          devInfoObj.type = type;
          devInfoObj.dev = dev;
          devInfoObj.ip = ip;
          devInfoObj.time = time;
          //查询唯一服务器的登录状态
          queryMyState(tdxid, function(didList) {
            for(var i = 0, len = didList.length; i < len; i++) {
              for(var j = 0, jLen = devInfoObj.did.length; j < jLen; j++) {
                if(didList[i] == devInfoObj.did[j]) {
                  ind.push(j);
                }
              }
            }
            //先展示列表数据，最后显示区域
            dispDevHtml(ind);
            //查询所在区域
            queryMyRegion(function(regList){
              if(regList.length == devInfoObj.ip.length) {
                clearInterval(timer);
                 devInfoObj.region = regList;
                 dispRegInfo();
              }
            });
          });
        });
      }
    });
  });
  
}

function dispErrHtml(err) {
  $(".errMsg").css("visibility", "visible");
  $(".errMsg .btn").click(function(){
    alert(err);
  });
}

function dispRegInfo() {
  for(var i = 0, len = devInfoObj.region.length; i < len; i++) {
    $(".addr_" + i).text(devInfoObj.region[i]);
  }
}

function dispDevHtml(indArr) {
  var len = devInfoObj.did.length;
  var jLen = indArr.length;
  if(jLen > 0) {
    $(".box").append(
        '<div class="status online">' +
          '<div class="head">当前登录设备</div>' +
          '<ul class="list"></ul>' +
        '</div>');
  }
  
  if(len > jLen) {
    $(".box").append(
        '<div class="status lately">' +
          '<div class="head">最近登录设备</div>' +
          '<ul class="list"></ul>' +
        '</div>');
  }
  for(var i = 0; i < len; i++) {
    var self = false;
    var $list = $(".lately .list");
    var type = devInfoObj.type[i];
    var imgSrc = type + ".png";
    
    for(var j = 0; j < jLen; j++) {
      if(i == indArr[j]) {
        if(selfPhone == devInfoObj.dev[i]) self = true;
        $list = $(".online .list");
        imgSrc =  type + "_on.png";
      }
    }

    $list.append(
      '<li>' + 
        '<div class="pic">' +
          '<img src="images/' + imgSrc + '">' +
        '</div>' +
        '<div class="content">' +
          '<div class="rowOne">' + 
            '<div class="brand">' + devInfoObj.dev[i] + '</div>' +
            '<div class="right right_' + i + '">本机</div>' +
          '</div>' +
          '<div class="detail">' +
            '<span class="time">' + devInfoObj.time[i] + '</span>' +
            '<span class="addr addr_' + i + '"></span>' +
            '<span class="device">' + transType[devInfoObj.type[i]] + '</span>' +
          '</div>' +
        '</div>' +
      '</li>' + 
      '<div class="border"></div>');
    if(self) {
      $(".right_" + i).css("display", "block");
    }
  }
}

function queryMyRegion(callback) {
  var regList = [];
  var flag = true;
  for(var i = 0, len = devInfoObj.ip.length; i < len; i++) {
    if(flag) {
      flag = false;
      var temp = devInfoObj.ip[i];
      if(!localStorage.getItem(temp)) {
        queryMyRegionInfo(temp, function(region){
          flag = true;
          localStorage.setItem(temp, region);
          regList.push(region);
        });
      } else {
        flag = true;
        regList.push(localStorage.getItem(temp));
      }
    }
  }
  timer = setInterval(function(){
    callback(regList);    
  }, 30);
}
function queryMyDevInfo(aid, callback) {
  queryUserDevInfo(aid, function(data) {
    var result = FormatResult(data);
    // alert(JSON.stringify(result)+'queryUserDevInfo')
    if(result.ErrorCode != 0) {
      dispErrHtml(result.ErrorInfo);
      return;
    }
    var didList = [];
    var typeList = [];
    var devList = [];
    var ipList = [];
    var timeList = [];

    var list = result.rows;
    for(var i = 0, len = list.length; i < len; i++) {
      // var machineInfo = list[i]["MachineInfo"];
      var machineInfo = list[i]["MACHINEINFO"];
      if(!machineInfo) continue;

      // var did = list[i]["DId"];
      var did = list[i]["DID"];
      // var type = getImg(list[i]["ClientType"]);
      var type = getImg(list[i]["CLIENTTYPE"]);
      // var time = getTimeStr(list[i]["Last"]);
      var time = getTimeStr(list[i]["LAST"]);
      var infoArr = machineInfo.split(";");
      var devInfo = infoArr[7];
      var devIp = infoArr[8];

      if(!devInfo) continue;

      var devArr = devInfo.split("_");
      if(devArr.length < 2) continue;

      devInfo = devArr[0] + "(" + devArr[1] + ")";

      var count = 0;
      if(devList.length == 0) {
        didList.push(did);
        typeList.push(type);
        devList.push(devInfo);
        ipList.push(devIp);
        timeList.push(time);
      } else {
        for(var n = 0, nLen = devList.length; n < nLen; n++) {
          if(devInfo != devList[n]) {
            count++;
            if(count == nLen) {
              didList.push(did);
              typeList.push(type);
              devList.push(devInfo);
              ipList.push(devIp);
              timeList.push(time);
            }
          }
        }
      } 
    }
    callback(didList, typeList, devList, ipList, timeList);
  });
}

function queryMyState(tdxid, callback) {
  queryUserState(tdxid, function(data) {
    var result = FormatResult(data);
    if(result.ErrorCode != 0) {
      dispErrHtml(result.ErrorInfo);
      return;
    }
    var list = result.rows;
    var didList = [];
    for(var i = 0, len = list.length; i < len; i++) {
      var status = list[i]["UserStatus"];
      if(status == "1") {
        didList.push(list[i]["DID"]);
      }
    }
    callback(didList);
  });
}

function queryMyRegionInfo(ip, callback) {
  queryRegionInfo(ip, function(data) {
    var result = JSON.parse(data);
    var region = "";
    if(result.code != 0) {
      region = ip;
    } else {
      var regObj = result.data;
      region = regObj["country"] + regObj["region"] + regObj["city"];  
    }
    
    callback(region);
  });
}

function getImg(type){
  switch(type) {
    case 34:
    case 35:
    case 37:
      type = "phone";
      break;
    case 36:
    case 38:
      type = "pad";
      break;
    case 39:
      type = "mac";
      break;
    case 40:
      type = "pc";
      break;
    default:
      return
  }
  return type;
}

function formatTime(time) {
  var year = time.getFullYear();       //年
  var month = time.getMonth() + 1;     //月
  var day = time.getDate();            //日
  
  var hh = time.getHours();            //时
  var mm = time.getMinutes();          //分
  var ss = time.getSeconds();           //秒

  var clock = year + "/";
    
  if(month < 10)
      clock += "0";
  
  clock += month + "/";
  
  if(day < 10)
      clock += "0";
      
  clock += day + " ";
  
  if(hh < 10)
      clock += "0";
      
  clock += hh + ":";

  if (mm < 10) 
    clock += '0'; 

  clock += mm + ":"; 
   
  if (ss < 10) 
    clock += '0'; 

  clock += ss; 
  
  return clock; 
}

function getTimeStr(str) {
  var time = new Date(str);
  var timeStr = formatTime(time);
  return timeStr;
}

function queryUserDevInfo(aid, callback) {
  var data = {
    'ATYPE': '340',
    'AID': aid
  };
  __fwCallTql.send('PUL.get_user_devinfo', [data], callback);
}

function queryUserState(tdxid, callback) {
  var data = {
    'TDXIDs': tdxid
  };
  __fwCallTql.send('UniqueSrv:QueryUNUserState', [data], callback);
}

function queryRegionInfo(ip, callback) {
  var data = {
    'ip': ip
  };
  __fwCallTql.send('IPService.GetRegionInfoByTaobao', [data], callback);
}