/*
  自执行函数，把需要抛出的变量绑定到 window 上
*/

!function(_g){
	var user = {};

	//检测用户是否登录
	var checkLogin = function(callback) {

		__tdxGetPulTdxID(function(data) {
			if (typeof data === 'string') {
				data = JSON.parse(data);
			}
			var tdxid;
			if (data.length > 3) {
				var result = FormatResult(data);
				tdxid = result.rows[0]["TDXID"];
			}

			// 一户通登录
			if (!tdxid) {
				__tdxYhtLogin();
				return
			}
			callback(tdxid);
		});
	}

	//获取注册手机号
	var getUserTel = function(callback) {
		__tdxGetRegTel(function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				dispErrHtml(result.ErrorInfo);
				return;
			}
			if(result.Num == 0){
				return
			}
			var tel = result.rows[0]["YHTTEL"];
			callback(tel);
		});
	}

	//获取一户通昵称信息
	var getNickName = function(tdxid, callback) {
		getZhMessage(tdxid, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				dispErrHtml(result.ErrorInfo);
				return;
			}
			if(result.Num == 0){
				return
			}
			var nick = result.rows[0]["NICK"];
			callback(nick);
		});
	}

	//获取一户通绑定信息
	var getZhBindInfo = function(tdxid, callback) {
		getZhConnect(tdxid, function(data) {
			var result = FormatResult(data);
			if(result.ErrorCode != 0){
				dispErrHtml(result.ErrorInfo);
				return;
			}
			if(result.Num == 0){
				return
			}
			var list = result.rows;
			var yhtBindInfo, uname;
			for (var i = 0, len = list.length; i < len; i++) {
				if (list[i]["ATYPE"] == '292') {
					yhtBindInfo = list[i];
					uname = list[i]["AID"];
				}
			}
			callback(yhtBindInfo, uname);
		});
	}


	var getL2Account = function(callback) {
		checkLogin(function(tdxid){
			user.tdxid = tdxid;
			getUserTel(function(tel){
				user.tel = tel;
				getNickName(user.tel, function(nick){
					user.nick = nick;
					getZhBindInfo(tdxid, function(yhtInfo, L2Account){
						// user.yhtInfo = yhtInfo;
						user.L2Account = L2Account;
						callback(user);
					});
				});
				
			});
		});
	}

	//获取level2账号
	_g["getL2Account"] = getL2Account;

}(window);

function dispErrHtml(err) {
  $(".errMsg").css("visibility", "visible");
  $(".errMsg .btn").click(function(){
    alert(err);
  });
}

function getZhMessage(tel, callback) {
	var data = {
		ATYPE: '340',
		AID: tel,
		tdxPageID: "_UrlEncode"
	}

	__fwCallTql.send('PUL.cget_zh_message', [data], callback);
}

function getZhConnect(tdxid, callback) {
	var data = {
		ATYPE: '999',
		AID: tdxid,
		tdxPageID: "_UrlEncode"
	}

	__fwCallTql.send('PUL.cget_zh_connect', [data], callback);
}

function regAndBind(tel, nick, callback) {
	var data = {
		in_atype: "292",
		in_u_no: "",
		in_u_name: nick,
		in_u_pwd: "888888",
		in_use_pul_pwd: "1",
		in_sid: "",
		in_u_property: "全价",
		in_u_type: "个人",
		in_u_product: "level2",
		in_u_infotype: "TDXAPP",
		in_u_address: "#CN#",
		in_u_linkman: tel,
		in_u_tel: tel,
		in_u_mobile: tel,
		in_u_email: ""
	}

	__fwCallTql.send('Level2:RegAndBind', [data], callback);
}