define(function(require, exports, module) {

module.exports = function(item) {

  return {

    template: ' \
      <div class="tdx-wdfx"> \
        <div v-if="data.rows.length > 0" \
          class="tdx-wdfx-list" \
          @scroll="onScroll"> \
          <div class="tdx-wdfx-row" v-for="(row, index) in data.rows"> \
            <div class="tdx-wdfx-row-left"> \
              <div class="tdx-wdfx-detail-row-title"> \
                <span class="tdx-wdfx-title" \
                  :style="title.style" \
                  @click="goDetail(row)">{{row[title.field]}}</span> \
                <span class="tdx-wdfx-install" \
                  :style="count.style">(安装量:{{row[count.field]}})</span> \
              </div> \
              <div class="tdx-wdfx-detail-row-content"> \
                <span class="tdx-wdfx-detail" \
                  @click="packClick(index)" \
                  v-html="getDetail(row[detail.field], index)"></span> \
                <span class="tdx-wdfx-pack" \
                  v-if="!data.pack[index] && row[detail.field].length > data.packlength" \
                  @click="unPackClick(index)"> \
                  显示全部 \
                </span> \
                <span class="tdx-wdfx-pack" \
                  v-else-if="row[detail.field].length > data.packlength" \
                  @click="packClick(index)"> \
                  收起 \
                </span> \
              </div> \
            </div> \
            <div class="tdx-wdfx-row-right"> \
              <div class="tdx-wdfx-btn-fx" @click="goShare(row)">分享</div> \
            </div> \
          </div> \
          <div v-if="data.loading" class="tdx-loading"></div> \
        </div> \
        <div v-else class="tdx-wdfx-nodata"> \
          <div class="tdx-wdfx-nodata-text"> \
            您还未编辑指标，请自定义编辑后再进行分享。 \
          </div> \
        </div> \
      </div> \
    ',

    data: function() {

      item.data = item.data || {};
      item.data.rows = [];

      // 字数长度
      item.data.packlength = 14;

      // 这里看收起，打开标示
      item.data.pack = [];

      item.data.loading = true;
      item.data.hasNextPage = true;
      item.data.page = item.page || 0;
      item.data.pageSize = item.pageSize || 15;

      return item;
    },

    methods: {

      // info, 指标详情内容
      // index, 行记录下标
      getDetail: function(info, index) {

        // 内容已经被展开
        if(this.data.pack[index] == 1) {
          return info.replace(/\r\n/g, "<br>");
        }

        // 内容长度不需要展开关闭
        if(info.length < this.data.packlength) {
          return info.replace(/\r\n/g, "<br>");
        }

        // 这里信息未被展开，并且有展开逻辑
        return info.substr(0, this.data.packlength).replace(/\r\n/g, "<br>") + "...";
      },

      // 点击展开操作
      unPackClick: function(index) {
        this.data.pack[index] = 1;
        this.$forceUpdate();
      },

      // 点击收起操作
      packClick: function(index) {
        this.data.pack[index] = 0;
        this.$forceUpdate();
      },

      // 跳转到详情界面
      goDetail: function(row) {

        // window.location.href = "./detail.html?DataID=" + row["DataID"];
        __webCallTql.send("tdxOpenUrl", {
          OpenName: "指标详情",
          OpenType: "native",
          OpenUrl: "./detail.html?id=" + row["DataID"],
          OpenParam: {
            UrlType: "Relative",
            WebViewType: "LocalURL"
          }
        });

      },

      // 点击分享
      goShare: function(row) {
        bus.$emit("tdx-wdfx-share", row);
      },

      // 滚动查询下一页
      onScroll: function(e) {
        e.preventDefault();
        if(this.data.loading || !this.data.hasNextPage) return;
        var el = e.target;
        if(el.clientHeight + el.scrollTop > el.scrollHeight - 10) {

          // 这里发查询
          this.data.loading = true;
          this.data.page = this.data.page + this.data.pageSize;
          console.log(this.data.page);
          bus.$emit("tdx-wdfx-nextpage", this.data);
        }
      }
    },

    mounted: function() {

      bus.$emit("tdx-module-load", this.data);
    },

    created: function() {
      var that = this;
      bus.$on("tdx-wdfx-loaddata", function(rows) {

        that.data.loading = false;
        if(rows.length < that.data.pageSize) {
          that.data.hasNextPage = false;
        }

        if(rows.constructor.name.toLowerCase() == "array") {
          that.data.rows = that.data.rows.concat(rows);
        }
        else {
          console.error("返回的数据记录格式不对，需要数组类型");
        }
      })
    }
  }
}

})