define(function(require, exports, module) {

var getValueByFields = require("../tlibs/common.js").getValueByFields;
var zbInstallEx = require("../tlibs/zbinstall.js");

var bw = require("../tlibs/checkbrowser.js");

module.exports = function(item) {

  return {

    template: ' \
      <div class="tdx-zb-detail" v-if="data.rows.length > 0"> \
        <div class="tdx-zb-head"> \
          <span>指标名称:{{data.rows[0]["Title"]}}</span> \
          <div v-if="isShowBtn && isZbInstalled" class="tdx-zb-installed">已安装</div> \
          <div v-if="isShowBtn && !isZbInstalled" class="tdx-zb-install" @click="zbInstall()">安装</div> \
        </div> \
        <div class="tdx-zb-title"> \
          <div :style="Explain.style">{{Explain.title}}</div> \
        </div> \
        <div class="tdx-zb-explain" v-html="getZbExplain()"></div> \
        <div class="tdx-zb-title"> \
          <div :style="Code.style">{{Code.title}}</div> \
        </div> \
        <p class="tdx-zb-zbcode" v-html="zbCode"></p> \
        <div class="tdx-zb-title"> \
          <div :style="Image.style">{{Image.title}}</div> \
        </div> \
        <div class="tdx-zb-image"> \
          <a :href="zbImage" data-lightbox="image-1"> \
            <img data-lightbox="image-1" :src="zbImage"> \
          </a> \
        </div> \
      </div> \
    ',

    data: function() {

      item.data = item.data || {};
      item.data.rows = item.data.rows || [];
      item.isZbInstalled = 0;

      return item;
    },

    methods: {

      // 获取指标说明
      getZbExplain: function() {

        var rowdata = this.data.rows[0];
        if(rowdata) {
          var field = this.Explain.field;
          return rowdata[field].replace(/\r\n/g, "<br>");
        }
        else {
          return "";
        }
      },

      // 指标安装
      zbInstall: function() {
        zbInstallEx(this.data.rows[0]);
      }
    },

    computed: {

      // 代码区域
      zbCode: function() {
        var rowdata = this.data.rows[0];
        if(rowdata) {
          var fields = this.Code.field;
          // return getValueByFields(rowdata, fields).replace(/<br>/g, "\r\n");
          // return getValueByFields(rowdata, fields) + "<br>" 
          //   + getValueByFields(rowdata, fields) + "<br>"
          //   + getValueByFields(rowdata, fields) + "<br>"
          //   + getValueByFields(rowdata, fields);
          return getValueByFields(rowdata, fields);
        }
        else {
          return "";
        }

      },

      // 图片区域,返回图片 url
      zbImage: function() {
        var rowdata = this.data.rows[0];
        if(rowdata) {
          var fields = this.Image.field;
          var urls = getValueByFields(rowdata, fields);

          if(urls.length <= 0) {
            return "";
          }
          else {
            return "http://mbser.tdx.com.cn:7615/dfs/" + urls[0].replace(/\|/g, "/");
            // return "http://" + location.host + "/dfs/" + urls[0].replace(/\|/g, "/");
          }
        }
        else {
          return "";
        }
      },

      // 判断是否显示安装按钮
      isShowBtn: function() {

        if(bw == "winpc" || bw == "macpc") {
          return false;
        }
        else {
          return true;
        }
      }
    },

    created: function() {

      var that = this;

      bus.$on("tdx-zb-detail-installed", function(flag) {
        that.isZbInstalled = 1;
      });
    },

    mounted: function() {

      bus.$emit("tdx-module-load", this.data);
    },

    updated: function() {
      console.log("tdx-zb-detail updated");
    }
  }
}

})