define(function(require, exports, module) {

var params = window.location.pathname.match(/\/([^\/]*)\/([^\/]*).html/);
var path = params[1];
var filename = params[2];

exports.path = path;
exports.file = filename;

// 读配置文件
var config = require("../config.js");
var layout = require("./layout.js");

var loadJsFile = require("./common.js").loadJsFile;

var $conf; // config 文件返回的对应配置
var $func; // func 文件返回的对应配置

// 存放当前页面需要用到的所有组件信息
var tdxItems = [];

var registerVueComponent = function() {

  tdxItems = [];

  // 处理第一层的 items
  if($conf.items && $conf.items.constructor.name.toLowerCase() == "array") {
    var items = $conf["items"];
    items.map(function(item) {
      if(item.tplid == undefined) return;
      tdxItems.push(item);
    });
  }

  for(var k in $conf) {

    var obj = $conf[k];
    if(obj.items && obj.items.constructor.name.toLowerCase() == "array") {
      var items = obj.items;
      items.map(function(item) {
        if(item.tplid == undefined) return;
        tdxItems.push(item);
      });
    }
  }

  var recnum = 0;
  tdxItems.map(function(item) {
    var componentpath = "../pages/" + item.tplid + ".js";
    require.async(componentpath, function(fun) {

      recnum ++;
      var component$conf = fun(item);
      Vue.component(item.tplid, component$conf);

      if(recnum == tdxItems.length) {

        vm = new Vue({
          el: "#app",
          data: {
            msg: "tdx"
          },
          mounted: function() {
            console.log("app mounted");
            // 设置高度
            // var ht = $(window).height() - 20;
            // var ht = $(window).height();
            // $(".tdx-layout").css({height: ht});
            // $(".tdx-layout-left").css({height: ht});
            // $(".tdx-layout-right").css({height: ht});
          },
          updated: function() {
            console.log("app updated");
            // var ht = $(window).height();
            // $(".tdx-layout").css({height: ht});
            // $(".tdx-layout-left").css({height: ht});
            // $(".tdx-layout-right").css({height: ht});
          }
        });
      }

    })
  })
}

var registerJsAct = function() {

  // 先载入业务逻辑函数，再注册组件。
  // 是因为我们会在业务逻辑函数里面注册组件的监听函数，这样组件被 mounted 后触发的
  // 事件，我们能够响应
  
  // 这里载入对应的业务逻辑函数
  if($conf.funcjs) {

    var funcjs = "./" + $conf.funcjs;
    require.async(funcjs, function(app) {
      app.init($conf, $func);
      registerVueComponent();
    })
  } else {
    registerVueComponent();
  }
}

exports.registerJsAct = registerJsAct;

exports.run =  function() {

  loadJsFile("config", function(conf) {

    $conf = conf;

    // 将这个变量抛出到 window 下，成为全局对象
    window["$conf"] = $conf;
    $("body").prepend(layout(conf));
    
    // registerJsAct(conf);
    loadJsFile("func", function(conf) {

      $func = conf;
      window["$func"] = $func;

      // 初始化请求的时候，在二次查询中，可能会用到初始化请求的内容
      // 这里放一个全局变量
      window["$initdata"] = {};

      registerJsAct();
    })
  });

}

});