define(function(require, exports, module) {

/*
  这里处理每个功能进去后，公共的查询部分

  主要处理

  1. 初始功能查询 initreqs

  2. 页面准备好后的一个查询 queryreq


  这里 $conf, $func 已经是 window 下的属性值了
*/

var common = require("./common.js");
var __localCallTql = common.__localCallTql;

var req = require("./req.js");
var getReqParams = req.getReqParams;
var tdxReq = req.tdxReq;

// 处理 queryreq 查询部分
// rowdata: 数据对象信息
var onQuery = function(rowdata) {

  var queryreq = $func.queryreq;
  var reqReceived = $func.reqReceived;

  if(queryreq) {

    var params = getReqParams(queryreq.fields, queryreq.params, rowdata, queryreq.funcid);
    tdxReq(queryreq.funcid, params, function(data) {

      if(typeof reqReceived == "function") {
        reqReceived(data);
      }
      else {

        $conf.items[0].data = data.rows[0];
      }

    });

  }
}


// 模块 mounted 后，触发查询操作
var onLoad = function(rowdata) {

  var initreqs = $func.initreqs;
  var initReqReceived = $func.initReqReceived;

  // 如果 initreqs 被定义，并且有查询功能
  if(initreqs && initreqs.length > 0) {

    var recnum = 0;
    initreqs.map(function(req, index) {


      !function(i) {

        var funcid = req.funcid;  // 功能号
        var params = getReqParams(req.fields, req.params, undefined, funcid);

        tdxReq(funcid, params, function(data) {

          recnum ++;

          // 如果是空值过来，标示报错了
          if(!data) return;

          if(typeof initReqReceived == "function") {
            initReqReceived(data, i);
          }

          if(recnum == initreqs.length) {
            // onQuery($initdata);
            onQuery($.extend({}, rowdata, $initdata));
          }

        });

      }(index);

    });

  }
  else {
    // onQuery();
    onQuery($.extend({}, rowdata, $initdata));
  }
}

module.exports = {
  onLoad: onLoad,
  onQuery: onQuery
}

})