define(function(require, exports, module) {

// ===============================================

var left_right = '\
  <div class="tdx-layout" id="app">\
    <div class="tdx-layout-left">{{left}}</div>\
    <div class="tdx-layout-right">{{right}}</div>\
  </div>\
';

var left_right_fixed = ' \
  <div class="tdx-layout" id="app"> \
    <div class="tdx-layout-left-auto">{{left}}</div> \
    <div class="tdx-layout-right-fixed">{{right}}</div> \
  </div> \
';

var layout_default = '\
  <div class="tdx-layout" id="app"> \
    {{default}} \
  </div> \
';

module.exports = function(conf) {
  
  if(conf.layout == "left-right" || conf.layout == "left-right-fixed") {

    var leftStr = "";
    var rightStr = "";

    try {
      conf.left.items.map(function(item, index) {
        leftStr += "<" + item.tplid + " ref='tdx-left-item-" + index + "'></" + item.tplid + ">";
      });

      conf.right.items.map(function(item, index) {
        rightStr += "<" + item.tplid + " ref='tdx-right-item-" + index + "'></" + item.tplid + ">";
      });

    } catch(e) {
      console.error(e);
    }

    if(conf.layout == "left-right") {

      return left_right.replace("{{left}}", leftStr).replace("{{right}}", rightStr);
    }
    else {

      return left_right_fixed.replace("{{left}}", leftStr).replace("{{right}}", rightStr);
    }

  }
  else {

    var itemStr = "";

    try {

      conf.items.map(function(item, index) {
        itemStr += "<" + item.tplid + " ref='tdx-item-" + index + "'></" + item.tplid + ">";
      });

    } catch(e) {
      console.error(e);
    }

    return layout_default.replace("{{default}}", itemStr);

  }

}

// =================================================
});