define(function(require, exports, module) {

var doRecData = function(data, callback) {

  try {

    // 替换下空格标识符
    data = data.replace(/ /g, "&nbsp;");

    data = data.replace(/\1/g, "");
    data = FormatResult(data);

    // 这里把空格内容还原了
    data = JSON.parse(JSON.stringify(data).replace(/&nbsp;/g, " "));

    // 这里 FormatResult 如果解析出错，会返回空内容

    if(data.ErrorCode != 0) {
      alert(data.ErrorInfo);
      callback();
    }
    else {
      callback(data)
    }

  }
  catch(e) {

    // alert(e + data);
    console.error(e);

    // 出错时，给个空值过去
    callback();
  }

}

/*
  获取请求入参信息，或者格式化请求入参信息

  fields: 入参的变量字段
  params: 入参中恒定变量字段
  row: 行记录数据
  entry: 功能号
*/
exports.getReqParams = function(fields, params, row, entry) {

  var rt = {};

  if(fields && row) {

    fields.map(function(field) {

      // 对 field[1] 进行分割，支持2层key
      var ks = field[1].split(".");
      var v;
      if(ks.length == 1) {
        v = row[ks[0]];
      } 
      else if(ks.length == 2) {
        v = row[ks[0]][ks[1]];
      }

      if(field[0].toLowerCase() == "select") {
        rt["F123"] = v.gddm;
        rt["F125"] = v.sc;
      }
      else {
        rt[field[0]] = v;
      }
    })
  }

  // 如果是本地调用，不转 _UrlEncode
  if(entry && (entry.indexOf("webcall") >= 0)) {

  }
  else {

    $.extend(rt, params, {
      tdxPageID: "_UrlEncode"
    });

  }

  return rt;
}

/*
  请求封装

  entry: 请求功能号
  params: 请求参数
  callback: 请求回调
*/
exports.tdxReq = function(entry, params, callback) {

  // 本地 webCallTql 请求
  if(entry.indexOf("webcall") >= 0) {

    __webCallTql.send(entry.replace("webcall.", ""), params, callback);

  }

  // PC 端的一些功能请求
  else if(
       entry == "tc.getuinfo"
    || entry == "tc.getclientver"
    || entry == "tc.getuname"
    || entry == "tc.getbranchid"
    || entry == "tc.getmachineinfo"
    || entry == "tc.getuidxml"
    || entry == "tc.gettradeccf"
  ) {

    __hqCallTql.send(entry, [params], callback);
  }

  // 转到行情 TP 的请求
  else if(entry.indexOf("hq.") >= 0) {

    __hqCallTql.send(entry.replace("hq.", ""), [params], function(data) {
      doRecData(data, callback);
    })
  }

  // 转到服务 TP 的请求
  else if(entry.indexOf("fw.") >= 0) {

    __fwCallTql.send(entry.replace("fw.", ""), [params], function(data) {
      doRecData(data, callback);
    })
  }

  // 转到 TC 的请求
  else if(entry.indexOf("jy.") >= 0) {
    __jyCallTql.send(entry.replace("jy.", ""), params, function(data) {
      doRecData(data, callback);
    })
  }

  // 默认转到行情 TP
  else {
    __hqCallTql.send(entry.replace("hq.", ""), [params], function(data) {
      doRecData(data, callback);
    })
  }

}

})