/**
 * [g_tdx_log 通讯日志开关 ] 
 * @type {Boolean}
 */
var g_tdx_log = false;

/**
 * [__tdxMobSystem 判断系统环境类型] 
 * @type {[String]}
 */
var __tdxMobSystem = tdxCheckMobSys();


/******************************************************connect.js  from tdx*****************************************************************/

/**
 * [ tdxCheckMobSys 检测手机系统]
 * @return {[String]}
 */
function tdxCheckMobSys() {
  var clientType = '';

  // TDXQuery 为新版webkit拓展调用方法
  if (window.TDXQuery) {
    clientType = "PCCEF";

  } else if (window.external && window.external.CallTQL) {
    clientType = "PC";
  }


  /***ios-app应用内***/
  var matches = /tdxios/i.test(navigator.userAgent.toLowerCase());
  if (matches) {
    if (window.location.href.indexOf("http") == 0 || window.location.href.indexOf("https") == 0) {
      clientType = 'WEB-IOS';
    } else {
      clientType = 'IOS';
    }

  }

  /*** Android-app 安卓app应用内***/
  var matches = /tdxandroid/i.test(navigator.userAgent.toLowerCase());
  if (matches) {
    if (window.location.href.indexOf("http") == 0 || window.location.href.indexOf("https") == 0) {
      clientType = 'WEB-Android';
    } else {
      clientType = 'Android';
    }
  }
  //
  /***wechat-app 微信内嵌浏览器内***/
  var ua = navigator.userAgent.toLowerCase();
  if (ua.match(/MicroMessenger/i) == "micromessenger") {
    clientType = 'WX';
  }

  if (g_tdx_log) {
    console.log("%c环境类型-clientType：" + clientType, 'color:gray')
  }

  return clientType;
}


/***返回URL的一个随机串***/
/**
 * @return {[string]}
 */
function getRnd() {
  return parseInt(Math.random() * 10000) + "=" + parseInt(Math.random() * 10000);
}


/***获取 function 名称***/


/**
 * @param {[func]}
 * @return {string} [函数名]
 */
function Fun_Name(func) {
  var tmp = func.toString();
  var re = /function\s*(\w*)/i;
  var matches = re.exec(tmp);
  return matches[1];
}


/**
 * [_theTime 获取当前时间-时分秒 ]
 * @return {[stirng ]}
 */
function _theTime() {
  var myDate = new Date();
  myhours = myDate.getHours();
  myminutes = myDate.getMinutes();
  myseconds = myDate.getSeconds();
  mymilliseconds = myDate.getMilliseconds();

  return myhours + ':' + myminutes + ':' + myseconds + ':' + mymilliseconds;
}



/**
 * [_callFuncDictConnect 回调函数字典]
 * @type {Object}
 */
var _callFuncDictConnect = {};

/***统一不同方式的回调函数***/
/**
 * @param  {[string]} formid 请求、回调统一标示
 * @param  {[string]} strFuncName 请求功能名称
 * @param  {[int]}    strErrNo  错误号
 * @param  {[string]} strResultCont  应答数据包
 * @return {[string]}  
 */
function tdxGetCallBack(formid, strFuncName, strErrNo, strResultCont) {


  if (g_tdx_log) {
    console.log([
      '接受应答:',
      '%c\nWebCall请求详情，formid: [' + formid + ']，功能名-strFuncName：[' + strFuncName + ']',
      '%cstrErrNo：',
      '%c' + strErrNo,
      '%c应答结果：',
      '%c' + strResultCont,
      '%c当前时间: ' + _theTime(),
      ''
    ].join('\n'), 'color: green', 'color: red', 'color: gray', 'color: blue', 'color: gray', 'color: green');
  }


  if (formid.indexOf('_UrlEncode') > -1) {
    strResultCont = decodeURIComponent(strResultCont);
  }

  if (strErrNo != 0) {
    strResultCont = JSON.stringify([
      [strErrNo, strResultCont, '', '', ''],
      [],
      []
    ]);
    if (strErrNo == '-10000') {
      __tdxLoginBox();
      strResultCont = JSON.stringify([
        [0, strResultCont, 0, "", ''],
        [],
        []
      ]);
    }
  }

  if (_callFuncDictConnect.hasOwnProperty(formid)) {
    var callback = _callFuncDictConnect[formid];
    _callFuncDictConnect[formid] = undefined;
    delete _callFuncDictConnect[formid];
    callback(strResultCont);
  }
}

/*****************************************IOS函数桥接******************************************/
var _IOSBridgeConnect = {
  callbacksCount: 1,
  callbacks: {},
  resultForCallback: function resultForCallback(callbackId, resultArray) {
    try {
      var callback = _IOSBridgeConnect.callbacks[callbackId];
      if (!callback) {
        return;
      }
      callback.apply(null, resultArray);
    } catch (e) {
      alert(e);
    }
  },
  call: function call(strCallWay, args, strFuncName, frameID, callback) {
    var hasCallback = callback && typeof callback == "function";
    var callbackId = hasCallback ? _IOSBridgeConnect.callbacksCount++ : 0;
    if (hasCallback) {
      _IOSBridgeConnect.callbacks[callbackId] = callback;
    }
    var iframe = document.createElement("IFRAME");
    iframe.style.display = 'none';
    iframe.setAttribute("src", "tdx-frame:" + strCallWay + ";;" + frameID + ";;" + strFuncName + ";;" + args + ";;" + callback);
    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
  }
};

/***创建TS_client对象***/
var tdxClientObj = CreateTDXClient({
  // serverType:,
  needReserve: false,
  needLogin: false,
  preLoginFuncList: [],
  notify: function(msgType, data, obj) {

  }
});

/**
 * [mCallTQL 实例化tsclient调用]
 * @type {[function]}
 */
var mCallTQL = tdxClientObj.execute.bind(tdxClientObj);

/***
针对远程url,http、https请求动态调整调用方式，
"tphttp"、"tpws"、 "pc"、"pccef"、"ios" "android" "http" "tqlex"
默认激活TQLEX调用方式
***/
var activeServerType = function(type) {
  var setServerType = tdxClientObj.setServerType.bind(tdxClientObj);
  setServerType(type || "tqlex");
}


/***转发请求到ts_client.js***/
/**
 * @param {[string]}  strFuncName  功能号
 * @param {[string]}  cparams      入参
 * @param {[function]}callbk       回调函数
 * @param {[object]}  otherparams  其他参数
 */
var NcallTql = function(strFuncName, cparams, callbk, otherparams) {
  var __formid = otherparams.formid;
  var __Way = otherparams.Way;

  if (strFuncName == 'TSTC.uinfo' && __tdxMobSystem != "IOS" && __tdxMobSystem != "Android") {
    callbk(_formidDict[__formid], strFuncName, 0, localStorage.getItem('uinfo'));
    return;
  }

  mCallTQL(strFuncName, cparams, function(err, data) {
    if (err == undefined || err == null) {
      err = '';
    }

    if (g_tdx_log) {
      console.log([
        '接受应答:',
        '%c\nCallTQL请求详情，功能名-strFuncName: [' + strFuncName + ']，入参-cparams：[' + cparams + ']',
        '%c应答结果：',
        '%c' + (typeof data === 'object') ? JSON.stringify(data) : data,
        '%c当前时间: ' + _theTime(),
        ''
      ].join('\n'), 'color: green', 'color: red', 'color: blue', 'color: green');
    }

    /***券商服务请求应答原始返回***/
    if (__Way == 'qs') {
      callbk(data);
      return;
    }

    if (typeof data === 'string') {
      data = data.replace(/\r\n/g, "<br>");
      data = data.replace(/\r/g, "<br>");
      data = data.replace(/\n/g, "<br>");
      data = data.replace(/&nbsp;/g, " ");
    }


    try {
      if (__tdxMobSystem != "IOS" && __tdxMobSystem != "Android" && __tdxMobSystem != 'WEB-IOS' && __tdxMobSystem != 'WEB-Android') {
        var curHref = window.location.href;
        /***未登录，唤起登录***/
        if (data.indexOf('[-10000]') > -1 && curHref.indexOf('login.html') < 0) {
          __tdxLoginBox();
        }
      } else {
        if (err == '-10000') {
          __tdxLoginBox();
        }
      }

      if (otherparams.jyflag === 1) {

        callbk(_formidDict[__formid], strFuncName, err, data);
      } else {

        if (err != '0' && err != '') {
          data = '[[' + err + ',"' + data + '",0,"",0,""],[],[],[]]';
        }
        callbk(data);
      }

    } catch (ex) {
      /***具体错误处理***/
      data = '-999';
      err = '[[' + data + ',"' + ex + '",0,"",0,""],[],[],[]]';
      callbk(err);
    }

  }, otherparams); //'jyflag':0 默认新的交易通道(通用),'jyflag':1,针对交易webview  otherparams={'jyflag': 0};
}

/**
 * [_formidDict 保存各个请求唯一识别串]
 * @type {Array}
 */
var _formidDict = [];

/**
 * [sendRequest 请求参数统一处理]
 * @param  {[string]}    strCallWay   请求方式通道
 * @param  {[string]}    strFuncName  功能号、功能名
 * @param  {[object]}    paramsFuncData 请求入参 
 * @param  {[object]}    objOptParam   通道参数
 * @param  {[function]}  funcCallBack  回调函数
 * @param  {[object]}    addParObj    其他参数 
 */
function sendRequest(strCallWay, strFuncName, paramsFuncData, objOptParam, funcCallBack, addParObj) {

  var PageId = '';
  if (typeof paramsFuncData == 'object' && paramsFuncData.length > 0) {
    PageId = paramsFuncData[0].tdxPageID;
  }

  if (typeof paramsFuncData == 'object' && paramsFuncData["tdxPageID"]) {
    PageId = paramsFuncData.tdxPageID;
  }

  var callback_name = typeof funcCallBack == "function" ? Fun_Name(funcCallBack) : "none";
  var formid = getRnd() + '_$$$$$' + '_' + callback_name + PageId;
  _callFuncDictConnect[formid] = funcCallBack;

  if (typeof addParObj == 'object' && addParObj.formid != undefined && addParObj.formid != '') {
    _formidDict[formid] = addParObj.formid;
  }
  var addWay = '';
  if (typeof addParObj == 'object' && addParObj.hasOwnProperty('Way')) {
    addWay = addParObj.Way;
  }

  if (addWay === 'qs') {
    if (__tdxMobSystem === 'WEB-IOS') {
      activeServerType('ios');
    } else if (__tdxMobSystem === 'WEB-Android') {
      activeServerType('android');
    }
  }


  if (__tdxMobSystem == "IOS" || __tdxMobSystem == 'WEB-IOS') {
    //处理tdx-IOS客户端请求
    var cparams = paramsFuncData;
    if (strCallWay === "CallTQL") {

      if (__tdxMobSystem == 'WEB-IOS' && addWay !== 'qs') {
        if (typeof paramsFuncData != 'string') {
          paramsFuncData = JSON.stringify(paramsFuncData);
        }
        NcallTql(strFuncName, paramsFuncData, funcCallBack, {
          'formid': formid,
          'Way': addWay
        });
        return;
      }

      /****新数据请求发送通道，支持发生到:行情、服务、交易****/
      var tmp = {
        "SessionType": objOptParam.sessionType,
        "TQLParam": paramsFuncData
      };

      if (objOptParam.sessionType === 'JYSession') {
        tmp.SessionID = objOptParam.SessionID;
        tmp.JYParam = paramsFuncData;
      }
      jsonExtend(tmp, objOptParam);
      cparams = JSON.stringify(tmp);
      NcallTql(strFuncName, cparams, funcCallBack, {
        'jyflag': 0,
        'formid': formid,
        'Way': addWay
      });
    } else if (strCallWay === 'WJyCallTql') {
      /****老交易请求发送通道****/
      if (typeof cparams != 'string') {
        cparams = JSON.stringify(cparams);
      }
      NcallTql(strFuncName, cparams, funcCallBack, {
        'jyflag': 1,
        'formid': formid
      });
    } else if (strCallWay === 'WebCall') {
      /***IOS客户端内部请求调用***/
      cparams = JSON.stringify(paramsFuncData);
      _IOSBridgeConnect.call(strCallWay, cparams, strFuncName, formid, 'tdxGetCallBack');
    }
  } else if (__tdxMobSystem == 'Android' || __tdxMobSystem == 'WEB-Android') {
    //处理tdx-Android客户端请求

    if (typeof paramsFuncData != 'string') {
      paramsFuncData = JSON.stringify(paramsFuncData);
    }
    if (strCallWay === "CallTQL") {

      /*
       新数据请求发送通道，支持发生到:行情、服务、交易
       * */

      var temp = {
        "SendSession": objOptParam.sessionType,
        "TQLParam": paramsFuncData
      };
      if (objOptParam.sessionType === 'JYSession') {
        temp.SessionID = objOptParam.SessionID;
      }
      jsonExtend(temp, objOptParam);

      var SendSession = JSON.stringify(temp);
      NcallTql(strFuncName, paramsFuncData, funcCallBack, {
        'jyflag': 0,
        'formid': formid,
        'SendSession': SendSession,
        'Way': addWay
      });
      // window.tdx_java.TdxSendData(strFuncName, paramsFuncData, SendSession, 'tdxGetCallBack', formid);
    } else if (strCallWay === 'WJyCallTql') {
      /*
       老交易请求发送通道
       * */
      NcallTql(strFuncName, paramsFuncData, funcCallBack, {
        'jyflag': 1,
        'formid': formid
      });
    } else if (strCallWay === 'WebCall') {
      /***Android客户端内部请求调用***/
      window.tdx_java.TdxWebCall(strFuncName, paramsFuncData, 'tdxGetCallBack', formid);
    }
  } else {

    //处理tdx-其他客户端请求
    if (strCallWay === 'WJyCallTql' || objOptParam.hasOwnProperty("TSTC") || strFuncName.indexOf("TSTC.") >= 0) {
      if (__tdxMobSystem == 'PCCEF') {

        if (strFuncName == "uinfo") {
          strFuncName = 'tc.getuinfo';
        } else {
          if (strFuncName.indexOf("FuncID(") == 0 && strFuncName.slice(strFuncName.length - 1) == ")") {
            strFuncName = strFuncName.slice(("FuncID(").length, strFuncName.length - 1);
          } else {
            strFuncName = 'atc.' + strFuncName;
          }
        }

        NcallTql(strFuncName, paramsFuncData, funcCallBack, {
          'jyflag': 1,
          'formid': formid
        });

      } else {
        var uinfo = localStorage.getItem("uinfo");

        // 如果这里检查到用户未登录，发 TSTC 请求的时候，必须去登录
        if (!uinfo) {
          __tdxLoginBox(function() {});
          return;
        }

        /***原来硬代码的功能进行兼容***/
        if (strFuncName == "uinfo") {
          funcCallBack(addParObj.formid, strFuncName, "", uinfo);
          return;
        }
        /***微信交易的处理分支***/
        uinfo = JSON.parse(uinfo);
        var tmpParams = [{
          "@AddPreF": "1",
          "@QSID": uinfo.qsid,
          "F1235": "webwt",
          "F121": uinfo.zjzh
        }]
        if (typeof paramsFuncData == 'string') {
          paramsFuncData = JSON.parse(paramsFuncData);
        }
        try {
          if (strFuncName.indexOf("TSTC.") >= 0) {
            jsonExtend(tmpParams[0], paramsFuncData[0]);
          } else {
            strFuncName = 'TSTC.' + strFuncName;
            paramsFuncData.forEach(function(item, index) {
              jsonExtend(tmpParams[0], item);
            })
          }
        } catch (err) {

        }

        tmpParams = JSON.stringify(tmpParams);
        if (strCallWay === "WJyCallTql") {
          NcallTql(strFuncName, tmpParams, funcCallBack, {
            'jyflag': 1,
            'formid': formid
          });
        } else {
          NcallTql(strFuncName, tmpParams, funcCallBack, {
            'jyflag': 0,
            'formid': formid
          });
        }
      }
    } else {
      if (typeof paramsFuncData != 'string') {
        paramsFuncData = JSON.stringify(paramsFuncData);
      }

      NcallTql(strFuncName, paramsFuncData, funcCallBack, {
        'formid': formid,
        'Way': addWay,
        'pccef_method': addParObj.method || 'CallTQL'
      });
    }

  }


  if (g_tdx_log) {
    console.log([
      '发送请求:',
      '%c\n【' + strCallWay + '】请求详情，功能名-strFuncName: [' + strFuncName + ']，入参-cparams：[' + paramsFuncData + ']',
      '%cobjOptParam: ' + JSON.stringify(objOptParam),
      '%c当前时间: ' + _theTime(),
      ''
    ].join('\n'), 'color: green', 'color: red', 'color: green');
  }

}



/***json对象合并***/
/**
 * @param  {object} destination 目标对象
 * @param  {object} source 源对象 
 * @return {object} destination 合并到目标对象
 */
function jsonExtend(destination, source) {
  for (var property in source)
    destination[property] = source[property];
  return destination;
}



/***通用交易请求通道***/

var JYCallTql = function() {
  this.SessionID = '';
  this.objOptParam = {
    'sessionType': 'JYSession',
    'SessionID': this.SessionID || ""
  };
  this.callWay = 'CallTQL';
  this.addParObj = {};

}

JYCallTql.prototype.send = function(entry, stream, callback) {
  sendRequest(this.callWay, entry, stream, this.objOptParam, callback, this.addParObj);
}

/***交易Webview专属请求通道***/
var WJyCallTql = function() {
  this.objOptParam = {};
  this.callWay = 'WJyCallTql';
}

WJyCallTql.prototype.send = function(entry, stream, callback, addParObj) {
  sendRequest(this.callWay, entry, stream, this.objOptParam, callback, addParObj)
}

/***行情请求发送***/
var HQCallTql = function() {
  this.objOptParam = {
    'sessionType': 'HQSession'
  };
  this.callWay = 'CallTQL';
  this.addParObj = {};
}

HQCallTql.prototype.send = function(entry, stream, callback) {
  sendRequest(this.callWay, entry, stream, this.objOptParam, callback, this.addParObj);
}

/***服务FWSession请求发送***/
var FWCallTql = function() {
  this.objOptParam = {
    'sessionType': 'FWSession',
    'SessionID': this.SessionID || ""
  };
  this.callWay = 'CallTQL';
  this.addParObj = {};
}

FWCallTql.prototype.send = function(entry, stream, callback) {
  sendRequest(this.callWay, entry, stream, this.objOptParam, callback, this.addParObj)
}

/***链接跳转调用/调用硬代码功能/枚举交易账号/唤起登陆界面***/
var WEBCallTql = function() {
  this.callWay = 'WebCall';
  this.objOptParam = {
    'sessionType': '',
    'SessionID': this.SessionID || ""
  };

  this.addParObj = {};
}


WEBCallTql.prototype.send = function(entry, stream, callback) {

  if (callback == '' || callback == undefined || typeof callback != 'function') {
    callback = function() {

    }
  }

  if (__tdxMobSystem != "IOS" && __tdxMobSystem != "Android" && __tdxMobSystem != 'WEB-IOS' && __tdxMobSystem != 'WEB-Android') {
    /*
     * 非app内部页面跳转支持（微信、浏览器）
     * */
    var streamObj = stream;
    if (typeof stream === 'string') {
      streamObj = JSON.parse(stream);
    }
    if (streamObj.hasOwnProperty('OpenUrl')) {

      var homePath = "/site/webApp/app/";
      var OpenName = streamObj.OpenName;
      var OpenUrl = streamObj.OpenUrl;
      var UrlType = streamObj.OpenParam.UrlType;
      var realUrl = OpenUrl;

      if (UrlType === "Absolute") {
        realUrl = homePath + OpenUrl;
      } else {
        // 取iframe中的路径，来计算出相对路径
        var curHref = window.location.href;
        var lastIndexSlash = curHref.lastIndexOf("/");
        realUrl = curHref.substring(0, lastIndexSlash + 1) + OpenUrl;
      }

      // 如果外层没有包裹页面，这里直接改变URL中的路径
      if (window.top === window) {
        window.location.href = realUrl;
      } else {
        parent.window.postMessage(JSON.stringify({
          OpenName: OpenName,
          OpenUrl: realUrl
        }), "*");
      }

    } else {

      if (__tdxMobSystem === 'PCCEF') {
        this.addParObj.method = entry;
      }

      sendRequest(this.callWay, entry, stream, this.objOptParam, callback, this.addParObj);

    }

  } else {

    sendRequest(this.callWay, entry, stream, this.objOptParam, callback);
  }

}

// 唤起登录框
/**
 * @param  {object} param 入参  {HostType:0 （普通 0 信用 1  期货 2  港股 3 ）,NeedCallBack:0 (0,1 NeedCallBack为1时就不考虑登录类型和传入的Hosttype是否一致，这个给券商让他们自己控制后续动作
)}
 * @param  {Function} callback 回调函数
 * @return {[type]}
 */
function __tdxLoginBox(param, callback) {

  if (__tdxMobSystem == 'IOS' || __tdxMobSystem == 'Android' || __tdxMobSystem == 'WEB-IOS' || __tdxMobSystem == 'WEB-Android') {
    callback = callback || param;
    var webCallTql = new WEBCallTql();
    var par = param;
    if (typeof param == 'function' || param == undefined) {
      par = {
        'HostType': '0'
      };
    }
    webCallTql.send('tdxLoginTrade', par, function(data) {
      callback(data);
    });
  } else if (__tdxMobSystem == 'PCCEF') {
    console.log('pc-chrome here')
    location.href("http://www.treeid/jy");

  } else {
    // location.href = '';
    //纯浏览器
    __webCallTql.send("tdxOpenUrl", {
      "OpenName": "登录",
      "OpenType": "native",
      "OpenUrl": "login/login.html",
      "OpenParam": {
        "UrlType": "Absolute"
      }
    }, function() {})
  }
}


/**
 * @param  {Function} callback 回调函数 
 * @return {[type]}  账户列表
 */
function __tdxgetAccList(callback) {

  if (__tdxMobSystem == "IOS" || __tdxMobSystem == "Android" || __tdxMobSystem == "WEB-Android" || __tdxMobSystem == "WEB-IOS") {

    var webCallTql = new WEBCallTql();
    webCallTql.send('tdxEnumTradeAcc', {}, function(data) {
      callback(data);
    });
  } else if (__tdxMobSystem == "PCCEF") {
    __TdxPcGetJyInfo(function(data) {
      callback(data);
    })
  } else {
    // debugger;
    var uinfo = JSON.parse(localStorage.getItem("uinfo"));
    if (uinfo == null) {
      callback([]);
    } else {
      callback([JSON.stringify(uinfo)]);
    }
  }
}



/**
 * @param  {Function} callback 回调函数 
 * @return {[type]}  自选股列表
 */
function __tdxGetZxgList(callback) {
  var webCallTql = new WEBCallTql();
  var entry = 'tdxGetZxgList';
  var param = {};

  webCallTql.send(entry, param, function(data) {
    callback(data);
  });
}


/**
 * @param  {Function} callback 回调函数 
 * @return {[type]} TDXID [[0,"",0,"",0,""],["TDXID"],[]]
 */
function __tdxGetPulTdxID(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetPulTdxID', {}, function(data) {
    callback(data);
  });

}



/**
 * [__tdxYhtLogin 唤起一户通登录框]
 */
function __tdxYhtLogin() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxYhtLogin', {}, function(data) {
    // callback(data);
  });
}


/**
 * [__tdxYhtLogout 退出一户通登录]
 */
function __tdxYhtLogout() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxYhtQuit', {}, function(data) {
    // callback(data);
  });
}



/**
 * [__tdxGetRegTel 获取注册手机号及一户通手机号]
 * @param {function} [callback] [回调函数]
 */
function __tdxGetRegTel(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetRegTel', {}, function(data) {
    callback(data);
  });
}



/**
 * [__tdxGetTradeMarkInfo 获取交易监管留痕信息]
 * @param {function} [callback] [回调函数,f返回数据格式示例：[[0,"",1,"",0,""],["RESULT"],[],["xxxxxxx"]]]  
 */
function __tdxGetTradeMarkInfo(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetTradeMarkInfo', {}, function(data) {
    callback(data);
  });
}



//激活页面通知网页消息函数
//function tdxActivity(){
// 开发自行定义该函数
// }


/**手机表单调用键盘精灵
 * @param {object} param 入参示例：{'m_bFindSHSZ ':1,'m_bFindQH':1, 'm_bFindHK':1,'m_bFindMG':1,'m_bFindALLOTHER':1}
 *                                  查找深沪市场,    查找期货市场,  查找港股市场, 查找美股市场, 查找其他             vlue 0 不启用/ 1 启用
 *@return {object}   回调  SETCODE,CODE 两个字段
 */
function __tdxWebKeyboardElves(param, callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxWebKeyboardElves', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxOpenSearchDialog 唤起行情搜索界面]
 */
function __tdxOpenSearchDialog() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxOpenSearchDialog', {}, function(data) {

  });
}

/**
 * [__tdxSetCustomNavIcon 设置导航栏自定义按钮的图标]
 * @param {object} param {ItemID:'',Image:''}  //ItemID  对应uiconfig配置的节点id   Image  新图标的名称
 */
function __tdxSetCustomNavIcon(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxSetCustomNavIcon', param || {}, function(data) {

  });
}


/**
 * [__tdxGotoTradeMark 唤起交易短信注册界面]
 */
function __tdxGotoTradeMark() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGotoTradeMark', {}, function(data) {

  });
}


/**
 * [__returnToSuperior 触发返回按钮]
 * @param {object or undefined} param  {"GotoRoot":1} 返还至首页 undefined 返回上一级
 */
function __returnToSuperior(param) {
  if (typeof param != 'object') {
    param = {};
  }
  var webCallTql = new WEBCallTql();
  webCallTql.send('ReturnToSuperior', param, function(data) {

  });
}

//__webCallTql.send('ReturnToSuperior', {"GotoRoot":1}, function (data) {}); 返还至首页


/**
 * [__getLocation 获得当前位置]
 * @param {function} [callback] [回调函数]
 * @return {json} 返回错误代码  0表示无错误  1表示权限错误，手机没有开启  2表示其他错误，无法定位
 *                返回数据是一个json  如下：{"latitude":"37.78583445","longitude":"122.40641749"}
 */
function __getLocation(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetLocation', {}, function(data) {
    callback(data);
  });
}

/**
 * [__callTel 拨打电话]
 * @param {string} cellnumb 电话号码
 */
function __callTel(cellnumb) {
  if (typeof cellnumb != 'string') {
    cellnumb = String(cellnumb);
  }
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxCallTel', {
    'PhoneNum': cellnumb
  }, function(data) {

  });
}


/**
 * [__tdxManipulateData 找回资金账号的接口]
 * @param {json} param {'account':content,'option':1}  account和option，account为要操作的数据，
 *                     比如电话号码，或者账号，option为操作类别，0复制到剪切板，1收藏数据到通讯录，2打开拨号盘
 */
function __tdxManipulateData(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxManipulateData', param, function(data) {

  });
}

// 

/**
 * [__isLoginNormal 判断是当前激活交易账号否普通账户登录]
 * @param {function} [callback] [回调函数]
 */
function __isLoginNormal(callback) {
  __tdxgetAccList(function(data) {
    try {
      var curUser;
      if (typeof data == "string") { // ios
        data = JSON.parse(data);
        curUser = data[0];
      } else { // android
        curUser = JSON.parse(data[0] || {});
      }
    } catch (e) {}

    // 未登录或者当前账号不是普通账号
    if (data.length == 0 || curUser["HostType"] != 0) {
      callback(0);
    } else {
      callback(1);
    }
  })
}



/**
 * [__tdxXgslReqHS 获取新股数量 沪深新股数量]
 * @param {function} [callback] [回调函数] 返回示例 {"SGSL": 2,"XGSL": 3,"ZQSL": 2}  //SGSL申购数量  XGSL 新股数量 ZQSL 中签数量
 */
function __tdxXgslReqHS(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxXgslReq', {
    Target: 0
  }, function(data) {
    callback(data);
  });
}


/**
 * [__tdxXgslReqGG 获取新股数量 港股新股数量]
 * @param {function} [callback] [回调函数] 返回示例 {"SGSL": 2,"XGSL": 3,"ZQSL": 2}  //SGSL申购数量  XGSL 新股数量 ZQSL 中签数量
 */
function __tdxXgslReqGG(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxXgslReq', {
    Target: 1
  }, function(data) {
    callback(data);
  });
}

/*
 * [__tdxFlushJYLockTime 延长交易锁屏时间]
 */
function __tdxFlushJYLockTime() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxFlushJYLockTime', {}, function(data) {});
}


/**
 * [__tdxGetUinfo 获取交易账号uinfo信息]
 * @param {function} [callback] [回调函数] 
 */
function __tdxGetUinfo(callback) {
  __WJyCallTql.send('uinfo', [{
    "zjxx": 'loc'
  }], function(data) {
    callback(data);
  });
}


/**
 * [__tdxGetYhtZhInfo 获取一户通账户信息]
 * @param {function} [callback] [回调函数] 
 */
function __tdxGetYhtZhInfo(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetYhtZhInfo', {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxGetEncryptAcc 新增加密接口]
 * @param {json} param  {EncryptType:0,EncryptedString:str}  0,des加密
 * @param {function} callback  回调函数
 * @return {string} 返回加密串
 */
function __tdxGetEncryptAcc(param, callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetEncryptAcc', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxOpenDialog 网页打开对话框]
 * @param {json} param 入参示例  
 *                         [{'title':'提示','content':'hello,tdx !','buttons':[{'value':'取消','fun':'func1'},{'value':'确定','focus':true,'fun':'func2'}]}]
 * @return {string} 返回加密串
 */
function __tdxOpenDialog(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxOpenDialog', param, function(data) {});
}

/**
 * [__tdxHideTopBar 隐藏顶部栏] 隐藏当前的顶部栏区域（注意：切换视图后顶部栏会自动恢复）
 */
function __tdxHideTopBar() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxHideTopBar', {}, function(data) {});
}

/**
 * [__tdxBottomBarVisibility 隐藏底部栏] 
 * @param {int} flag 0:底部栏隐藏，1：底部栏显示
 */
function __tdxBottomBarVisibility(flag) {
  var webCallTql = new WEBCallTql();
  var param = {
    'VisibilityFlag': flag || 1
  }
  webCallTql.send('tdxBottomBarVisibility', param, function(data) {});
}


/**
 * [__tdxOpenPwdDialog 弹出交易密码输入对话框 （港股有的网页操作前需要弹出密码框，要根据后台返回的标志判断是否弹框）]
 * 如果输入密码后点击确定，errFlag为0 返回一个密码替换串"passwordstr"，示例：[[0,"",1,"",0,""],["password"],[],["passwordstr"]]
 * 如果取消输入，errFlag为-1
 */
function __tdxOpenPwdDialog(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxOpenPwdDialog', {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxQuitTrade 交易账号全部退出] 
 */
function __tdxQuitTrade() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxQuitTrade', {}, function(data) {});
}

/**
 * [__tdxIsTradeLocked 判断交易是否锁定] 
 * @param {function} callback  回调函数
 *     锁定返回1，[[0,"1",0,"",0,""],[],[]]
 *    未锁定返回0:[[0,"0",0,"",0,""],[],[]]
 */
function __tdxIsTradeLocked(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxIsTradeLocked', {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxConfirmPay 支付请求确认]
 * @param {json} param  orderInfo和payType,orderInfo是字符串，payType是支付类型 {'orderInfo':'','payType':''}
 * @param {function} callback  回调函数
 */
function __tdxConfirmPay(param, callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxConfirmPay', param, function(data) {
    callback(data);
  });
}

/**
 * [__tdxReFetchGDDM 刷新股东列表]
 * @param {function} callback  回调函数
 */
function __tdxReFetchGDDM(callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxReFetchGDDM', {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxOpenPDF 下载并打开PDF文档]
 * @param {json} param {"File":"下载的url"}
 */
function __tdxOpenPDF(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxOpenPDF', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxSetTopbarTitle 网页动态修改顶部栏标题]
 * @param {json} param {"Title":"xxx"}
 */
function __tdxSetTopbarTitle(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxSetTopbarTitle', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxChangeCurAcc 切换账号]
 * @param {json} param  {"SessionID":SessionID}
 */
function __tdxChangeCurAcc(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxChangeCurAcc', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxSetBadgeNum 设置iOS角标个数：]
 * @param {json} param  BadgeNum为iOS角标数字 {"BadgeNum":"1"}
 */
function __tdxSetBadgeNum(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxSetBadgeNum', param || {}, function(data) {
    callback(data);
  });
}


/**
 * [__tdxGotoAccountCenter 网页打开个人中心]
 */
function __tdxGotoAccountCenter() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGotoAccountCenter', {}, function(data) {

  });
}



/**
 * [__tdxGetUIConfigInfo 获取服务器文件 ]
 * @param    {[type]}                 param    {"ItemID":"uiconfig中Item的ID"}
 * @param    {Function}               callback 返回 对应Item的uiconfig信息 
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:26:10+0800
 * @version  [1.0]
 */
function __tdxGetUIConfigInfo(param, callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetUIConfigInfo', param, function(data) {
    callback(data);
  });
}

/**
 * [__tdxStartScan 启动扫描]
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:29:19+0800
 * @version  [1.0]
 */
function __tdxStartScan() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('StartScan', {}, function(data) {

  });
}


/**
 * [__tdxSetStatusBarState 设置状态栏状态及颜色]
 * @param    {[type]}                 param {"ShowFlag":"0表示显示状态栏，1表示状态栏透明";"Color":"当ShowFlag为0时，传入Color可以改变状态栏颜色，若不传Color颜色默认为顶部栏背景色"}
 * @return   {[type]}                       [无]
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:30:57+0800
 * @version  [1.0]
 */
function __tdxSetStatusBarState(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('SetStatusBarState', param || {}, function(data) {
    callback(data);
  });
}

/**
 * [__tdxOpenSearchDialog 打开行情股票搜索框 ]
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:32:32+0800
 * @version  [1.0]
 */
function __tdxOpenSearchDialog() {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxOpenSearchDialog', {}, function(data) {

  });
}


/**
 * [__tdxGetXTSet 获取系统设置 ]
 * @param    {[type]}                 param    { SetType:[HqRefreshTime..] HqRefreshTime 行情刷新时间 }
 * @param    {Function}               callback 回调数据示例：[[0,"",1,"",0,""],["value"],[],["5"]]
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:38:22+0800
 * @version  [1.0]
 */
function __tdxGetXTSet(param, callback) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxGetXTSet', param, function(data) {
    callback(data);
  });
}

/**
 * [__tdxAddZXG 添加自选股]
 * @param    {[type]}                 param {"StkInfo":json数组格式","GroupName":"分组名"}
 * @return   {[type]}                       [无]
 * @Author   tdxypf
 * @DateTime 2017-12-22T09:54:10+0800
 * @version  [version]
 */

function __tdxAddZXG(param) {
  var webCallTql = new WEBCallTql();
  webCallTql.send('tdxAddZXG', param || {}, function(data) {
    callback(data);
  });
}

/**********其他通用api************/

/*
 * 应答数据包格式化
 * */
var FormatResult = function(data) {
  try {

    if (typeof data == 'string') {
      data = data.replace(/\r\n/ig, "<br>");
      // data = data.replace(/\s/g, "");
      data = JSON.parse(data);
    }

    var rt = {};
    rt.ErrorCode = data[0][0];
    rt.ErrorInfo = data[0][1];
    rt.Num = data[0][2];
    rt.Cookies = data[0][3];
    rt.POS = data[0][4];

    if (rt.ErrorCode != 0) {
      return rt;
    }

    // 数据部分
    rt.rows = [];

    var titles = data[1];
    data.shift();
    data.shift();
    data.shift();

    rt.rows = data.reduce(function(prev, curr) {
      // 将扁平数组转换为对象
      prev.push(curr.reduce(function(p, c, index) {
        p[titles[index]] = c;
        return p;
      }, {}));
      return prev;
    }, []);

    return rt;

  } catch (e) {

    // alert('FormatResult，应答数据格式化失败。' + e);
    return {'ErrorCode':-1,'ErrorInfo':'FormatResult，应答数据格异常。' + e,'rows':[]};
  }
}


/**
 * [__webCallTql 客户端框架交互调用api]
 * @type {WEBCallTql}
 */
var __webCallTql = new WEBCallTql();

/**
 * [__jyCallTql 向交易中心发请求调用api]
 * @type {JYCallTql}
 */
var __jyCallTql = new JYCallTql();

/**
 * [__hqCallTql 向行情主站(tp)发请求调用api]
 * @type {HQCallTql}
 */
var __hqCallTql = new HQCallTql();

/**
 * [__fwCallTql 向服务主站(tp)发请求调用api]
 * @type {FWCallTql}
 */
var __fwCallTql = new FWCallTql();

/**
 * [__WJyCallTql 针对jyhtml特别实例化]
 * @type {WJyCallTql}
 */
var __WJyCallTql = new WJyCallTql();

/**
 * [__jyhtmlTQL description]
 * @type {Object}
 */
var __jyhtmlTQL = {
  App: __webCallTql,
  Call: __WJyCallTql
};


/********************这里实例化请求对象,券商合作开发调用*******************/

/**
 * [__jyCallTqlEx 客户端框架交互调用api]
 * @type {JYCallTql}
 */
var __jyCallTqlEx = new JYCallTql();
__jyCallTqlEx.addParObj = {
  'Way': 'qs'
};

/**
 * [__hqCallTqlEx 向行情主站(tp)发请求调用api]
 * @type {HQCallTql}
 */
var __hqCallTqlEx = new HQCallTql();
__hqCallTqlEx.addParObj = {
  'Way': 'qs'
};

/**
 * [__fwCallTqlEx 向行情主站(tp)发请求调用api]
 * @type {FWCallTql}
 */
var __fwCallTqlEx = new FWCallTql();
__fwCallTqlEx.addParObj = {
  'Way': 'qs'
};

/*****************************end*********************************************/


! function() {

  // 这里实现公共函数,都绑定到 tdx 下
  var TDX = function() {};

  TDX.prototype.getUrlParam = function(url) {

    var param = {};
    var index = url.indexOf("?");
    if (index == -1) {
      return param;
    }

    url = url.substr(index + 1);
    var queryArr = url.split("&");
    queryArr.forEach(function(p) {
      var a = p.split("=");
      param[a[0]] = a[1];
    })

    return param;
  }

  window["tdx"] = new TDX();

}()


/**
 * [webCall OpenURL 新增入参]
 * OpenParam添加参数：
 * PullMode为0表示禁用下拉刷新，默认不添加时启用下拉刷新
 * NoTopBarFlag为1禁用硬代码的topbar
 * PinWebTopBar为1用于网页用输入弹出键盘时固定住网页的topbar
 */


