﻿
/*

协议转换  IX--JS

*/

var dictEncode = {
    '\\': '\\',
    '|': 's',
    '\x00': '0',
    '\x01': '1',
    '\x02': '2',
    '\x03': '3',
    '\x04': '4',
    '\x05': '5',
    '\x06': '6',
    '\x07': '7',
    '\x08': '8',
    '\x09': 't',
    '\x0A': 'n',
    '\x0B': 'b',
    '\x0C': 'c',
    '\x0D': 'r',
    '\x0E': 'e',
    '\x0F': 'f'
}

var dictDecode = {
    '\\': '\\',
    's': '|',
    '0': '\x00',
    '1': '\x01',
    '2': '\x02',
    '3': '\x03',
    '4': '\x04',
    '5': '\x05',
    '6': '\x06',
    '7': '\x07',
    '8': '\x08',
    't': '\x09',
    'n': '\x0A',
    'b': '\x0B',
    'c': '\x0C',
    'r': '\x0D',
    'e': '\x0E',
    'f': '\x0F'
}


function Encode(strValue) {
    if (strValue == null || strValue == "" || strValue == undefined) {
        return "";
    }

    strValue = String(strValue);

//    alert(strValue + '_' + typeof (strValue));    
    
    var strResult = "";

    for (var c = 0; c < strValue.length; c++) {
        var _c = strValue.charAt(c);
        var r = dictEncode[_c];
        
        if (r == null || r == "" || r == undefined) {
            strResult += _c;
        }
        else {
            strResult += '\\' + r;
        }   
    }
    return strResult;
}


function Decode(strValue) {
    if (strValue == null || strValue == "" || strValue == undefined) {
        return "";
    }

    var bEscape = false;
    var strResult = "";

    for (var _c = 0; _c < strValue.length; _c++) {
        var c = strValue.charAt(_c);
        if (bEscape) {
            bEscape = false;
            var r = dictDecode[c];
            if (r != null || r != "" || r != undefined) {
                strResult += r;
            }
            else {
                strResult += c;
            }
        }
        else if (c == '\\') {
            bEscape = true;
        }
        else {
            strResult += c;
        }
    }
    return strResult;    
}


function ToRequest(listJSON) {
    if (listJSON == null || listJSON == "" || listJSON == undefined) {
        return "";
    }

    var strResult = "";
    
    //解析KEY
    var listKey = [];

	//将 listJSON 中的不同参数压入数组中
    for (var d in listJSON) {
        for (var k in listJSON[d]) {
            if ($.inArray(k, listKey) < 0) {
                listKey.push(k);
            }
        }
    }
    
	// 填充版本
    strResult = "IX,SPEC=2834,STRUCT=0\r\n"
    // 填充Key
    nIndex = 0
    //遍历数组 填充 strResult 字符串
    for (var k in listKey) {
    	nIndex += 1;
        strResult += (String(nIndex) + ',' + listKey[k] + '|');
    }
    strResult += '\r\n';

    for (var d in listJSON) {

        for (var k in listKey) {
            var _k = listKey[k];

            if (listJSON[d][_k] != null || listJSON[d][_k] != "" || listJSON[d][_k] != undefined) {
                strResult += Encode(listJSON[d][_k]) + '|';
            }
            else {
                strResult += Encode('') + '|';
            }
        }
        strResult += '\r\n';
    }
    
    
    
    
    return strResult;
}



function FromAnswer(strIX) {
    if (strIX == null || strIX == "" || strIX == undefined) {
        return null;
    }

    var listRecord = strIX.split("\r\n");
    var nRecordCount = listRecord.length;
    
    // for (var i=0;i<nRecordCount;i++){
    	// alert(listRecord[i]);	
    // }
    
    

    if (nRecordCount < 1) {
        return null;
    }

    listRecord.splice(listRecord.length - 1, 1);
    nRecordCount -= 1;


	if(nRecordCount > 0 && listRecord[0] != "" && listRecord[0].indexOf("|") < 0){
		listRecord.splice(0,1);  //清除数组第一位
		nRecordCount -= 1;
	}


    var listResult = [];
    var nRecordIndex = 0;
    var nFieldCount = 0;

    for (var s in listRecord) {
        var listField = [];
        nRecordIndex += 1;
        //头信息
        if (nRecordIndex == 1) {

            var listTemp = listRecord[s].split("|");
            var nTempCount = listTemp.length;

            if (nTempCount > 5) {
                listTemp.splice(listTemp.length - 1, 1);
                nTempCount -= 1;
            }

            for (var v in listTemp) {
                listField.push(Decode(listTemp[v]));
            }
            while (nTempCount < 5) {
                nTempCount += 1;
                listField.push("");
            }
        }
        //字段信息
        else if (nRecordIndex == 2) {
            var listTemp = listRecord[s].split("|");
            var nFieldCount = listTemp.length;

            if (nFieldCount > 0) {
                listTemp.splice(listTemp.length - 1, 1);
                nFieldCount -= 1;
            }
            var listKey = [];
            for (var v in listTemp) {
                var listInfo = Decode(listTemp[v]).split(",");
                var strKey = ""
                if (listInfo.length >= 2) {
                    strKey = listInfo[1];
                    listInfo.splice(1, 1);
                }
                listKey.push(strKey);
                listField.push(listInfo);
            }
            listResult.push(listKey);
        }
        //字段取值
        else {
            var listTemp = listRecord[s].split("|");
            var nTempCount = listTemp.length;

            if (nTempCount > 0) {
                listTemp.splice(listTemp.length - 1, 1);
                nTempCount -= 1;
            }

            for (var v in listTemp) {
                listField.push(Decode(listTemp[v]));
            }

            while (nTempCount < nFieldCount) {
                nTempCount += 1;
                listField.push("");
            }
        }
        listResult.push(listField);
    }

    return listResult;
}


/*2013-5-31
  返回的是数组，数组元素是对象
  数组第一个元素是头部对象，共5个属性（ErrorCode，ErrorInfo，Num，Cookies，POS）
  数组从第二个元素起是记录每条结果记录封装成的对象
  数组至少含有1个元素（头部对象）
  数组示例：[{ErrorCode:0,ErrorInfo:'',Num:2,Cookies:'',POS:''},{CUST_ID:'75119',CUST_NM:'李雷'},{CUST_ID:'11000',CUST_NM:'韩梅'}]
  调用示例 var result = getResultList(IXstr);
           alert(result[1].CUST_NM);//李雷
*/

function getResultList(str)
{
	if(str.indexOf("MsgCode")!=-1){//兼容老协议
		try{
			/*错误信息*/
			var obj=null;
			var resultArray= new Array();
			eval("obj="+str);
			var head = new Object();
			head.ErrorCode = obj.MsgCode;
			head.ErrorInfo = obj.MsgInfo;
			head.Num = 0;
			head.Cookies = "";
			head.POS = "0";
			resultArray.push(head);
			return resultArray;
		}
		catch(e){
			//pass
		}
	}
    var list = FromAnswer(str);
    
    
	if(list.length==0||list[0].length<5)
	{
		return;
	}
	var resultArray= new Array();//最终返回的结果数组
	var fieldList = list[1];//字段名数组
	
	
	/*结果头部信息*/
	//alert();
    var head = new Object();
	head.ErrorCode = list[0][0];
	head.ErrorInfo = list[0][1];
	head.Num = list[0][2];
	head.Cookies = list[0][3];
	head.POS = list[0][4];
	resultArray.push(head);
	
	/*每条记录封装成一个Object，放入resultArray*/
	for(var i = 1;i<=head.Num;i++)
	{
	    var object = new Object();
		for(var k = 0;k<fieldList.length;k++)
		{		
		    object[fieldList[k].replace(/(^\s*)|(\s*$)/g, "").toUpperCase()]=list[i+2][k].replace(/(^\s*)|(\s*$)/g, "");
		}
		resultArray.push(object);
	}
	return resultArray;
}

// 将  '[a,b,c,d,e]'格式的数据解析成数组
var parseToarray=function(datastr){
	var str=datastr.substring(1,datastr.length-1);
	str.replace(/(^\\r\\n*)|(\\r\\n*$)/img, "");//去掉换行符
	//alert(str);
	return str.replace(/(^\s*)|(\s*$)/g, "").split(",");
	//return str.split(",");
}

var TOGBK2312=function(str){
	//[4e00-u9fa5]
	
	if (str.match(/\\u/gi)==null)
	{
		//alert(str);
		return str;
	}
	return unescape(str.replace(/\\u/gi,'%u'))
}


var parsevalue=function(str)
{
	//是字符型的数据要做处理
	if (typeof(str)=='string'){
		var key="";
		key=str.replace(/(^\s*)|(\s*$)/g, "");//去掉首尾的空格
		key=key.replace(/(^\'*)/,"").replace(/(\'*$)/,"");//去掉多余的单引号
		key=key.replace(/(^\"*)/,"").replace(/(\"*$)/,"");//去掉多余的双引号引号
		key=TOGBK2312(key);//判断是否是中文字符的unicode编码，是则做转换
		return key;
	}
	else
	{
		return str;
	}
}
//返回结果
//[{ErrorCode:0,ErrorInfo:'',Num:2,Cookies:'',POS:''},{CUST_ID:'75119',CUST_NM:'李雷'},{CUST_ID:'11000',CUST_NM:'韩梅'}]
var parseNewprotocal1=function(datastr){
	//datastr
	//标准包格式
	/*[
		[ErrorCode,ErrorInfo,Num,Cookies,POS],
		[FieldID,FieldID,...],
		[FieldInfo,FieldInfo,...],
		[FieldValue,FieldValue,...],
		[FieldValue,FieldValue,...],
    	...
	]*/
	var str=datastr.replace(/(^\s*)|(\s*$)/g, "").substring(1,datastr.length-1);
	//var str=datastr.replace(/(^\s*)(\s*$)|(^\'*)(\'*$)/g, "").substring(1,datastr.length-1);
	var matdata=str.match(/\[.*?\]/img);//将标准包分割成数组，每个这个为一个字符数组
	
	
	if (matdata==null||matdata==undefined){
		return;
	}
	var resultArray=new Array();
	var head=new Object();//应答包头信息
	var headone=parseToarray(matdata[0]);
	if(headone.length<5)
	{
		return;
	}
	var fieldList = parseToarray(matdata[1]);//字段名数组
	
	//设置应答结果头	
	if (isNaN(parseInt(headone[0]))){
		return;
	}
	head.ErrorCode = parseInt(headone[0]);//整形
	head.ErrorInfo = headone[1];
	head.Num = parseInt(headone[2]);//整形
	head.Cookies = headone[3];
	head.POS = headone[4];
	resultArray.push(head);
	
	//填充数组
	for(var i = 1;i<=head.Num;i++)
	{
	    var object = new Object();
	    var list=parseToarray(matdata[i+2]);//数据是从第四行开始的
		for(var k = 0;k<fieldList.length;k++)
		{	 
			
			
			var key=parsevalue(fieldList[k]);
			
		    // var key=fieldList[k].replace(/(^\s*)|(\s*$)/g, "");
			// key=key.replace(/(^\'*)/,"").replace(/(\'*$)/,"");
			// key=key.replace(/(^\"*)/,"").replace(/(\"*$)/,"");
			//key=TOGBK2312(key);
			
			
			//var value=list[k].replace(/(^\s*)|(\s*$)/g, "").replace(/(^\'*)|(\'*$)/g,"");
			// value=Decode(value);
			
			var value=parsevalue(list[k]);
			
			// var value=list[k].replace(/(^\s*)|(\s*$)/g, "");
			// value=value.replace(/(^\'*)/,"").replace(/(\'*$)/,"");
			// object[key]=TOGBK2312(value);
			
			object[key]=value;
			
		    //object[fieldList[k].replace(/(^\s*)|(\s*$)/g, "").replace(/(^\'*)(\'*$)|(^\"*)(\"*$)/g,"")]=list[k].replace(/(^\s*)(\s*$)/g, "").replace(/(^\'*)(\'*$)|(^\"*)(\"*$)/g,"");
		    //object[fieldList[k]]=list[k];
		}
		resultArray.push(object);
	}
	return resultArray;
	
}


//返回的数据格式  .表头返回包中的field信息必须包含  HeadNo，HeadName 这2个
//[{表头ID:表头Name}]
var parseTOGridHead=function(resultarr)
{
	var head=new Array();//表头数组
    var head2=new Object();//表头对象（字典)
    
	//将所有的表头数据给表头对象，然后表头数组加入表头对象，表头字典就组装完成
    for(var i=1;i<resultarr.length;i++)
    {
    	head2[resultarr[i]["HeadNo"]]=resultarr[i]["HeadName"];
    }
    head.push(head2)
    return head;
}


var parseTOTableList=function(GridHead,GridValue)
{
	var arrlist=new Array();
	arrlist.push(GridHead[0]);
	for(var i=1;i<GridValue.length;i++)
	{
		var obj=new Object();
		var nfalg=0;//判断表头的字段能否在列表中取到数据
		for (var j in GridHead[0])
		{
			//tolocaleLowerCase()
			if (typeof(j)=='string')
			{
				//alert(j);
				if (GridValue[i].hasOwnProperty(j))
				{
					nfalg=nfalg+1;
					obj[j]=GridValue[i][j];
				} 
				else if (GridValue[i].hasOwnProperty(j.toUpperCase()))
				{
					nfalg=nfalg+1;
					obj[j]=GridValue[i][j.toUpperCase()];
				} 
				else if (GridValue[i].hasOwnProperty(j.toLowerCase()))
				{
					nfalg=nfalg+1;
					obj[j]=GridValue[i][j.toLowerCase()];
				}
				else
				{
					obj[j]="";
				}
			}
			else
			{
				if (GridValue[i].hasOwnProperty(j))
				{
					nfalg=nfalg+1;
					obj[j]=GridValue[i][j];
				} 
				else
				{
					obj[j]="";
				}
			}
			
		}
		if (nfalg==0)continue;// 按 表头的key没获取到数据，继续循环
		arrlist.push(obj);// 按 表头的key获取到数据，压入列表
	}
	return arrlist;
}

var MessageBox=function(resultarray,MoneyFundGridHead)
{
	for(var q=0;q<resultarray.length;q++)
	{
		var messeg="";
		for(var t in resultarray[q])
		{
			messeg=messeg+t+":"+resultarray[q][t]+";";
		}
		alert(messeg);
	}
	if (MoneyFundGridHead==undefined){return};
	for(var q=0;q<MoneyFundGridHead.length;q++)
	{
		var messeg="";
		for(var t in MoneyFundGridHead[q])
		{
			messeg=messeg+t+":"+MoneyFundGridHead[q][t]+";";
		}
		alert(messeg);
	}
}

//返回结果
//[{ErrorCode:0,ErrorInfo:'',Num:2,Cookies:'',POS:''},{CUST_ID:'75119',CUST_NM:'李雷'},{CUST_ID:'11000',CUST_NM:'韩梅'}]
var parseNewprotocal=function(datastr){
	//datastr
	//标准包格式
	/*[
		[ErrorCode,ErrorInfo,Num,Cookies,POS],
		[FieldID,FieldID,...],
		[FieldInfo,FieldInfo,...],
		[FieldValue,FieldValue,...],
		[FieldValue,FieldValue,...],
    	...
	]*/
	try
	{
		datastr=datastr.replace(/(\r\n)*/ig, "");//去掉换行符
		var matdata=eval(datastr);//解析数组	

	}
	catch(e){
		return;
	}

	if (matdata==null||matdata==undefined){
		return;
	}
	
	
	var resultArray=new Array();
	var head=new Object();//应答包头信息
	var headone=matdata[0];
	if(headone.length<5)
	{
		return;
	}
	var fieldList = matdata[1];//字段名数组

	//设置应答结果头	
	if (isNaN(parseInt(headone[0]))){
		return;
	}
	
	head.ErrorCode = parseInt(headone[0]);//整形
	head.ErrorInfo = headone[1];
	head.Num = parseInt(headone[2]);//整形
	head.Cookies = headone[3];
	head.POS = headone[4];
	
	resultArray.push(head);
	//填充数组
	for(var i = 1;i<=head.Num;i++)
	{
	    var object = new Object();
	    var list=matdata[i+2];//数据是从第四行开始的
	    if (list== undefined ){
	    	continue
	    }
		for(var k = 0;k<fieldList.length;k++)
		{	 
			var key=fieldList[k];
			
			var value=list[k];
			object[key]=value;
		}
		resultArray.push(object);
	}
	return resultArray;
}

/**
 * JSONIX的结构解析
 */
var IXJSON2Obj = function (IXJSON) {
    if (typeof IXJSON === "string") {
        IXJSON = JSON.parse(IXJSON);
  }
  if (IXJSON === null) return {
    errorCode: -1,
    errorInfo: '底层通信错误'
  };
  var ret = {};
  ret.errorCode = +IXJSON[0][0];
  ret.errorInfo = IXJSON[0][1];
  ret.pos = IXJSON[0][4];
  ret.count = IXJSON[0][2];

  var titles = IXJSON[1];
  IXJSON.shift();
  IXJSON.shift();
  IXJSON.shift();

  ret.list = IXJSON.reduce(function (prev, curr) {
    // 将扁平数组转换为对象
    prev.push(curr.reduce(function (p, c, index) {
      p[titles[index]] = c;
      return p;
    }, {}));
    return prev;
  }, []);

  return ret;
}
